function isCocosEngine() {
return "undefined" != typeof window && void 0 !== window.cc && void 0 !== window.cc.ENGINE_VERSION;
}

function isLayaEngine() {
return "undefined" != typeof window && void 0 !== window.Laya && void 0 !== window.Laya.version;
}

function _isWINPlatform() {
return void 0 === window.wx && void 0 === window.qq && void 0 === window.tt && void 0 === window.qg;
}

function _isWXPlatform() {
return void 0 !== window.wx && void 0 === window.qq && void 0 === window.tt && void 0 === window.qg;
}

function _isQQPlatform() {
return void 0 !== window.qq;
}

function _isTTPlatform() {
return void 0 !== window.tt;
}

function _isOPPOPlatform() {
return void 0 !== window.qg && window.qg.getProvider().toLowerCase().indexOf("oppo") > -1;
}

function _isVIVOPlatform() {
return void 0 !== window.qg && window.qg.getProvider().toLowerCase().indexOf("vivo") > -1;
}

function _isQGPlatform() {
return void 0 !== window.qg;
}

function _isAndroidPlatform() {
return !(!isCocosEngine() || void 0 === window.jsb || cc.sys.os !== cc.sys.OS_ANDROID) || !(!isLayaEngine() || void 0 === window.conch || "Conch-android" !== window.conchConfig.getOS());
}

function _isIOSPlatform() {
return !(!isCocosEngine() || void 0 === window.jsb || cc.sys.os !== cc.sys.OS_IOS) || !(!isLayaEngine() || void 0 === window.conch || "Conch-ios" !== window.conchConfig.getOS());
}

function getLayaMiniAdapter() {
if (isLayaEngine()) return Laya.MiniAdpter ? Laya.MiniAdpter : Laya.QQMiniAdapter ? Laya.QQMiniAdapter : Laya.VVMiniAdapter ? Laya.VVMiniAdapter : Laya.QGMiniAdapter ? Laya.QGMiniAdapter : Laya.TTMiniAdapter ? Laya.TTMiniAdapter : Laya.HWMiniAdapter ? Laya.HWMiniAdapter : null;
}

function checkString(e) {
return "string" == typeof e && "" !== e;
}

function checkFunc(e) {
return "function" == typeof e;
}

function isObject$1(e) {
return e && "object" == typeof e;
}

function doCallback$1(e) {
if ("function" == typeof e) {
var t = Array.prototype.slice.call(arguments);
return t.shift(), e.apply(null, t);
}
return null;
}

function random(e, t) {
if (e < 0 || t <= 0) return 0;
switch (arguments.length) {
case 1:
return Math.floor(Math.random() * e + 1);

case 2:
return Math.floor(Math.random() * (t - e + 1) + e);

default:
return 0;
}
}

function generateString(e) {
var t = "";
if ("number" == typeof e) for (var n = 0; n < e; n++) Math.random() < .5 ? t += String.fromCharCode(random("0".charCodeAt(), "0".charCodeAt() + 9)) : t += String.fromCharCode(random("a".charCodeAt(), "a".charCodeAt() + 25));
return t;
}

function cutString(e, t) {
var n = 0, o = "", i = /[^\x00-\xff]/g, a = "", r = e.replace(i, "**").length;
if (r > t) {
for (var s = 0; s < r && (null != (a = e.charAt(s).toString()).match(i) ? n += 2 : n++, 
!(n > t)); s++) o += a;
r > t && (o += "...");
} else o = e;
return o;
}

function formatString(e) {
for (var t = e, n = arguments.length, o = new Array(n > 1 ? n - 1 : 0), i = 1; i < n; i++) o[i - 1] = arguments[i];
if (0 === o.length) return t;
for (var a in o) {
var r = o[a];
void 0 !== r && (t = t.replace("{" + a + "}", r));
}
return t;
}

function shuffleArray(e) {
if (Array.isArray(e)) for (var t = 0; t < e.length; t++) {
var n = Math.round(Math.random() * (e.length - 1 - t)) + t, o = e[n];
e[n] = e[t], e[t] = o;
}
}

function convertWebParams(e) {
var t = {};
if (isObject$1(e)) for (var n in e) "string" == typeof e[n] && (e[n] = e[n].trim()), 
/^\d+(?=\.{0,1}\d+$|$)/.test(e[n]) ? t[n] = parseFloat(e[n]) : t[n] = e[n];
return t;
}

String.prototype.format = function(e) {
var t = this;
if (arguments.length < 1) return t;
var n = arguments;
for (var o in 1 == arguments.length && "object" == typeof e && (n = e), n) {
var i = n[o];
null != i && (t = t.replace("{" + o + "}", i));
}
return t;
}, Date.prototype.format = function(e) {
var t = {
"M+": this.getMonth() + 1,
"d+": this.getDate(),
"h+": this.getHours(),
"m+": this.getMinutes(),
"s+": this.getSeconds(),
"q+": Math.floor((this.getMonth() + 3) / 3),
S: this.getMilliseconds()
};
for (var n in /(y+)/.test(e) && (e = e.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length))), 
t) new RegExp("(" + n + ")").test(e) && (e = e.replace(RegExp.$1, 1 == RegExp.$1.length ? t[n] : ("00" + t[n]).substr(("" + t[n]).length)));
return e;
}, isLayaEngine() && Object.defineProperty(Laya.List.prototype, "selectedIndex", {
get: function() {
return this._selectedIndex;
},
set: function(e) {
this._selectedIndex = e, this.changeSelectStatus(), this.event(Laya.Event.CHANGE), 
this.selectHandler && this.selectHandler.runWith(e), this.startIndex = this._startIndex;
}
});

var DesignSize = {
width: 750,
height: 1334
}, EventName = {
EN_SYSTEM_ERROR: "EN_SYSTEM_ERROR",
EN_SDK_NOT_SUPPORT: "EN_SDK_NOT_SUPPORT",
EN_NET_CONNECTION_LOST: "EN_NET_CONNECTION_LOST",
EN_NET_CONNECTION_RECOVER: "EN_NET_CONNECTION_RECOVER",
EN_APP_ONSHOW: "EN_APP_ONSHOW",
EN_APP_ONHIDE: "EN_APP_ONHIDE",
EN_CANCEL_NAVIGATION_FROM_AD: "EN_CANCEL_NAVIGATION_FROM_AD",
EN_BANNER_NOT_SUPPORT_RIGHT_NOW: "EN_BANNER_NOT_SUPPORT_RIGHT_NOW",
EN_VIDEO_NOT_SUPPORT_RIGHT_NOW: "EN_VIDEO_NOT_SUPPORT_RIGHT_NOW",
EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW: "EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW",
EN_SHOW_CUSTOM_TIPS: "EN_SHOW_CUSTOM_TIPS",
EN_HIDE_CUSTOM_TIPS: "EN_HIDE_CUSTOM_TIPS",
EN_SHOW_CUSTOM_MODAL: "EN_SHOW_CUSTOM_MODAL",
EN_SHOW_CUSTOM_LOADING: "EN_SHOW_CUSTOM_LOADING",
EN_HIDE_CUSTOM_LOADING: "EN_HIDE_CUSTOM_LOADING",
EN_LAUNCH_APP_FROM_UNKNOW: "EN_LAUNCH_APP_FROM_UNKNOW",
EN_LAUNCH_APP_FROM_EVERYWHERE: "EN_LAUNCH_APP_FROM_EVERYWHERE",
EN_LAUNCH_APP_FROM_RECENT: "EN_LAUNCH_APP_FROM_RECENT",
EN_LAUNCH_APP_FROM_FAVOURITE: "EN_LAUNCH_APP_FROM_FAVOURITE",
EN_LAUNCH_APP_FROM_SINGLE_SHARE: "EN_LAUNCH_APP_FROM_SINGLE_SHARE",
EN_LAUNCH_APP_FROM_GROUP_SHARE: "EN_LAUNCH_APP_FROM_GROUP_SHARE",
EN_LAUNCH_APP_FROM_SHARE: "EN_LAUNCH_APP_FROM_SHARE",
EN_LAUNCH_APP_BACK_FROM_OTHER_APP: "EN_LAUNCH_APP_BACK_FROM_OTHER_APP"
}, PropagationEventNames = {}, SwitchName = {
SN_REWARD_TIMES_OF_EACH_DAY: "rewardTimesOfEachDay",
SN_ADV_TIMES_BEFORE_SHARE: "advTimesBeforeShare",
SN_RATE_OF_SHARE: "rateOfShare",
SN_MIN_DURATION_BETWEEN_SHARE: "minDurationBetweenShare",
SN_IS_PUBLISHING: "isPublishing",
SN_COMMIT_VERSION: "commitVersion"
}, SwitchCfgs = {}, ReportEventName = {
REN_NAVIGATION_TO_MINIPROGRAM: "navigation_to_miniprogram",
REN_NAVIGATION_TO_MINIPROGRAM_SUCCESS: "navigation_to_miniprogram_success",
REN_NAVIGATION_TO_MINIPROGRAM_CANCEL: "navigation_to_miniprogram_cancel",
REN_NAVIGATION_TO_MINIPROGRAM_ERROR: "navigation_to_miniprogram_error",
REN_NAVIGATE_SUCC_ON_TT_PLAT: "navigate_succ_on_tt_plat",
REN_RECEIVED_MEMORY_WARNING: "received_memory_warning"
}, FreeGetWay = {
FGW_NONE: "none",
FGW_SHARE: "share",
FGW_ADV: "adv"
}, ShareScene = {
SS_SYSTEM_MENU: "SystemMenu",
SS_SHARE_APP: "ShareApp"
}, ShareSceneCfgs = {}, LoginConfig = {
isAlwaysNewPlayer: !1,
fixedOpenID: null
}, PlatIDs = {
winAppID: "",
wxAppID: "",
qqAppID: "",
ttAppID: "",
oppoAppID: "",
vivoAppID: ""
}, PlatAdUnitIDs = {
bannerAdUnitIDs: [],
videoAdUnitIDs: [],
interstitialAdUnitIDs: [],
splashAdUnitIDs: [],
boxAdUnitIDs: [],
blockAdUnitIDs: [],
nativeAdUnitIDs: [],
customAdUnitIDs: [],
gameNativeAdUnitIDs: []
}, PlatAdOnShowFlow = {
banner: "",
video: "",
interstitial: "",
custom: "",
box: "",
block: "",
portal: "",
streamer: "",
drawer: ""
}, ScreenOrientation = {
landscape: "landscape",
portrait: "portrait"
}, AppConfig = {
version: ""
}, CompanyConfig = {
name: "quyou",
FullName: "长沙嗨鹿网络科技有限公司"
}, UIGroupConfig = {
name: ""
}, SubConfig = {
path: ""
}, PreloadConfig = {
isPreloadResInInit: !0
}, AldConfig = {
appKey: "",
qqAppKey: "",
getLocation: !1,
useOpen: !0,
openKey: "key_of_hl_ald_open_id"
}, UmaConfig = {
wxAppKey: "",
qqAppKey: ""
}, UserTypeTag = {
All: "0",
New: "1",
Old: "2"
}, BlackTypeTag = {
All: "0",
Black: "1",
Normal: "2"
}, RewatchVideoDialog = {
content: "观看完整的视频才可获得游戏奖励",
cancelText: "稍后观看",
confirmText: "重新观看"
}, ShowVideoFailTips = {
noFinish: "奖励视频未观看完成，无法领取奖励",
noReady: "暂无奖励视频播放，请稍后重新尝试",
wait: "奖励视频还未准备好，请{0}秒后重新尝试",
noMore: "很抱歉，今日奖励已经达到上限"
}, ShareFailTips = [ "请不要一直打扰同一个群", "只有分享到群中才可以获得奖励", "很抱歉，本次游戏时间太短了，无法分享" ], ShareVideoFailTips = [ "很抱歉，本次游戏时间太短了，无法分享" ], HandleErrorDialog = {
title: "网络错误",
content: "网络连接异常，请稍后重试",
cancelText: "退出游戏",
confirmText: "重新启动"
}, BtnClickInvokeType = {
None: 0,
Banner: 1,
RewardedVideo: 2
}, BtnClickMistakeType = {
None: 0,
Move: 1,
Show: 2
}, CrazyClickInvokeType = {
None: 0,
Banner: 1,
CustomScroll: 2,
Box: 3,
VideoBanner: 4
}, CrazyClickBannerMistakeType = {
None: 0,
Move: 1,
Show: 2
}, PreloadFlowType = {
Loading: 0,
Main: 1,
Gaming: 2
}, HLSDKLocalData$1 = {
_isInited: !1,
_isPreloadAllResInInit: !0,
_openID: null,
_token: null,
_address: "",
_isNewPlayer: !1,
_isMistakeEnabled: !1,
_blackInfo: {
backArea: "",
blackScene: ""
},
_advInfos: null,
_gameFlows: null,
_runningScene: null,
_gameTimes: 0,
_isNativeland: !1,
_lastOnShowPagePath: "",
_curOnShowPagePath: "",
_isSkipFlow: !1,
_witchPrivacy: 0,
_viewStatus: {
_isMainViewShowed: !1,
_isGamingViewShowed: !1,
_isGameEndViewShowed: !1,
_isReviveViewShowed: !1,
_isFinishViewShowed: !1,
_isFinishFailViewShowed: !1
},
_isBannerOnShow: !1,
_bannerAdvObj: {},
_nextFreeGetWay: null,
_settings: {
_isSoundEnabled: !0,
_isMusicEnabled: !1,
_isMuteEnabled: !1
},
_interactInfo: {
_todayAdvTimes: 0,
_totalAdvTimes: 0,
_todayShareTimes: 0,
_totalShareTimes: 0,
_saveDay: 0
},
_handles: {
onErr: null,
onShow: null,
onHide: null
},
_tempHides: {
ui: {
couplet: null,
scroll: null,
scrollWithName: null,
matrix: null,
MoreGameEntrance: null,
VideoBanner: null
},
adv: {
couplet: [],
scroll: [],
matrix: []
}
},
_globalBannerCfg: {
preloadCount: 0,
maxShowTime: 999999,
maxClickedTimes: 99,
isTest: !1,
isLongstay: !1
},
_globalVideoCfg: {
videoLoadingTips: "",
videoLoadingShowTime: 0
},
_globalNoMoveMistakeBtnCfg: {
isEnabled: !1,
btnDelay: 0,
btnHide: 0,
btnUnhandle: 0,
btnInvokeType: 0,
btnMistakeType: 0,
bannerShow: 0
},
_globalMoveMistakeBtnCfg: {
isEnabled: !1,
btnDelay: 0,
btnHide: 0,
btnUnhandle: 0,
btnInvokeType: 0,
btnMoveAfterShowBanner: 0,
moveDuration: 0
},
_globalCrazyClickBtnCfg: {
isEnabled: !1,
invokeType: "",
mistakeStyle: 0,
scrollAdUnitId: "",
gap: 0,
miniMinus: 0,
maxMinus: 0,
add: 0,
target: 0,
videoTarget: 0,
miniClick: 0,
maxClick: 0,
rate: 0,
duration: 0,
maxMistakeTimes: 0,
mistakeSuccTimes: 0,
customParams: "",
ov_nativeMistake: "mainView-主页-0-0,gamingView-游戏中-0-0,gameEndView-游戏结束-0-0,reviveView-复活-0-0,finishView-结算-0-0,finishFailView-失败结算-0-0,customView-自定义-0-0,customView_02-自定义2-0-0,customView_03-自定义3-0-0,customView_04-自定义4-0-0,customView_05-自定义5-0-0"
},
_flowPreloadStates: [ !1, !1, !1 ],
_flowPreloadPromises: [ null, null, null ],
_globalMatrixAdCfg: [],
_globalScrollAdCfg: [],
_globalCoupleAdCfg: [],
_isMatrixPreloadSucc: !1,
_isEnableQQShowAnnounceUI: !1,
_qqAnnouncementData: []
}, addAdvTimes = function() {
HLSDKLocalData$1._interactInfo._todayAdvTimes += 1, HLSDKLocalData$1._interactInfo._totalAdvTimes += 1;
}, addShareTimes = function() {
HLSDKLocalData$1._interactInfo._todayShareTimes += 1, HLSDKLocalData$1._interactInfo._totalShareTimes += 1;
}, saveInteractInfoToString = function() {
return JSON.stringify(HLSDKLocalData$1._interactInfo);
}, loadInteractInfoFromString = function(e) {
HLSDKLocalData$1._interactInfo = JSON.parse(e);
}, SK_KEY_OF_LOGINED_OPENID_AND_TOKEN = "storage_of_logined_openid_and_token", SK_KEY_OF_INTERACT_INFO = "storage_of_interact_info", DEFAULT_BUNDLE_TEMPLATE = "default_16_01", G_IsGlobalEventPropagation = function(e) {
return "string" != typeof e || !EventName[e] || !PropagationEventNames[e];
}, _Event = function() {
function e() {
_classCallCheck2(this, e);
this._listerners = {};
}
_createClass2(e, [ {
key: "addEventListerner",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
if (!this._checkString(e) || !this._checkListerner(t)) return "";
void 0 === this._listerners[e] && (this._listerners[e] = []);
var o = generateString(32);
return this._listerners[e].push({
key: o,
method: t,
caller: n
}), o;
}
}, {
key: "removeEventListernerByKey",
value: function(e, t) {
if (this._checkString(e) && this._checkString(t) && void 0 !== this._listerners[e]) for (var n = 0; n < this._listerners[e].length; n++) if (this._listerners[e][n].key === t) return void this._listerners[e].splice(n, 1);
}
}, {
key: "removeEventListerner",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
if (this._checkString(e) && this._checkListerner(t) && void 0 !== this._listerners[e]) for (var o = 0; o < this._listerners[e].length; o++) {
var i = this._listerners[e][o];
if (i.method === t && i.caller === n) return void this._listerners[e].splice(o, 1);
}
}
}, {
key: "removeAllEventListerners",
value: function() {
this._listerners = {};
}
}, {
key: "hasEventListerner",
value: function(e) {
return !!this._checkString(e) && void 0 !== this._listerners[e] && this._listerners[e].length > 0;
}
}, {
key: "dispatchEvent",
value: function(e) {
if (this._checkString(e)) {
var t = Array.prototype.slice.call(arguments);
t.shift(), t.length > 0 ? console.log(formatString("dispatch EventName: {0}, Params: {1}", e, JSON.stringify(t))) : console.log(formatString("dispatch EventName: {0}", e));
var n = null;
for (var o in this._listerners[e]) {
var i = this._listerners[e][o], a = !1;
void 0 === (a = i.method.apply(i.caller, t)) && (a = null), n = n || a;
}
if (null === n && (n = G_IsGlobalEventPropagation(e)), !n) {
var r = this._getParentEventName(e);
"" !== r && (t.splice(0, 0, r), this.dispatchEvent.apply(this, t));
}
}
}
}, {
key: "_checkString",
value: function(e) {
return void 0 !== e && "string" == typeof e && "" !== e;
}
}, {
key: "_checkListerner",
value: function(e) {
return "function" == typeof e;
}
}, {
key: "_getParentEventName",
value: function(e) {
if (!this._checkString(e)) return "";
for (var t = e.split("_"), n = "", o = 0; o < t.length - 1; o++) n += "" === n ? t[o] : "_" + t[o];
return n;
}
} ]);
return e;
}(), Event = new _Event(), _Switch = function() {
function e() {
_classCallCheck2(this, e);
this._initedCbs = {};
}
_createClass2(e, [ {
key: "markInited",
value: function() {
var e = this, t = function(t) {
e._initedCbs[t].forEach(function(e) {
void 0 !== SwitchCfgs[t] ? e(!0, SwitchCfgs[t]) : e(!1, "");
});
};
for (var n in this._initedCbs) t(n);
this._initedCbs = {};
}
}, {
key: "getCfgByKey",
value: function(e, t) {
checkFunc(t) && this._getCfgByKey(e, function(e, n) {
e ? doCallback(t, n) : doCallback(t, null);
});
}
}, {
key: "getCfgByKeySync",
value: function(e) {
return void 0 !== SwitchCfgs[e] ? SwitchCfgs[e] : null;
}
}, {
key: "getCommitVersion",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_COMMIT_VERSION, function(t, n) {
e(t ? n : "000000");
});
}
}, {
key: "getCommitVersionSync",
value: function() {
return void 0 !== SwitchCfgs[SwitchName.SN_COMMIT_VERSION] && SwitchCfgs[SwitchName.SN_COMMIT_VERSION];
}
}, {
key: "isPublishing",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_IS_PUBLISHING, function(t, n) {
e(!!t && 1 === parseInt(n, 10));
});
}
}, {
key: "isPublishingSync",
value: function() {
return void 0 !== SwitchCfgs[SwitchName.SN_IS_PUBLISHING] && 1 === parseInt(SwitchCfgs[SwitchName.SN_IS_PUBLISHING], 10);
}
}, {
key: "getRewardTimesOfEachDay",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_REWARD_TIMES_OF_EACH_DAY, function(t, n) {
e(t ? parseInt(n, 10) : 0);
});
}
}, {
key: "getRateOfShare",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_RATE_OF_SHARE, function(t, n) {
e(t ? parseInt(n, 10) : 100);
});
}
}, {
key: "getAdvTimesBeforeShare",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_ADV_TIMES_BEFORE_SHARE, function(t, n) {
e(t ? parseInt(n, 10) : 0);
});
}
}, {
key: "getMinDurationBetweenShare",
value: function(e) {
checkFunc(e) && this._getCfgByKey(SwitchName.SN_MIN_DURATION_BETWEEN_SHARE, function(t, n) {
e(t ? parseInt(n, 10) : 0);
});
}
}, {
key: "_getCfgByKey",
value: function(e, t) {
checkString(e) || t(!1, ""), Object.keys(SwitchCfgs).length > 0 ? void 0 !== SwitchCfgs[e] ? t(!0, SwitchCfgs[e]) : t(!1, "") : (this._initedCbs[e] || (this._initedCbs[e] = []), 
this._initedCbs[e].push(t));
}
} ]);
return e;
}(), Switch = new _Switch();

function checkBlackState() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "", t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "";
if (checkString(e)) for (var n = e.split(","), o = 0; o < n.length; o++) if (-1 !== HLSDKLocalData$1._address.indexOf(n[o])) return !1;
if (checkString(t)) for (var i = PlatHelper.getLaunchScene(), a = t.split(","), r = 0; r < a.length; r++) if (i === a[r]) return !1;
return !0;
}

function isGlobalMistakeEnabled() {
return !Switch.isPublishingSync() && HLSDKLocalData$1._isMistakeEnabled;
}

function isLoadLandscapeConfig$1() {
return HLSDK_CFG.Orientation === ScreenOrientation.landscape;
}

function isLoadWXConfig() {
return !(!_isWINPlatform() || HLSDK_CFG.PlatIDs.winAppID !== HLSDK_CFG.PlatIDs.wxAppID) || _isWXPlatform();
}

function getMatrixInputLayout(e) {
var t = {};
t.row = Number(e.row || 5), t.height = Math.min(Math.max(85 + 55 * t.row, 195), 360), 
t.width = 300;
var n = PlatHelper.getPlat();
if (null != n) {
var o = n.getSystemInfoSync();
isLoadLandscapeConfig$1() || "1" != e.isStret || (t.height = t.height * (o.screenWidth / t.width), 
t.width = o.screenWidth);
}
return t.isNewLayout = !0, null != e && getLayoutStyle(e, t), t;
}

function getScrollInputLayout(e) {
var t = {}, n = Number(e.rowCount || 1), o = Number(e.cellCount || 1);
return 1 == n && 1 == o ? (t.width = 60, t.height = 106) : n > 1 ? (t.orientation = "vertical", 
t.width = 72, t.height = 72 * Math.min(5, Math.max(2, n)) + 47) : (t.orientation = "landscape", 
t.height = 106, t.width = 72 * Math.min(5, Math.max(2, o))), t.isNewLayout = !0, 
null != e && getLayoutStyle(e, t), t;
}

function getLayoutStyle(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {};
return null != e.fromTopPercent && -1 != Number(e.fromTopPercent) ? t.top = Number(e.fromTopPercent) : null != e.fromBottomPercent && -1 != Number(e.fromBottomPercent) ? t.bottom = Number(e.fromBottomPercent) : null != e.centerY && -1 != Number(e.centerY) ? t.centerY = Number(e.centerY) : t.top = 0, 
null != e.fromLeftPercent && -1 != Number(e.fromLeftPercent) ? t.left = Number(e.fromLeftPercent) : null != e.fromRightPercent && -1 != Number(e.fromRightPercent) ? t.right = Number(e.fromRightPercent) : null != e.centerX && -1 != Number(e.centerX) ? t.centerX = Number(e.centerX) : t.left = 0, 
t;
}

function isLoadQQConfig() {
return !(!_isWINPlatform() || HLSDK_CFG.PlatIDs.winAppID !== HLSDK_CFG.PlatIDs.qqAppID) || _isQQPlatform();
}

function isLoadTTConfig() {
return !(!_isWINPlatform() || HLSDK_CFG.PlatIDs.winAppID !== HLSDK_CFG.PlatIDs.ttAppID) || _isTTPlatform();
}

function isLoadOPPOConfig() {
return !(!_isWINPlatform() || HLSDK_CFG.PlatIDs.winAppID !== HLSDK_CFG.PlatIDs.oppoAppID) || _isOPPOPlatform();
}

function isLoadVIVOConfig() {
return !(!_isWINPlatform() || HLSDK_CFG.PlatIDs.winAppID !== HLSDK_CFG.PlatIDs.vivoAppID) || _isVIVOPlatform();
}

var WX_AdvKeys = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Interstitial: "interstitialAd",
VideoInterstitial: "videoInterstitialAd",
Couplet: "coupletAd",
Scroll: "scrollAd",
MoreGame: "moreGameAd",
Matrix: "matrixAd"
}, WX_FlowAdvType = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Interstitial: "interstitialAd",
Custom: "customAd"
}, WX_FlowAdvActionType = {
Show: "0",
LoadSucc: "1",
LoadFail: "2"
}, WX_FlowBannerAdvSize = {
Width: 960,
Height: 334
}, QQ_AdvKeys = {
Banner: "bannerAd_QQ",
RewardedVideo: "rewardedVideoAd_QQ",
Interstitial: "interstitialAd_QQ",
Couplet: "coupletAd_QQ",
Scroll: "scrollAd_QQ",
MoreGame: "moreGameAd_QQ",
Matrix: "matrixAd_QQ"
}, QQ_FlowAdvType = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Interstitial: "interstitialAd",
Box: "boxAd",
Block: "blockAd"
}, QQ_FlowAdvActionType = {
Show: "0",
LoadSucc: "1",
LoadFail: "2"
}, QQ_FlowBannerAdvSize = {
Width: 960,
Height: 223
}, TT_AdvKeys = {
Banner: "bannerAd_TT",
RewardedVideo: "rewardedVideoAd_TT",
Interstitial: "interstitialAd_TT",
MoreGame: "moreGameAd_TT"
}, TT_FlowAdvType = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Interstitial: "interstitialAd"
}, TT_FlowAdvActionType = {
Show: "0",
LoadSucc: "1",
LoadFail: "2"
}, TT_FlowBannerAdvSize = {
Width: 960,
Height: 336
}, OPPO_AdvKeys = {
Banner: "bannerAd_OPPO",
RewardedVideo: "rewardedVideoAd_OPPO",
Portal: "portalAd_OPPO",
Scroll: "scrollAd_OPPO",
Drawer: "drawerAd_OPPO",
Graphic: "graphic_OPPO"
}, OPPO_FlowAdvType = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Portal: "portalAd",
Streamer: "streamerAd",
Drawer: "drawerAd",
Custom: "customAd"
}, OPPO_FlowAdvActionType = {
Show: "0",
LoadSucc: "1",
LoadFail: "2"
}, VIVO_AdvKeys = {
Banner: "bannerAd_VIVO",
RewardedVideo: "rewardedVideoAd_VIVO",
Interstitial: "interstitialAd_VIVO",
Portal: "portalAd_VIVO",
Streamer: "streamerAd_VIVO",
Graphic: "graphic_VIVO"
}, VIVO_FlowAdvType = {
Banner: "bannerAd",
RewardedVideo: "rewardedVideoAd",
Interstitial: "interstitialAd",
Portal: "portalAd",
Streamer: "streamerAd",
Custom: "customAd"
}, VIVO_FlowAdvActionType = {
Show: "0",
LoadSucc: "1",
LoadFail: "2"
}, _AdvKeys = {
Banner: "",
RewardedVideo: "",
Interstitial: "",
VideoInterstitial: "",
Couplet: "",
Scroll: "",
MoreGame: "",
Matrix: "",
Portal: ""
}, _FlowAdvType = {
Banner: "",
RewardedVideo: "",
Interstitial: "",
Custom: "",
Box: "",
Block: "",
Portal: "",
Streamer: "",
Drawer: ""
}, _FlowAdvActionType = {
Show: "",
LoadSucc: "",
LoadFail: ""
}, _FlowBannerAdvSize = {
Width: 0,
Height: 0
};

isLoadQQConfig() ? (Object.assign(_AdvKeys, QQ_AdvKeys), Object.assign(_FlowAdvType, QQ_FlowAdvType), 
Object.assign(_FlowAdvActionType, QQ_FlowAdvActionType), Object.assign(_FlowBannerAdvSize, QQ_FlowBannerAdvSize)) : isLoadTTConfig() ? (Object.assign(_AdvKeys, TT_AdvKeys), 
Object.assign(_FlowAdvType, TT_FlowAdvType), Object.assign(_FlowAdvActionType, TT_FlowAdvActionType), 
Object.assign(_FlowBannerAdvSize, TT_FlowBannerAdvSize)) : isLoadOPPOConfig() ? (Object.assign(_AdvKeys, OPPO_AdvKeys), 
Object.assign(_FlowAdvType, OPPO_FlowAdvType), Object.assign(_FlowAdvActionType, OPPO_FlowAdvActionType)) : isLoadVIVOConfig() ? (Object.assign(_AdvKeys, VIVO_AdvKeys), 
Object.assign(_FlowAdvType, VIVO_FlowAdvType), Object.assign(_FlowAdvActionType, VIVO_FlowAdvActionType)) : isLoadWXConfig() ? (Object.assign(_AdvKeys, WX_AdvKeys), 
Object.assign(_FlowAdvType, WX_FlowAdvType), Object.assign(_FlowAdvActionType, WX_FlowAdvActionType), 
Object.assign(_FlowBannerAdvSize, WX_FlowBannerAdvSize)) : console.error("Not Support This Platform, check hlsdk_config.js first...");

var FlowAdvType = _FlowAdvType, FlowAdvActionType = _FlowAdvActionType, FlowBannerAdvSize = _FlowBannerAdvSize, hl_cfg = {
app_id_key: "",
company: CompanyConfig.name
}, hl = {}, plat = null;

if (_isQQPlatform() ? (plat = window.qq, hl_cfg.app_id_key = "qqAppID") : _isTTPlatform() ? (plat = window.tt, 
hl_cfg.app_id_key = "ttAppID") : _isOPPOPlatform() ? (plat = window.qg, hl_cfg.app_id_key = "oppoAppID") : _isVIVOPlatform() ? (plat = window.qg, 
hl_cfg.app_id_key = "vivoAppID") : _isWXPlatform() && (plat = window.wx, hl_cfg.app_id_key = "wxAppID"), 
plat) {
var g_sendingCount = 0;
hl.init = function() {
console.log("start to load hl sdk...");
var e = function(e) {
return "string" == typeof e && "" !== e;
}, t = function() {
function e() {
return Math.floor(65536 * (1 + Math.random())).toString(16).substring(1);
}
return e() + e() + e() + e() + e() + e() + e() + e();
}, n = function(t, n) {
e(t) ? e(n) ? "undefined" != typeof Laya ? Laya.LocalStorage.setItem(t, n) : "undefined" != typeof cc && cc.sys.localStorage.setItem(t, n) : console.error("setStorage Fail, only support string data...") : console.error("setStorage Fail, Check Input Key...");
}, o = function(t, n) {
if (!e(t)) return console.error("getStorage Fail, Check Input Key..."), void 0 !== n ? n : null;
var o = null;
return "undefined" != typeof Laya ? o = Laya.LocalStorage.getItem(t) : "undefined" != typeof cc && (o = cc.sys.localStorage.getItem(t)), 
null !== o && "" !== o || void 0 === n ? o : n;
}, i = function(t) {
e(t) ? "undefined" != typeof Laya ? Laya.LocalStorage.removeItem(t) : "undefined" != typeof cc && cc.sys.localStorage.removeItem(t) : console.error("clearStorage Fail, Check Input Key...");
}, a = function() {
return "" !== v ? new Promise(function(e) {
e("");
}) : _isWXPlatform() || _isQQPlatform() ? new Promise(function(e) {
plat.login({
success: function(t) {
m = t.code, e("");
}
});
}) : new Promise(function(e) {
e("");
});
}, r = function(e, t) {
if ("object" == typeof t) {
var n = null;
if ("undefined" != typeof Laya ? n = new Laya.HttpRequest()._http : "undefined" != typeof cc && (n = cc.loader.getXMLHttpRequest()), 
n) {
if (n.open("POST", t.url, !0), console.log("req adv url: " + t.url), "function" == typeof t.complete && (n.onreadystatechange = function() {
2 === n.readyState && "function" == typeof t.complete && t.complete();
}), n.onload = function() {
if (4 === n.readyState) {
var e = null;
if ("function" == typeof (e = n.status >= 200 && n.status < 300 ? t.success : t.fail)) try {
e({
data: JSON.parse(n.responseText),
statusCode: n.status
});
} catch (t) {
e({
data: n.responseText,
statusCode: n.status
});
}
}
}, n.timeout = 1e4, n.ontimeout = function(e) {
console.error(e), "function" == typeof t.fail && t.fail({
data: null,
statusCode: n.status
});
}, n.onerror = function(e) {
console.error(e), "function" == typeof t.fail && t.fail({
data: null,
statusCode: n.status
});
}, n.setRequestHeader("au", hl_cfg.company), "object" == typeof t.header) for (var o in t.header) n.setRequestHeader(o, t.header[o]);
"form" === e ? n.setRequestHeader("content-type", "application/x-www-form-urlencoded") : n.setRequestHeader("content-type", "application/json"), 
t.data ? "form" === e ? n.send(t.data) : n.send(JSON.stringify(t.data)) : n.send(null);
}
}
}, s = function() {
if (!(g_sendingCount > 0)) {
var e = o("qy_unsend_dict");
if ("string" == typeof e && "" !== e) {
var t = JSON.parse(e), n = function(e) {
if (g_sendingCount >= 9) return "break";
++g_sendingCount;
var n = t[e].event, o = t[e].data;
a().then(function() {
u(n, o, function() {
--g_sendingCount, l(e);
}, function() {
--g_sendingCount;
});
});
};
for (var i in t) if ("break" === n(i)) break;
}
}
}, l = function(e) {
var t = o("qy_unsend_dict");
if ("string" == typeof t && "" !== t) {
var i = JSON.parse(t), a = !1;
for (var r in i) if (r === e) {
a = !0, delete i[r];
break;
}
a && n("qy_unsend_dict", JSON.stringify(i));
}
}, c = function() {
var e = null, t = o("qy_unsend_adv_infos");
"string" == typeof t && "" !== t && (e = JSON.parse(t)), null !== e && (plat.h_SendEvent("ad", e), 
i("qy_unsend_adv_infos"));
}, d = function() {
var e = null, t = o("qy_unsend_flow_adv_infos");
"string" == typeof t && "" !== t && (e = JSON.parse(t)), null !== e && (plat.h_SendEvent("adv", e), 
i("qy_unsend_flow_adv_infos"));
}, h = function(e) {
if (e && plat.getSystemInfoSync) {
var t = plat.getSystemInfoSync();
t && (e.br = t.brand, e.md = t.model, e.pr = t.pixelRatio, e.sw = t.screenWidth, 
e.sh = t.screenHeight, e.ww = t.windowWidth, e.wh = t.windowHeight, e.lang = t.language, 
e.wv = t.COREVersion, e.sv = t.system || "", e.wvv = t.platform || "", e.wsdk = t.platformVersion || "", 
e.fs = t.fontSizeSetting || "", e.bh = t.benchmarkLevel || "", e.bt = t.battery || "", 
e.wf = t.wifiSignal || "", e.lng = "", e.lat = "", e.nt = A, e.spd = "", e.ufo = "");
}
}, u = function(t, n, o, i) {
if (!e(t) || t.length > 255) console.error("上报事件名称必须为String类型且不能超过255个字符"); else {
var a = "";
"string" == typeof n ? a = n : "object" == typeof n && (a = JSON.stringify(n));
var s = {
ak: PlatIDs[hl_cfg.app_id_key],
uu: _,
oid: "",
openid: v,
cd: m,
ev: "event",
tp: t,
ct: a,
v: f,
st: Date.now(),
wsr: g
};
h(s), r("json", {
url: p + "/sdk/v2/report",
data: s,
success: function(e) {
e.data && "200" === e.data.status ? (console.log("report to server succ..."), "function" == typeof o && o()) : (console.log("report to server fail..."), 
"function" == typeof i && i());
},
fail: function() {
console.log("report to server fail..."), "function" == typeof i && i();
}
});
}
};
e(PlatIDs[hl_cfg.app_id_key]) || console.error("请在配置文件(qy-plat-config.js)中填写您的app_key"), 
PlatIDs[hl_cfg.app_id_key] = PlatIDs[hl_cfg.app_id_key].replace(/\s/g, "");
var f = "1.0.0", _ = function() {
var e = o("hl_uuid");
return null !== e && "" !== e || (e = t(), n("hl_uuid", e)), e;
}(), p = "https://api.game.hnquyou.com", g = {}, v = "", m = "", A = "";
plat.getLaunchOptionsSync && (g = plat.getLaunchOptionsSync(), console.log("g_launchOpts: ", g)), 
console.log("g_uuid: ", _);
for (var y = [ "h_ShowAdvs", "h_ShowView", "h_ShowPage", "h_ShowComponent", "h_ReportFlowAdv", "h_ToMinProgram", "h_SendEvent", "h_ReportAllSavedAdvInfos", "h_SendOpenid" ], S = {
h_ShowAdvs: function() {},
h_ShowView: function() {},
h_ShowPage: function() {},
h_ShowComponent: function() {},
h_ReportFlowAdv: function() {},
h_ToMinProgram: function(t, n) {
var o, i = "object" === (o = n, Object.prototype.toString(o).slice(8, -1).toLowerCase()) ? n : {}, a = n.success, r = n.fail;
!e(i.pkgName) && e(i.appid) && (i.pkgName = i.appid), e(i.path) || (i.path = void 0);
var s = function(e) {
plat.h_SendEvent("ad", [ {
workflow_path: t,
adv_id: i.adv_id,
origin_path: i.origin_path,
type: e
} ]), plat.h_SendEvent("clickad", [ {
adv_id: i.adv_id,
timelog: Date.now(),
type: e
} ]);
};
i.success = function(e) {
s(1), "function" == typeof a && a(e);
}, i.fail = function(e) {
s(2), "function" == typeof r && r(e);
};
var l = null;
plat && (plat.navigateToMiniGame ? l = plat.navigateToMiniGame : plat.navigateToMiniProgram && (l = plat.navigateToMiniProgram)), 
l && (s(0), l(i));
},
h_SendEvent: function(e, t) {
a().then(function() {
u(e, t, function() {
s();
}, function() {});
});
},
h_ReportAllSavedAdvInfos: function() {
c(), d();
},
h_SendOpenid: function(e) {
console.log("register openid into hl sdk succ..."), v = e;
}
}, I = 0; I < y.length; I++) {
var C = y[I], b = S[C];
Object.defineProperty(plat, C, {
value: b,
writable: !1,
enumerable: !0,
configurable: !0
});
}
plat.h_SendEvent && (plat.getNetworkType ? new Promise(function(e) {
plat.getNetworkType({
success: function(t) {
A = t.networkType ? t.networkType : "", e("");
},
fail: function() {
e("");
}
});
}) : new Promise(function(e) {
e("");
})).then(function() {
plat.h_SendEvent("sdk_init"), c(), d(), setInterval(function() {
c(), d();
}, 1e4);
});
};
} else hl.init = function() {
console.log("hl sdk not support on windows platform....");
};

var getLocation$1 = AldConfig.getLocation, useOpen$1 = AldConfig.useOpen, openKey$1 = AldConfig.openKey, ald = {};

window.wx ? ald.init = function() {} : ald.init = function() {
console.log("ald sdk not support on windows platform....");
};

var getLocation = AldConfig.getLocation, useOpen = AldConfig.useOpen, openKey = AldConfig.openKey, ald_qq = {};

window.qq ? ald_qq.init = function() {} : ald_qq.init = function() {
console.log("ald qq sdk not support on windows platform....");
};

var uma_wx = {};

_isWXPlatform() ? uma_wx.init = function() {} : uma_wx.init = function() {
console.log("uma sdk not support on windows platform....");
};

var _Reportor = function() {
function e() {
_classCallCheck2(this, e);
this._reportors = [];
}
_createClass2(e, [ {
key: "init",
value: function(e, t, n) {
e && this._enable("hl"), t && this._enable("ald"), n && this._enable("uma"), PlatHelper.isWXPlatform() && this._enable("wx");
}
}, {
key: "setOpenID",
value: function(e) {
PlatHelper.getPlat() && checkFunc(PlatHelper.getPlat().h_SendOpenid) && PlatHelper.getPlat().h_SendOpenid(e), 
PlatHelper.getPlat() && checkFunc(PlatHelper.getPlat().aldSendOpenid) && PlatHelper.getPlat().aldSendOpenid(e), 
PlatHelper.getPlat() && PlatHelper.getPlat().uma && checkFunc(PlatHelper.getPlat().uma.setOpenid) && PlatHelper.getPlat().uma.setOpenid(e);
}
}, {
key: "_enable",
value: function(e) {
"ald" === e ? PlatHelper.getPlat() && (PlatHelper.getPlat().aldSendEvent || (PlatHelper.isQQPlatform() ? ald_qq.init() : PlatHelper.isWXPlatform() && ald.init()), 
PlatHelper.getPlat().aldSendEvent && this._reportors.push({
type: e,
sender: PlatHelper.getPlat().aldSendEvent
})) : "uma" === e ? PlatHelper.getPlat() && (PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.trackEvent || PlatHelper.isWXPlatform() && uma_wx.init(), 
PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.trackEvent && this._reportors.push({
type: e,
sender: PlatHelper.getPlat().uma.trackEvent
})) : "hl" === e ? PlatHelper.getPlat() && (PlatHelper.getPlat().h_SendEvent || hl.init(), 
PlatHelper.getPlat().h_SendEvent && this._reportors.push({
type: e,
sender: PlatHelper.getPlat().h_SendEvent
})) : "wx" === e && PlatHelper.getPlat() && PlatHelper.getPlat().reportEvent && this._reportors.push({
plat: e,
sender: PlatHelper.getPlat().reportEvent
});
}
}, {
key: "report",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
checkString(e) && (!t || isObject$1(t) ? (t || (t = void 0), this._doReport(e, t)) : console.error("A Valid Param Must Be A Type Of Json Object."));
}
}, {
key: "postBackToTT",
value: function(e) {
var t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "1.0.0";
if (!t || !PlatHelper.getStorage("KeyOfTT_eventType_" + e)) {
var o = PlatHelper.getLaunchOptions(), i = o && o.query && void 0 !== o.query.clue_token ? o.query.clue_token : PlatHelper.getStorage("KeyOfTT_clue_token");
i && (console.log("PostBackToTT: eventType:".concat(e, ", sdkVersion:").concat(n, ", token:").concat(i, ", openID:").concat(HLSDKLocalData$1._openID)), 
PlatHelper.setStorage("KeyOfTT_clue_token", i), PlatHelper.setStorage("KeyOfTT_eventType_" + e, 1), 
this.report("TTPostBack", {
clue_token: i,
open_id: HLSDKLocalData$1._openID,
eventType: e.toString(),
sdkVer: n
}));
}
}
}, {
key: "beginLevel",
value: function(e) {
this._doReport("level", {
level_id: e,
type: 0
});
}
}, {
key: "endLevel",
value: function(e) {
this._doReport("level", {
level_id: e,
type: 1
});
}
}, {
key: "failLevel",
value: function(e) {
this._doReport("level", {
level_id: e,
type: 2
});
}
}, {
key: "_doReport",
value: function(e, t) {
for (var n = 0; n < this._reportors.length; n++) {
var o = this._reportors[n];
"function" == typeof o.sender && o.sender(e, t);
}
console.log(formatString("Report Event {0} Succ!", e));
}
} ]);
return e;
}(), Reportor$1 = new _Reportor(), C_SCHEDULE_REPEAT_FOREVER = 1561963389461, _Scheduler = function() {
function e() {
_classCallCheck2(this, e);
this._scheduledInfos = {};
}
_createClass2(e, [ {
key: "schedule",
value: function(e, t) {
var n = this, o = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
if (!checkString(e) || !checkFunc(t)) return !1;
if (this._scheduledInfos[e]) return !1;
isCocosEngine() && (o = !1), null === i && (i = 0), null === a && (a = C_SCHEDULE_REPEAT_FOREVER);
var r = 0 === a ? t : function(t) {
var o = n._scheduledInfos[e];
if (o) if (o.invokeTimes += 1, o.invokeTimes >= a) {
var i = o.cb;
n.unschedule(e), i();
} else o.cb(t);
};
return 0 !== a && (this._scheduledInfos[e] = {
invokeTimes: 0,
scheduleCb: r,
cb: t
}), isCocosEngine() ? (cc.director.getScheduler().enableForTarget(this), cc.director.getScheduler().schedule(r, this, i / 1e3, a, 0, !1)) : isLayaEngine() ? 0 === a ? o ? Laya.timer.frameOnce(i, this, r) : Laya.timer.once(i, this, r) : o ? Laya.timer.frameLoop(i, this, r) : Laya.timer.loop(i, this, r) : 0 === a ? "function" == typeof setTimeout && setTimeout(r, i) : "function" == typeof setInterval && (0 === i && (i = 1e3 / 60), 
this._scheduledInfos[e].timerID = setInterval(r, i)), !0;
}
}, {
key: "unschedule",
value: function(e) {
return !!checkString(e) && !!this._scheduledInfos[e] && (isCocosEngine() ? cc.director.getScheduler().unschedule(this._scheduledInfos[e].scheduleCb, this) : isLayaEngine() ? Laya.timer.clear(this, this._scheduledInfos[e].scheduleCb) : "function" == typeof clearInterval && clearInterval(this._scheduledInfos[e].timerID), 
delete this._scheduledInfos[e], !0);
}
}, {
key: "isScheduled",
value: function(e) {
return !!checkString(e) && !!this._scheduledInfos[e];
}
}, {
key: "unscheduleAll",
value: function() {
for (var e in this._scheduledInfos) isCocosEngine() ? cc.director.getScheduler().unschedule(this._scheduledInfos[e].scheduleCb, this) : isLayaEngine() ? Laya.timer.clear(this, this._scheduledInfos[e].scheduleCb) : "function" == typeof clearInterval && clearInterval(this._scheduledInfos[e].timerID);
this._scheduledInfos = {};
}
} ]);
return e;
}(), Scheduler = new _Scheduler(), PlatBaseHelper = function() {
function e() {
_classCallCheck2(this, e);
this._plat = null, this._platType = "None", this._platDesc = "未定义", this._sysInfo = null, 
this._recogniseSceneIDs = [], this._isModalOnShow = !1, this._isToastOnShow = !1, 
this._isLoadingOnShow = !1, this._hideAppTime = 0, this._channelID = null;
}
_createClass2(e, [ {
key: "_checkLaunchOptions",
value: function(e, t) {
for (var n = !1, o = 0; o < this._recogniseSceneIDs.length; ++o) for (var i = this._recogniseSceneIDs[o], a = 0; a < i.sceneIDs.length; ++a) if (e === i.sceneIDs[a]) {
n = !0, Event.dispatchEvent(i.eventName, t);
break;
}
Event.dispatchEvent(EventName.EN_LAUNCH_APP_FROM_EVERYWHERE, e, t), n || Event.dispatchEvent(EventName.EN_LAUNCH_APP_FROM_UNKNOW, e, t);
}
}, {
key: "init",
value: function() {
var e = this;
if (console.log("当前平台为：" + this.getPlatDesc()), this._plat) {
var t = this.getLaunchOptions();
t && t.scene && t.query && this._checkLaunchOptions(t.scene, t.query), this._plat.onShow && this._plat.onShow(function(t) {
HLSDKLocalData$1._isInited && ServerInfo.reLoad(function() {
0 !== e._hideAppTime ? (Event.dispatchEvent(EventName.EN_APP_ONSHOW, ServerInfo.getServerTime() - e._hideAppTime), 
e._hideAppTime = 0) : Event.dispatchEvent(EventName.EN_APP_ONSHOW), e._checkLaunchOptions(t.scene, t.query);
});
}), this._plat.onHide && this._plat.onHide(function() {
e._hideAppTime = ServerInfo.getServerTime(), Event.dispatchEvent(EventName.EN_APP_ONHIDE);
}), this._plat.onMemoryWarning && this._plat.onMemoryWarning(function() {
console.warn("On Memory Warning Received..."), Reportor$1.report(ReportEventName.REN_RECEIVED_MEMORY_WARNING);
});
}
}
}, {
key: "getPlat",
value: function() {
return this._plat;
}
}, {
key: "getPlatType",
value: function() {
return this._platType;
}
}, {
key: "getPlatDesc",
value: function() {
return this._platDesc;
}
}, {
key: "restartApp",
value: function() {
this.exitApp();
}
}, {
key: "exitApp",
value: function() {
this._plat && this._plat.exitMiniProgram && this._plat.exitMiniProgram({
fail: function() {
Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
}
});
}
}, {
key: "getLaunchOptions",
value: function() {
return this._plat && this._plat.getLaunchOptionsSync ? this._plat.getLaunchOptionsSync() : null;
}
}, {
key: "getLaunchScene",
value: function() {
var e = this.getLaunchOptions();
return e && e.scene ? e.scene.toString() : "";
}
}, {
key: "getChannelID",
value: function() {
if (null === this._channelID) {
this._channelID = "";
var e = this.getLaunchOptions();
if (e) for (var t in e.query || {}) if ("chid" === t) {
this._channelID = e.query[t].toString();
break;
}
}
return this._channelID;
}
}, {
key: "isSupportVibratePhone",
value: function() {
return !0;
}
}, {
key: "vibratePhone",
value: function(e) {
HLSDKLocalData$1._settings._isMuteEnabled || RETURN, e ? this._plat && this._plat.vibrateLong && this._plat.vibrateLong() : this._plat && this._plat.vibrateShort && this._plat.vibrateShort();
}
}, {
key: "installShortcut",
value: function() {}
}, {
key: "showMoreGamesModal",
value: function() {}
}, {
key: "startRecord",
value: function() {}
}, {
key: "pauseRecord",
value: function() {}
}, {
key: "resumeRecord",
value: function() {}
}, {
key: "stopRecord",
value: function() {}
}, {
key: "getSavedVideoPath",
value: function() {
return "";
}
}, {
key: "showModal",
value: function(e, t, n, o, i) {
if (!this._isModalOnShow) if (this._plat && this._plat.showModal && checkString(t)) {
var a = {
content: t,
showCancel: n,
success: function(e) {
this._isModalOnShow = !1, "function" == typeof o && ("boolean" == typeof e ? o(e) : e.confirm ? o(!0) : (e.cancel, 
o(!1)));
}.bind(this)
};
checkString(e) && (a.title = e), i && (i.cancelText && (a.cancelText = i.cancelText), 
i.cancelColor && (a.cancelColor = i.cancelColor), i.confirmText && (a.confirmText = i.confirmText), 
i.confirmColor && (a.confirmColor = i.confirmColor)), this._isModalOnShow = !0, 
this._plat.showModal(a);
} else "function" == typeof o && o(!1);
}
}, {
key: "showToast",
value: function(e, t) {
if (this._clearToastAndLoading(), this._plat && this._plat.showToast && checkString(e)) {
var n = {
title: e,
duration: 2e3,
success: function() {
this._isToastOnShow = !0, Scheduler.schedule("Auto_Reset_Toast_State", function() {
this._isToastOnShow = !1;
}.bind(this), !1, 2e3, 0);
}.bind(this)
};
n.icon = t || "none", this._plat.showToast(n);
}
}
}, {
key: "hideToast",
value: function() {
this._isToastOnShow && (this._isToastOnShow = !1, this._plat && this._plat.hideToast && this._plat.hideToast());
}
}, {
key: "showRandomToast",
value: function(e) {
if (e) {
var t = random(0, e.length - 1);
this.showToast(e[t]);
}
}
}, {
key: "showLoading",
value: function(e) {
if (this._clearToastAndLoading(), this._plat && this._plat.showLoading) {
var t = {
title: e,
mask: !0
};
this._isLoadingOnShow = !0, this._plat.showLoading(t);
} else console.log("show loading: " + e);
}
}, {
key: "hideLoading",
value: function() {
this._isLoadingOnShow && (this._isLoadingOnShow = !1, this._plat && this._plat.hideLoading && this._plat.hideLoading());
}
}, {
key: "_clearToastAndLoading",
value: function() {
this.hideToast(), this.hideLoading();
}
}, {
key: "getSysInfo",
value: function() {
if (null === this._sysInfo) if (this._plat && this._plat.getSystemInfoSync) try {
this._sysInfo = this._plat.getSystemInfoSync();
} catch (e) {
Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
} else this._sysInfo = {
screenHeight: Math.round(cc.winSize.height),
screenWidth: Math.round(cc.winSize.width),
windowHeight: Math.round(cc.winSize.height),
windowWidth: Math.round(cc.winSize.width),
statusBarHeight: 0,
brand: "microsoft",
platform: "window",
system: "Window 7",
SDKVersion: "0.0.0"
};
return this._sysInfo;
}
}, {
key: "getSDKVersion",
value: function() {
var e = this.getSysInfo();
return e && void 0 !== e.SDKVersion ? e.SDKVersion : "0.0.0";
}
}, {
key: "isIPhoneX",
value: function() {
var e = this.getSysInfo();
if (e) {
if (e.model && (-1 !== e.model.indexOf("iPhone X") || -1 !== e.model.indexOf("iPhone 11") || -1 !== e.model.indexOf("iPhone 12"))) return !0;
if (this.isIOSPlatform() && e.screenHeight / e.screenWidth > 2) return !0;
}
return !1;
}
}, {
key: "setStorage",
value: function(e, t) {
if (checkString(e)) {
if (isLayaEngine()) Laya.LocalStorage.setItem(e, t); else if (isCocosEngine()) cc.sys.localStorage.setItem(e, t); else if (platHelper.getPlat()) try {
platHelper.getPlat().setStorageSync(e, t);
} catch (e) {
console.error("PlatHelper.setStorage Fail, No Support This Engine Or No Support This Kind Of Data: ", t);
}
} else console.error("PlatHelper.setStorage Fail, Check Input...");
}
}, {
key: "getStorage",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
if (checkString(e)) {
var n = null;
if (isLayaEngine()) n = Laya.LocalStorage.getItem(e); else if (isCocosEngine()) n = cc.sys.localStorage.getItem(e); else if (this._plat) try {
n = this._plat.getStorageSync(e);
} catch (e) {
console.error("PlatHelper.getStorage Fail, No Support This Engine...");
}
return null !== n && "" !== n || null === t ? n : t;
}
console.error("PlatHelper.getStorage Fail, Check Input...");
}
}, {
key: "clearStorage",
value: function(e) {
if (checkString(e)) {
if (isLayaEngine()) Laya.LocalStorage.removeItem(e); else if (isCocosEngine()) cc.sys.localStorage.removeItem(e); else if (this._plat) try {
this._plat.removeStorageSync(e);
} catch (e) {
console.error("PlatHelper.clearStorage Fail, No Support This Engine...");
}
} else console.error("PlatHelper.clearStorage Fail, Check Input...");
}
}, {
key: "canLoginOnline",
value: function() {
return !1;
}
}, {
key: "canSaveOnline",
value: function() {
return !1;
}
}, {
key: "isWINPlatform",
value: function() {
return null === this._plat && _isWINPlatform();
}
}, {
key: "isWXPlatform",
value: function() {
return _isWXPlatform();
}
}, {
key: "isQQPlatform",
value: function() {
return _isQQPlatform();
}
}, {
key: "isTTPlatform",
value: function() {
return _isTTPlatform();
}
}, {
key: "isOPPOPlatform",
value: function() {
return _isOPPOPlatform();
}
}, {
key: "isVIVOPlatform",
value: function() {
return _isVIVOPlatform();
}
}, {
key: "isQGPlatform",
value: function() {
return _isQGPlatform();
}
}, {
key: "isAndroidPlatform",
value: function() {
return _isAndroidPlatform();
}
}, {
key: "isIOSPlatform",
value: function() {
return _isIOSPlatform();
}
} ]);
return e;
}(), ExtPlatHelper = function() {
_inherits2(t, PlatBaseHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._isUseLocalModal = !1, n._isUseLocalToast = !1, n._isUseLocalLoading = !1;
return n;
}
_createClass2(t, [ {
key: "init",
value: function() {
_get2(_getPrototypeOf2(t.prototype), "init", this).call(this), this._isUseLocalModal && (t.prototype.showModal = function(e, t, n, o, i) {
var a = this;
if (!this._isModalOnShow) if (checkString(t)) {
var r = {
content: t,
showCancel: n,
cb: function(e) {
a._isModalOnShow = !1, "function" == typeof o && o(e);
}
};
checkString(e) && (r.title = e), i && (i.cancelText && (r.cancelText = i.cancelText), 
i.cancelColor && (r.cancelColor = i.cancelColor), i.confirmText && (r.confirmText = i.confirmText), 
i.confirmColor && (r.confirmColor = i.confirmColor)), Event.dispatchEvent(EventName.EN_SHOW_CUSTOM_MODAL, r);
} else "function" == typeof o && o(!1);
}), this._isUseLocalToast && (t.prototype.showToast = function(e) {
this._clearToastAndLoading(), console.log("show toast: " + e), Event.dispatchEvent(EventName.EN_SHOW_CUSTOM_TIPS, e);
}, t.prototype.hideToast = function() {
Event.dispatchEvent(EventName.EN_HIDE_CUSTOM_TIPS);
}), this._isUseLocalLoading && (t.prototype.showLoading = function(e) {
this._clearToastAndLoading(), console.log("show loading: " + e), Event.dispatchEvent(EventName.EN_SHOW_CUSTOM_LOADING, e);
}, t.prototype.hideLoading = function() {
Event.dispatchEvent(EventName.EN_HIDE_CUSTOM_LOADING);
});
}
} ]);
return t;
}(), WINPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._platType = "WIN", n._platDesc = "Windows小游戏平台", n._isUseLocalModal = !0, 
n._isUseLocalToast = !0, n._isUseLocalLoading = !0;
return n;
}
_createClass2(t, [ {
key: "canLoginOnline",
value: function() {
return !1;
}
}, {
key: "canSaveOnline",
value: function() {
return !1;
}
}, {
key: "isSupportVibratePhone",
value: function() {
return !1;
}
} ]);
return t;
}(), WXPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._plat = window.wx, n._platType = "WX", n._platDesc = "微信小游戏平台", 
n._recogniseSceneIDs.push({
sceneIDs: [ 1007 ],
eventName: EventName.EN_LAUNCH_APP_FROM_SINGLE_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1008 ],
eventName: EventName.EN_LAUNCH_APP_FROM_GROUP_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1007, 1008 ],
eventName: EventName.EN_LAUNCH_APP_FROM_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1089 ],
eventName: EventName.EN_LAUNCH_APP_FROM_RECENT
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1038 ],
eventName: EventName.EN_LAUNCH_APP_BACK_FROM_OTHER_APP
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1104 ],
eventName: EventName.EN_LAUNCH_APP_FROM_FAVOURITE
});
return n;
}
_createClass2(t, [ {
key: "canLoginOnline",
value: function() {
return !0;
}
}, {
key: "canSaveOnline",
value: function() {
return !0;
}
} ]);
return t;
}(), QQPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._plat = window.qq, n._platType = "QQ", n._platDesc = "QQ小游戏平台", 
n._recogniseSceneIDs.push({
sceneIDs: [ 1007 ],
eventName: EventName.EN_LAUNCH_APP_FROM_SINGLE_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1008 ],
eventName: EventName.EN_LAUNCH_APP_FROM_GROUP_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1007, 1008 ],
eventName: EventName.EN_LAUNCH_APP_FROM_SHARE
}), n._recogniseSceneIDs.push({
sceneIDs: [ 1038 ],
eventName: EventName.EN_LAUNCH_APP_BACK_FROM_OTHER_APP
});
return n;
}
_createClass2(t, [ {
key: "canLoginOnline",
value: function() {
return !0;
}
}, {
key: "canSaveOnline",
value: function() {
return !0;
}
} ]);
return t;
}(), OPPOPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._plat = window.qg, n._platType = "OPPO", n._platDesc = "OPPO小游戏平台", 
n._isUseLocalToast = !0;
return n;
}
_createClass2(t, [ {
key: "exitApp",
value: function() {
this._plat && this._plat.exitApplication && this._plat.exitApplication({
fail: function() {
Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
}
});
}
}, {
key: "getSDKVersion",
value: function() {
var e = this.getSysInfo();
return e && void 0 !== e.platformVersion ? e.platformVersion.toString() : "0";
}
}, {
key: "canLoginOnline",
value: function() {
return !1;
}
}, {
key: "canSaveOnline",
value: function() {
return !1;
}
}, {
key: "vibratePhone",
value: function(e) {
e ? this._plat && this._plat.vibrateLong && this._plat.vibrateLong({
success: null,
fail: null,
complete: null
}) : this._plat && this._plat.vibrateShort && this._plat.vibrateShort({});
}
}, {
key: "hideLoading",
value: function() {
this._isLoadingOnShow && (this._isLoadingOnShow = !1, this._plat && this._plat.hideLoading && this._plat.hideLoading({
success: null,
fail: null,
complete: null
}));
}
}, {
key: "installShortcut",
value: function(e) {
var t = this;
this._plat.hasShortcutInstalled({
success: function(n) {
0 == n && t._plat.installShortcut({
success: function() {
"function" == typeof e && e();
}
});
}
});
}
} ]);
return t;
}(), VIVOPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._plat = window.qg, n._platType = "VIVO", n._platDesc = "VIVO小游戏平台", 
n._isUseLocalToast = !0;
return n;
}
_createClass2(t, [ {
key: "exitApp",
value: function() {
this._plat && this._plat.exitApplication && this._plat.exitApplication();
}
}, {
key: "getSDKVersion",
value: function() {
var e = this.getSysInfo();
return e && void 0 !== e.platformVersion ? e.platformVersion.toString() : "0";
}
}, {
key: "canLoginOnline",
value: function() {
return !1;
}
}, {
key: "canSaveOnline",
value: function() {
return !1;
}
}, {
key: "showModal",
value: function(e, t, n, o, i) {
var a = this;
if (!this._isModalOnShow) if (this._plat && this._plat.showDialog && checkString(t)) {
var r = {
message: t,
buttons: [ {
text: "确认"
} ],
success: function(e) {
a._isModalOnShow = !1, "function" == typeof o && (0 === e.index ? o(!0) : 1 === e.index && o(!1));
},
cancel: function() {
a._isModalOnShow = !1, "function" == typeof o && o(!1);
},
fail: function() {
a._isModalOnShow = !1, "function" == typeof o && o(!1);
}
};
n && r.buttons.push({
text: "取消"
}), i && (checkString(e) && (r.title = e), i.confirmText && (r.buttons[0].text = i.confirmText), 
i.confirmColor && (r.buttons[0].color = i.confirmColor), n && (i.cancelText && (r.buttons[1].text = i.cancelText), 
i.cancelColor && (r.buttons[1].color = i.cancelColor))), this._isModalOnShow = !0, 
this._plat.showDialog(r);
} else "function" == typeof o && o(!1);
}
}, {
key: "installShortcut",
value: function(e) {
var t = this;
this._plat.hasShortcutInstalled({
success: function(n) {
0 == n && t._plat.installShortcut({
success: function() {
"function" == typeof e && e();
}
});
}
});
}
} ]);
return t;
}(), TTPlatHelper = function() {
_inherits2(t, ExtPlatHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._plat = window.tt, n._platType = "TT", n._platDesc = "TT小游戏平台", 
n._onNavigateSuccCb = null, n._onNavigateFailCb = null, n._onMoreGamesModalCloseCb = null, 
n._videoRecorder = null, n._shareVideoPath = "", n._isUseLocalToast = !0;
return n;
}
_createClass2(t, [ {
key: "init",
value: function() {
var e = this;
_get2(_getPrototypeOf2(t.prototype), "init", this).call(this), this._plat && this._plat.onNavigateToMiniProgram && this._plat.onNavigateToMiniProgram(function(t) {
0 === t.errCode || 1 === t.errCode ? (console.log("跳转成功", t), Reportor.report(ReportEventName.REN_NAVIGATE_SUCC_ON_TT_PLAT), 
"function" == typeof e._onNavigateSuccCb && e._onNavigateSuccCb()) : (console.error("跳转失败", t), 
"function" == typeof e._onNavigateFailCb && e._onNavigateFailCb());
}), this._plat && this._plat.onMoreGamesModalClose && this._plat.onMoreGamesModalClose(function() {
e._onNavigateSuccCb = null, e._onNavigateFailCb = null;
var t = e._onMoreGamesModalCloseCb;
e._onMoreGamesModalCloseCb = null, "function" == typeof t && t();
});
}
}, {
key: "exitApp",
value: function() {
this._plat && this._plat.exitApplication && this._plat.exitApplication();
}
}, {
key: "canLoginOnline",
value: function() {
return !1;
}
}, {
key: "canSaveOnline",
value: function() {
return !1;
}
}, {
key: "showMoreGamesModal",
value: function(e, t, n) {
"ios" !== this.getSysInfo().platform ? this._plat.showMoreGamesModal && (this._plat.showMoreGamesModal({
appLaunchOptions: []
}), this._onNavigateSuccCb = t, this._onNavigateFailCb = n, this._onMoreGamesModalCloseCb = e) : this.showToast(G_GameDB.getUIWordByID(UIWordIDs.UIWORD_ID_NOT_SUPPORT_ON_IOS_PLATFORM).word);
}
}, {
key: "startRecord",
value: function() {
var e = this;
this._videoRecorder || (this._videoRecorder = this._plat.getGameRecorderManager(), 
this._videoRecorder.onStart(function() {
console.log("start record and clear succ..."), e._shareVideoPath = "";
}), this._videoRecorder.onStop(function(t) {
console.log("stop record and save succ..."), e._videoRecorder.clipVideo({
path: t.videoPath,
timeRange: [ 25, 0 ],
success: function(t) {
e._shareVideoPath = t.videoPath;
},
fail: function(e) {
console.error("clip video fail: ", e);
}
});
})), this._videoRecorder && this._videoRecorder.start({
duration: 60
});
}
}, {
key: "pauseRecord",
value: function() {
this._videoRecorder && this._videoRecorder.pause();
}
}, {
key: "resumeRecord",
value: function() {
this._videoRecorder && this._videoRecorder.resume();
}
}, {
key: "stopRecord",
value: function() {
this._videoRecorder && this._videoRecorder.stop();
}
}, {
key: "getSavedVideoPath",
value: function() {
return this._shareVideoPath;
}
} ]);
return t;
}(), _PlatHelper = PlatBaseHelper, PlatHelper = new (_PlatHelper = _isQQPlatform() ? QQPlatHelper : _isTTPlatform() ? TTPlatHelper : _isOPPOPlatform() ? OPPOPlatHelper : _isVIVOPlatform() ? VIVOPlatHelper : _isWXPlatform() ? WXPlatHelper : WINPlatHelper)(), TIMEOUT_OF_HTTPS_REQUEST = 1e4, _HttpsHelper = function() {
function e() {
_classCallCheck2(this, e);
this._getServerTimeFunc = null;
}
_createClass2(e, [ {
key: "registerGetServerTimeFunc",
value: function(e) {
this._getServerTimeFunc = null, checkFunc(e) && (this._getServerTimeFunc = e);
}
}, {
key: "_getServerTime",
value: function() {
return this._getServerTimeFunc ? this._getServerTimeFunc() : Date.now();
}
}, {
key: "getJson",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
this._doJsonRequest("GET", e, t, n, o);
}
}, {
key: "sendJson",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
this._doJsonRequest("POST", e, t, n, o);
}
}, {
key: "sendForm",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
this._doFormRequest("POST", e, t, n, o);
}
}, {
key: "_doJsonRequest",
value: function(e, t, n, o, i) {
var a = this._createRequest(e, t, i);
try {
if (a.setRequestHeader("content-type", "application/json"), isObject$1(n)) for (var r in n) a.setRequestHeader(r, n[r]);
o ? a.send(JSON.stringify(o)) : a.send(null);
} catch (e) {
console.error(e), doCallback$1(i, !1, "未知错误，请检查错误输出");
}
}
}, {
key: "_doFormRequest",
value: function(e, t, n, o, i) {
var a = this._createRequest(e, t, i);
try {
if (a.setRequestHeader("content-type", "application/x-www-form-urlencoded"), isObject$1(n)) for (var r in n) a.setRequestHeader(r, n[r]);
if (o) {
var s = null, l = [];
for (var c in o) l.push(encodeURIComponent(c) + "=" + encodeURIComponent(o[c]));
l.length > 0 && (s = l.join("&").replace(/%20/g, "+")), a.send(s);
} else a.send(null);
} catch (e) {
console.error(e), doCallback$1(i, !1, "未知错误，请检查错误输出");
}
}
}, {
key: "_createRequest",
value: function(e, t, n) {
return this._createBaseRequest(e, t, function(e, t) {
e && t ? "json" === t ? doCallback$1(n, !0, JSON.parse(e)) : doCallback$1(n, !1, "返回数据格式错误") : doCallback$1(n, !1, "未知错误，请检查错误输出");
});
}
}, {
key: "_createBaseRequest",
value: function(e, t, n) {
if ("GET" !== e && "POST" !== e) return console.error("Https Err: Only Support GET or POST Way of Request, Way: ", e), 
null;
if (!checkString(t)) return console.error("Https Err: url Is Not Right, Url: ", t), 
null;
var o = null;
return isLayaEngine() ? o = new Laya.HttpRequest()._http : isCocosEngine() && (o = new XMLHttpRequest()), 
o && (t = -1 == t.indexOf("?") ? formatString("{0}?timestamp={1}", t, Math.round(this._getServerTime() / 1e3).toString()) : t + "&timestamp=" + Math.round(this._getServerTime() / 1e3).toString(), 
o.open(e, t, !0), console.log("req url:", t), o.onload = function() {
if (checkFunc(n)) if (4 === o.readyState) if (o.status >= 200 && o.status < 300) if ("application/json" === o.getResponseHeader("content-type")) n(o.responseText, "json"); else {
var e = !1;
try {
JSON.parse(o.responseText), e = !0;
} catch (e) {
console.error(e);
}
n(o.responseText, e ? "json" : "text");
} else n(); else n();
}, o.timeout = TIMEOUT_OF_HTTPS_REQUEST, o.ontimeout = function(e) {
console.error(e), doCallback$1(n);
}, o.onerror = function(e) {
console.error(e), doCallback$1(n);
}), o;
}
} ]);
return e;
}(), HttpsHelper = new _HttpsHelper(), chrsz = 8;

function hex_md5(e) {
return binl2hex(core_md5(str2binl(e), e.length * chrsz));
}

function core_md5(e, t) {
e[t >> 5] |= 128 << t % 32, e[14 + (t + 64 >>> 9 << 4)] = t;
for (var n = 1732584193, o = -271733879, i = -1732584194, a = 271733878, r = 0; r < e.length; r += 16) {
var s = n, l = o, c = i, d = a;
n = md5_ff(n, o, i, a, e[r + 0], 7, -680876936), a = md5_ff(a, n, o, i, e[r + 1], 12, -389564586), 
i = md5_ff(i, a, n, o, e[r + 2], 17, 606105819), o = md5_ff(o, i, a, n, e[r + 3], 22, -1044525330), 
n = md5_ff(n, o, i, a, e[r + 4], 7, -176418897), a = md5_ff(a, n, o, i, e[r + 5], 12, 1200080426), 
i = md5_ff(i, a, n, o, e[r + 6], 17, -1473231341), o = md5_ff(o, i, a, n, e[r + 7], 22, -45705983), 
n = md5_ff(n, o, i, a, e[r + 8], 7, 1770035416), a = md5_ff(a, n, o, i, e[r + 9], 12, -1958414417), 
i = md5_ff(i, a, n, o, e[r + 10], 17, -42063), o = md5_ff(o, i, a, n, e[r + 11], 22, -1990404162), 
n = md5_ff(n, o, i, a, e[r + 12], 7, 1804603682), a = md5_ff(a, n, o, i, e[r + 13], 12, -40341101), 
i = md5_ff(i, a, n, o, e[r + 14], 17, -1502002290), n = md5_gg(n, o = md5_ff(o, i, a, n, e[r + 15], 22, 1236535329), i, a, e[r + 1], 5, -165796510), 
a = md5_gg(a, n, o, i, e[r + 6], 9, -1069501632), i = md5_gg(i, a, n, o, e[r + 11], 14, 643717713), 
o = md5_gg(o, i, a, n, e[r + 0], 20, -373897302), n = md5_gg(n, o, i, a, e[r + 5], 5, -701558691), 
a = md5_gg(a, n, o, i, e[r + 10], 9, 38016083), i = md5_gg(i, a, n, o, e[r + 15], 14, -660478335), 
o = md5_gg(o, i, a, n, e[r + 4], 20, -405537848), n = md5_gg(n, o, i, a, e[r + 9], 5, 568446438), 
a = md5_gg(a, n, o, i, e[r + 14], 9, -1019803690), i = md5_gg(i, a, n, o, e[r + 3], 14, -187363961), 
o = md5_gg(o, i, a, n, e[r + 8], 20, 1163531501), n = md5_gg(n, o, i, a, e[r + 13], 5, -1444681467), 
a = md5_gg(a, n, o, i, e[r + 2], 9, -51403784), i = md5_gg(i, a, n, o, e[r + 7], 14, 1735328473), 
n = md5_hh(n, o = md5_gg(o, i, a, n, e[r + 12], 20, -1926607734), i, a, e[r + 5], 4, -378558), 
a = md5_hh(a, n, o, i, e[r + 8], 11, -2022574463), i = md5_hh(i, a, n, o, e[r + 11], 16, 1839030562), 
o = md5_hh(o, i, a, n, e[r + 14], 23, -35309556), n = md5_hh(n, o, i, a, e[r + 1], 4, -1530992060), 
a = md5_hh(a, n, o, i, e[r + 4], 11, 1272893353), i = md5_hh(i, a, n, o, e[r + 7], 16, -155497632), 
o = md5_hh(o, i, a, n, e[r + 10], 23, -1094730640), n = md5_hh(n, o, i, a, e[r + 13], 4, 681279174), 
a = md5_hh(a, n, o, i, e[r + 0], 11, -358537222), i = md5_hh(i, a, n, o, e[r + 3], 16, -722521979), 
o = md5_hh(o, i, a, n, e[r + 6], 23, 76029189), n = md5_hh(n, o, i, a, e[r + 9], 4, -640364487), 
a = md5_hh(a, n, o, i, e[r + 12], 11, -421815835), i = md5_hh(i, a, n, o, e[r + 15], 16, 530742520), 
n = md5_ii(n, o = md5_hh(o, i, a, n, e[r + 2], 23, -995338651), i, a, e[r + 0], 6, -198630844), 
a = md5_ii(a, n, o, i, e[r + 7], 10, 1126891415), i = md5_ii(i, a, n, o, e[r + 14], 15, -1416354905), 
o = md5_ii(o, i, a, n, e[r + 5], 21, -57434055), n = md5_ii(n, o, i, a, e[r + 12], 6, 1700485571), 
a = md5_ii(a, n, o, i, e[r + 3], 10, -1894986606), i = md5_ii(i, a, n, o, e[r + 10], 15, -1051523), 
o = md5_ii(o, i, a, n, e[r + 1], 21, -2054922799), n = md5_ii(n, o, i, a, e[r + 8], 6, 1873313359), 
a = md5_ii(a, n, o, i, e[r + 15], 10, -30611744), i = md5_ii(i, a, n, o, e[r + 6], 15, -1560198380), 
o = md5_ii(o, i, a, n, e[r + 13], 21, 1309151649), n = md5_ii(n, o, i, a, e[r + 4], 6, -145523070), 
a = md5_ii(a, n, o, i, e[r + 11], 10, -1120210379), i = md5_ii(i, a, n, o, e[r + 2], 15, 718787259), 
o = md5_ii(o, i, a, n, e[r + 9], 21, -343485551), n = safe_add(n, s), o = safe_add(o, l), 
i = safe_add(i, c), a = safe_add(a, d);
}
return Array(n, o, i, a);
}

function md5_cmn(e, t, n, o, i, a) {
return safe_add(bit_rol(safe_add(safe_add(t, e), safe_add(o, a)), i), n);
}

function md5_ff(e, t, n, o, i, a, r) {
return md5_cmn(t & n | ~t & o, e, t, i, a, r);
}

function md5_gg(e, t, n, o, i, a, r) {
return md5_cmn(t & o | n & ~o, e, t, i, a, r);
}

function md5_hh(e, t, n, o, i, a, r) {
return md5_cmn(t ^ n ^ o, e, t, i, a, r);
}

function md5_ii(e, t, n, o, i, a, r) {
return md5_cmn(n ^ (t | ~o), e, t, i, a, r);
}

function safe_add(e, t) {
var n = (65535 & e) + (65535 & t);
return (e >> 16) + (t >> 16) + (n >> 16) << 16 | 65535 & n;
}

function bit_rol(e, t) {
return e << t | e >>> 32 - t;
}

function str2binl(e) {
for (var t = Array(), n = (1 << chrsz) - 1, o = 0; o < e.length * chrsz; o += chrsz) t[o >> 5] |= (e.charCodeAt(o / chrsz) & n) << o % 32;
return t;
}

function binl2hex(e) {
for (var t = "", n = 0; n < 4 * e.length; n++) t += "0123456789abcdef".charAt(e[n >> 2] >> n % 4 * 8 + 4 & 15) + "0123456789abcdef".charAt(e[n >> 2] >> n % 4 * 8 & 15);
return t;
}

var LZString = function() {
var e = String.fromCharCode, t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", n = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-$", o = {};
function i(e, t) {
if (!o[e]) {
o[e] = {};
for (var n = 0; n < e.length; n++) o[e][e.charAt(n)] = n;
}
return o[e][t];
}
var a = {
compressToBase64: function(e) {
if (null == e) return "";
var n = a._compress(e, 6, function(e) {
return t.charAt(e);
});
switch (n.length % 4) {
default:
case 0:
return n;

case 1:
return n + "===";

case 2:
return n + "==";

case 3:
return n + "=";
}
},
decompressFromBase64: function(e) {
return null == e ? "" : "" == e ? null : a._decompress(e.length, 32, function(n) {
return i(t, e.charAt(n));
});
},
compressToUTF16: function(t) {
return null == t ? "" : a._compress(t, 15, function(t) {
return e(t + 32);
}) + " ";
},
decompressFromUTF16: function(e) {
return null == e ? "" : "" == e ? null : a._decompress(e.length, 16384, function(t) {
return e.charCodeAt(t) - 32;
});
},
compressToUint8Array: function(e) {
for (var t = a.compress(e), n = new Uint8Array(2 * t.length), o = 0, i = t.length; o < i; o++) {
var r = t.charCodeAt(o);
n[2 * o] = r >>> 8, n[2 * o + 1] = r % 256;
}
return n;
},
decompressFromUint8Array: function(t) {
if (null == t) return a.decompress(t);
for (var n = new Array(t.length / 2), o = 0, i = n.length; o < i; o++) n[o] = 256 * t[2 * o] + t[2 * o + 1];
var r = [];
return n.forEach(function(t) {
r.push(e(t));
}), a.decompress(r.join(""));
},
compressToEncodedURIComponent: function(e) {
return null == e ? "" : a._compress(e, 6, function(e) {
return n.charAt(e);
});
},
decompressFromEncodedURIComponent: function(e) {
return null == e ? "" : "" == e ? null : (e = e.replace(/ /g, "+"), a._decompress(e.length, 32, function(t) {
return i(n, e.charAt(t));
}));
},
compress: function(t) {
return a._compress(t, 16, function(t) {
return e(t);
});
},
_compress: function(e, t, n) {
if (null == e) return "";
var o, i, a, r = {}, s = {}, l = "", c = "", d = "", h = 2, u = 3, f = 2, _ = [], p = 0, g = 0;
for (a = 0; a < e.length; a += 1) if (l = e.charAt(a), Object.prototype.hasOwnProperty.call(r, l) || (r[l] = u++, 
s[l] = !0), c = d + l, Object.prototype.hasOwnProperty.call(r, c)) d = c; else {
if (Object.prototype.hasOwnProperty.call(s, d)) {
if (d.charCodeAt(0) < 256) {
for (o = 0; o < f; o++) p <<= 1, g == t - 1 ? (g = 0, _.push(n(p)), p = 0) : g++;
for (i = d.charCodeAt(0), o = 0; o < 8; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
} else {
for (i = 1, o = 0; o < f; o++) p = p << 1 | i, g == t - 1 ? (g = 0, _.push(n(p)), 
p = 0) : g++, i = 0;
for (i = d.charCodeAt(0), o = 0; o < 16; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
}
0 == --h && (h = Math.pow(2, f), f++), delete s[d];
} else for (i = r[d], o = 0; o < f; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
0 == --h && (h = Math.pow(2, f), f++), r[c] = u++, d = String(l);
}
if ("" !== d) {
if (Object.prototype.hasOwnProperty.call(s, d)) {
if (d.charCodeAt(0) < 256) {
for (o = 0; o < f; o++) p <<= 1, g == t - 1 ? (g = 0, _.push(n(p)), p = 0) : g++;
for (i = d.charCodeAt(0), o = 0; o < 8; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
} else {
for (i = 1, o = 0; o < f; o++) p = p << 1 | i, g == t - 1 ? (g = 0, _.push(n(p)), 
p = 0) : g++, i = 0;
for (i = d.charCodeAt(0), o = 0; o < 16; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
}
0 == --h && (h = Math.pow(2, f), f++), delete s[d];
} else for (i = r[d], o = 0; o < f; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, 
_.push(n(p)), p = 0) : g++, i >>= 1;
0 == --h && (h = Math.pow(2, f), f++);
}
for (i = 2, o = 0; o < f; o++) p = p << 1 | 1 & i, g == t - 1 ? (g = 0, _.push(n(p)), 
p = 0) : g++, i >>= 1;
for (;;) {
if (p <<= 1, g == t - 1) {
_.push(n(p));
break;
}
g++;
}
return _.join("");
},
decompress: function(e) {
return null == e ? "" : "" == e ? null : a._decompress(e.length, 32768, function(t) {
return e.charCodeAt(t);
});
},
_decompress: function(t, n, o) {
var i, a, r, s, l, c, d, h = [], u = 4, f = 4, _ = 3, p = "", g = [], v = {
val: o(0),
position: n,
index: 1
};
for (i = 0; i < 3; i += 1) h[i] = i;
for (r = 0, l = Math.pow(2, 2), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
switch (r) {
case 0:
for (r = 0, l = Math.pow(2, 8), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
d = e(r);
break;

case 1:
for (r = 0, l = Math.pow(2, 16), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
d = e(r);
break;

case 2:
return "";
}
for (h[3] = d, a = d, g.push(d); ;) {
if (v.index > t) return "";
for (r = 0, l = Math.pow(2, _), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
switch (d = r) {
case 0:
for (r = 0, l = Math.pow(2, 8), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
h[f++] = e(r), d = f - 1, u--;
break;

case 1:
for (r = 0, l = Math.pow(2, 16), c = 1; c != l; ) s = v.val & v.position, v.position >>= 1, 
0 == v.position && (v.position = n, v.val = o(v.index++)), r |= (s > 0 ? 1 : 0) * c, 
c <<= 1;
h[f++] = e(r), d = f - 1, u--;
break;

case 2:
return g.join("");
}
if (0 == u && (u = Math.pow(2, _), _++), h[d]) p = h[d]; else {
if (d !== f) return null;
p = a + a.charAt(0);
}
g.push(p), h[f++] = a + p.charAt(0), a = p, 0 == --u && (u = Math.pow(2, _), _++);
}
}
};
return a;
}(), MAX_TRY_TIMES = 3, _NetHelper = function() {
function e() {
_classCallCheck2(this, e);
this._baseUrls = {
hlsdk: "https://api.game.hnquyou.com"
}, this._netType = null, this._initedCbs = [];
}
_createClass2(e, [ {
key: "init",
value: function() {
var e = this;
if (PlatHelper.getPlat() && PlatHelper.getPlat().onNetworkStatusChange) {
PlatHelper.getPlat().onNetworkStatusChange(function(t) {
var n = e._netType;
e._netType = t.networkType, t.isConnected || (e._netType = "none"), "none" === e._netType ? Event.dispatchEvent(EventName.EN_NET_CONNECTION_LOST) : "none" === n && Event.dispatchEvent(EventName.EN_NET_CONNECTION_RECOVER);
});
var t = function() {
for (var t = 0; t < e._initedCbs.length; t++) e._initedCbs[t](e._netType);
e._initedCbs = [];
};
PlatHelper.getPlat().getNetworkType && PlatHelper.getPlat().getNetworkType({
success: function(n) {
e._netType = n.networkType, t();
},
fail: function() {
e._netType = "none", t();
}
});
} else this._netType = "wifi";
}
}, {
key: "getNetType",
value: function(e) {
"function" == typeof e && (null !== this._netType ? e(this._netType) : this._initedCbs.push(e));
}
}, {
key: "isConnected",
value: function(e) {
"function" == typeof e && (null !== this._netType ? e("none" !== this._netType) : this._initedCbs.push(function(t) {
e("none" !== t);
}));
}
}, {
key: "_getTag",
value: function() {
return "" === this._tag && (this._tag = "hlsdk"), this._tag;
}
}, {
key: "_makeUrl",
value: function(e, t) {
return void 0 !== this._baseUrls[e] ? this._baseUrls[e] + t : "";
}
}, {
key: "reqGetServerTime",
value: function(e) {
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/time", null, e);
}
}, {
key: "reqLogin",
value: function(e, t) {
var n = {
code: e,
appid: this._getAppID()
};
PlatHelper.isQQPlatform() ? (n.sign = hex_md5("appid=" + this._getAppID() + "&code=" + e + "&path=/sdk/v2/qq/login"), 
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/qq/login", n, t)) : PlatHelper.isTTPlatform() ? (n.sign = hex_md5("appid=" + this._getAppID() + "&code=" + e + "&path=/sdk/v2/tt/login"), 
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/tt/login", n, t)) : (n.sign = hex_md5("appid=" + this._getAppID() + "&code=" + e + "&path=/sdk/v2/wx/login"), 
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/wx/login", n, t));
}
}, {
key: "reqIsEnterRealGame",
value: function(e, t) {
var n = {
appid: this._getAppID(),
time: Math.floor(ServerInfo.getServerTime() / 1e3),
version: e
};
n.sign = hex_md5("appid=" + n.appid + "&path=/sdk/v2/config/quickly&time=" + n.time), 
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/config/quickly", n, function(e) {
if (e && "200" === e.status) try {
e.result = JSON.parse(LZString.decompressFromBase64(e.result));
} catch (t) {
console.error("parse result from /sdk/v2/config/quickly fail: ", t), e = null;
}
doCallback$1(t, e);
});
}
}, {
key: "reqGetAdvList",
value: function(e) {
var t = {
appid: this._getAppID(),
time: Math.floor(ServerInfo.getServerTime() / 1e3)
};
t.sign = hex_md5("appid=" + t.appid + "&path=/sdk/v2/ad&time=" + t.time), this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/ad", t, e);
}
}, {
key: "reqGetWebConfig",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = {
appid: this._getAppID(),
time: Math.floor(ServerInfo.getServerTime() / 1e3),
version: e
};
t && (o.openid = t), o.sign = hex_md5("appid=" + o.appid + "&path=/sdk/v2/config/info&time=" + o.time), 
this._prepareRequest("sendForm", "hlsdk", "/sdk/v2/config/info", o, function(e) {
if (e && "200" === e.status) try {
e.result = JSON.parse(LZString.decompressFromBase64(e.result));
} catch (t) {
console.error("parse result from /sdk/v2/config/info fail: ", t), e = null;
}
doCallback$1(n, e);
});
}
}, {
key: "_prepareRequest",
value: function(e, t, n, o, i) {
var a = this;
this.isConnected(function(r) {
r ? a._doRequest(a._makeObj(e, t, n, o, i)) : "function" == typeof i && i(null);
});
}
}, {
key: "_makeObj",
value: function(e, t, n, o, i) {
return {
way: e,
key: t,
path: n,
data: o,
cb: i,
try_times: 0
};
}
}, {
key: "_doRequest",
value: function(e) {
if (e) {
var t = this, n = function(n, o) {
if (n) {
if ("function" == typeof e.cb) {
var i = e.cb;
e.cb = null, i(o);
}
} else if (console.log(formatString("Request {0} Fail, Reason: {1}", e.path, o)), 
e.try_times >= MAX_TRY_TIMES) {
if ("function" == typeof e.cb) {
var a = e.cb;
e.cb = null, a(null);
}
} else t._doRequest(e);
};
e.try_times += 1;
var o = {
appId: this._getAppID()
};
"sendJson" === e.way ? HttpsHelper.sendJson(this._makeUrl(e.key, e.path), o, e.data, n) : "getJson" === e.way ? HttpsHelper.getJson(this._makeUrl(e.key, e.path), o, e.data, n) : "sendForm" === e.way ? HttpsHelper.sendForm(this._makeUrl(e.key, e.path), o, e.data, n) : "sendProto" === e.way ? HttpsHelper.sendProto(this._makeUrl(e.key, e.path), o, e.data, n) : (console.error(formatString("Do Not Support This Kind Of Request Right Now, Way: {0}", e.way)), 
n(!1, null));
}
}
}, {
key: "_getAppID",
value: function() {
return PlatHelper.isQQPlatform() ? PlatIDs.qqAppID : PlatHelper.isTTPlatform() ? PlatIDs.ttAppID : PlatHelper.isOPPOPlatform() ? PlatIDs.oppoAppID : PlatHelper.isVIVOPlatform() ? PlatIDs.vivoAppID : PlatHelper.isWXPlatform() ? PlatIDs.wxAppID : checkString(PlatIDs.winAppID) ? PlatIDs.winAppID : PlatIDs.wxAppID;
}
} ]);
return e;
}(), NetHelper = new _NetHelper(), TAG_OF_SCHEDULE_SERVER_TIME = "Server_Time_Tick", _ServerInfo = function() {
function e() {
_classCallCheck2(this, e);
this._loaded = !1, this._serverTime = 0, this._startedAppTime = 0, this._startedServerTime = 0;
}
_createClass2(e, [ {
key: "reLoad",
value: function(e) {
var t = this;
PlatHelper.canLoginOnline() ? (this.unregisterServerTime(), NetHelper.reqGetServerTime(function(n) {
n && "200" === n.status ? (t._loaded = !0, t.registerServerTime(Math.floor(parseInt(n.time_stamp, 10) / 1e3)), 
doCallback$1(e)) : Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
})) : doCallback$1(e);
}
}, {
key: "registerServerTime",
value: function(e) {
console.log("server time: ", e), this.unregisterServerTime(), this._startedAppTime = Date.now(), 
this._serverTime = 1e3 * e, this._startedServerTime = this._serverTime, Scheduler.schedule(TAG_OF_SCHEDULE_SERVER_TIME, function() {
this._loaded && (this._serverTime = this._startedServerTime + Date.now() - this._startedAppTime);
}, !0);
}
}, {
key: "unregisterServerTime",
value: function() {
this._loaded && (this._loaded = !1, this._serverTime = 0, this._startedAppTime = 0, 
this._startedServerTime = 0, Scheduler.unschedule(TAG_OF_SCHEDULE_SERVER_TIME));
}
}, {
key: "getServerTime",
value: function() {
return this._loaded ? this._serverTime : Date.now();
}
}, {
key: "getServerDate",
value: function() {
return this._loaded ? new Date(this._serverTime) : new Date();
}
}, {
key: "getCurServerDayOfWeek",
value: function() {
var e = this.getServerDate().getDay();
return 0 === e && (e = 7), e;
}
}, {
key: "getCurServerDayOfMonth",
value: function() {
return this.getServerDate().getDate();
}
}, {
key: "getCurServerDayOfYear",
value: function() {
var e = this.getServerDate(), t = new Date(e.getFullYear(), 0, 0), n = e - t + 6e4 * (t.getTimezoneOffset() - e.getTimezoneOffset());
return Math.floor(n / 864e5);
}
}, {
key: "getCurServerWeekOfYear",
value: function() {
var e = this.getServerDate(), t = new Date(e.valueOf()), n = (e.getDay() + 6) % 7;
t.setDate(t.getDate() - n + 3);
var o = t.valueOf();
return t.setMonth(0, 1), 4 !== t.getDay() && t.setMonth(0, 1 + (4 - t.getDay() + 7) % 7), 
1 + Math.ceil((o - t) / 6048e5);
}
} ]);
return e;
}(), ServerInfo = new _ServerInfo(), ShareBase = function() {
function e() {
_classCallCheck2(this, e);
this._initedCbs = {}, this._inited = !1, this._shareFailTips = null, this._sharingSceneInfo = null, 
this._minDurationBetweenShare = 3e3;
}
_createClass2(e, [ {
key: "init",
value: function() {
var e = this;
this._inited || (this._inited = !0, Switch.getMinDurationBetweenShare(function(e) {
this._minDurationBetweenShare = e;
}.bind(this)), this.isSupportCallback() || Event.addEventListerner(EventName.EN_APP_ONSHOW, function() {
Scheduler.schedule("Auto_Share_Callback", function() {
if (console.log("Auto_Share_Callback"), this._sharingSceneInfo) {
var e = this._checkShareResult(this._sharingSceneInfo);
"function" == typeof this._sharingSceneInfo.cb && this._sharingSceneInfo.cb(e), 
!e && this._sharingSceneInfo.showFailTips && PlatHelper.showRandomToast(this._getShareFailTips()), 
this._sharingSceneInfo = null;
}
}.bind(this), !1, 10, 0);
}.bind(this)), PlatHelper.getPlat() && PlatHelper.getPlat().showShareMenu && this._getOnMenuShareFunc(function(t) {
(function(t) {
t && (PlatHelper.getPlat().showShareMenu({
withShareTicket: !0
}), t(function() {
var t = e._getDoShareCfg(e._getShareInfo(ShareScene.SS_SYSTEM_MENU));
return t ? e._makeAndSaveShareInfo(ShareScene.SS_SYSTEM_MENU, null, t, null, !1, null) : {};
}));
})(t);
}));
}
}, {
key: "isSupport",
value: function() {
return !1;
}
}, {
key: "isSupportCallback",
value: function() {
return !1;
}
}, {
key: "isSharing",
value: function() {
return null !== this._sharingSceneInfo;
}
}, {
key: "share",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = !(arguments.length > 2 && void 0 !== arguments[2]) || arguments[2], o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
this._checkString(e) ? this.isSupport() ? this._doShare(e, null, t, n, o) : "function" == typeof o && o(PlatHelper.isWINPlatform()) : "function" == typeof o && o(!1);
}
}, {
key: "shareVideo",
value: function(e, t) {
arguments.length > 2 && void 0 !== arguments[2] && arguments[2], !(arguments.length > 3 && void 0 !== arguments[3]) || arguments[3], 
arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
}
}, {
key: "getShareInfo",
value: function(e) {
return this._getShareInfo(e);
}
}, {
key: "getDoShareCfg",
value: function(e) {
return this._getDoShareCfg(e);
}
}, {
key: "_getShareInfo",
value: function(e) {
return ShareSceneCfgs[e] ? ShareSceneCfgs[e] : null;
}
}, {
key: "_getDoShareCfg",
value: function(e) {
if (!e || !e.cfgs) return null;
for (var t = e.cfgs, n = 0, o = 0; o < t.length; o++) void 0 === t[o].weight && (t[o].weight = "10"), 
n += parseInt(t[o].weight, 10);
for (var i = 0; 0 === i; ) i = random(n);
for (var a = 0, r = 0, s = 0; s < t.length; s++) if (a = r, r += parseInt(t[s].weight, 10), 
i >= a && i <= r) return t[s];
return null;
}
}, {
key: "_doShare",
value: function(e, t, n, o, i) {
var a = this._getDoShareCfg(this._getShareInfo(e));
if (a && this.isSupport()) {
var r = this._getShareAppFunc();
r && r(this._makeAndSaveShareInfo(e, t, a, n, o, i));
} else "function" == typeof i && i(!1);
}
}, {
key: "_makeAndSaveShareInfo",
value: function(e, t, n, o, i, a) {
if (this._sharingSceneInfo = null, n) {
this._sharingSceneInfo = {
scene: e,
customQueryObj: o,
showFailTips: i,
startTime: new Date().getTime(),
cb: a
};
var r = formatString("scene={0}&tag={1}", e, n.tag);
if (o) for (var s in o) r += "&" + s + "=" + o[s];
var l = this;
return {
query: r,
success: function() {
if (console.log("share success!!!"), l._sharingSceneInfo) {
var e = l._checkShareResult(l._sharingSceneInfo);
!e && l._sharingSceneInfo.showFailTips && PlatHelper.showRandomToast(l._getShareFailTips()), 
"function" == typeof l._sharingSceneInfo.cb && l._sharingSceneInfo.cb(e), l._sharingSceneInfo = null;
}
},
fail: function() {
console.log("share fail!!!"), l._sharingSceneInfo && (l._sharingSceneInfo.showFailTips && PlatHelper.showRandomToast(l._getShareFailTips(t)), 
"function" == typeof l._sharingSceneInfo.cb && l._sharingSceneInfo.cb(!1), l._sharingSceneInfo = null);
}
};
}
return {};
}
}, {
key: "_checkShareResult",
value: function(e) {
return !!(e && new Date().getTime() - e.startTime >= this._minDurationBetweenShare);
}
}, {
key: "_getShareFailTips",
value: function() {
return this._shareFailTips || (this._shareFailTips = [].concat(ShareFailTips)), 
this._shareFailTips;
}
}, {
key: "_getOnMenuShareFunc",
value: function(e) {
"function" == typeof e && e(null);
}
}, {
key: "_getShareAppFunc",
value: function() {
return null;
}
}, {
key: "_checkString",
value: function(e) {
return "string" == typeof e && "" !== e;
}
} ]);
return e;
}(), UnSupportShare = function() {
_inherits2(t, ShareBase);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "isSupport",
value: function() {
return !1;
}
} ]);
return t;
}(), WXShare = function() {
_inherits2(t, ShareBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._cfgs = {};
return n;
}
_createClass2(t, [ {
key: "isSupport",
value: function() {
return !0;
}
}, {
key: "isSupportCallback",
value: function() {
return !1;
}
}, {
key: "_makeAndSaveShareInfo",
value: function(e, n, o, i, a, r) {
var s = _get2(_getPrototypeOf2(t.prototype), "_makeAndSaveShareInfo", this).call(this, e, n, o, i, a, r);
return o && (s.title = o.title, s.imageUrl = o.img_url), s;
}
}, {
key: "_getOnMenuShareFunc",
value: function(e) {
"function" == typeof e && (this.isSupport() ? PlatHelper.getPlat().aldOnShareAppMessage ? e(PlatHelper.getPlat().aldOnShareAppMessage) : PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.onShareAppMessage ? e(PlatHelper.getPlat().uma.onShareAppMessage) : e(PlatHelper.getPlat().onShareAppMessage) : e(null));
}
}, {
key: "_getShareAppFunc",
value: function() {
return this.isSupport() ? PlatHelper.getPlat().aldShareAppMessage ? PlatHelper.getPlat().aldShareAppMessage : PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.shareAppMessage ? PlatHelper.getPlat().uma.shareAppMessage : PlatHelper.getPlat().shareAppMessage : null;
}
} ]);
return t;
}(), QQShare = function() {
_inherits2(t, ShareBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._cfgs = {};
return n;
}
_createClass2(t, [ {
key: "isSupport",
value: function() {
return !0;
}
}, {
key: "isSupportCallback",
value: function() {
return !0;
}
}, {
key: "_makeAndSaveShareInfo",
value: function(e, n, o, i, a, r) {
var s = _get2(_getPrototypeOf2(t.prototype), "_makeAndSaveShareInfo", this).call(this, e, n, o, i, a, r);
return o && (s.title = o.title, s.imageUrl = o.img_url), s;
}
}, {
key: "_getOnMenuShareFunc",
value: function(e) {
"function" == typeof e && (this.isSupport() ? PlatHelper.getPlat().aldOnShareAppMessage ? e(PlatHelper.getPlat().aldOnShareAppMessage) : PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.onShareAppMessage ? e(PlatHelper.getPlat().uma.onShareAppMessage) : e(PlatHelper.getPlat().onShareAppMessage) : e(null));
}
}, {
key: "_getShareAppFunc",
value: function() {
return this.isSupport() ? PlatHelper.getPlat().aldShareAppMessage ? PlatHelper.getPlat().aldShareAppMessage : PlatHelper.getPlat().uma && PlatHelper.getPlat().uma.shareAppMessage ? PlatHelper.getPlat().uma.shareAppMessage : PlatHelper.getPlat().shareAppMessage : null;
}
} ]);
return t;
}(), TTShare = function() {
_inherits2(t, ShareBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._cfgs = {};
return n;
}
_createClass2(t, [ {
key: "isSupport",
value: function() {
return !0;
}
}, {
key: "isSupportCallback",
value: function() {
return !0;
}
}, {
key: "shareVideo",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = !(arguments.length > 3 && void 0 !== arguments[3]) || arguments[3], i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
this._checkString(e) && this._checkString(t) ? this.isSupport() ? this.isReady() ? this._doShare(e, {
videoPath: t
}, n, o, i) : this._initedCbs[e] = {
extendParams: {
videoPath: t
},
customQueryObj: n,
showFailTips: o,
cb: i
} : "function" == typeof i && i(!0) : "function" == typeof i && i(!1);
}
}, {
key: "_makeAndSaveShareInfo",
value: function(e, n, o, i, a, r) {
var s = this, l = _get2(_getPrototypeOf2(t.prototype), "_makeAndSaveShareInfo", this).call(this, e, n, o, i, a, r);
l.success = function(e) {
if (console.log("share success!!!"), s._sharingSceneInfo) {
var t = s._checkShareResult(s._sharingSceneInfo);
!t && s._sharingSceneInfo.showFailTips && PlatHelper.showRandomToast(s._getShareFailTips()), 
"function" == typeof s._sharingSceneInfo.cb && s._sharingSceneInfo.cb(t, e.videoId), 
s._sharingSceneInfo = null;
}
}, o && (l.templateId = o.template_id), n && void 0 !== n.videoPath && (l.channel = "video", 
l.extra = {
videoPath: n.videoPath,
withVideoId: !0
}, void 0 !== n.videoTopics && (l.extra.videoTopics = n.videoTopics));
var c = "", d = PlatHelper.getLaunchOptions();
if (d && d.query) for (var h in d.query) {
var u = d.query[h].toString();
"sc" === h && (u = (parseInt(u) + 1).toString()), c += "" === c ? h + "=" + u : "&" + h + "=" + u;
}
return "" !== c && (l.query = c), l;
}
}, {
key: "_getOnMenuShareFunc",
value: function(e) {
"function" == typeof e && (this.isSupport() ? e(PlatHelper.getPlat().onShareAppMessage) : e(null));
}
}, {
key: "_getShareAppFunc",
value: function() {
return this.isSupport() ? PlatHelper.getPlat().shareAppMessage : null;
}
}, {
key: "_getShareFailTips",
value: function(e) {
return e && void 0 !== e.videoPath ? (this._shareFailTips || (this._shareFailTips = [].concat(ShareVideoFailTips)), 
this._shareFailTips) : _get2(_getPrototypeOf2(t.prototype), "_makeAndSaveShareInfo", this).call(this);
}
} ]);
return t;
}(), _Share = UnSupportShare, Share = new (_Share = _isQQPlatform() ? QQShare : _isTTPlatform() ? TTShare : _isWXPlatform() ? WXShare : UnSupportShare)(), WX_UIKeys = {
FakeLoading: "fakeLoading",
MoreGame: "moreGame",
MoreGameEntrance: "moreGameEntrance",
FullExport: "fullExport",
FullExport_V2: "fullExport_v2",
FullExit: "fullExit",
CrazyClick: "crazyClick",
Scroll: "scroll",
ScrollWithName: "scrollWithName",
Couplet: "couplet",
Matrix: "matrix",
NativeTemplateAd: "nativeTemplateAd",
VideoBanner: "videoBanner"
}, QQ_UIKeys = {
MoreGameEntrance: "moreGameEntrance_QQ",
CrazyClick: "crazyClick_QQ"
}, TT_UIKeys = {
MoreGameEntrance: "moreGameEntrance_TT",
CrazyClick: "crazyClick_TT"
}, OPPO_UIKeys = {
MoreGameEntrance: "moreGameEntrance_OPPO",
NativeBanner: "nativeBanner_OPPO",
NativeBottomBanner: "nativeBottomBanner_OPPO",
NativeMiddleBanner: "nativeMiddleBanner_OPPO"
}, VIVO_UIKeys = {
MoreGameEntrance: "moreGameEntrance_VIVO",
NativeBanner: "nativeBanner_VIVO",
NativeBottomBanner: "nativeBottomBanner_VIVO",
NativeMiddleBanner: "nativeMiddleBanner_VIVO"
}, _UIKeys = {
Modal: "modal",
Loading: "loading",
Tips: "tips",
Finger: "finger",
Mask: "mask",
Transplate: "transplate",
FakeLoading: "",
MoreGame: "",
MoreGameEntrance: "",
FullExport: "",
FullExport_V2: "",
FullExit: "",
CrazyClick: "",
Scroll: "",
ScrollWithName: "",
Couplet: "",
Matrix: "",
NativeTemplateAd: "",
NativeBanner: "",
NativeBottomBanner: "",
NativeMiddleBanner: "",
Private: "private",
VideoBanner: "",
Announcement: "Announcement"
};

isLoadQQConfig() ? Object.assign(_UIKeys, QQ_UIKeys) : isLoadTTConfig() ? Object.assign(_UIKeys, TT_UIKeys) : isLoadOPPOConfig() ? Object.assign(_UIKeys, OPPO_UIKeys) : isLoadVIVOConfig() ? Object.assign(_UIKeys, VIVO_UIKeys) : isLoadWXConfig() ? Object.assign(_UIKeys, WX_UIKeys) : console.error("Not Support This Platform, check hlsdk_config.js first...");

var UIKeys = _UIKeys, OpenType = cc.Enum({
None: 0,
Scale: 1,
FromLeft: 2,
FromBottom: 3,
Opacity: 4
}), CloseType = cc.Enum({
None: 0,
Scale: 1,
Opacity: 2
}), cls$y = cc.Class({
extends: cc.Component,
properties: {
rootNode: {
default: null,
type: cc.Node
},
_callbacks: {
default: {},
visible: !1
},
openType: {
type: cc.Enum(OpenType),
default: OpenType.None
},
closeType: {
type: cc.Enum(CloseType),
default: CloseType.None
},
_bundle: {
default: null,
visible: !1
}
},
onLoad: function() {
this._onInitUI();
},
_onInitUI: function() {
"function" == typeof this.onInitUI && this.onInitUI();
},
showUI: function() {
var e = this;
this.node.active = !0, arguments.length > 0 ? this._onInit.apply(this, arguments) : this._onInit(), 
this.openType === OpenType.Scale ? this._runScaleOpenAction(function() {
e._onShow();
}) : this.openType === OpenType.FromLeft ? this._runFromLeftOpenAction(function() {
e._onShow();
}) : this.openType === OpenType.FromBottom ? this._runFromBottomOpenAction(function() {
e._onShow();
}) : this.openType === OpenType.Opacity ? this._runOpacityOpenAction(function() {
e._onShow();
}) : this._onShow();
},
hideUI: function() {
var e = this;
this.closeType === CloseType.Scale ? this._runScaleCloseAction(function() {
e._onHide();
}) : this.closeType === CloseType.Opacity ? this._runOpacityCloseAction(function() {
e._onHide();
}) : this._onHide();
},
isOnShow: function() {
var e = cc.director.getScene();
return function t(n) {
return !!n && (n === e || !!n.active && !!n.parent && t(n.parent));
}(this.node);
},
tempShowUI: function() {
this.node.visible = !0;
},
tempHideUI: function() {
this.node.visible = !1;
},
_onInit: function() {
this.rootNode && (this.rootNode.anchorX = .5, this.rootNode.anchorY = .5, this.rootNode.x = 0, 
this.rootNode.y = 0, this.rootNode.opacity = 255), "function" == typeof this.onInit && (arguments.length > 0 ? this.onInit.apply(this, arguments) : this.onInit());
},
_onShow: function() {
this.rootNode && this.rootNode.stopAllActions(), "function" == typeof this.onShow && this.onShow();
},
_onHide: function() {
"function" == typeof this.onHide && this.onHide(), this.node.active = !1, this.invokeCallback("close");
},
_runScaleOpenAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.setScale(.8), this.rootNode.runAction(cc.sequence(cc.scaleTo(.5, 1, 1).easing(cc.easeElasticOut(.5)), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
_runFromLeftOpenAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.x = -cc.winSize.width / 6, 
this.rootNode.runAction(cc.sequence(cc.moveTo(.5, cc.v2(0, 0)).easing(cc.easeElasticOut(.5)), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
_runFromBottomOpenAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.y = -cc.winSize.height / 4, 
this.rootNode.runAction(cc.sequence(cc.moveTo(.5, cc.v2(0, 0)).easing(cc.easeElasticOut(.5)), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
_runOpacityOpenAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.opacity = 0, this.rootNode.runAction(cc.sequence(cc.fadeIn(.4), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
_runScaleCloseAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.setScale(1), this.rootNode.runAction(cc.sequence(cc.scaleTo(.5, .1, .1).easing(cc.easeElasticIn(.5)), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
_runOpacityCloseAction: function(e) {
this.rootNode && (this.rootNode.stopAllActions(), this.rootNode.opacity = 255, this.rootNode.runAction(cc.sequence(cc.fadeOut(.4), cc.callFunc(function() {
"function" == typeof e && e();
}))));
},
registerCallback: function(e, t) {
checkString(e) && (void 0 === this._callbacks[e] && (this._callbacks[e] = []), this._callbacks[e].push(t));
},
unregisterCallback: function(e, t) {
if (checkString(e) && void 0 !== this._callbacks[e]) if (t) {
var n = this._callbacks[e], o = n.indexOf(t);
o > -1 && n.splice(o, 1);
} else this._callbacks[e] = [];
},
invokeCallback: function(e) {
if (checkString(e) && void 0 !== this._callbacks[e]) {
var t = [].concat(this._callbacks[e]), n = Array.prototype.slice.call(arguments);
n.shift();
for (var o = 0; o < t.length; o++) t[o].apply(null, n);
}
},
registerBundle: function(e) {
this._bundle = e;
},
unregisterBundle: function() {
this._bundle = null;
},
getBundle: function() {
return this._bundle;
}
}), cls$x = cc.Class({
extends: cc.Node,
properties: {
animSpeed: {
get: function() {
return this._speed;
},
set: function(e) {
"number" == typeof e && e >= 0 && (this._speed = e, this._setAnimSpeed());
}
},
_defaultAnimName: {
default: "gif"
},
_speed: {
default: 1,
type: cc.Float
},
_size: {
default: null
},
_imgData: {
default: {},
type: cc.Object
}
},
ctor: function() {
this.addComponent(cc.Sprite), this.addComponent(cc.Animation);
},
setSize: function(e, t) {
"number" == typeof e && "number" == typeof t && e >= 0 && t >= 0 && (this._size = cc.size(e, t), 
this._updateSize());
},
setImageData: function(e) {
"string" == typeof e && this._imgData.path !== e ? (this._imgData = {
path: e,
frame_count: 1
}, this._updateSelf()) : "object" != typeof e || this._isTwoObjectsEqual(this._imgData, e) || (this._imgData = e, 
this._updateSelf());
},
getImgData: function() {
return this._imgData;
},
_checkImgData: function(e) {
return !(!e || "object" != typeof e || this._isTwoObjectsEqual(this._imgData, e));
},
_setAnimSpeed: function() {
var e = this.getComponent(cc.Animation).getAnimationState(this._defaultAnimName);
e && (e.speed = this._speed);
},
_updateSelf: function() {
var e = this, t = this._imgData;
switch (this._getImageDataType(t)) {
case "sprite":
this._getSpriteFrame(t, function(n) {
e._isTwoObjectsEqual(t, e._imgData) && (e._updateSprite(n), e._updateAnimation([]));
});
break;

case "gif":
this._getSpriteFrameArr(t, function(n) {
e._isTwoObjectsEqual(t, e._imgData) && (e._updateSprite(null), e._updateAnimation(n));
});
}
},
_updateSprite: function(e) {
e instanceof cc.SpriteFrame ? this.getComponent(cc.Sprite).spriteFrame = e : this.getComponent(cc.Sprite).spriteFrame = null;
},
_updateAnimation: function(e) {
var t = this.getComponent(cc.Animation);
t.stop();
for (var n = t.getClips(), o = 0; o < n.length; o++) t.removeClip(n[o]);
if (e && e.length > 1) {
var i = cc.AnimationClip.createWithSpriteFrames(e, e.length);
i.name = this._defaultAnimName, i.wrapMode = cc.WrapMode.Loop, t.addClip(i), t.play(i.name).speed = this._speed;
}
},
_updateSize: function() {
var e = this.getComponent(cc.Sprite);
null === this._size ? e.sizeMode = cc.Sprite.SizeMode.TRIMMED : (e.sizeMode = cc.Sprite.SizeMode.CUSTOM, 
this.width = this._size.width, this.height = this._size.height);
},
_getSpriteFrameArr: function(e, t) {
var n = this;
this._loadImage(e.path, function(o) {
var i = n._cutSpriteFrame(o, e.width, e.height, e.frame_count);
"function" == typeof t && t(i);
});
},
_getSpriteFrame: function(e, t) {
this._loadImage(e.path, t);
},
_loadImage: function(e, t) {
cc.assetManager.loadRemote(e, function(n, o) {
n || o.nativeUrl !== e || doCallback$1(t, new cc.SpriteFrame(o));
});
},
_getImageDataType: function(e) {
return 1 === e.frame_count ? "sprite" : e.frame_count > 1 ? "gif" : (cc.error("imgData wrong, frame_count not match..."), 
null);
},
_cutSpriteFrame: function(e, t, n, o) {
for (var i = e.getOriginalSize(), a = e.getTexture(), r = Math.round(i.width / t), s = Math.round(i.height / n), l = [], c = 0, d = 0; d < s; d++) for (var h = 0; h < r; h++) {
var u = new cc.SpriteFrame(a, cc.Rect(0, 0, a.width, a.height));
if (u.setRect(new cc.Rect(h * t, d * n, t, n)), l.push(u), ++c >= o) return l;
}
return l;
},
_isTwoObjectsEqual: function(e, t) {
var n = Object.getOwnPropertyNames(e), o = Object.getOwnPropertyNames(t);
if (n.length !== o.length) return !1;
for (var i = 0; i < n.length; i++) {
var a = n[i];
if (e[a] !== t[a]) return !1;
}
return !0;
}
}), cls$w = cc.Class({
extends: cc.Node,
ctor: function() {
this._index = 0, this._advID = 0, this._advImgData = {}, this._advTitle = "", this._advPath = "", 
this._itemCfg = null, this._advImg = null, this._advFrame = null, this._advName = null, 
this.anchorX = 0, this.anchorY = 0, this.addComponent(cc.Button);
},
getImgCenterPt: function() {
return this._advImg ? this._advImg.convertToWorldSpaceAR(cc.v2(this._advImg.width / 2 - this._advImg.width * this._advImg.anchorX, this._advImg.height / 2 - this._advImg.height * this._advImg.anchorY)) : cc.v2(0, 0);
},
setIndex: function(e) {
this._index = e;
},
getIndex: function() {
return this._index;
},
setSize: function(e, t) {
this.width = e, this.height = t;
},
setCfg: function(e) {
this._itemCfg = e;
},
setAdvInfo: function(e, t, n, o) {
this._advID === e && this._isTwoObjectsEqual(this._advImgData, t) && this._advTitle === n && this._advPath === o || (this._advID = e, 
this._advImgData = t, this._advTitle = n, this._advPath = o, this._advImg || this._initImg(), 
this._advImg.setImageData(this._advImgData), this._advFrame || this._initFrame(), 
this._advName || this._initName(), this._advName && (this._advName.getComponent(cc.Label).string = this._advTitle));
},
_initImg: function() {
if (!this._advImg) {
var e = new cls$x();
if (e) {
if (this._itemCfg.imgWidth > 0 && this._itemCfg.imgHeight > 0 ? e.setSize(this._itemCfg.imgWidth, this._itemCfg.imgHeight) : e.setSize(this.width, this.height), 
this._itemCfg.iconNeedPos) {
var t = this._itemCfg.iconPos;
e.anchorX = 0, e.anchorY = 1, e.x = t.x, e.y = this.height - t.y;
} else e.anchorX = .5, e.anchorY = 1, e.x = this.width / 2, e.y = this.height;
e.zIndex = 0, this.addChild(e), this._advImg = e;
}
}
},
_initName: function() {
if (!this._advName && this._itemCfg.nameCfg) {
var e = new cc.Node();
if (e) {
var t = e.addComponent(cc.Label), n = this._itemCfg.nameCfg.split("||");
if (n.length > 0) if (t.fontSize = parseInt(n[0], 10), t.lineHeight = parseInt(n[0], 10), 
e.height = parseInt(n[0], 10), e.color = cc.color("#" + n[2]), this._itemCfg.nameNeedPos) {
var o = this._itemCfg.namePos;
e.anchorX = 0, e.anchorY = 1, e.x = o.x, e.y = this.height - o.y;
} else e.anchorX = .5, e.anchorY = 1, e.x = this.width / 2, e.y = this.height - this._advImg.height - parseInt(n[1], 10);
e.zIndex = 2, this.addChild(e), this._advName = e;
}
}
},
_initFrame: function() {
if (!this._advFrame && this._itemCfg.framePath) {
var e = new cc.Node();
if (e) {
var t = e.addComponent(cc.Sprite);
e.width = this.width, e.height = this.height, e.anchorX = .5, e.anchorY = 1, e.x = this.width / 2, 
e.y = this.height;
var n = this._itemCfg.framePath;
if (this._itemCfg.framePathCount > 1) {
var o = this._index % this._itemCfg.framePathCount;
0 === o && (o = this._itemCfg.framePathCount), n = formatString(this._itemCfg.framePath, o.toString());
}
t.sizeMode = cc.Sprite.SizeMode.CUSTOM, this._loadImage(n, function(e) {
t.spriteFrame = e;
}), e.zIndex = 1, this.addChild(e), this._advFrame = e;
}
}
},
_loadImage: function(e, t) {
cc.assetManager.getBundle("hl_core").load(e, cc.SpriteFrame, function(e, n) {
e || doCallback$1(t, n);
});
},
_isTwoObjectsEqual: function(e, t) {
var n = Object.getOwnPropertyNames(e), o = Object.getOwnPropertyNames(t);
if (n.length !== o.length) return !1;
for (var i = 0; i < n.length; i++) {
var a = n[i];
if (e[a] !== t[a]) return !1;
}
return !0;
}
}), MINI_PRELOAD_LENGTH = 20, cls$v = cc.Class({
extends: cc.ScrollView,
properties: {
horizontal: {
default: !1,
override: !0,
visible: !1
},
vertical: {
default: !0,
override: !0,
visible: !1
},
landscape: {
default: !1,
tooltip: "是否水平方向"
},
gap: {
default: 0,
tooltip: "Cell之间的间隔"
},
firstGap: {
default: 0,
tooltip: "最上面/左边的Cell与顶部/左部的间隔"
},
lastGap: {
default: 0,
tooltip: "最下面/右边的Cell与底部/右部的间隔"
}
},
ctor: function() {
this._cellRects = [], this._workCells = [], this._freeCells = [], this._freeNodeParent = null, 
this._cellCount = 0, this._peloadLenght = 0, this._fillDirection = !0, this._dirtyCell = !1, 
this._sizeOfIndex = null, this._cellAtIndex = null, this._extCellAtIndex = null, 
this._countOfCell = null, this._OuterScrollView = null;
},
onLoad: function() {
this._freeNodeParent = new cc.Node(), this._freeNodeParent.active = !1, this._freeNodeParent.zIndex = -1e3, 
this._freeNodeParent.parent = this.node;
var e = this;
this.node.on("scrolling", function() {
e._onContentMoved();
});
},
onDestroy: function() {
this._workCells = void 0, this._freeCells = void 0;
},
start: function() {
this.setContentSize(cc.size(this.node.width, this.node.height)), this.gap = this.gap || 0, 
this.firstGap = this.firstGap || 0, this.lastGap = this.lastGap || 0, this.setLandscape(this.landscape);
},
lateUpdate: function() {
this._dirtyCell && this._reloadNodes();
},
setContentSize: function(e) {
var t = this.content, n = t.parent, o = this.node;
n.width = e.width, n.height = e.height, t.anchorX = 0, t.anchorY = 0, n.anchorX = 0, 
n.anchorY = 0, n.x = -o.width * o.anchorX, n.y = -o.height * o.anchorY;
},
setGap: function(e) {
this.gap = e;
},
setFirstGap: function(e) {
this.firstGap = e;
},
setLastGap: function(e) {
this.lastGap = e;
},
setLandscape: function(e) {
this.landscape = e, this.horizontal = e, this.vertical = !e;
},
setFillDirection: function(e) {
this._fillDirection = !e;
},
sizeOfIndex: function(e) {
this._sizeOfIndex = e;
},
cellAtIndex: function(e) {
this._cellAtIndex = e;
},
extCellAtIndex: function(e) {
this._extCellAtIndex = e;
},
countOfCells: function(e) {
this._countOfCell = e;
},
getWorkCells: function() {
return this._workCells;
},
dequeueCell: function() {
if (this._freeCells.length > 0) {
var e = this._freeCells[0];
return this._freeCells.splice(0, 1), e;
}
},
reloadData: function() {
var e = this;
this._cellRects.forEach(function(t) {
t.node && (e._deliverFreeNode(t.node), t.node = null);
});
var t = this.node.width, n = this.node.height, o = 0, i = 0;
this._peloadLenght = 0, this.landscape ? (o = this.firstGap, i = n) : (o = t, i = this.firstGap);
for (var a = this.content, r = this._cellCount = this._countOfCell(this), s = 0; s < r; ++s) {
var l = this._sizeOfIndex(this, s);
this._cellRects.length <= s && this._cellRects.push({
x: 0,
y: 0,
width: 0,
height: 0,
node: null
}), (d = this._cellRects[s]).width = l.width, d.height = l.height, this.landscape ? (d.x = o, 
d.y = (i - l.height) / 2, o = s < r - 1 ? o + l.width + this.gap : o + l.width + this.lastGap, 
this._peloadLenght < l.width && (this._peloadLenght = l.width)) : (d.x = (o - l.width) / 2, 
d.y = i, i = s < r - 1 ? i + l.height + this.gap : i + l.height + this.lastGap, 
this._peloadLenght < l.height && (this._peloadLenght = l.height));
}
if (a.width = Math.max(t, o), a.height = Math.max(n, i), this._fillDirection) a.x = 0, 
a.y = 0, this.node.runAction(cc.sequence(cc.delayTime(.01), cc.callFunc(function() {
this.landscape ? this.scrollToLeft() : this.scrollToBottom(), this._reloadNodes();
}, this))); else {
a.x = t - a.width, a.y = n - a.height;
for (var c = 0; c < this._cellCount; ++c) {
var d = this._cellRects[c];
this.landscape ? d.x = a.width - d.x - d.width : d.y = a.height - d.y - d.height;
}
this.node.runAction(cc.sequence(cc.delayTime(.01), cc.callFunc(function() {
this.landscape ? this.scrollToRight() : this.scrollToTop(), this._reloadNodes();
}, this)));
}
},
_onContentMoved: function() {
this._dirtyCell || this._reloadNodes();
},
_reloadNodes: function() {
this._dirtyCell = !1;
var e = this.content, t = Math.max(MINI_PRELOAD_LENGTH, this._peloadLenght / 2), n = -e.x, o = -e.y, i = n + this.node.width, a = o + this.node.height;
n -= t, o -= t, i += t, a += t;
for (var r = 0; r < this._cellCount; ++r) {
var s = this._cellRects[r];
if (s.x > i || s.y > a || s.x + s.width < n || s.y + s.height < o) s.node && (this._deliverFreeNode(s.node), 
s.node = null); else if (!s.node && (s.node = this._cellAtIndex(this, r), s.node)) {
this._extCellAtIndex && this._extCellAtIndex(s.node, r);
var l = s.node;
this._addWorkNode(l);
var c = l.width * l.scaleX, d = l.height * l.scaleY, h = s.x + (s.width - c) / 2, u = s.y + (s.height - d) / 2;
l.x = h + c * l.anchorX, l.y = u + d * l.anchorY;
}
}
},
_addWorkNode: function(e) {
if (e) {
e.parent = this.content, this._workCells.push(e);
for (var t = 0; t < this._freeCells.length; t++) if (this._freeCells[t] === e) {
this._freeCells.splice(t, 1);
break;
}
}
},
_deliverFreeNode: function(e) {
if (e) {
e.parent = this._freeNodeParent, this._freeCells.push(e);
for (var t = 0; t < this._workCells.length; t++) if (this._workCells[t] === e) {
this._workCells.splice(t, 1);
break;
}
}
},
setOuterScrollView: function(e) {
this._outerScrollView = e;
},
hasNestedViewGroup: function(e, t) {
return "function" == typeof this._hasNestedViewGroup ? this._hasNestedViewGroup(e, t) : this._super(e, t);
},
_onTouchMoved: function(e, t) {
if (this._outerScrollView) {
if (this.enabledInHierarchy && !this.hasNestedViewGroup(e, t)) {
var n = e.touch, o = n.getLocation().sub(n.getStartLocation());
if (this.content && (this._outerScrollView.isDifferentBetweenSettingAndPlan(this) || this._handleMoveLogic(n)), 
this.cancelInnerEvents) {
if (o.mag() > 7 && !this._touchMoved && e.target !== this.node) {
var i = new cc.Event.EventTouch(e.getTouches(), e.bubbles);
i.type = cc.Node.EventType.TOUCH_CANCEL, i.touch = e.touch, i.simulate = !0, e.target.dispatchEvent(i), 
this._touchMoved = !0;
}
this._stopPropagationIfTargetIsMe(e);
}
}
} else this._super(e, t);
}
}), cls$u = cc.Class({
extends: cc.Component,
ctor: function() {
this._inited = !1, this._touchCb = null, this._selectCb = null, this._isHorizontal = !1, 
this._cellSize = null, this._tableView = null, this._itemCfg = null, this._advInfoList = [];
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = this, t = this.node.getComponent(cls$v);
t && (this._tableView = t, t.node.on("scroll-began", function() {
e._doTouchCallback("began");
}), t.node.on("scroll-ended", function() {
console.log("tween stoped..."), e._doTouchCallback("ended");
}));
},
getAllExposedAdvInfos: function() {
var e = this, t = [];
if (!this.node) return t;
var n = this._getBoundingBoxToWorld();
return this._tableView.getWorkCells().forEach(function(o) {
o.children.forEach(function(o) {
if (o instanceof cls$w) {
var i = o.getIndex(), a = e._advInfoList[i - 1];
n.contains(o.convertToWorldSpaceAR(cc.v2(.5, .5))) && n.contains(o.convertToWorldSpaceAR(cc.v2(o.width - .5, o.height - .5))) && t.push({
index: i,
info: a,
getCenterPt: function() {
return o.getImgCenterPt();
}
});
}
});
}), t;
},
_getBoundingBoxToWorld: function() {
var e = cc.rect(), t = this.node.convertToWorldSpaceAR(cc.v2(0 - this.node.width * this.node.anchorX, 0 - this.node.height * this.node.anchorY));
e.x = t.x, e.y = t.y;
var n = this.node.convertToWorldSpaceAR(cc.v2(0 + this.node.width * (1 - this.node.anchorX), 0 + this.node.height * (1 - this.node.anchorY)));
return e.width = n.x - t.x, e.height = n.y - t.y, e;
},
registerTouchCallback: function(e) {
"function" == typeof e && (this._touchCb = e);
},
_doTouchCallback: function(e) {
this._touchCb && this._touchCb(e);
},
registerSelectCallback: function(e) {
"function" == typeof e && (this._selectCb = e);
},
_doSelectCallback: function(e, t) {
this._selectCb && this._selectCb(e, t);
},
setList: function(e, t, n, o) {
var i = this;
if (!this._inited) {
this._inited = !0, this._isHorizontal = e, this._cellSize = t;
var a = 1;
a = this._isHorizontal ? this.node.height > this._cellSize.height ? Math.floor(this.node.height / (this._cellSize.height + 5)) : 1 : this.node.width > this._cellSize.width ? Math.floor(this.node.width / (this._cellSize.width + 5)) : 1;
if (this._cellCount = a, this._tableView) {
if (this._tableView.sizeOfIndex(function() {
return cc.size(i._cellSize.width, i._cellSize.height);
}), this._tableView.cellAtIndex(function(e, t) {
var n = e.dequeueCell();
return n || (n = i._createAdvItem(t)) && (n.parent = i.content), i._updateAdvItem(n, t), 
n;
}), -1 !== this._advInfoList.advCount) this._tableView.countOfCells(function() {
return i._advInfoList.length / i._cellCount;
}); else {
var r = 1, s = 0;
this._isHorizontal ? this.node.width > this._cellSize.width ? (r = Math.floor(this.node.width / (this._cellSize.width + 5)), 
s = (this.node.width - r * this._cellSize.width) / (r - 1)) : r = 1 : this.node.height > this._cellSize.height ? (r = Math.floor(this.node.height / (this._cellSize.height + 5)), 
s = (this.node.height - r * this._cellSize.height) / (r - 1)) : r = 1;
this._tableView.gap = s, this._tableView.countOfCells(function() {
return r;
});
}
e ? this._tableView.setFillDirection(!1) : this._tableView.setFillDirection(!0);
}
}
Array.isArray(o) && o.length > 0 && (this._itemCfg = n, this._advInfoList = o, this._tableView.reloadData());
},
_createAdvItem: function(e) {
var t = this, n = new cc.Node();
if (n) {
n.name = "AdvItems", n.anchorX = 0, n.anchorY = 0, n.getCellCount = function() {
return t._cellCount;
}, this._isHorizontal ? (n.width = this._cellSize.width, n.height = this.node.height) : (n.width = this.node.width, 
n.height = this._cellSize.height);
for (var o = 0; o < this._cellCount; o++) {
var i = this.__createAdvItem(o + this._cellCount * e);
if (i) {
if (i.name = "AdvItem", this._isHorizontal) {
var a = 0;
this._cellCount > 1 && (a = (this.node.height - this._cellCount * this._cellSize.height) / (this._cellCount - 1)), 
i.x = 0, i.y = o * (this._cellSize.height + a);
} else {
var r = 0;
this._cellCount > 1 && (r = (this.node.width - this._cellCount * this._cellSize.width) / (this._cellCount - 1)), 
i.x = o * (this._cellSize.width + r), i.y = 0;
}
n.addChild(i);
}
}
}
return n;
},
__createAdvItem: function(e) {
var t = this, n = this._advInfoList[e];
if (!n) return null;
var o = new cls$w();
return o.setIndex(e + 1), o.setSize(this._cellSize.width, this._cellSize.height), 
o.setCfg(this._itemCfg), o.setAdvInfo(n.adv_id, n.logo_url, n.title, n.path), o.on("click", function() {
var e = o.getIndex(), n = t._advInfoList[e - 1];
t._doSelectCallback(n, function(e) {
e && o.setAdvInfo(e.adv_id, e.logo_url, e.title, e.path);
}.bind(t));
}), o;
},
_updateAdvItem: function(e, t) {
if (e) for (var n = this._cellCount * t, o = -1, i = 0; i < e.childrenCount; i++) {
var a = e.children[i];
a instanceof cls$w && (o += 1, this.__updateAdvItem(a, n + o));
}
},
__updateAdvItem: function(e, t) {
if (e) {
var n = this._advInfoList[t];
e.setIndex(t + 1), e.setAdvInfo(n.adv_id, n.logo_url, n.title, n.path);
}
}
}), freeGlobal = "object" == ("undefined" == typeof global ? "undefined" : typeof global) && global && global.Object === Object && global, freeSelf = "object" == ("undefined" == typeof self ? "undefined" : typeof self) && self && self.Object === Object && self, root = freeGlobal || freeSelf || window, _Symbol = root.Symbol, objectProto$e = Object.prototype, hasOwnProperty$c = objectProto$e.hasOwnProperty, nativeObjectToString$1 = objectProto$e.toString, symToStringTag$1 = _Symbol ? _Symbol.toStringTag : void 0;

function getRawTag(e) {
var t = hasOwnProperty$c.call(e, symToStringTag$1), n = e[symToStringTag$1];
try {
e[symToStringTag$1] = void 0;
var o = !0;
} catch (e) {}
var i = nativeObjectToString$1.call(e);
return o && (t ? e[symToStringTag$1] = n : delete e[symToStringTag$1]), i;
}

var objectProto$d = Object.prototype, nativeObjectToString = objectProto$d.toString;

function objectToString(e) {
return nativeObjectToString.call(e);
}

var nullTag = "[object Null]", undefinedTag = "[object Undefined]", symToStringTag = _Symbol ? _Symbol.toStringTag : void 0;

function baseGetTag(e) {
return null == e ? void 0 === e ? undefinedTag : nullTag : symToStringTag && symToStringTag in Object(e) ? getRawTag(e) : objectToString(e);
}

function isObjectLike(e) {
return null != e && "object" == typeof e;
}

var symbolTag$3 = "[object Symbol]";

function isSymbol(e) {
return "symbol" == typeof e || isObjectLike(e) && baseGetTag(e) == symbolTag$3;
}

function arrayMap(e, t) {
for (var n = -1, o = null == e ? 0 : e.length, i = Array(o); ++n < o; ) i[n] = t(e[n], n, e);
return i;
}

var isArray = Array.isArray, INFINITY$2 = 1 / 0, symbolProto$2 = _Symbol ? _Symbol.prototype : void 0, symbolToString = symbolProto$2 ? symbolProto$2.toString : void 0;

function baseToString(e) {
if ("string" == typeof e) return e;
if (isArray(e)) return arrayMap(e, baseToString) + "";
if (isSymbol(e)) return symbolToString ? symbolToString.call(e) : "";
var t = e + "";
return "0" == t && 1 / e == -INFINITY$2 ? "-0" : t;
}

function isObject(e) {
var t = typeof e;
return null != e && ("object" == t || "function" == t);
}

function identity(e) {
return e;
}

var asyncTag = "[object AsyncFunction]", funcTag$2 = "[object Function]", genTag$1 = "[object GeneratorFunction]", proxyTag = "[object Proxy]";

function isFunction(e) {
if (!isObject(e)) return !1;
var t = baseGetTag(e);
return t == funcTag$2 || t == genTag$1 || t == asyncTag || t == proxyTag;
}

var coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
var e = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
return e ? "Symbol(src)_1." + e : "";
}();

function isMasked(e) {
return !!maskSrcKey && maskSrcKey in e;
}

var funcProto$1 = Function.prototype, funcToString$1 = funcProto$1.toString;

function toSource(e) {
if (null != e) {
try {
return funcToString$1.call(e);
} catch (e) {}
try {
return e + "";
} catch (e) {}
}
return "";
}

var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reIsHostCtor = /^\[object .+?Constructor\]$/, funcProto = Function.prototype, objectProto$c = Object.prototype, funcToString = funcProto.toString, hasOwnProperty$b = objectProto$c.hasOwnProperty, reIsNative = RegExp("^" + funcToString.call(hasOwnProperty$b).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");

function baseIsNative(e) {
return !(!isObject(e) || isMasked(e)) && (isFunction(e) ? reIsNative : reIsHostCtor).test(toSource(e));
}

function getValue(e, t) {
return null == e ? void 0 : e[t];
}

function getNative(e, t) {
var n = getValue(e, t);
return baseIsNative(n) ? n : void 0;
}

var WeakMap = getNative(root, "WeakMap"), objectCreate = Object.create, baseCreate = function() {
function e() {}
return function(t) {
if (!isObject(t)) return {};
if (objectCreate) return objectCreate(t);
e.prototype = t;
var n = new e();
return e.prototype = void 0, n;
};
}();

function apply(e, t, n) {
switch (n.length) {
case 0:
return e.call(t);

case 1:
return e.call(t, n[0]);

case 2:
return e.call(t, n[0], n[1]);

case 3:
return e.call(t, n[0], n[1], n[2]);
}
return e.apply(t, n);
}

function noop() {}

function copyArray(e, t) {
var n = -1, o = e.length;
for (t || (t = Array(o)); ++n < o; ) t[n] = e[n];
return t;
}

var HOT_COUNT = 800, HOT_SPAN = 16, nativeNow = Date.now;

function shortOut(e) {
var t = 0, n = 0;
return function() {
var o = nativeNow(), i = HOT_SPAN - (o - n);
if (n = o, i > 0) {
if (++t >= HOT_COUNT) return arguments[0];
} else t = 0;
return e.apply(void 0, arguments);
};
}

function constant(e) {
return function() {
return e;
};
}

var defineProperty = function() {
try {
var e = getNative(Object, "defineProperty");
return e({}, "", {}), e;
} catch (e) {}
}(), baseSetToString = defineProperty ? function(e, t) {
return defineProperty(e, "toString", {
configurable: !0,
enumerable: !1,
value: constant(t),
writable: !0
});
} : identity, setToString = shortOut(baseSetToString);

function arrayEach(e, t) {
for (var n = -1, o = null == e ? 0 : e.length; ++n < o && !1 !== t(e[n], n, e); ) ;
return e;
}

function baseFindIndex(e, t, n, o) {
for (var i = e.length, a = n + (o ? 1 : -1); o ? a-- : ++a < i; ) if (t(e[a], a, e)) return a;
return -1;
}

function baseIsNaN(e) {
return e != e;
}

function strictIndexOf(e, t, n) {
for (var o = n - 1, i = e.length; ++o < i; ) if (e[o] === t) return o;
return -1;
}

function baseIndexOf(e, t, n) {
return t == t ? strictIndexOf(e, t, n) : baseFindIndex(e, baseIsNaN, n);
}

function arrayIncludes(e, t) {
return !(null == e || !e.length) && baseIndexOf(e, t, 0) > -1;
}

var MAX_SAFE_INTEGER$1 = 9007199254740991, reIsUint = /^(?:0|[1-9]\d*)$/;

function isIndex(e, t) {
var n = typeof e;
return !!(t = null == t ? MAX_SAFE_INTEGER$1 : t) && ("number" == n || "symbol" != n && reIsUint.test(e)) && e > -1 && e % 1 == 0 && e < t;
}

function baseAssignValue(e, t, n) {
"__proto__" == t && defineProperty ? defineProperty(e, t, {
configurable: !0,
enumerable: !0,
value: n,
writable: !0
}) : e[t] = n;
}

function eq(e, t) {
return e === t || e != e && t != t;
}

var objectProto$b = Object.prototype, hasOwnProperty$a = objectProto$b.hasOwnProperty;

function assignValue(e, t, n) {
var o = e[t];
hasOwnProperty$a.call(e, t) && eq(o, n) && (void 0 !== n || t in e) || baseAssignValue(e, t, n);
}

function copyObject(e, t, n, o) {
var i = !n;
n || (n = {});
for (var a = -1, r = t.length; ++a < r; ) {
var s = t[a], l = o ? o(n[s], e[s], s, n, e) : void 0;
void 0 === l && (l = e[s]), i ? baseAssignValue(n, s, l) : assignValue(n, s, l);
}
return n;
}

var nativeMax = Math.max;

function overRest(e, t, n) {
return t = nativeMax(void 0 === t ? e.length - 1 : t, 0), function() {
for (var o = arguments, i = -1, a = nativeMax(o.length - t, 0), r = Array(a); ++i < a; ) r[i] = o[t + i];
i = -1;
for (var s = Array(t + 1); ++i < t; ) s[i] = o[i];
return s[t] = n(r), apply(e, this, s);
};
}

function baseRest(e, t) {
return setToString(overRest(e, t, identity), e + "");
}

var MAX_SAFE_INTEGER = 9007199254740991;

function isLength(e) {
return "number" == typeof e && e > -1 && e % 1 == 0 && e <= MAX_SAFE_INTEGER;
}

function isArrayLike(e) {
return null != e && isLength(e.length) && !isFunction(e);
}

var objectProto$a = Object.prototype;

function isPrototype(e) {
var t = e && e.constructor;
return e === ("function" == typeof t && t.prototype || objectProto$a);
}

function baseTimes(e, t) {
for (var n = -1, o = Array(e); ++n < e; ) o[n] = t(n);
return o;
}

var argsTag$3 = "[object Arguments]";

function baseIsArguments(e) {
return isObjectLike(e) && baseGetTag(e) == argsTag$3;
}

var objectProto$9 = Object.prototype, hasOwnProperty$9 = objectProto$9.hasOwnProperty, propertyIsEnumerable$1 = objectProto$9.propertyIsEnumerable, isArguments = baseIsArguments(function() {
return arguments;
}()) ? baseIsArguments : function(e) {
return isObjectLike(e) && hasOwnProperty$9.call(e, "callee") && !propertyIsEnumerable$1.call(e, "callee");
};

function stubFalse() {
return !1;
}

var freeExports$2 = "object" == ("undefined" == typeof exports ? "undefined" : typeof exports) && exports && !exports.nodeType && exports, freeModule$2 = freeExports$2 && "object" == ("undefined" == typeof module ? "undefined" : typeof module) && module && !module.nodeType && module, moduleExports$2 = freeModule$2 && freeModule$2.exports === freeExports$2, Buffer$1 = moduleExports$2 ? root.Buffer : void 0, nativeIsBuffer = Buffer$1 ? Buffer$1.isBuffer : void 0, isBuffer = nativeIsBuffer || stubFalse, argsTag$2 = "[object Arguments]", arrayTag$2 = "[object Array]", boolTag$3 = "[object Boolean]", dateTag$3 = "[object Date]", errorTag$2 = "[object Error]", funcTag$1 = "[object Function]", mapTag$5 = "[object Map]", numberTag$3 = "[object Number]", objectTag$3 = "[object Object]", regexpTag$3 = "[object RegExp]", setTag$5 = "[object Set]", stringTag$3 = "[object String]", weakMapTag$2 = "[object WeakMap]", arrayBufferTag$3 = "[object ArrayBuffer]", dataViewTag$4 = "[object DataView]", float32Tag$2 = "[object Float32Array]", float64Tag$2 = "[object Float64Array]", int8Tag$2 = "[object Int8Array]", int16Tag$2 = "[object Int16Array]", int32Tag$2 = "[object Int32Array]", uint8Tag$2 = "[object Uint8Array]", uint8ClampedTag$2 = "[object Uint8ClampedArray]", uint16Tag$2 = "[object Uint16Array]", uint32Tag$2 = "[object Uint32Array]", typedArrayTags = {};

function baseIsTypedArray(e) {
return isObjectLike(e) && isLength(e.length) && !!typedArrayTags[baseGetTag(e)];
}

function baseUnary(e) {
return function(t) {
return e(t);
};
}

typedArrayTags[float32Tag$2] = typedArrayTags[float64Tag$2] = typedArrayTags[int8Tag$2] = typedArrayTags[int16Tag$2] = typedArrayTags[int32Tag$2] = typedArrayTags[uint8Tag$2] = typedArrayTags[uint8ClampedTag$2] = typedArrayTags[uint16Tag$2] = typedArrayTags[uint32Tag$2] = !0, 
typedArrayTags[argsTag$2] = typedArrayTags[arrayTag$2] = typedArrayTags[arrayBufferTag$3] = typedArrayTags[boolTag$3] = typedArrayTags[dataViewTag$4] = typedArrayTags[dateTag$3] = typedArrayTags[errorTag$2] = typedArrayTags[funcTag$1] = typedArrayTags[mapTag$5] = typedArrayTags[numberTag$3] = typedArrayTags[objectTag$3] = typedArrayTags[regexpTag$3] = typedArrayTags[setTag$5] = typedArrayTags[stringTag$3] = typedArrayTags[weakMapTag$2] = !1;

var freeExports$1 = "object" == ("undefined" == typeof exports ? "undefined" : typeof exports) && exports && !exports.nodeType && exports, freeModule$1 = freeExports$1 && "object" == ("undefined" == typeof module ? "undefined" : typeof module) && module && !module.nodeType && module, moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1, freeProcess = moduleExports$1 && freeGlobal.process, nodeUtil = function() {
try {
return freeModule$1 && freeModule$1.require && freeModule$1.require("util").types || freeProcess && freeProcess.binding && freeProcess.binding("util");
} catch (e) {}
}(), nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray, isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray, objectProto$8 = Object.prototype, hasOwnProperty$8 = objectProto$8.hasOwnProperty;

function arrayLikeKeys(e, t) {
var n = isArray(e), o = !n && isArguments(e), i = !n && !o && isBuffer(e), a = !n && !o && !i && isTypedArray(e), r = n || o || i || a, s = r ? baseTimes(e.length, String) : [], l = s.length;
for (var c in e) !t && !hasOwnProperty$8.call(e, c) || r && ("length" == c || i && ("offset" == c || "parent" == c) || a && ("buffer" == c || "byteLength" == c || "byteOffset" == c) || isIndex(c, l)) || s.push(c);
return s;
}

function overArg(e, t) {
return function(n) {
return e(t(n));
};
}

var nativeKeys = overArg(Object.keys, Object), objectProto$7 = Object.prototype, hasOwnProperty$7 = objectProto$7.hasOwnProperty;

function baseKeys(e) {
if (!isPrototype(e)) return nativeKeys(e);
var t = [];
for (var n in Object(e)) hasOwnProperty$7.call(e, n) && "constructor" != n && t.push(n);
return t;
}

function keys(e) {
return isArrayLike(e) ? arrayLikeKeys(e) : baseKeys(e);
}

function nativeKeysIn(e) {
var t = [];
if (null != e) for (var n in Object(e)) t.push(n);
return t;
}

var objectProto$6 = Object.prototype, hasOwnProperty$6 = objectProto$6.hasOwnProperty;

function baseKeysIn(e) {
if (!isObject(e)) return nativeKeysIn(e);
var t = isPrototype(e), n = [];
for (var o in e) ("constructor" != o || !t && hasOwnProperty$6.call(e, o)) && n.push(o);
return n;
}

function keysIn(e) {
return isArrayLike(e) ? arrayLikeKeys(e, !0) : baseKeysIn(e);
}

var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/;

function isKey(e, t) {
if (isArray(e)) return !1;
var n = typeof e;
return !("number" != n && "symbol" != n && "boolean" != n && null != e && !isSymbol(e)) || reIsPlainProp.test(e) || !reIsDeepProp.test(e) || null != t && e in Object(t);
}

var nativeCreate = getNative(Object, "create");

function hashClear() {
this.__data__ = nativeCreate ? nativeCreate(null) : {}, this.size = 0;
}

function hashDelete(e) {
var t = this.has(e) && delete this.__data__[e];
return this.size -= t ? 1 : 0, t;
}

var HASH_UNDEFINED$2 = "__lodash_hash_undefined__", objectProto$5 = Object.prototype, hasOwnProperty$5 = objectProto$5.hasOwnProperty;

function hashGet(e) {
var t = this.__data__;
if (nativeCreate) {
var n = t[e];
return n === HASH_UNDEFINED$2 ? void 0 : n;
}
return hasOwnProperty$5.call(t, e) ? t[e] : void 0;
}

var objectProto$4 = Object.prototype, hasOwnProperty$4 = objectProto$4.hasOwnProperty;

function hashHas(e) {
var t = this.__data__;
return nativeCreate ? void 0 !== t[e] : hasOwnProperty$4.call(t, e);
}

var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";

function hashSet(e, t) {
var n = this.__data__;
return this.size += this.has(e) ? 0 : 1, n[e] = nativeCreate && void 0 === t ? HASH_UNDEFINED$1 : t, 
this;
}

function Hash(e) {
var t = -1, n = null == e ? 0 : e.length;
for (this.clear(); ++t < n; ) {
var o = e[t];
this.set(o[0], o[1]);
}
}

function listCacheClear() {
this.__data__ = [], this.size = 0;
}

function assocIndexOf(e, t) {
for (var n = e.length; n--; ) if (eq(e[n][0], t)) return n;
return -1;
}

Hash.prototype.clear = hashClear, Hash.prototype.delete = hashDelete, Hash.prototype.get = hashGet, 
Hash.prototype.has = hashHas, Hash.prototype.set = hashSet;

var arrayProto = Array.prototype, splice = arrayProto.splice;

function listCacheDelete(e) {
var t = this.__data__, n = assocIndexOf(t, e);
return !(n < 0 || (n == t.length - 1 ? t.pop() : splice.call(t, n, 1), --this.size, 
0));
}

function listCacheGet(e) {
var t = this.__data__, n = assocIndexOf(t, e);
return n < 0 ? void 0 : t[n][1];
}

function listCacheHas(e) {
return assocIndexOf(this.__data__, e) > -1;
}

function listCacheSet(e, t) {
var n = this.__data__, o = assocIndexOf(n, e);
return o < 0 ? (++this.size, n.push([ e, t ])) : n[o][1] = t, this;
}

function ListCache(e) {
var t = -1, n = null == e ? 0 : e.length;
for (this.clear(); ++t < n; ) {
var o = e[t];
this.set(o[0], o[1]);
}
}

ListCache.prototype.clear = listCacheClear, ListCache.prototype.delete = listCacheDelete, 
ListCache.prototype.get = listCacheGet, ListCache.prototype.has = listCacheHas, 
ListCache.prototype.set = listCacheSet;

var Map = getNative(root, "Map");

function mapCacheClear() {
this.size = 0, this.__data__ = {
hash: new Hash(),
map: new (Map || ListCache)(),
string: new Hash()
};
}

function isKeyable(e) {
var t = typeof e;
return "string" == t || "number" == t || "symbol" == t || "boolean" == t ? "__proto__" !== e : null === e;
}

function getMapData(e, t) {
var n = e.__data__;
return isKeyable(t) ? n["string" == typeof t ? "string" : "hash"] : n.map;
}

function mapCacheDelete(e) {
var t = getMapData(this, e).delete(e);
return this.size -= t ? 1 : 0, t;
}

function mapCacheGet(e) {
return getMapData(this, e).get(e);
}

function mapCacheHas(e) {
return getMapData(this, e).has(e);
}

function mapCacheSet(e, t) {
var n = getMapData(this, e), o = n.size;
return n.set(e, t), this.size += n.size == o ? 0 : 1, this;
}

function MapCache(e) {
var t = -1, n = null == e ? 0 : e.length;
for (this.clear(); ++t < n; ) {
var o = e[t];
this.set(o[0], o[1]);
}
}

MapCache.prototype.clear = mapCacheClear, MapCache.prototype.delete = mapCacheDelete, 
MapCache.prototype.get = mapCacheGet, MapCache.prototype.has = mapCacheHas, MapCache.prototype.set = mapCacheSet;

var FUNC_ERROR_TEXT = "Expected a function";

function memoize(e, t) {
if ("function" != typeof e || null != t && "function" != typeof t) throw new TypeError(FUNC_ERROR_TEXT);
var n = function n() {
var o = arguments, i = t ? t.apply(this, o) : o[0], a = n.cache;
if (a.has(i)) return a.get(i);
var r = e.apply(this, o);
return n.cache = a.set(i, r) || a, r;
};
return n.cache = new (memoize.Cache || MapCache)(), n;
}

memoize.Cache = MapCache;

var MAX_MEMOIZE_SIZE = 500;

function memoizeCapped(e) {
var t = memoize(e, function(e) {
return n.size === MAX_MEMOIZE_SIZE && n.clear(), e;
}), n = t.cache;
return t;
}

var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reEscapeChar = /\\(\\)?/g, stringToPath = memoizeCapped(function(e) {
var t = [];
return 46 === e.charCodeAt(0) && t.push(""), e.replace(rePropName, function(e, n, o, i) {
t.push(o ? i.replace(reEscapeChar, "$1") : n || e);
}), t;
});

function toString$1(e) {
return null == e ? "" : baseToString(e);
}

function castPath(e, t) {
return isArray(e) ? e : isKey(e, t) ? [ e ] : stringToPath(toString$1(e));
}

var INFINITY$1 = 1 / 0;

function toKey(e) {
if ("string" == typeof e || isSymbol(e)) return e;
var t = e + "";
return "0" == t && 1 / e == -INFINITY$1 ? "-0" : t;
}

function baseGet(e, t) {
for (var n = 0, o = (t = castPath(t, e)).length; null != e && n < o; ) e = e[toKey(t[n++])];
return n && n == o ? e : void 0;
}

function get(e, t, n) {
var o = null == e ? void 0 : baseGet(e, t);
return void 0 === o ? n : o;
}

function arrayPush(e, t) {
for (var n = -1, o = t.length, i = e.length; ++n < o; ) e[i + n] = t[n];
return e;
}

var spreadableSymbol = _Symbol ? _Symbol.isConcatSpreadable : void 0;

function isFlattenable(e) {
return isArray(e) || isArguments(e) || !!(spreadableSymbol && e && e[spreadableSymbol]);
}

function baseFlatten(e, t, n, o, i) {
var a = -1, r = e.length;
for (n || (n = isFlattenable), i || (i = []); ++a < r; ) {
var s = e[a];
t > 0 && n(s) ? t > 1 ? baseFlatten(s, t - 1, n, o, i) : arrayPush(i, s) : o || (i[i.length] = s);
}
return i;
}

var getPrototype = overArg(Object.getPrototypeOf, Object);

function stackClear() {
this.__data__ = new ListCache(), this.size = 0;
}

function stackDelete(e) {
var t = this.__data__, n = t.delete(e);
return this.size = t.size, n;
}

function stackGet(e) {
return this.__data__.get(e);
}

function stackHas(e) {
return this.__data__.has(e);
}

var LARGE_ARRAY_SIZE$2 = 200;

function stackSet(e, t) {
var n = this.__data__;
if (n instanceof ListCache) {
var o = n.__data__;
if (!Map || o.length < LARGE_ARRAY_SIZE$2 - 1) return o.push([ e, t ]), this.size = ++n.size, 
this;
n = this.__data__ = new MapCache(o);
}
return n.set(e, t), this.size = n.size, this;
}

function Stack(e) {
var t = this.__data__ = new ListCache(e);
this.size = t.size;
}

function baseAssign(e, t) {
return e && copyObject(t, keys(t), e);
}

function baseAssignIn(e, t) {
return e && copyObject(t, keysIn(t), e);
}

Stack.prototype.clear = stackClear, Stack.prototype.delete = stackDelete, Stack.prototype.get = stackGet, 
Stack.prototype.has = stackHas, Stack.prototype.set = stackSet;

var freeExports = "object" == ("undefined" == typeof exports ? "undefined" : typeof exports) && exports && !exports.nodeType && exports, freeModule = freeExports && "object" == ("undefined" == typeof module ? "undefined" : typeof module) && module && !module.nodeType && module, moduleExports = freeModule && freeModule.exports === freeExports, Buffer = moduleExports ? root.Buffer : void 0, allocUnsafe = Buffer ? Buffer.allocUnsafe : void 0;

function cloneBuffer(e, t) {
if (t) return e.slice();
var n = e.length, o = allocUnsafe ? allocUnsafe(n) : new e.constructor(n);
return e.copy(o), o;
}

function arrayFilter(e, t) {
for (var n = -1, o = null == e ? 0 : e.length, i = 0, a = []; ++n < o; ) {
var r = e[n];
t(r, n, e) && (a[i++] = r);
}
return a;
}

function stubArray() {
return [];
}

var objectProto$3 = Object.prototype, propertyIsEnumerable = objectProto$3.propertyIsEnumerable, nativeGetSymbols$1 = Object.getOwnPropertySymbols, getSymbols = nativeGetSymbols$1 ? function(e) {
return null == e ? [] : (e = Object(e), arrayFilter(nativeGetSymbols$1(e), function(t) {
return propertyIsEnumerable.call(e, t);
}));
} : stubArray;

function copySymbols(e, t) {
return copyObject(e, getSymbols(e), t);
}

var nativeGetSymbols = Object.getOwnPropertySymbols, getSymbolsIn = nativeGetSymbols ? function(e) {
for (var t = []; e; ) arrayPush(t, getSymbols(e)), e = getPrototype(e);
return t;
} : stubArray;

function copySymbolsIn(e, t) {
return copyObject(e, getSymbolsIn(e), t);
}

function baseGetAllKeys(e, t, n) {
var o = t(e);
return isArray(e) ? o : arrayPush(o, n(e));
}

function getAllKeys(e) {
return baseGetAllKeys(e, keys, getSymbols);
}

function getAllKeysIn(e) {
return baseGetAllKeys(e, keysIn, getSymbolsIn);
}

var DataView = getNative(root, "DataView"), Promise$1 = getNative(root, "Promise"), Set = getNative(root, "Set"), mapTag$4 = "[object Map]", objectTag$2 = "[object Object]", promiseTag = "[object Promise]", setTag$4 = "[object Set]", weakMapTag$1 = "[object WeakMap]", dataViewTag$3 = "[object DataView]", dataViewCtorString = toSource(DataView), mapCtorString = toSource(Map), promiseCtorString = toSource(Promise$1), setCtorString = toSource(Set), weakMapCtorString = toSource(WeakMap), getTag = baseGetTag;

(DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag$3 || Map && getTag(new Map()) != mapTag$4 || Promise$1 && getTag(Promise$1.resolve()) != promiseTag || Set && getTag(new Set()) != setTag$4 || WeakMap && getTag(new WeakMap()) != weakMapTag$1) && (getTag = function(e) {
var t = baseGetTag(e), n = t == objectTag$2 ? e.constructor : void 0, o = n ? toSource(n) : "";
if (o) switch (o) {
case dataViewCtorString:
return dataViewTag$3;

case mapCtorString:
return mapTag$4;

case promiseCtorString:
return promiseTag;

case setCtorString:
return setTag$4;

case weakMapCtorString:
return weakMapTag$1;
}
return t;
});

var getTag$1 = getTag, objectProto$2 = Object.prototype, hasOwnProperty$3 = objectProto$2.hasOwnProperty;

function initCloneArray(e) {
var t = e.length, n = new e.constructor(t);
return t && "string" == typeof e[0] && hasOwnProperty$3.call(e, "index") && (n.index = e.index, 
n.input = e.input), n;
}

var Uint8Array$1 = root.Uint8Array;

function cloneArrayBuffer(e) {
var t = new e.constructor(e.byteLength);
return new Uint8Array$1(t).set(new Uint8Array$1(e)), t;
}

function cloneDataView(e, t) {
var n = t ? cloneArrayBuffer(e.buffer) : e.buffer;
return new e.constructor(n, e.byteOffset, e.byteLength);
}

var reFlags = /\w*$/;

function cloneRegExp(e) {
var t = new e.constructor(e.source, reFlags.exec(e));
return t.lastIndex = e.lastIndex, t;
}

var symbolProto$1 = _Symbol ? _Symbol.prototype : void 0, symbolValueOf$1 = symbolProto$1 ? symbolProto$1.valueOf : void 0;

function cloneSymbol(e) {
return symbolValueOf$1 ? Object(symbolValueOf$1.call(e)) : {};
}

function cloneTypedArray(e, t) {
var n = t ? cloneArrayBuffer(e.buffer) : e.buffer;
return new e.constructor(n, e.byteOffset, e.length);
}

var boolTag$2 = "[object Boolean]", dateTag$2 = "[object Date]", mapTag$3 = "[object Map]", numberTag$2 = "[object Number]", regexpTag$2 = "[object RegExp]", setTag$3 = "[object Set]", stringTag$2 = "[object String]", symbolTag$2 = "[object Symbol]", arrayBufferTag$2 = "[object ArrayBuffer]", dataViewTag$2 = "[object DataView]", float32Tag$1 = "[object Float32Array]", float64Tag$1 = "[object Float64Array]", int8Tag$1 = "[object Int8Array]", int16Tag$1 = "[object Int16Array]", int32Tag$1 = "[object Int32Array]", uint8Tag$1 = "[object Uint8Array]", uint8ClampedTag$1 = "[object Uint8ClampedArray]", uint16Tag$1 = "[object Uint16Array]", uint32Tag$1 = "[object Uint32Array]";

function initCloneByTag(e, t, n) {
var o = e.constructor;
switch (t) {
case arrayBufferTag$2:
return cloneArrayBuffer(e);

case boolTag$2:
case dateTag$2:
return new o(+e);

case dataViewTag$2:
return cloneDataView(e, n);

case float32Tag$1:
case float64Tag$1:
case int8Tag$1:
case int16Tag$1:
case int32Tag$1:
case uint8Tag$1:
case uint8ClampedTag$1:
case uint16Tag$1:
case uint32Tag$1:
return cloneTypedArray(e, n);

case mapTag$3:
return new o();

case numberTag$2:
case stringTag$2:
return new o(e);

case regexpTag$2:
return cloneRegExp(e);

case setTag$3:
return new o();

case symbolTag$2:
return cloneSymbol(e);
}
}

function initCloneObject(e) {
return "function" != typeof e.constructor || isPrototype(e) ? {} : baseCreate(getPrototype(e));
}

var mapTag$2 = "[object Map]";

function baseIsMap(e) {
return isObjectLike(e) && getTag$1(e) == mapTag$2;
}

var nodeIsMap = nodeUtil && nodeUtil.isMap, isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap, setTag$2 = "[object Set]";

function baseIsSet(e) {
return isObjectLike(e) && getTag$1(e) == setTag$2;
}

var nodeIsSet = nodeUtil && nodeUtil.isSet, isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet, CLONE_DEEP_FLAG$1 = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG$1 = 4, argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", errorTag$1 = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag$1 = "[object Map]", numberTag$1 = "[object Number]", objectTag$1 = "[object Object]", regexpTag$1 = "[object RegExp]", setTag$1 = "[object Set]", stringTag$1 = "[object String]", symbolTag$1 = "[object Symbol]", weakMapTag = "[object WeakMap]", arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$1 = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]", cloneableTags = {};

function baseClone(e, t, n, o, i, a) {
var r, s = t & CLONE_DEEP_FLAG$1, l = t & CLONE_FLAT_FLAG, c = t & CLONE_SYMBOLS_FLAG$1;
if (n && (r = i ? n(e, o, i, a) : n(e)), void 0 !== r) return r;
if (!isObject(e)) return e;
var d = isArray(e);
if (d) {
if (r = initCloneArray(e), !s) return copyArray(e, r);
} else {
var h = getTag$1(e), u = h == funcTag || h == genTag;
if (isBuffer(e)) return cloneBuffer(e, s);
if (h == objectTag$1 || h == argsTag$1 || u && !i) {
if (r = l || u ? {} : initCloneObject(e), !s) return l ? copySymbolsIn(e, baseAssignIn(r, e)) : copySymbols(e, baseAssign(r, e));
} else {
if (!cloneableTags[h]) return i ? e : {};
r = initCloneByTag(e, h, s);
}
}
a || (a = new Stack());
var f = a.get(e);
if (f) return f;
a.set(e, r), isSet(e) ? e.forEach(function(o) {
r.add(baseClone(o, t, n, o, e, a));
}) : isMap(e) && e.forEach(function(o, i) {
r.set(i, baseClone(o, t, n, i, e, a));
});
var _ = d ? void 0 : (c ? l ? getAllKeysIn : getAllKeys : l ? keysIn : keys)(e);
return arrayEach(_ || e, function(o, i) {
_ && (o = e[i = o]), assignValue(r, i, baseClone(o, t, n, i, e, a));
}), r;
}

cloneableTags[argsTag$1] = cloneableTags[arrayTag$1] = cloneableTags[arrayBufferTag$1] = cloneableTags[dataViewTag$1] = cloneableTags[boolTag$1] = cloneableTags[dateTag$1] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag$1] = cloneableTags[numberTag$1] = cloneableTags[objectTag$1] = cloneableTags[regexpTag$1] = cloneableTags[setTag$1] = cloneableTags[stringTag$1] = cloneableTags[symbolTag$1] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = !0, 
cloneableTags[errorTag$1] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = !1;

var CLONE_DEEP_FLAG = 1, CLONE_SYMBOLS_FLAG = 4;

function cloneDeep(e) {
return baseClone(e, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
}

var HASH_UNDEFINED = "__lodash_hash_undefined__";

function setCacheAdd(e) {
return this.__data__.set(e, HASH_UNDEFINED), this;
}

function setCacheHas(e) {
return this.__data__.has(e);
}

function SetCache(e) {
var t = -1, n = null == e ? 0 : e.length;
for (this.__data__ = new MapCache(); ++t < n; ) this.add(e[t]);
}

function arraySome(e, t) {
for (var n = -1, o = null == e ? 0 : e.length; ++n < o; ) if (t(e[n], n, e)) return !0;
return !1;
}

function cacheHas(e, t) {
return e.has(t);
}

SetCache.prototype.add = SetCache.prototype.push = setCacheAdd, SetCache.prototype.has = setCacheHas;

var COMPARE_PARTIAL_FLAG$5 = 1, COMPARE_UNORDERED_FLAG$3 = 2;

function equalArrays(e, t, n, o, i, a) {
var r = n & COMPARE_PARTIAL_FLAG$5, s = e.length, l = t.length;
if (s != l && !(r && l > s)) return !1;
var c = a.get(e), d = a.get(t);
if (c && d) return c == t && d == e;
var h = -1, u = !0, f = n & COMPARE_UNORDERED_FLAG$3 ? new SetCache() : void 0;
for (a.set(e, t), a.set(t, e); ++h < s; ) {
var _ = e[h], p = t[h];
if (o) var g = r ? o(p, _, h, t, e, a) : o(_, p, h, e, t, a);
if (void 0 !== g) {
if (g) continue;
u = !1;
break;
}
if (f) {
if (!arraySome(t, function(e, t) {
if (!cacheHas(f, t) && (_ === e || i(_, e, n, o, a))) return f.push(t);
})) {
u = !1;
break;
}
} else if (_ !== p && !i(_, p, n, o, a)) {
u = !1;
break;
}
}
return a.delete(e), a.delete(t), u;
}

function mapToArray(e) {
var t = -1, n = Array(e.size);
return e.forEach(function(e, o) {
n[++t] = [ o, e ];
}), n;
}

function setToArray(e) {
var t = -1, n = Array(e.size);
return e.forEach(function(e) {
n[++t] = e;
}), n;
}

var COMPARE_PARTIAL_FLAG$4 = 1, COMPARE_UNORDERED_FLAG$2 = 2, boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", mapTag = "[object Map]", numberTag = "[object Number]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", symbolProto = _Symbol ? _Symbol.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;

function equalByTag(e, t, n, o, i, a, r) {
switch (n) {
case dataViewTag:
if (e.byteLength != t.byteLength || e.byteOffset != t.byteOffset) return !1;
e = e.buffer, t = t.buffer;

case arrayBufferTag:
return !(e.byteLength != t.byteLength || !a(new Uint8Array$1(e), new Uint8Array$1(t)));

case boolTag:
case dateTag:
case numberTag:
return eq(+e, +t);

case errorTag:
return e.name == t.name && e.message == t.message;

case regexpTag:
case stringTag:
return e == t + "";

case mapTag:
var s = mapToArray;

case setTag:
var l = o & COMPARE_PARTIAL_FLAG$4;
if (s || (s = setToArray), e.size != t.size && !l) return !1;
var c = r.get(e);
if (c) return c == t;
o |= COMPARE_UNORDERED_FLAG$2, r.set(e, t);
var d = equalArrays(s(e), s(t), o, i, a, r);
return r.delete(e), d;

case symbolTag:
if (symbolValueOf) return symbolValueOf.call(e) == symbolValueOf.call(t);
}
return !1;
}

var COMPARE_PARTIAL_FLAG$3 = 1, objectProto$1 = Object.prototype, hasOwnProperty$2 = objectProto$1.hasOwnProperty;

function equalObjects(e, t, n, o, i, a) {
var r = n & COMPARE_PARTIAL_FLAG$3, s = getAllKeys(e), l = s.length;
if (l != getAllKeys(t).length && !r) return !1;
for (var c = l; c--; ) {
var d = s[c];
if (!(r ? d in t : hasOwnProperty$2.call(t, d))) return !1;
}
var h = a.get(e), u = a.get(t);
if (h && u) return h == t && u == e;
var f = !0;
a.set(e, t), a.set(t, e);
for (var _ = r; ++c < l; ) {
var p = e[d = s[c]], g = t[d];
if (o) var v = r ? o(g, p, d, t, e, a) : o(p, g, d, e, t, a);
if (!(void 0 === v ? p === g || i(p, g, n, o, a) : v)) {
f = !1;
break;
}
_ || (_ = "constructor" == d);
}
if (f && !_) {
var m = e.constructor, A = t.constructor;
m != A && "constructor" in e && "constructor" in t && !("function" == typeof m && m instanceof m && "function" == typeof A && A instanceof A) && (f = !1);
}
return a.delete(e), a.delete(t), f;
}

var COMPARE_PARTIAL_FLAG$2 = 1, argsTag = "[object Arguments]", arrayTag = "[object Array]", objectTag = "[object Object]", objectProto = Object.prototype, hasOwnProperty$1 = objectProto.hasOwnProperty;

function baseIsEqualDeep(e, t, n, o, i, a) {
var r = isArray(e), s = isArray(t), l = r ? arrayTag : getTag$1(e), c = s ? arrayTag : getTag$1(t), d = (l = l == argsTag ? objectTag : l) == objectTag, h = (c = c == argsTag ? objectTag : c) == objectTag, u = l == c;
if (u && isBuffer(e)) {
if (!isBuffer(t)) return !1;
r = !0, d = !1;
}
if (u && !d) return a || (a = new Stack()), r || isTypedArray(e) ? equalArrays(e, t, n, o, i, a) : equalByTag(e, t, l, n, o, i, a);
if (!(n & COMPARE_PARTIAL_FLAG$2)) {
var f = d && hasOwnProperty$1.call(e, "__wrapped__"), _ = h && hasOwnProperty$1.call(t, "__wrapped__");
if (f || _) {
var p = f ? e.value() : e, g = _ ? t.value() : t;
return a || (a = new Stack()), i(p, g, n, o, a);
}
}
return !!u && (a || (a = new Stack()), equalObjects(e, t, n, o, i, a));
}

function baseIsEqual(e, t, n, o, i) {
return e === t || (null == e || null == t || !isObjectLike(e) && !isObjectLike(t) ? e != e && t != t : baseIsEqualDeep(e, t, n, o, baseIsEqual, i));
}

var COMPARE_PARTIAL_FLAG$1 = 1, COMPARE_UNORDERED_FLAG$1 = 2;

function baseIsMatch(e, t, n, o) {
var i = n.length, a = i, r = !o;
if (null == e) return !a;
for (e = Object(e); i--; ) {
var s = n[i];
if (r && s[2] ? s[1] !== e[s[0]] : !(s[0] in e)) return !1;
}
for (;++i < a; ) {
var l = (s = n[i])[0], c = e[l], d = s[1];
if (r && s[2]) {
if (void 0 === c && !(l in e)) return !1;
} else {
var h = new Stack();
if (o) var u = o(c, d, l, e, t, h);
if (!(void 0 === u ? baseIsEqual(d, c, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, o, h) : u)) return !1;
}
}
return !0;
}

function isStrictComparable(e) {
return e == e && !isObject(e);
}

function getMatchData(e) {
for (var t = keys(e), n = t.length; n--; ) {
var o = t[n], i = e[o];
t[n] = [ o, i, isStrictComparable(i) ];
}
return t;
}

function matchesStrictComparable(e, t) {
return function(n) {
return null != n && n[e] === t && (void 0 !== t || e in Object(n));
};
}

function baseMatches(e) {
var t = getMatchData(e);
return 1 == t.length && t[0][2] ? matchesStrictComparable(t[0][0], t[0][1]) : function(n) {
return n === e || baseIsMatch(n, e, t);
};
}

function baseHasIn(e, t) {
return null != e && t in Object(e);
}

function hasPath(e, t, n) {
for (var o = -1, i = (t = castPath(t, e)).length, a = !1; ++o < i; ) {
var r = toKey(t[o]);
if (!(a = null != e && n(e, r))) break;
e = e[r];
}
return a || ++o != i ? a : !!(i = null == e ? 0 : e.length) && isLength(i) && isIndex(r, i) && (isArray(e) || isArguments(e));
}

function hasIn(e, t) {
return null != e && hasPath(e, t, baseHasIn);
}

var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;

function baseMatchesProperty(e, t) {
return isKey(e) && isStrictComparable(t) ? matchesStrictComparable(toKey(e), t) : function(n) {
var o = get(n, e);
return void 0 === o && o === t ? hasIn(n, e) : baseIsEqual(t, o, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
};
}

function baseProperty(e) {
return function(t) {
return null == t ? void 0 : t[e];
};
}

function basePropertyDeep(e) {
return function(t) {
return baseGet(t, e);
};
}

function property(e) {
return isKey(e) ? baseProperty(toKey(e)) : basePropertyDeep(e);
}

function baseIteratee(e) {
return "function" == typeof e ? e : null == e ? identity : "object" == typeof e ? isArray(e) ? baseMatchesProperty(e[0], e[1]) : baseMatches(e) : property(e);
}

function isArrayLikeObject(e) {
return isObjectLike(e) && isArrayLike(e);
}

function arrayIncludesWith(e, t, n) {
for (var o = -1, i = null == e ? 0 : e.length; ++o < i; ) if (n(t, e[o])) return !0;
return !1;
}

var LARGE_ARRAY_SIZE$1 = 200;

function baseDifference(e, t, n, o) {
var i = -1, a = arrayIncludes, r = !0, s = e.length, l = [], c = t.length;
if (!s) return l;
n && (t = arrayMap(t, baseUnary(n))), o ? (a = arrayIncludesWith, r = !1) : t.length >= LARGE_ARRAY_SIZE$1 && (a = cacheHas, 
r = !1, t = new SetCache(t));
e: for (;++i < s; ) {
var d = e[i], h = null == n ? d : n(d);
if (d = o || 0 !== d ? d : 0, r && h == h) {
for (var u = c; u--; ) if (t[u] === h) continue e;
l.push(d);
} else a(t, h, o) || l.push(d);
}
return l;
}

function last(e) {
var t = null == e ? 0 : e.length;
return t ? e[t - 1] : void 0;
}

var INFINITY = 1 / 0, createSet = Set && 1 / setToArray(new Set([ , -0 ]))[1] == INFINITY ? function(e) {
return new Set(e);
} : noop, LARGE_ARRAY_SIZE = 200;

function baseUniq(e, t, n) {
var o = -1, i = arrayIncludes, a = e.length, r = !0, s = [], l = s;
if (n) r = !1, i = arrayIncludesWith; else if (a >= LARGE_ARRAY_SIZE) {
var c = t ? null : createSet(e);
if (c) return setToArray(c);
r = !1, i = cacheHas, l = new SetCache();
} else l = t ? [] : s;
e: for (;++o < a; ) {
var d = e[o], h = t ? t(d) : d;
if (d = n || 0 !== d ? d : 0, r && h == h) {
for (var u = l.length; u--; ) if (l[u] === h) continue e;
t && l.push(h), s.push(d);
} else i(l, h, n) || (l !== s && l.push(h), s.push(d));
}
return s;
}

function uniq(e) {
return e && e.length ? baseUniq(e) : [];
}

function baseXor(e, t, n) {
var o = e.length;
if (o < 2) return o ? baseUniq(e[0]) : [];
for (var i = -1, a = Array(o); ++i < o; ) for (var r = e[i], s = -1; ++s < o; ) s != i && (a[i] = baseDifference(a[i] || r, e[s], t, n));
return baseUniq(baseFlatten(a, 1), t, n);
}

var xorBy = baseRest(function(e) {
var t = last(e);
return isArrayLikeObject(t) && (t = void 0), baseXor(arrayFilter(e, isArrayLikeObject), baseIteratee(t));
}), C_MaxTimesOfCreateBanner = 3, C_MaxTimesOfCreateInterstitial = 3, AdvBase = function() {
function e() {
_classCallCheck2(this, e);
this._bannerAdUnitIDIndex = -1, this._bannerAdObj = null, this._bannerAdObjs = [], 
this._bannerAdObjIndex = -1, this._preloadBannerAdObj = null, this._preloadingBannerAd = !1, 
this._failCountOfCreateBanner = 0, this._passedTimeFromLastRefresh = 0, this._bannerOnShow = !1, 
this._isForceUnSupportedVideo = !1, this._videoAdUnitIDIndex = -1, this._videoAdIns = null, 
this._interstitialAdUnitIDIndex = -1, this._interstitialAdObj = null, this._preloadInterstitialAdObj = null, 
this._preloadingInterstitialAd = !1, this._failCountOfCreateInterstitial = 0, this._lastTimeOfShowInterstitialAd = 0, 
this._gapOfEachInterstitialAd = 0, this._isCustomAdOnShow = {}, this._onLoadedCustomAdObjs = {};
}
_createClass2(e, [ {
key: "isSupportBannerAd",
value: function() {
return PlatAdUnitIDs.bannerAdUnitIDs.length > 0;
}
}, {
key: "_stopSupportBannerAd",
value: function() {
console.log("stop support banner ad..."), Event.dispatchEvent(EventName.EN_BANNER_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "isSupportVideoAd",
value: function() {
return PlatAdUnitIDs.videoAdUnitIDs.length > 0 && !this._isForceUnSupportedVideo;
}
}, {
key: "_stopSupportVideoAd",
value: function() {
console.log("stop support video ad..."), this._isForceUnSupportedVideo = !0, Event.dispatchEvent(EventName.EN_VIDEO_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "isSupportInterstitialAd",
value: function() {
return PlatAdUnitIDs.interstitialAdUnitIDs.length > 0;
}
}, {
key: "_stopSupportInterstitialAd",
value: function() {
console.log("stop support interstitial ad..."), Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "preload",
value: function() {
var e = this;
if (HLSDKLocalData$1._globalBannerCfg.preloadCount > 1 && this.isSupportBannerAd()) {
Event.addEventListerner(EventName.EN_APP_ONHIDE, function() {
e._bannerAdObj && (e._bannerAdObj._clickedTimes += 1);
});
for (var t = [], n = 0; n < HLSDKLocalData$1._globalBannerCfg.preloadCount; n++) t.push(0);
for (var o = function n(o) {
e._doCreateBannerAdObj(null, function(t) {
console.log("preload a banner finished..."), e._bannerAdObjs.push(t);
}, function() {
t[o] += 1, t[o] < C_MaxTimesOfCreateBanner && (console.log("preload a banner failed..."), 
Scheduler.schedule("Delay_Recreate_Banner_" + o.toString(), function() {
console.log("retry preload banner..."), n(o);
}, !1, 200, 0));
});
}, i = 0; i < HLSDKLocalData$1._globalBannerCfg.preloadCount; i++) o(i);
} else this._preloadBannerAd();
this._preloadVideoAd(), _isQQPlatform() && this._preloadInterstitialAd(), this._lastTimeOfShowInterstitialAd = ServerInfo.getServerTime();
}
}, {
key: "getOnShowBannerAdUnitIDs",
value: function() {
var e = [];
return this._bannerAdObjs.length > 0 && this._bannerAdObjs.forEach(function(t) {
e.push(t._adUnitId);
}), 0 === e.length && this._bannerAdObj && e.push(this._bannerAdObj._adUnitId), 
e;
}
}, {
key: "createBannerAd",
value: function() {}
}, {
key: "_getBannerAdObj",
value: function() {}
}, {
key: "_preloadBannerAd",
value: function() {}
}, {
key: "_doCreateBannerAdObj",
value: function() {}
}, {
key: "showBannerAd",
value: function() {}
}, {
key: "_showBannerAd",
value: function() {}
}, {
key: "hideBannerAd",
value: function() {}
}, {
key: "_hideBannerAd",
value: function() {}
}, {
key: "destroyBannerAdv",
value: function() {}
}, {
key: "createVideoAdv",
value: function(e, t, n) {
var o = this;
if (PlatHelper.getPlat() && PlatHelper.getPlat().createRewardedVideoAd) {
if (!this.isSupportVideoAd()) return Event.dispatchEvent(EventName.EN_VIDEO_NOT_SUPPORT_RIGHT_NOW), 
void ("function" == typeof n && n("Stop Support..."));
if (void 0 === n && (n = null), null !== this._videoAdIns) {
var i = this;
"function" == typeof t && (this._videoAdIns.closeCb = t), "function" == typeof n && (this._videoAdIns.errCb = n);
var a = this._videoAdIns.show();
null != a && a.then(function() {
adv_interface.reportShowAdv(FlowAdvType.RewardedVideo, PlatAdOnShowFlow.video), 
doCallback$1(e);
}).catch(function() {
o._videoAdIns && o._videoAdIns.load().then(function() {
return o._videoAdIns.show().then(function() {
adv_interface.reportShowAdv(FlowAdvType.RewardedVideo, PlatAdOnShowFlow.video), 
doCallback$1(e);
});
}).catch(function(e) {
if (i._stopSupportVideoAd(), o._videoAdIns) {
var t = o._videoAdIns.errCb;
doCallback$1(t, e), checkFunc(t) || console.error(e), o._videoAdIns = null;
}
});
});
} else this._stopSupportVideoAd(), "function" == typeof n && n("Stop Support...");
} else "function" == typeof t && t(!0);
}
}, {
key: "_preloadVideoAd",
value: function(e) {
this.isSupportVideoAd() ? null === this._videoAdIns && (this._videoAdIns = this._doCreateVideoAdObj(function() {
console.log("preload video finished...");
})) : doCallback$1(e);
}
}, {
key: "_doCreateVideoAdObj",
value: function(e) {
if (this._videoAdIns) return this._videoAdIns;
if (this._videoAdUnitIDIndex += 1, this._videoAdUnitIDIndex >= PlatAdUnitIDs.videoAdUnitIDs.length && (this._videoAdUnitIDIndex = 0), 
this._videoAdIns = null, PlatHelper.getPlat().createRewardedVideoAd && (this._videoAdIns = PlatHelper.getPlat().createRewardedVideoAd({
adUnitId: PlatAdUnitIDs.videoAdUnitIDs[this._videoAdUnitIDIndex]
})), this._videoAdIns) {
var t = this;
this._videoAdIns.onLoad(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.RewardedVideo), "function" == typeof e && e();
}), this._videoAdIns.onClose(function(e) {
if (t._videoAdIns) {
var n = t._videoAdIns.closeCb;
t._videoAdIns.errCb, t._videoAdIns.closeCb = null, t._videoAdIns.errCb = null, !e || e.isEnded ? n && n(!0) : n && n(!1), 
t._preloadVideoAd();
}
}), this._videoAdIns.onError(function(e) {
if (adv_interface.reportLoadFailAdv(FlowAdvType.RewardedVideo), t._stopSupportVideoAd(), 
t._videoAdIns) {
var n = t._videoAdIns.errCb;
n ? n(e) : console.error(e), t._videoAdIns = null;
}
});
}
return this._videoAdIns;
}
}, {
key: "isWatchingVideoAdv",
value: function() {
return !(!this._videoAdIns || !this._videoAdIns.closeCb);
}
}, {
key: "createInterstitialAd",
value: function(e, t, n) {
var o = this;
if (!this.isSupportInterstitialAd()) return Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW), 
void doCallback$1(n);
if (this._canShowInterstitialNow()) {
if (this._failCountOfCreateInterstitial = 0, this._interstitialAdObj) {
var i = this._interstitialAdObj;
this._isSupportDelayDestroyInterstitial() && Scheduler.schedule("Destroy_old_Interstitial", function() {
console.log("destory old interstitial..."), i && i.destroy();
}.bind(this), !1, 60, 0), this._interstitialAdObj = null;
}
this._getInterstitialAdObj(function() {
o.showInterstitialAd(e, n);
}, t, n);
} else doCallback$1(n);
}
}, {
key: "_getInterstitialAdObj",
value: function(e, t, n) {
var o = null, i = function() {
this._preloadingInterstitialAd = !0, Scheduler.schedule("Delay_Preload_Interstitial", function() {
var e = this;
console.log("Delay preload next interstitial..."), this._preloadInterstitialAd(function() {
e._preloadingInterstitialAd = !1, console.log("Delay preload create interstitial success");
}, function() {
e._preloadingInterstitialAd = !1, console.log("Delay preload create interstitial fail");
});
}.bind(this), !1, 30, 0);
}.bind(this);
null != this._preloadInterstitialAdObj ? (o = this._preloadInterstitialAdObj, this._preloadInterstitialAdObj = null, 
i()) : this._preloadingInterstitialAd || i(), o ? ("function" == typeof t && (o.closeCb = t), 
this._interstitialAdObj = o, doCallback$1(e, o)) : this._interstitialAdObj = this._doCreateInterstitialAdObj(t, e, n);
}
}, {
key: "_preloadInterstitialAd",
value: function(e, t) {
var n = this;
this.isSupportInterstitialAd() && this._isSupportPreloadInterstitial() ? null === this._preloadInterstitialAdObj ? this._doCreateInterstitialAdObj(null, function(t) {
console.log("preload interstitial finished..."), n._preloadInterstitialAdObj = t, 
"function" == typeof e && e(t);
}, t) : "function" == typeof e && e(this._preloadInterstitialAdObj) : doCallback$1(t);
}
}, {
key: "_doCreateInterstitialAdObj",
value: function(e, t, n) {
var o = this;
this._interstitialAdUnitIDIndex += 1, this._interstitialAdUnitIDIndex >= PlatAdUnitIDs.interstitialAdUnitIDs.length && (this._interstitialAdUnitIDIndex = 0);
var i = PlatHelper.getPlat().createInterstitialAd({
adUnitId: PlatAdUnitIDs.interstitialAdUnitIDs[this._interstitialAdUnitIDIndex]
});
"function" == typeof e && (i.closeCb = e), "function" == typeof t && (i.loadCb = t), 
"function" == typeof n && (i.errCb = n);
var a = this;
i.onClose(function e() {
i.offClose(e), o._lastTimeOfShowInterstitialAd = ServerInfo.getServerTime();
var t = i.closeCb;
i.closeCb = void 0, t && t();
});
i.onLoad(function e() {
i.offLoad(e), adv_interface.reportLoadSuccAdv(FlowAdvType.Interstitial);
var t = i.loadCb;
i.loadCb = void 0, t && t(i);
});
return i.onError(function o(r) {
i.offError(o), adv_interface.reportLoadFailAdv(FlowAdvType.Interstitial);
var s = null;
i && (s = i.errCb, i = null), a._failCountOfCreateInterstitial += 1, a._failCountOfCreateInterstitial >= C_MaxTimesOfCreateInterstitial ? (doCallback$1(s, r), 
checkFunc(s) || console.error(r)) : Scheduler.schedule("Delay_Recreate_Interstitial", function() {
console.log("retry preload interstitial..."), a._doCreateInterstitialAdObj(e, t, n);
}, !1, 200, 0);
}), i;
}
}, {
key: "showInterstitialAd",
value: function(e, t) {
this._interstitialAdObj && this._interstitialAdObj.show().then(function() {
doCallback$1(e), adv_interface.reportShowAdv(FlowAdvType.Interstitial, PlatAdOnShowFlow.interstitial);
}).catch(function(e) {
doCallback$1(t, e), checkFunc(t) || console.error(e);
});
}
}, {
key: "createCustomAd",
value: function(e, t) {
var n = this, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 0, i = arguments.length > 3 ? arguments[3] : void 0, a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, r = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null, s = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : null;
if (PlatAdUnitIDs.customAdUnitIDs && 0 !== PlatAdUnitIDs.customAdUnitIDs.length && -1 !== PlatAdUnitIDs.customAdUnitIDs.indexOf(e)) {
var l = !1;
isLoadOPPOConfig() && (l = !0), this._isCustomAdOnShow[e] = !0;
var c = this._onLoadedCustomAdObjs[e], d = function() {
n._isCustomAdOnShow[e] ? (adv_interface.reportShowAdv(FlowAdvType.Custom, PlatAdOnShowFlow.custom), 
console.log("customAdObj.show"), doCallback$1(a)) : c.hide();
}, h = function(e) {
adv_interface.reportLoadFailAdv(FlowAdvType.Custom), checkFunc(s) ? doCallback$1(s, e) : console.error(e);
};
try {
null == c ? l ? (c = this._doCreateCustomAd(e, o, t, null), this._onLoadedCustomAdObjs[e] = c, 
i ? c.show().then(d) : doCallback$1(a)) : c = this._doCreateCustomAd(e, o, t, function(t) {
t && (n._onLoadedCustomAdObjs[e] = t, n._isCustomAdOnShow[e] ? i ? t.show().then(d) : doCallback$1(a) : i || doCallback$1(a));
}) : i ? c.show().then(d) : doCallback$1(a);
} catch (e) {
h(e);
}
null != c && (null != c.offError && null != c.errorBack && c.offError(c.errorBack), 
c.errorBack = h, null != c.onError && c.onError(c.errorBack), null != c.offHide && null != c.hideBack && c.offHide(c.hideBack), 
c.hideBack = function() {
console.log("customAdObj.onHide"), doCallback$1(r), c.offHide(c.hideCustomAd);
}, null != c.offClose && null != c.closeBack && c.offClose(c.closeBack), c.closeBack = function() {
console.log("customAdObj.onClose......."), doCallback$1(r), c.offClose(c.hideCustomAd), 
Scheduler.unschedule("Schedule_Of_Create_CustomAd_Agin"), Scheduler.schedule("Schedule_Of_Create_CustomAd_Agin", function() {
n._onLoadedCustomAdObjs[e] = null, n.createCustomAd(e, t, o, !1, a, r, s);
}, !1, 2e3, 0);
}, null != c.onHide && c.onHide(c.hideBack), null != c.onClose && c.onClose(c.closeBack));
} else console.error("Config Target Custom adUnitId first, adUnitId:", e);
}
}, {
key: "showCustomAd",
value: function(e) {
if (!this._isCustomAdOnShow[e] && void 0 !== this._onLoadedCustomAdObjs[e]) {
this._isCustomAdOnShow[e] = !0;
var t = this._onLoadedCustomAdObjs[e];
void 0 !== t && (isLoadOPPOConfig() ? t.show() : t.isShow() || t.show());
}
}
}, {
key: "hideCustomAd",
value: function(e) {
if (this._isCustomAdOnShow[e]) {
this._isCustomAdOnShow[e] = !1;
var t = this._onLoadedCustomAdObjs[e];
void 0 !== t && (isLoadOPPOConfig() ? t.hide() : t.isShow() && t.hide());
}
}
}, {
key: "hideAllCustomAds",
value: function() {
for (var e in this._isCustomAdOnShow) this._isCustomAdOnShow[e] && this.hideCustomAd(e);
}
}, {
key: "destoryCustomAd",
value: function(e) {
this._isCustomAdOnShow[e] = !1;
var t = this._onLoadedCustomAdObjs[e];
void 0 !== t && (t.destroy(), delete this._onLoadedCustomAdObjs[e]);
}
}, {
key: "isCustomAdPreloaded",
value: function(e) {
return void 0 !== this._onLoadedCustomAdObjs[e];
}
}, {
key: "isCustomAdOnShow",
value: function(e) {
var t = this._onLoadedCustomAdObjs[e];
return void 0 !== t && void 0 !== this._isCustomAdOnShow[e] && this._isCustomAdOnShow[e] && t.isShow();
}
}, {
key: "_doCreateCustomAd",
value: function(e, t, n, o) {
if (PlatHelper.getPlat() && PlatHelper.getPlat().createCustomAd) {
var i = {
left: 0,
top: 0,
width: 0
}, a = PlatHelper.getPlat().getSystemInfoSync(), r = {
width: 72,
height: 106
}, s = {
width: 360,
height: 106
}, l = {
width: a.screenWidth,
rowHeight: 71,
defaultHeight: 140
}, c = {
width: 1280,
height: 720
};
if (isLoadLandscapeConfig$1() && (l.width = 360), n.isNewLayout) {
if (null != n) {
if (null != n.top) i.top = n.top / getSceneSize().height * a.screenHeight; else if (null != n.bottom) {
var d = n.bottom / getSceneSize().height * a.screenHeight;
i.top = a.screenHeight - (d + n.height);
} else null != n.centerY && (i.top = (a.screenHeight - n.height) / 2 + a.screenHeight * (n.centerY / 100));
if (null != n.left) i.left = n.left / getSceneSize().width * a.screenWidth; else if (null != n.right) {
var h = n.right / getSceneSize().width * a.screenWidth;
i.left = a.screenWidth - (h + n.width);
} else null != n.centerX && (i.left = (a.screenWidth - n.width) / 2 + a.screenWidth * (n.centerX / 100));
i.width = n.width;
}
} else if (n && "left" === n.layout && "number" == typeof n.top) i.left = n.left, 
i.top = n.top / getSceneSize().height * a.screenHeight; else if (n && "right" === n.layout && "number" == typeof n.top) i.left = a.screenWidth - r.width - n.left, 
i.top = n.top / getSceneSize().height * a.screenHeight; else if (n && "top" === n.layout && "number" == typeof n.top && 1 === n.type) a.screenWidth >= c.width ? i.width = c.width : i.width = 720, 
"number" == typeof n.left && n.left > 0 ? i.left = n.left / 100 * a.screenWidth : i.left = (a.screenWidth - i.width) / 2, 
i.top = n.top / 100 * a.screenHeight; else if (n && "top" === n.layout && "number" == typeof n.top && 2 === n.type) a.screenWidth >= c.width ? i.width = c.width : i.width = 720, 
"number" == typeof n.left && n.left > 0 ? i.left = n.left / 100 * a.screenWidth : i.left = (a.screenWidth - i.width) / 2, 
i.top = n.top / 100 * a.screenHeight; else if (n && "top" === n.layout && "number" == typeof n.top && 3 === n.type) a.screenWidth >= c.width ? i.width = c.width : i.width = 720, 
"number" == typeof n.left && n.left > 0 ? i.left = n.left / 100 * a.screenWidth : i.left = (a.screenWidth - i.width) / 2, 
i.top = n.top / 100 * a.screenHeight; else if (n && "top" === n.layout && "number" == typeof n.top) isLoadLandscapeConfig$1() ? i.left = a.screenWidth - s.width : i.left = (a.screenWidth - s.width) / 2, 
i.top = n.top / getSceneSize().height * a.screenHeight; else if (n && "bottom" === n.layout && "number" == typeof n.bottom) i.left = (a.screenWidth - s.width) / 2, 
i.top = (getSceneSize().height - n.bottom) / getSceneSize().height * a.screenHeight - s.height; else if (n && "center" === n.layout && "number" == typeof n.top && "number" == typeof n.row) if (i.width = l.width, 
isLoadLandscapeConfig$1()) {
i.left = 40;
var u = l.defaultHeight + l.rowHeight * n.row;
i.top = (a.screenHeight - u) / 2;
} else i.left = (a.screenWidth - l.width) / 2, i.top = n.top / getSceneSize().height * a.screenHeight; else if (n && "center" === n.layout && "number" == typeof n.row) {
i.width = l.width, i.left = (a.screenWidth - l.width) / 2;
var f = l.defaultHeight + l.rowHeight * n.row;
i.top = (a.screenHeight - f) / 2;
} else if (n && "center" === n.layout && "object" == typeof n.centerPt) {
i.width = r.width;
var _ = convertToOpenGLPt(n.centerPt);
i.left = _.x - r.width / 2, i.top = _.y - r.height / 2, i.top > a.screenHeight - r.height / 2 && (i.top = a.screenHeight - r.height / 2);
} else console.error("align error, check input...", n);
var p = {
adUnitId: e,
style: i
};
"number" == typeof t && t >= 30 && (p.adIntervals = t), console.log("params: ", p);
var g = PlatHelper.getPlat().createCustomAd(p);
return g && (g.loadCallBack = function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Custom), console.log("customAdObj.onLoad"), 
doCallback$1(o, g);
}, g.onLoad(g.loadCallBack)), g;
}
return null;
}
}, {
key: "isBlockAdPreloaded",
value: function() {
return console.error("Not Support On Current Platform..."), !1;
}
}, {
key: "createBoxAd",
value: function() {
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
var e = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
console.error("Not Support On Current Platform..."), "function" == typeof e && e();
}
}, {
key: "addColorSign",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "createBlockAd",
value: function(e, t) {
arguments.length > 2 && void 0 !== arguments[2] && arguments[2], arguments.length > 3 && void 0 !== arguments[3] && arguments[3], 
arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
var n = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
console.error("Not Support On Current Platform..."), "function" == typeof n && n();
}
}, {
key: "showBlockAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideBlockAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideAllBlockAds",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "destoryBlockAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "destroyAllBlockAds",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "createPortalAd",
value: function(e) {
arguments.length > 1 && void 0 !== arguments[1] && arguments[1], arguments.length > 2 && void 0 !== arguments[2] && arguments[2];
var t = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
console.error("Not Support On Current Platform..."), "function" == typeof t && t();
}
}, {
key: "createDrawerAd",
value: function(e, t) {
arguments.length > 2 && void 0 !== arguments[2] && arguments[2];
var n = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
console.error("Not Support On Current Platform..."), "function" == typeof n && n();
}
}, {
key: "createStreamerAd",
value: function(e, t, n) {
arguments.length > 3 && void 0 !== arguments[3] && arguments[3], arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
var o = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
console.error("Not Support On Current Platform..."), doCallback$1(o);
}
}, {
key: "showStreamerAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "showDrawerAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideStreamerAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideDrawerAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideAllStreamerAds",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "isStreamerAdPreloaded",
value: function() {
return console.error("Not Support On Current Platform..."), !1;
}
}, {
key: "createQgPortalAd",
value: function(e, t) {
arguments.length > 2 && void 0 !== arguments[2] && arguments[2];
var n = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
console.error("Not Support On Current Platform..."), "function" == typeof n && n();
}
}, {
key: "createQgStreamerAd",
value: function() {
console.error("Not Support On Current Platform..."), doCallback$1(errCb);
}
}, {
key: "showPortalQgAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "showStreamerQgAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hidePortalQgAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideStreamerQgAd",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "hideAllQgStreamerAds",
value: function() {
console.error("Not Support On Current Platform...");
}
}, {
key: "isQgStreamerAdPreloaded",
value: function() {
return console.error("Not Support On Current Platform..."), !1;
}
}, {
key: "_convertToPlatformStyle",
value: function(e) {
var t = this._getDefaultPlatformStyle();
if (e) {
var n = PlatHelper.getSysInfo();
this._fixedStyle(e), t.width = e.width;
var o = this._caculateRealWidth(e.width);
"number" == typeof e.centerX ? t.left = (n.screenWidth - o) / 2 + e.centerX : "number" == typeof e.left ? t.left = e.left : "number" == typeof e.right && (t.left = n.screenWidth - o - e.right);
var i = FlowBannerAdvSize.Height / FlowBannerAdvSize.Width * o;
"number" == typeof e.centerY ? t.top = (n.screenHeight - i) / 2 + e.centerY : "number" == typeof e.top ? t.top = e.top : "number" == typeof e.bottom && (t.top = n.screenHeight - i - e.bottom);
}
return t;
}
}, {
key: "_getDefaultPlatformStyle",
value: function() {
return {};
}
}, {
key: "_caculateRealWidth",
value: function(e) {
return e;
}
}, {
key: "_fixedStyle",
value: function() {}
}, {
key: "getMiniGapFromBottom",
value: function() {
return 0;
}
}, {
key: "_isSupportResizeTwice",
value: function() {
return !0;
}
}, {
key: "_isSupportPreloadBanner",
value: function() {
return !0;
}
}, {
key: "_isSupportDelayDestroyBanner",
value: function() {
return !0;
}
}, {
key: "_canShowInterstitialNow",
value: function() {
return !0;
}
}, {
key: "_isSupportPreloadInterstitial",
value: function() {
return !0;
}
}, {
key: "_isSupportDelayDestroyInterstitial",
value: function() {
return !0;
}
} ]);
return e;
}(), SK_KEY_OF_COLOR_SIGN_INFO = "storage_key_of_color_sign_info", GAP_OF_EACH_INTERSTITIAL_AD = 3e4;

void 0 !== window.tt && (GAP_OF_EACH_INTERSTITIAL_AD = 6e4);

var UnSupportAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
return t;
}(), WXAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._gapOfEachInterstitialAd = GAP_OF_EACH_INTERSTITIAL_AD, n._customAdUnitIDIndex = -1, 
n._isCustomAdOnShow = {}, n._onLoadedCustomAdObjs = {};
return n;
}
_createClass2(t, [ {
key: "_doCreateBannerAdObj",
value: function(e, n, o) {
return _get2(_getPrototypeOf2(t.prototype), "_doCreateBannerAdObj", this).call(this, e, n, o);
}
}, {
key: "_getDefaultPlatformStyle",
value: function() {
return {
left: 0,
top: 0,
width: 300
};
}
}, {
key: "getMiniGapFromBottom",
value: function() {
return 0;
}
}, {
key: "_fixedStyle",
value: function(e) {
e && ("number" != typeof e.width && (e.width = 300), e.width < 300 && (e.width = 300));
}
} ]);
return t;
}(), QQAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._gapOfEachInterstitialAd = GAP_OF_EACH_INTERSTITIAL_AD, n.isCreating = !1, 
n.createBlockIDs = [], n.blockObj = [], n._interstitialAdIns = null, n._isForceUnSupportedInterstitial = !1, 
n._boxAdObj = null, n._boxAdUnitIDIndex = -1, n._isShowColorSignBefore = !1, n._blockAdUnitIDIndex = -1, 
n._isBlockAdOnShow = {}, n._onLoadedBlockAdObjs = {};
return n;
}
_createClass2(t, [ {
key: "isSupportInterstitialAd",
value: function() {
return PlatAdUnitIDs.interstitialAdUnitIDs.length > 0 && !this._isForceUnSupportedInterstitial;
}
}, {
key: "_stopSupportInterstitialAd",
value: function() {
console.log("stop support interstitial ad..."), this._isForceUnSupportedInterstitial = !0, 
Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "_preloadInterstitialAd",
value: function(e, t) {
this.isSupportInterstitialAd() ? null === this._interstitialAdIns && (this._interstitialAdIns = this._doCreateInterstitialAdObj(null, function() {
console.log("preload interstitial finished...");
}, null)) : doCallback$1(t);
}
}, {
key: "createInterstitialAd",
value: function(e, t, n) {
if (!this.isSupportInterstitialAd()) return Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW), 
void doCallback$1(n);
this._canShowInterstitialNow() ? null !== this._interstitialAdIns ? (checkFunc(t) && (this._interstitialAdIns.closeCb = t), 
checkFunc(n) && (this._interstitialAdIns.errCb = n), this.showInterstitialAd(e, n)) : (this._stopSupportInterstitialAd(), 
doCallback$1(n)) : doCallback$1(n);
}
}, {
key: "_doCreateInterstitialAdObj",
value: function(e, t) {
if (this._interstitialAdIns) return this._interstitialAdIns;
if (this._interstitialAdUnitIDIndex += 1, this._interstitialAdUnitIDIndex >= PlatAdUnitIDs.interstitialAdUnitIDs.length && (this._interstitialAdUnitIDIndex = 0), 
this._interstitialAdIns = PlatHelper.getPlat().createInterstitialAd({
adUnitId: PlatAdUnitIDs.interstitialAdUnitIDs[this._interstitialAdUnitIDIndex]
}), this._interstitialAdIns) {
var n = this;
this._interstitialAdIns.onLoad(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Interstitial), "function" == typeof t && t();
}), this._interstitialAdIns.onClose(function() {
if (n._interstitialAdIns) {
var e = n._interstitialAdIns.closeCb;
n._interstitialAdIns.errCb, n._lastTimeOfShowInterstitialAd = ServerInfo.getServerTime(), 
n._interstitialAdIns.closeCb = null, n._interstitialAdIns.errCb = null, e && e(), 
n._preloadInterstitialAd();
}
}), this._interstitialAdIns.onError(function(e) {
if (-1 === [ 2001, 2002, 2003, 2004, 2005 ].indexOf(e.errCode) && (adv_interface.reportLoadFailAdv(FlowAdvType.Interstitial), 
n._stopSupportInterstitialAd(), n._interstitialAdIns)) {
var t = n._interstitialAdIns.errCb;
t ? t(e) : console.error(e), n._interstitialAdIns = null;
}
});
}
return this._interstitialAdIns;
}
}, {
key: "showInterstitialAd",
value: function(e, t) {
this._interstitialAdIns && this._interstitialAdIns.show().then(function() {
doCallback$1(e), adv_interface.reportShowAdv(FlowAdvType.Interstitial, PlatAdOnShowFlow.interstitial);
}).catch(function(e) {
doCallback$1(t, e), checkFunc(t) || console.error(e);
});
}
}, {
key: "createBoxAd",
value: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
if (PlatHelper.getPlat() && PlatHelper.getPlat().createAppBox) {
if (this._boxAdObj && (console.log("destory old unclosed box..."), this._boxAdObj.destroy(), 
this._boxAdObj = null), 0 === PlatAdUnitIDs.boxAdUnitIDs.length) return doCallback$1(o), 
null;
this._boxAdUnitIDIndex += 1, this._boxAdUnitIDIndex >= PlatAdUnitIDs.boxAdUnitIDs.length && (this._boxAdUnitIDIndex = 0);
var i = PlatHelper.getPlat().createAppBox({
adUnitId: PlatAdUnitIDs.boxAdUnitIDs[this._boxAdUnitIDIndex]
});
i && (checkFunc(n) && (i.closeCb = n), i.onClose(function() {
var t = i.closeCb;
i.closeCb = null, e._boxAdObj.destroy(), e._boxAdObj = null, doCallback$1(t);
}), i.load().then(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Box), i.show().then(function() {
doCallback$1(t), adv_interface.reportShowAdv(FlowAdvType.Box, PlatAdOnShowFlow.box);
}).catch(function(e) {
doCallback$1(o, e), checkFunc(o) || console.error(e);
});
}).catch(function(e) {
adv_interface.reportLoadFailAdv(FlowAdvType.Box), doCallback$1(o, e), checkFunc(o) || console.error(e);
}), this._boxAdObj = i);
}
return this._boxAdObj;
}
}, {
key: "addColorSign",
value: function() {
PlatHelper.getPlat() && PlatHelper.getPlat().addColorSign && !this._isShowColorSignBefore && (this._isShowColorSignBefore = !0, 
PlatHelper.getPlat().addColorSign());
}
}, {
key: "createBlockAd",
value: function(e, t) {
var n = this, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 1, i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : "landscape", a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, r = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
if (!PlatAdUnitIDs.blockAdUnitIDs || 0 === PlatAdUnitIDs.blockAdUnitIDs.length || -1 === PlatAdUnitIDs.blockAdUnitIDs.indexOf(e)) return doCallback$1(r, "Config Target Block adUnitId first, adUnitId:" + e), 
null;
this.isCreating = !1, this._isBlockAdOnShow[e] = !0;
var s = null, l = this._onLoadedBlockAdObjs[e];
if (Array.isArray(l) && l.length > 0) for (var c = 0; c < l.length; c++) if (!l[c]._isUsing) {
s = l[c];
break;
}
if (s) {
var d = s.show();
null != d && d.then(function() {
doCallback$1(a), n._isBlockAdOnShow[e] ? (adv_interface.reportShowAdv(FlowAdvType.Block, PlatAdOnShowFlow.block), 
s._isUsing = !0) : s.hide();
});
} else this._doCreateBlockAd(e, t, o, i, function(t) {
t && (Array.isArray(n._onLoadedBlockAdObjs[e]) || (n._onLoadedBlockAdObjs[e] = []), 
n._onLoadedBlockAdObjs[e].push(t), n._isBlockAdOnShow[e] && t.show().then(function() {
doCallback$1(a), n._isBlockAdOnShow[e] ? (adv_interface.reportShowAdv(FlowAdvType.Block, PlatAdOnShowFlow.block), 
t._isUsing = !0) : t.hide();
}));
}, r);
}
}, {
key: "_doCreateNextBlock",
value: function() {
var e = this;
if (!this.isCreating) {
this.isCreating = !0;
var t = this.createBlockIDs.shift();
if (null != t) {
var n = t.adUnitId, o = t.align, i = t.size, a = t.orientation, r = t.loadCb, s = t.errCb;
if (PlatHelper.getPlat() && PlatHelper.getPlat().createBlockAd) {
var l = PlatHelper.getPlat().createBlockAd({
adUnitId: n,
style: {
left: 20,
top: 32
},
size: i,
orientation: a
});
if (l) {
this.blockObj.push(l), "function" == typeof r && (l.loadCb = r), "function" == typeof s && (l.errCb = s);
var c = function t() {
if (l.offLoad(t), adv_interface.reportLoadSuccAdv(FlowAdvType.Block), e.blockObj.indexOf(l) >= 0) {
var n = l.loadCb;
l.loadCb = null, n && n(l);
}
e.isCreating = !1, e._doCreateNextBlock();
}, d = function(t) {
if (console.log(JSON.stringify(t)), !(e.blockObj.indexOf(l) < 0)) {
var n = t.height, i = t.width, a = PlatHelper.getPlat().getSystemInfoSync();
if (o && "left" === o.layout && "number" == typeof o.top) l.style.left = 20, l.style.top = o.top / getSceneSize().height * a.screenHeight, 
l.style.top < 32 && (l.style.top = 32); else if (o && "leftCenter" === o.layout) l.style.left = 20, 
l.style.top = (a.screenHeight - n) / 2; else if (o && "right" === o.layout && "number" == typeof o.top) l.style.left = a.screenWidth - i - 20, 
l.style.top = o.top / getSceneSize().height * a.screenHeight, l.style.top < 32 && (l.style.top = 32); else if (o && "rightCenter" === o.layout) l.style.left = a.screenWidth - i, 
l.style.top = (a.screenHeight - n) / 2; else if (o && "top" === o.layout && "number" == typeof o.top) l.style.left = (a.screenWidth - i) / 2, 
l.style.top = o.top / getSceneSize().height * a.screenHeight; else if (o && "bottom" === o.layout && "number" == typeof o.bottom) o.bottom < 35 && (o.bottom = 35), 
l.style.left = (a.screenWidth - i) / 2, l.style.top = (getSceneSize().height - o.bottom) / getSceneSize().height * a.screenHeight - n; else if (o && "center" === o.layout && "number" == typeof o.row) l.style.left = (a.screenWidth - i) / 2, 
l.style.top = o.top; else if (o && "center" === o.layout && "object" == typeof o.centerPt) {
l.style.width = i;
var r = convertToOpenGLPt(o.centerPt);
l.style.left = r.x - i / 2, l.style.top = r.y - n / 2, l.style.top > a.screenHeight - n / 2 && (l.style.top = a.screenHeight - n / 2);
} else o && "center" === o.layout ? (l.style.left = (a.screenWidth - i) / 2, l.style.top = (a.screenHeight - n) / 2, 
"number" == typeof o.hor && (l.style.left += o.hor), "number" == typeof o.vel && (l.style.top += o.vel)) : console.error("align error, check input...", o);
}
};
l.onLoad(c), l.onResize(d), l.onError(function e(t) {
adv_interface.reportLoadFailAdv(FlowAdvType.Block), l.offLoad(c), l.offResize(d), 
l.offError(e);
var n = l.errCb;
l._errCb = null, n ? n(t) : console.error(t);
});
}
}
} else this.isCreating = !1;
}
}
}, {
key: "_doCreateBlockAd",
value: function(e, t, n, o, i, a) {
this.createBlockIDs.push({
adUnitId: e,
align: t,
size: n,
orientation: o,
loadCb: i,
errCb: a
}), this._doCreateNextBlock();
}
}, {
key: "isBlockAdPreloaded",
value: function(e) {
var t = this._onLoadedBlockAdObjs[e];
return !!(Array.isArray(t) && t.length > 0);
}
}, {
key: "showBlockAd",
value: function(e) {
if (!this._isBlockAdOnShow[e] && void 0 !== this._onLoadedBlockAdObjs[e]) {
this._isBlockAdOnShow[e] = !0;
var t = this._onLoadedBlockAdObjs[e];
Array.isArray(t) && t.length > 0 && t.forEach(function(e) {
e._isUsing = !0, e.show();
});
}
}
}, {
key: "hideBlockAd",
value: function(e) {
if (this._isBlockAdOnShow[e]) {
this._isBlockAdOnShow[e] = !1;
var t = this._onLoadedBlockAdObjs[e];
Array.isArray(t) && t.length > 0 && t.forEach(function(e) {
e._isUsing = !1, e.hide();
});
}
}
}, {
key: "destoryBlockAd",
value: function(e) {
var t = this;
this._isBlockAdOnShow[e] = !1;
var n = this._onLoadedBlockAdObjs[e];
return new Promise(function(o) {
var i = [];
Array.isArray(n) && n.length > 0 && i.push(new Promise(function(e) {
n.forEach(function(t) {
t.destroy().then(e()).catch(function(t) {
console.error(t), e();
});
});
})), delete t._onLoadedBlockAdObjs[e], i.length > 0 ? Promise.all(i).then(function() {
o();
}) : o();
});
}
}, {
key: "destroyAllBlockAds",
value: function() {
var e = [];
this.createBlockIDs = [], this.blockObj = [];
for (var t in this._onLoadedBlockAdObjs) void 0 !== this._onLoadedBlockAdObjs[t] && e.push(this.destoryBlockAd(t));
return new Promise(function(t) {
e.length > 0 ? Promise.all(e).then(function() {
t();
}) : t();
});
}
}, {
key: "_canShowColorSign",
value: function() {
var e = PlatHelper.getStorage(SK_KEY_OF_COLOR_SIGN_INFO);
if (e && "" !== e) {
var t = JSON.parse(e);
if (void 0 !== t.lastSignDay && t.lastSignDay === ServerInfo.getCurServerDayOfYear()) return !1;
}
return !0;
}
}, {
key: "_markShowColorSign",
value: function() {
var e = {
lastSignDay: ServerInfo.getCurServerDayOfYear()
};
PlatHelper.setStorage(SK_KEY_OF_COLOR_SIGN_INFO, JSON.stringify(e));
}
}, {
key: "_doCreateBannerAdObj",
value: function(e, n, o) {
return _get2(_getPrototypeOf2(t.prototype), "_doCreateBannerAdObj", this).call(this, e, n, o);
}
}, {
key: "_getDefaultPlatformStyle",
value: function() {
var e = PlatHelper.getSysInfo(), t = FlowBannerAdvSize.Height / FlowBannerAdvSize.Width * 300, n = {
left: (e.screenWidth - 300) / 2,
top: e.screenHeight - t,
width: 300
};
return PlatHelper.isIPhoneX() && (n.top -= 20), n;
}
}, {
key: "getMiniGapFromBottom",
value: function() {
return 20;
}
}, {
key: "_fixedStyle",
value: function(e) {
e && ("number" != typeof e.width && (e.width = 300), e.width < 300 && (e.width = 300));
}
}, {
key: "_isSupportPreloadBanner",
value: function() {
return !1;
}
}, {
key: "_isSupportDelayDestroyBanner",
value: function() {
return !1;
}
} ]);
return t;
}(), TTAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._gapOfEachInterstitialAd = GAP_OF_EACH_INTERSTITIAL_AD;
return n;
}
_createClass2(t, [ {
key: "_doCreateBannerAdObj",
value: function(e, n, o) {
var i = _get2(_getPrototypeOf2(t.prototype), "_doCreateBannerAdObj", this).call(this, e, n, o), a = PlatHelper.getPlat().getSystemInfoSync(), r = a.windowWidth, s = a.windowHeight;
return i.onResize(function e(t) {
i.style.top = s - t.height, i.style.left = (r - t.width) / 2, PlatHelper.isIPhoneX() && (i.style.top -= 20), 
i.offResize(e);
}), i;
}
}, {
key: "_doCreateInterstitialAdObj",
value: function(e, n, o) {
var i = this, a = _get2(_getPrototypeOf2(t.prototype), "_doCreateInterstitialAdObj", this).call(this, function() {
var t = a;
Scheduler.schedule("Destroy_Interstitial_Ad", function() {
t && (console.log("destory interstitial ad..."), t.destroy());
}.bind(i), !1, 60, 0), i._interstitialAdObj = null, "function" == typeof e && e();
}, n, o);
return console.log("start to load interstitial ad..."), a.load(), a;
}
}, {
key: "_isSupportPreloadInterstitial",
value: function() {
return !1;
}
}, {
key: "_isSupportDelayDestroyInterstitial",
value: function() {
return !1;
}
}, {
key: "_getDefaultPlatformStyle",
value: function() {
return {
left: 0,
top: 0,
width: 128
};
}
}, {
key: "_caculateRealWidth",
value: function(e) {
return e / 208 * 300;
}
}, {
key: "getMiniGapFromBottom",
value: function() {
return 0;
}
}, {
key: "_isSupportResizeTwice",
value: function() {
return !1;
}
}, {
key: "_fixedStyle",
value: function(e) {
e && ("number" != typeof e.width && (e.width = 128), e.width < 128 && (e.width = 128));
}
} ]);
return t;
}(), OPPOAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._gapOfEachInterstitialAd = GAP_OF_EACH_INTERSTITIAL_AD, n._portalAdObj = null, 
n._portalAdUnitIDIndex = -1, n._isStreamerAdOnShow = {}, n._onLoadedStreamerAdObjs = {}, 
n._DrawerAdObj = null, n._isDrawerAdOnShow = {};
return n;
}
_createClass2(t, [ {
key: "isSupportInterstitialAd",
value: function() {
return PlatAdUnitIDs.interstitialAdUnitIDs.length > 0 && !this._isForceUnSupportedInterstitial;
}
}, {
key: "_stopSupportInterstitialAd",
value: function() {
console.log("stop support interstitial ad..."), this._isForceUnSupportedInterstitial = !0, 
Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "_preloadInterstitialAd",
value: function(e, t) {
this.isSupportInterstitialAd() ? null === this._interstitialAdIns && (this._interstitialAdIns = this._doCreateInterstitialAdObj(null, function() {
console.log("preload interstitial finished...");
}, null)) : doCallback$1(t);
}
}, {
key: "createInterstitialAd",
value: function(e, t, n) {
if (!this.isSupportInterstitialAd()) return Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW), 
void doCallback$1(n);
this._canShowInterstitialNow() ? null !== this._interstitialAdIns ? (checkFunc(t) && (this._interstitialAdIns.closeCb = t), 
checkFunc(n) && (this._interstitialAdIns.errCb = n), this.showInterstitialAd(e, n)) : (this._stopSupportInterstitialAd(), 
doCallback$1(n)) : doCallback$1(n);
}
}, {
key: "_doCreateInterstitialAdObj",
value: function(e, t) {
if (this._interstitialAdIns) return this._interstitialAdIns;
if (this._interstitialAdUnitIDIndex += 1, this._interstitialAdUnitIDIndex >= PlatAdUnitIDs.interstitialAdUnitIDs.length && (this._interstitialAdUnitIDIndex = 0), 
this._interstitialAdIns = PlatHelper.getPlat().createInterstitialAd({
adUnitId: PlatAdUnitIDs.interstitialAdUnitIDs[this._interstitialAdUnitIDIndex]
}), this._interstitialAdIns) {
var n = this;
this._interstitialAdIns.onLoad(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Interstitial), "function" == typeof t && t();
}), this._interstitialAdIns.onClose(function() {
if (n._interstitialAdIns) {
var e = n._interstitialAdIns.closeCb;
n._interstitialAdIns.errCb, n._lastTimeOfShowInterstitialAd = ServerInfo.getServerTime(), 
n._interstitialAdIns.closeCb = null, n._interstitialAdIns.errCb = null, e && e(), 
n._preloadInterstitialAd();
}
}), this._interstitialAdIns.onError(function(e) {
if (-1 === [ 2001, 2002, 2003, 2004, 2005 ].indexOf(e.errCode) && (adv_interface.reportLoadFailAdv(FlowAdvType.Interstitial), 
n._stopSupportInterstitialAd(), n._interstitialAdIns)) {
var t = n._interstitialAdIns.errCb;
t ? t(e) : console.error(e), n._interstitialAdIns = null;
}
});
}
return this._interstitialAdIns;
}
}, {
key: "createPortalAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
if (PlatHelper.getPlat() && PlatHelper.getPlat().createGamePortalAd) {
this._portalAdObj && (console.log("destory old unclosed portal..."), this._portalAdObj.destroy(), 
this._portalAdObj = null);
var a = PlatHelper.getPlat().createGamePortalAd({
adUnitId: e
});
a && (checkFunc(o) && (a.closeCb = o), a.onClose(function() {
var e = a.closeCb;
a.closeCb = null, t._portalAdObj.destroy(), t._portalAdObj = null, doCallback$1(e);
}), a.load().then(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Portal), a.show().then(function() {
doCallback$1(n), console.error("show...portalAdObj"), adv_interface.reportShowAdv(FlowAdvType.Portal, PlatAdOnShowFlow.portal);
}).catch(function(e) {
doCallback$1(i, e), checkFunc(i) || console.error(e);
});
}).catch(function(e) {
adv_interface.reportLoadFailAdv(FlowAdvType.Portal), doCallback$1(i, e), checkFunc(i) || console.error(e);
}), this._portalAdObj = a);
}
return this._portalAdObj;
}
}, {
key: "createDrawerAd",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
arguments.length > 4 && void 0 !== arguments[4] && arguments[4];
if (PlatHelper.getPlat() && PlatHelper.getPlat().createGameDrawerAd) {
if (0 === PlatAdUnitIDs.gameNativeAdUnitIDs.length) return doCallback$1(o), null;
this._isDrawerAdOnShow[e] = !0;
var i = t / 100 * PlatHelper.getPlat().getSystemInfoSync().screenHeight, a = PlatHelper.getPlat().createGameDrawerAd({
adUnitId: e,
style: {
top: i
}
});
a && (a.show().then(function() {
doCallback$1(n), console.error("show...DrawerAdObj"), adv_interface.reportShowAdv(FlowAdvType.Drawer, PlatAdOnShowFlow.drawer);
}).catch(function(e) {
doCallback$1(o, e), checkFunc(o) || console.error(e);
}), this._DrawerAdObj = a);
}
return this._DrawerAdObj;
}
}, {
key: "createStreamerAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0, o = arguments.length > 2 ? arguments[2] : void 0, i = arguments.length > 3 ? arguments[3] : void 0, a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, r = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null, s = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : null;
if (PlatAdUnitIDs.gameNativeAdUnitIDs && 0 !== PlatAdUnitIDs.gameNativeAdUnitIDs.length && -1 !== PlatAdUnitIDs.gameNativeAdUnitIDs.indexOf(e)) {
this._isStreamerAdOnShow[e] = !0;
var l = this._onLoadedStreamerAdObjs[e];
l ? l.show().then(function() {
console.error("Streamer....onShow"), adv_interface.reportShowAdv(FlowAdvType.Streamer, PlatAdOnShowFlow.streamer), 
doCallback$1(a), t._isStreamerAdOnShow[e] || l.hide();
}) : this._doCreateStreamerAd(e, n, o, i, function(n) {
n && (console.error("OBJ"), t._isStreamerAdOnShow[e] && n.show().then(function() {
console.error("Streamer....onShow"), adv_interface.reportShowAdv(FlowAdvType.Streamer, PlatAdOnShowFlow.streamer), 
doCallback$1(a), t._isStreamerAdOnShow[e] || n.hide();
}));
}, r, s);
} else console.error("Config Target Streamer adUnitId first, adUnitId:", e);
}
}, {
key: "_doCreateStreamerAd",
value: function(e, t, n, o, i, a) {
if (PlatHelper.getPlat() && PlatHelper.getPlat().createGameBannerAd) {
var r = {
left: 0,
top: 0,
orientation: "landscape" == n ? "horizontal" : "vertical"
}, s = PlatHelper.getPlat().getSystemInfoSync(), l = {
width: 985,
height: 285
};
t && "left" === t.layout && "number" == typeof t.top ? (r.left = 5, r.top = t.top / getSceneSize().height * s.screenHeight) : t && "right" === t.layout && "number" == typeof t.top ? (r.left = s.screenWidth - 230, 
r.top = t.top / getSceneSize().height * s.screenHeight) : t && "top" === t.layout && "number" == typeof t.top ? (isLoadLandscapeConfig$1() ? r.left = s.screenWidth - l.width : r.left = (s.screenWidth - l.width) / 2, 
console.error("Align@@@@"), r.top = t.top / getSceneSize().height * s.screenHeight) : t && "bottom" === t.layout && "number" == typeof t.bottom ? (r.left = (s.screenWidth - l.width) / 2, 
r.top = (getSceneSize().height - t.bottom) / getSceneSize().height * s.screenHeight - l.height) : console.error("align error, check input...", t);
var c = {
adUnitId: e,
style: r
};
"number" == typeof gap && gap >= 30 && (c.adIntervals = gap);
var d = PlatHelper.getPlat().createGameBannerAd(c);
console.error("params: " + c), d && (d.onLoad(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Streamer), doCallback$1(o, d);
}), d.onError(function(e) {
adv_interface.reportLoadFailAdv(FlowAdvType.Streamer), doCallback$1(a, e), checkFunc(a) || console.error(e);
}), this._onLoadedStreamerAdObjs[e] = d, d.show().then(function() {
console.log("show success");
}).catch(function(e) {
console.log("show fail with:" + e.errCode + "," + e.errMsg);
}));
}
}
}, {
key: "showStreamerAd",
value: function(e) {
this.hideBase(e, this._isStreamerAdOnShow, this._onLoadedStreamerAdObjs[e], "show");
}
}, {
key: "showDrawerAd",
value: function(e) {
this.hideBase(e, this._isDrawerAdOnShow, this._DrawerAdObj, "show");
}
}, {
key: "hideStreamerAd",
value: function(e) {
this.hideBase(e, this._isStreamerAdOnShow, this._onLoadedStreamerAdObjs[e]);
}
}, {
key: "hideDrawerAd",
value: function(e) {
this.hideBase(e, this._isDrawerAdOnShow, this._DrawerAdObj);
}
}, {
key: "hideBase",
value: function(e, t, n) {
var o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : "hide";
if (t[e]) {
t[e] = !1;
var i = n;
void 0 !== i && i[o]();
}
}
}, {
key: "hideAllStreamerAds",
value: function() {
for (var e in this._isStreamerAdOnShow) this._isStreamerAdOnShow[e] && this.hideStreamerAd(e);
for (var t in this._isDrawerAdOnShow) this._isDrawerAdOnShow[t] && this.hideDrawerAd(t);
}
}, {
key: "isStreamerAdPreloaded",
value: function(e) {
return void 0 !== this._onLoadedStreamerAdObjs[e];
}
} ]);
return t;
}(), VIVOAdv = function() {
_inherits2(t, AdvBase);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._gapOfEachInterstitialAd = GAP_OF_EACH_INTERSTITIAL_AD, n._qgPortalAdObj = null, 
n._isQgPortalAdOnShow = {}, n._isQgStreamerAdOnShow = {}, n._onLoadedQgStreamerAdObjs = {};
return n;
}
_createClass2(t, [ {
key: "isSupportInterstitialAd",
value: function() {
return PlatAdUnitIDs.interstitialAdUnitIDs.length > 0 && !this._isForceUnSupportedInterstitial;
}
}, {
key: "_stopSupportInterstitialAd",
value: function() {
console.log("stop support interstitial ad..."), this._isForceUnSupportedInterstitial = !0, 
Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW);
}
}, {
key: "_preloadInterstitialAd",
value: function(e, t) {
this.isSupportInterstitialAd() ? null === this._interstitialAdIns && (this._interstitialAdIns = this._doCreateInterstitialAdObj(null, function() {
console.log("preload interstitial finished...");
}, null)) : doCallback$1(t);
}
}, {
key: "createInterstitialAd",
value: function(e, t, n) {
if (!this.isSupportInterstitialAd()) return Event.dispatchEvent(EventName.EN_INTERSTITIAL_NOT_SUPPORT_RIGHT_NOW), 
void doCallback$1(n);
this._canShowInterstitialNow() ? null !== this._interstitialAdIns ? (checkFunc(t) && (this._interstitialAdIns.closeCb = t), 
checkFunc(n) && (this._interstitialAdIns.errCb = n), this.showInterstitialAd(e, n)) : (this._stopSupportInterstitialAd(), 
doCallback$1(n)) : doCallback$1(n);
}
}, {
key: "_doCreateInterstitialAdObj",
value: function(e, t) {
if (this._interstitialAdIns) return this._interstitialAdIns;
if (this._interstitialAdUnitIDIndex += 1, this._interstitialAdUnitIDIndex >= PlatAdUnitIDs.interstitialAdUnitIDs.length && (this._interstitialAdUnitIDIndex = 0), 
this._interstitialAdIns = PlatHelper.getPlat().createInterstitialAd({
adUnitId: PlatAdUnitIDs.interstitialAdUnitIDs[this._interstitialAdUnitIDIndex]
}), this._interstitialAdIns) {
var n = this;
this._interstitialAdIns.onLoad(function() {
adv_interface.reportLoadSuccAdv(FlowAdvType.Interstitial), "function" == typeof t && t();
}), this._interstitialAdIns.onClose(function() {
if (n._interstitialAdIns) {
var e = n._interstitialAdIns.closeCb;
n._interstitialAdIns.errCb, n._lastTimeOfShowInterstitialAd = ServerInfo.getServerTime(), 
n._interstitialAdIns.closeCb = null, n._interstitialAdIns.errCb = null, e && e(), 
n._preloadInterstitialAd();
}
}), this._interstitialAdIns.onError(function(e) {
if (-1 === [ 2001, 2002, 2003, 2004, 2005 ].indexOf(e.errCode) && (adv_interface.reportLoadFailAdv(FlowAdvType.Interstitial), 
n._stopSupportInterstitialAd(), n._interstitialAdIns)) {
var t = n._interstitialAdIns.errCb;
t ? t(e) : console.error(e), n._interstitialAdIns = null;
}
});
}
return this._interstitialAdIns;
}
}, {
key: "createQgPortalAd",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
if (PlatHelper.getPlat() && PlatHelper.getPlat().createBoxPortalAd) {
if (0 === PlatAdUnitIDs.gameNativeAdUnitIDs.length) return doCallback$1(o), null;
this._isQgPortalAdOnShow[e] = !0;
var a = t / 100 * PlatHelper.getPlat().getSystemInfoSync().screenHeight, r = PlatHelper.getPlat().createBoxPortalAd({
posId: e,
image: "",
marginTop: a
});
r && (r.onError(function(e) {
console.log("盒子九宫格广告加载失败", e);
}), r.onClose(function() {
console.log("close"), r.isDestroyed || (Scheduler.schedule("Delay_Show_QgPortalAd_Icon", function() {
qgPortalAdObj.show(), console.log("show");
}, !1, 500, 0), doCallback$1(i));
}), r.show().then(function() {
doCallback$1(n), console.error("show...QgPortalAdObj"), adv_interface.reportShowAdv(FlowAdvType.Portal, PlatAdOnShowFlow.portal);
}).catch(function(e) {
doCallback$1(o, e), console.error("show...QgPortalAdObj...err"), checkFunc(o) || console.error(e);
}), this._qgPortalAdObj = r);
}
return this._qgPortalAdObj;
}
}, {
key: "createQgStreamerAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
if (PlatAdUnitIDs.gameNativeAdUnitIDs && 0 !== PlatAdUnitIDs.gameNativeAdUnitIDs.length && -1 !== PlatAdUnitIDs.gameNativeAdUnitIDs.indexOf(e)) {
this._isQgStreamerAdOnShow[e] = !0;
var a = this._onLoadedQgStreamerAdObjs[e];
a ? a.show().then(function() {
console.error("Streamer....onShow"), adv_interface.reportShowAdv(FlowAdvType.Streamer, PlatAdOnShowFlow.streamer), 
doCallback$1(n), t._isStreamerAdOnShow[e] || a.hide();
}) : this._doCreateQgStreamerAd(e, function(o) {
o && (console.error("OBJ"), t._isQgStreamerAdOnShow[e] && o.show().then(function() {
console.error("Streamer....onShow"), adv_interface.reportShowAdv(FlowAdvType.Streamer, PlatAdOnShowFlow.streamer), 
doCallback$1(n), t._isQgStreamerAdOnShow[e] || o.hide();
}));
}, o, i);
} else console.error("Config Target Streamer adUnitId first, adUnitId:", e);
}
}, {
key: "_doCreateQgStreamerAd",
value: function(e, t, n, o) {
if (PlatHelper.getPlat() && PlatHelper.getPlat().createBoxBannerAd) {
var i = PlatHelper.getPlat().createBoxBannerAd({
posId: e
});
i && (i.onError(function(e) {
adv_interface.reportLoadFailAdv(FlowAdvType.Streamer), doCallback$1(o, e), checkFunc(o) || console.error(e);
}), this._onLoadedQgStreamerAdObjs[e] = i, i.show().then(function() {
console.log("show success"), doCallback$1(t);
}).catch(function(e) {
console.log("show fail with:" + e.errCode + "," + e.errMsg);
}));
}
}
}, {
key: "showPortalQgAd",
value: function(e) {
this.hideBase(e, this._isQgPortalAdOnShow, this._qgPortalAdObj, "show");
}
}, {
key: "showStreamerQgAd",
value: function(e) {
this.hideBase(e, this._isQgStreamerAdOnShow, this._onLoadedQgStreamerAdObjs[e], "show");
}
}, {
key: "hidePortalQgAd",
value: function(e) {
this.hideBase(e, this._isQgPortalAdOnShow, this._qgPortalAdObj);
}
}, {
key: "hideStreamerQgAd",
value: function(e) {
this.hideBase(e, this._isQgStreamerAdOnShow, this._onLoadedQgStreamerAdObjs[e]);
}
}, {
key: "hideBase",
value: function(e, t, n) {
var o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : "hide";
if (t[e]) {
t[e] = !1;
var i = n;
void 0 !== i && i[o]();
}
}
}, {
key: "hideAllQgStreamerAds",
value: function() {
for (var e in this._isQgStreamerAdOnShow) this._isQgStreamerAdOnShow[e] && this.hideStreamerQgAd(e);
for (var t in this._isQgPortalAdOnShow) this._isQgPortalAdOnShow[t] && this.hidePortalQgAd(t);
}
}, {
key: "isQgStreamerAdPreloaded",
value: function(e) {
return void 0 !== this._onLoadedQgStreamerAdObjs[e];
}
} ]);
return t;
}(), _Adv = UnSupportAdv, Adv = new (_Adv = _isQQPlatform() ? QQAdv : _isTTPlatform() ? TTAdv : _isWXPlatform() ? WXAdv : _isOPPOPlatform() ? OPPOAdv : isLoadVIVOConfig() ? VIVOAdv : UnSupportAdv)(), C_GapOfEachBanner = 3e3, C_GapOfEachVideo = 3e3, _QGAdv = function() {
function e() {
_classCallCheck2(this, e);
this._isSupport = !1, this._configs = null, this._onShowBannerObj = null, this._onShowVideoObj = null, 
this._onShowInsertObj = null, this._unClickNativeObjs = [], this._lastUsedAdID = "";
}
_createClass2(e, [ {
key: "init",
value: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
PlatHelper.isOPPOPlatform() && PlatHelper.getPlat().initAdService && checkString(PlatIDs.oppoAppID) ? PlatHelper.getPlat().initAdService({
appId: PlatIDs.oppoAppID,
isDebug: !0,
success: function() {
e._isSupport = !0, console.log("initAdService success"), doCallback$1(t);
},
fail: function(e) {
console.error("initAdService fail, code: " + e.code + ", msg: " + e.msg);
},
complete: function() {
console.log("initAdService complete");
}
}) : PlatHelper.isVIVOPlatform() && (this._isSupport = !0, doCallback$1(t));
}
}, {
key: "isSupport",
value: function() {
return this._isSupport && this._configs.length > 0;
}
}, {
key: "stopSupport",
value: function() {
console.log("force stop support all qg advs..."), this._isSupport = !1;
}
}, {
key: "isSupportBanner",
value: function() {
return this._isSupport && PlatAdUnitIDs.bannerAdUnitIDs.length > 0;
}
}, {
key: "isSupportVideo",
value: function() {
return this._isSupport && PlatAdUnitIDs.videoAdUnitIDs.length > 0;
}
}, {
key: "isSupportInsert",
value: function() {
return this._isSupport && PlatAdUnitIDs.interstitialAdUnitIDs.length > 0;
}
}, {
key: "isSupportNative",
value: function() {
return this._isSupport && PlatAdUnitIDs.nativeAdUnitIDs.length > 0 && this._unClickNativeObjs.length > 0;
}
}, {
key: "preload",
value: function(e) {
console.log("start preload ov adv...");
var t = 0, n = !1;
this.loadRandomNativeAd(function(o) {
o ? console.log("preload native ad succ...") : console.log("preload native ad fail..."), 
o && (n = !0), 1 === (t += 1) && doCallback$1(e, !1, n);
});
}
}, {
key: "showRandomBannerAd",
value: function(e) {
if (PlatAdUnitIDs.bannerAdUnitIDs.length > 0) {
var t = random(0, PlatAdUnitIDs.bannerAdUnitIDs.length - 1), n = PlatAdUnitIDs.bannerAdUnitIDs[t];
return this._doShowBanner(n, e);
}
}
}, {
key: "showRandomVideoAd",
value: function(e, t) {
if (PlatAdUnitIDs.videoAdUnitIDs.length > 0) {
var n = random(0, PlatAdUnitIDs.videoAdUnitIDs.length - 1), o = PlatAdUnitIDs.videoAdUnitIDs[n];
return this._doShowVideo(o, e, t);
}
return null;
}
}, {
key: "showRandomInsertAd",
value: function(e, t) {
if (PlatAdUnitIDs.interstitialAdUnitIDs.length > 0) {
var n = random(0, PlatAdUnitIDs.interstitialAdUnitIDs.length - 1), o = PlatAdUnitIDs.interstitialAdUnitIDs[n];
return this._doShowInsertAd(o, e, t);
}
return null;
}
}, {
key: "loadRandomNativeAd",
value: function(e) {
var t = this, n = 0, o = Math.min(3, PlatAdUnitIDs.nativeAdUnitIDs.length), i = function(e, n) {
var o = PlatAdUnitIDs.nativeAdUnitIDs[e];
t._doLoadNativeAd(o, function(e) {
if (e) {
for (var o = !1, i = 0; i < t._unClickNativeObjs.length; i++) if (t._unClickNativeObjs[i]._adList[0].adId === e._adList[0].adId) {
o = !0;
break;
}
o || t._unClickNativeObjs.push(e);
}
doCallback$1(n, e);
});
};
PlatAdUnitIDs.nativeAdUnitIDs.length > 0 ? function t(a) {
n += 1, i(a, function(i) {
if (i) doCallback$1(e, i); else if (n < o) {
var r = a + 1;
r === PlatAdUnitIDs.nativeAdUnitIDs.length && (r = 0), t(r);
} else doCallback$1(e, null);
});
}(random(0, PlatAdUnitIDs.nativeAdUnitIDs.length - 1)) : doCallback$1(e, null);
}
}, {
key: "hideOnShowBannerAd",
value: function() {
this._onShowBannerObj && this._onShowBannerObj.hide();
}
}, {
key: "destroyOnShowBannerAd",
value: function() {
this._onShowBannerObj && (this._onShowBannerObj.destroy(), this._onShowBannerObj = null);
}
}, {
key: "_doShowBanner",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
if (!this._isSupport) return null;
if (console.log("show banner: ", e), this._onShowBannerObj) if (PlatHelper.isOPPOPlatform()) this._onShowBannerObj.destroy(), 
this._onShowBannerObj = null; else if (ServerInfo.getServerTime() - this._onShowBannerObj._lastCreatedTime > C_GapOfEachBanner) this._onShowBannerObj.destroy(), 
this._onShowBannerObj = null; else {
var n = C_GapOfEachBanner / 1e3 - Math.floor((ServerInfo.getServerTime() - this._onShowBannerObj._lastCreatedTime) / 1e3);
console.log(formatString("banner广告还未准备好，请{0}秒后重新尝试", n.toString()));
}
if (null === this._onShowBannerObj) {
var o = null;
if (o = PlatHelper.isOPPOPlatform() ? PlatHelper.getPlat().createBannerAd({
posId: e
}) : PlatHelper.getPlat().createBannerAd({
posId: e,
style: {}
}), checkFunc(t) && (o._loadCb = t), PlatHelper.isVIVOPlatform() && o.onLoad(function() {
if (o && o._loadCb) {
var e = o._loadCb;
o._loadCb = null, e(o);
} else o.show().then(function() {
adv_interface.reportShowAdv(FlowAdvType.Banner, PlatAdOnShowFlow.banner);
});
}), o.onError(function(e) {
console.error("banner ad err: ", e), PlatHelper.isVIVOPlatform() && (this._onShowBannerObj = null);
}), PlatHelper.isVIVOPlatform() && o.onClose(function() {
this._onShowBannerObj = null;
}), this._onShowBannerObj = o, this._onShowBannerObj._lastCreatedTime = ServerInfo.getServerTime(), 
PlatHelper.isOPPOPlatform()) if (o._loadCb) {
var i = o._loadCb;
o._loadCb = null, i(o);
} else o.show().then(function() {
adv_interface.reportShowAdv(FlowAdvType.Banner, PlatAdOnShowFlow.banner);
});
}
return this._onShowBannerObj;
}
}, {
key: "_doShowVideo",
value: function(e, t, n) {
if (!this._isSupport) return null;
if (this._onShowVideoObj && PlatHelper.isOPPOPlatform() && (this._onShowVideoObj.destroy(), 
this._onShowVideoObj = null), null === this._onShowVideoObj && (this._onShowVideoObj = this._doCreateVideoObj(e)), 
console.log("show video: ", e), checkFunc(t) && (this._onShowVideoObj.closeCb = t), 
checkFunc(n) && (this._onShowVideoObj.errCb = n), PlatHelper.isOPPOPlatform()) this._onShowVideoObj.load(); else if (this._onShowVideoObj._lastShowedTime) if (console.log(ServerInfo.getServerTime(), "-", this._onShowVideoObj._lastShowedTime), 
ServerInfo.getServerTime() - this._onShowVideoObj._lastShowedTime > C_GapOfEachVideo) this._onShowVideoObj.load(); else {
var o = this._onShowVideoObj.errCb;
this._onShowVideoObj.closeCb = null, this._onShowVideoObj.errCb = null, doCallback$1(o, -1);
} else this._onShowVideoObj.load();
return this._onShowVideoObj;
}
}, {
key: "_doCreateVideoObj",
value: function(e) {
var t = PlatHelper.getPlat().createRewardedVideoAd({
posId: e
});
return t.onLoad(function() {
t.show().then(function() {
adv_interface.reportShowAdv(FlowAdvType.RewardedVideo, PlatAdOnShowFlow.video);
});
}), t.onClose(function(e) {
t._lastShowedTime = ServerInfo.getServerTime(), e.isEnded ? console.log("激励视频广告完成，发放奖励") : console.log("激励视频广告取消关闭，不发放奖励");
var n = t.closeCb;
t.closeCb = null, t.errCb = null, doCallback$1(n, e.isEnded);
}), t.onError(function(e) {
console.error("video ad err: ", e);
var n = t.errCb;
t.closeCb = null, t.errCb = null, doCallback$1(n, -1);
}), t;
}
}, {
key: "_doShowInsertAd",
value: function(e, t, n) {
var o = this;
if (!this._isSupport) return null;
console.log("show insert: ", e);
var i = null;
return i = PlatHelper.getPlat().createInsertAd ? PlatHelper.getPlat().createInsertAd({
posId: e
}) : PlatHelper.getPlat().createInterstitialAd({
posId: e
}), PlatHelper.isOPPOPlatform() && i.onLoad(function() {
this._onShowBannerObj && this._onShowBannerObj.hide(), i.show().then(function() {
adv_interface.reportShowAdv(FlowAdvType.Interstitial, PlatAdOnShowFlow.interstitial);
});
}), i.onClose(function() {
this._onShowInsertObj = null, doCallback$1(t);
}), i.onError(function(e) {
console.error("insert ad err: ", e), doCallback$1(n);
}), this._onShowInsertObj = i, PlatHelper.isOPPOPlatform() ? (console.log("start to load insert ad..."), 
i.load()) : i.show().then(function() {
console.log("show insert ad succ..."), o._onShowBannerObj && o._onShowBannerObj.hide();
}), i;
}
}, {
key: "_doLoadNativeAd",
value: function(e, t) {
if (!this._isSupport) return null;
console.log("load native: ", e);
var n = PlatHelper.getPlat().createNativeAd({
posId: e
}), o = null;
o = function(e) {
console.error("native ad loaded:", e), n.offLoad(o), n.offError(i), e.adList.length > 0 && (e.adList.forEach(function(e) {
e.localAdID = generateString(32);
}), n._adList = e.adList, doCallback$1(t, n));
};
var i = null;
return i = function(e) {
console.error("native ad err:", e), n.offLoad(o), n.offError(i), doCallback$1(t, null);
}, n.onLoad(o), n.onError(i), n.load(), n;
}
}, {
key: "isWatchingVideoAdv",
value: function() {
return !(!this._onShowVideoObj || !this._onShowVideoObj.closeCb);
}
}, {
key: "getNextNativeAdInfo",
value: function() {
if (this._unClickNativeObjs.length > 0) for (var e = this._unClickNativeObjs.length - 1; e >= 0; e--) this._unClickNativeObjs[e] || this._unClickNativeObjs.splice(e, 1);
if (this._unClickNativeObjs.length > 0) {
var t = this._unClickNativeObjs;
if (console.log("last used ad id: ", this._lastUsedAdID), this._unClickNativeObjs.length > 1 && "" !== this._lastUsedAdID) {
t = [];
for (var n = 0; n < this._unClickNativeObjs.length; n++) this._unClickNativeObjs[n]._adList[this._unClickNativeObjs[n]._adList.length - 1].localAdID !== this._lastUsedAdID && t.push(this._unClickNativeObjs[n]);
}
var o = t[random(0, t.length - 1)], i = o._adList[o._adList.length - 1];
return this._lastUsedAdID = i.localAdID, console.log("next used ad id: ", this._lastUsedAdID), 
[ o, i ];
}
return this.loadRandomNativeAd(function(e) {
e ? console.log("auto preload next native ad succ...") : console.log("auto preload next native ad fail...");
}), null;
}
}, {
key: "reportNativeAdShow",
value: function(e, t) {
console.log("just show native ad..."), e && e.reportAdShow({
adId: t
});
}
}, {
key: "reportNativeAdHide",
value: function() {
this._isSupport && (console.log("just hide native ad..."), this.loadRandomNativeAd(function(e) {
e ? console.log("auto preload next native ad succ...") : console.log("auto preload next native ad fail...");
}));
}
}, {
key: "reportNativeAdClick",
value: function(e, t) {
if (console.log("just click native ad..."), e && (e.reportAdClick({
adId: t
}), e._adList.pop(), 0 === e._adList.length)) for (var n = 0; n < this._unClickNativeObjs.length; n++) this._unClickNativeObjs[n] === e && this._unClickNativeObjs.splice(n, 1);
}
} ]);
return e;
}(), QGAdv = new _QGAdv(), bannerMgr = function() {
function e() {
_classCallCheck2(this, e);
}
_createClass2(e, [ {
key: "init",
value: function(e) {
arguments.length > 1 && void 0 !== arguments[1] && arguments[1], arguments.length > 2 && void 0 !== arguments[2] && arguments[2], 
arguments.length > 3 && void 0 !== arguments[3] && arguments[3], arguments.length > 4 && void 0 !== arguments[4] && arguments[4], 
arguments.length > 5 && void 0 !== arguments[5] && arguments[5], arguments.length > 6 && void 0 !== arguments[6] && arguments[6], 
arguments.length > 7 && void 0 !== arguments[7] && arguments[7];
var t = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : null;
t && t();
}
}, {
key: "createBannerAd",
value: function() {}
}, {
key: "left",
get: function() {
return 0;
}
}, {
key: "top",
get: function() {
return 0;
}
}, {
key: "width",
get: function() {
return 300;
}
}, {
key: "height",
get: function() {
return 105;
}
}, {
key: "destroyBannerAd",
value: function() {}
}, {
key: "resetBannerAd",
value: function() {}
}, {
key: "showBannerAd",
value: function() {
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
}
}, {
key: "hideBannerAd",
value: function() {}
} ]);
return e;
}(), Version = function() {
function e() {
var t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : 0, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 0, i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0;
_classCallCheck2(this, e);
"number" == typeof t ? (this.minor = t, this.major = n, this.build = o, this.revision = i) : "string" == typeof t && this.m_parse(t);
}
_createClass2(e, [ {
key: "Minor",
get: function() {
return this.minor;
}
}, {
key: "Major",
get: function() {
return this.major;
}
}, {
key: "Build",
get: function() {
return this.build;
}
}, {
key: "Revision",
get: function() {
return this.revision;
}
}, {
key: "m_parse",
value: function(e) {
this.minor = this.major = this.build = this.revision = 0;
var t = e.split(".");
this.minor = Number(t[0]), t.length > 1 && (this.major = Number(t[1])), t.length > 2 && (this.build = Number(t[2])), 
t.length > 3 && (this.revision = Number(t[3]));
}
}, {
key: "Compare",
value: function(e) {
return 1e3 * (this.minor - e.Minor) + 100 * (this.major - e.Major) + 10 * (this.build - e.Build) + (this.revision - e.Revision);
}
}, {
key: "CompareToString",
value: function(e) {
return versionCompare.m_parse(e), this.Compare(versionCompare);
}
} ]);
return e;
}(), versionCompare = new Version(), qqBannerMgr = function() {
_inherits2(t, bannerMgr);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this)).banIndex = -1, n.BannerIDs = [], n.BannerBrushIDs = [], n.Version = new Version("0.0.0.0"), 
n.bannerAds = [], n.bannerAd = null, n.nextBannerAd = null, n.BrushBannerObj = null, 
n.isBannerShow = !1, n.BrushBannerAdIntervals = 40, n.BrushBannerRefreshTime = 35, 
n.SystemInfo = null, n.MaxShowTime = 0, n.MaxClickCount = 0, n.preloadCount = 0, 
n.DefaultHeight = 73;
return n;
}
_createClass2(t, [ {
key: "refreshBanId",
get: function() {
return this.banIndex++, this.BannerIDs.length <= 0 ? -1 : this.banIndex % this.BannerIDs.length;
}
}, {
key: "init",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 3e4, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 60, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = (arguments.length > 6 && void 0 !== arguments[6] && arguments[6], 
arguments.length > 7 && void 0 !== arguments[7] && arguments[7], arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : null);
shuffleArray(e = e.split("||")), this.BrushBannerAdIntervals = t, this.BrushBannerRefreshTime = n, 
this.preloadCount = 0, this.SystemInfo = qq.getSystemInfoSync();
for (var s = e.length, l = 0; l < s; l++) this.BannerIDs.push(e[l]);
this.preloadBanner(a), this.MaxShowTime = o, this.MaxClickCount = i, 0 == o && 0 == i || (console.log("监听小游戏打开事件"), 
qq.onShow(this.onShow.bind(this))), doCallback$1(r);
}
}, {
key: "preloadBanner",
value: function(e) {
if (e > 0) for (var t = 0; t < this.BannerIDs.length && t < e; t++) this.bannerAds.push(this.createBannerAd(null, this.BannerIDs[t]));
}
}, {
key: "onShow",
value: function() {
null != this.bannerAd && (this.censusTime(), this.bannerAd.ClickCount++, this.checkReset());
}
}, {
key: "checkReset",
value: function() {
null != this.bannerAd && (this.MaxClickCount > 0 || this.MaxShowTime > 0) && this.bannerAd.ClickCount >= this.MaxClickCount && this.bannerAd.ShowTotalTime >= this.MaxShowTime && this.resetBannerAd();
}
}, {
key: "createBannerAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, o = null;
if (qq) {
var i = n;
if (null == n) {
if ((i = this.refreshBanId) < 0) return;
i = this.BannerIDs[i];
}
null == e && (e = {
left: this.SystemInfo.screenWidth / 2 - 150,
top: this.SystemInfo.screenHeight - this.DefaultHeight,
width: 300
}), e.width = 300, (o = this.MaxClickCount > 0 || this.MaxShowTime > 0 ? qq.createBannerAd({
adUnitId: i,
style: e
}) : qq.createBannerAd({
adIntervals: 30,
adUnitId: i,
style: e
})).bannerID = i, o.ClickCount = 0, o.ShowTime = o.ShowTotalTime = 0, console.log("banner创建 id=", i), 
o.onLoad(function() {
if (console.log("banner创建成功 id=", i), o.offLoad(), o.loaded = !0, t.nextBannerAd == o) {
if (t.preloadCount > 0) {
var n = t.bannerAds.indexOf(t.bannerAd);
n >= 0 && t.bannerAds.splice(n, 1);
}
t.destroyBannerAd(), t.preloadCount > 0 ? (t.bannerAds.indexOf(), t.bannerAds.push(o)) : t.bannerAd = t.nextBannerAd, 
t.nextBannerAd = null;
}
t.isBannerShow && t.bannerAd == o && t.showBannerAd(e), adv_interface.reportLoadSuccAdv(FlowAdvType.Banner);
}), o.onResize(function() {
console.log("Resize", o), o.width = o.style.realWidth || 300, o.height = o.style.realHeight || t.DefaultHeight, 
o.aspectratio = o.width / o.height, null != o.lastStyle ? (o.style.left = o.lastStyle.left, 
o.style.top = o.lastStyle.top) : o.style.left = (t.SystemInfo.screenWidth - o.style.realWidth) / 2, 
o.offResize();
}), o.onError(function(e) {
o.offError(), console.log("创建banner失败: ", e), adv_interface.reportLoadFailAdv(FlowAdvType.Banner);
});
}
return o;
}
}, {
key: "left",
get: function() {
return null != this.bannerAd ? this.bannerAd.style.left : this.SystemInfo.screenWidth / 2 - 150;
}
}, {
key: "top",
get: function() {
return null != this.bannerAd ? this.bannerAd.style.top : this.SystemInfo.screenHeight - this.DefaultHeight;
}
}, {
key: "width",
get: function() {
return null != this.bannerAd ? this.bannerAd.width : 300;
}
}, {
key: "height",
get: function() {
return null != this.bannerAd ? this.bannerAd.height : this.DefaultHeight;
}
}, {
key: "destroyBannerAd",
value: function() {
null != this.bannerAd && (console.log("销毁 banner"), this.bannerAd.destroy(), this.bannerAd = null);
}
}, {
key: "resetBannerAd",
value: function() {
console.log("创建新banner");
var e = null, t = this.getBannerIDUnrepeat();
null != this.bannerAd && (e = this.bannerAd.lastStyle, this.preloadCount > 0 && this.bannerAds.push(this.bannerAd)), 
this.nextBannerAd = this.createBannerAd(e, t);
}
}, {
key: "getBannerIDUnrepeat",
value: function() {
for (var e = 0; e < this.BannerIDs.length; e++) {
for (var t = !1, n = 0; n < this.bannerAds.length; n++) if (this.BannerIDs[e] == this.bannerAds[n].bannerID) {
t = !0;
break;
}
if (!t) return this.BannerIDs[e];
}
return null;
}
}, {
key: "showBannerAd",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
return this.isBannerShow = !0, null == this.bannerAd && (this.bannerAds.length > 0 ? this.bannerAd = this.bannerAds.shift() : this.bannerAd = this.createBannerAd(e)), 
null != this.bannerAd && (adv_interface.reportShowAdv(FlowAdvType.Banner, PlatAdOnShowFlow.banner), 
!this.bannerAd.visible && this.bannerAd.loaded && (console.log("显示 banner"), this.bannerAd.show(), 
this.bannerAd.visible = !0, this.bannerAd.ShowTime = Date.now()), this.bannerAd.lastStyle = e, 
null == e ? (this.bannerAd.width = 300, this.bannerAd.height = this.DefaultHeight, 
this.bannerAd.style.left = (this.SystemInfo.screenWidth - (this.bannerAd.style.realWidth || this.bannerAd.width)) / 2, 
this.bannerAd.style.top = this.SystemInfo.screenHeight - (this.bannerAd.style.realHeight || this.bannerAd.height)) : (this.bannerAd.width = e.width || 300, 
this.bannerAd.height = e.height || this.DefaultHeight, this.bannerAd.style.left = null != e.left ? e.left : (this.SystemInfo.screenWidth - (this.bannerAd.style.realWidth || this.bannerAd.width)) / 2, 
this.bannerAd.style.top = null != e.top ? e.top : this.SystemInfo.screenHeight - (this.bannerAd.style.realHeight || this.bannerAd.height))), 
this.bannerAd;
}
}, {
key: "hideBannerAd",
value: function() {
this.isBannerShow = !1, null != this.bannerAd && this.bannerAd.visible && (this.censusTime(), 
console.log("隐藏 banner"), this.bannerAd.hide(), this.bannerAd.visible = !1, this.checkReset(), 
this.preloadCount > 0 && (this.bannerAds.push(this.bannerAd), this.bannerAd = null));
}
}, {
key: "censusTime",
value: function() {
null != this.bannerAd && (this.bannerAd.ShowTotalTime += Date.now() - this.bannerAd.ShowTime, 
this.bannerAd.ShowTime = Date.now());
}
} ]);
return t;
}(), wxBannerMgr = function() {
_inherits2(t, bannerMgr);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this)).banIndex = -1, n.BannerIDs = [], n.CreateBannerID = [], n.BannerBrushIDs = [], 
n.Version = new Version(wx.version.version), n.bannerAds = [], n.bannerAd = null, 
n.isBannerShow = !1, n.BrushBannerAdIntervals = 40, n.BrushBannerRefreshTime = 35, 
n.SystemInfo = null, n.MaxShowTime = 0, n.MaxClickCount = 0, n.preloadCount = 0, 
n.refreshTime = 0, n.createTime = 0, n.BrushBanners = [], n.MaxBrushBannerRefreshCount = 5, 
n.brushBannerRefreshCount = 0, n.clickedBannerAds = [];
return n;
}
_createClass2(t, [ {
key: "init",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 3e4, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 60, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : 0, s = arguments.length > 7 && void 0 !== arguments[7] ? arguments[7] : 5, l = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : null, c = e.split("||");
for (e = []; c.length > 0; ) {
var d = Math.floor(Math.random() * c.length), h = c[d];
-1 == e.indexOf(h) && e.push(c[d]), c.splice(d, 1);
}
if (this.BrushBannerAdIntervals = t, this.BrushBannerRefreshTime = n, this.MaxBrushBannerRefreshCount = s, 
this.brushBannerRefreshCount = 0, this.preloadCount = a, this.SystemInfo = wx.getSystemInfoSync(), 
1 == r) {
if (e.length > 1) {
for (var u = Math.floor(e.length / 2), f = 0; f < u; f++) this.BannerIDs.push(e[f]);
for (var _ = u; _ < e.length; _++) this.BannerBrushIDs.push(e[_]);
}
} else for (var p = 0; p < e.length; p++) this.BannerIDs.push(e[p]);
this.CreateBannerID = this.BannerIDs.concat([]), 1 == r && this.BannerBrushIDs.length > 0 && (console.log("..初始创建屏幕外的banner..最大刷新次数: ", this.BannerBrushIDs.length, this.MaxBrushBannerRefreshCount), 
this.brushBanner()), this.MaxShowTime = o, this.MaxClickCount = i, 0 == o && 0 == i || (console.log("监听小游戏打开事件"), 
wx.onShow(this.onShow.bind(this))), this.preloadBanner(a, l);
}
}, {
key: "preloadBanner",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
if (console.log("预加载banner"), e > 0) {
var o = -1;
e > 2 && (o = 2);
for (var i = [], a = 0; a < this.BannerIDs.length && a < e && a < 2; a++) i.push(new Promise(function(e) {
t.createBannerAd(null, null, function() {
e();
});
}));
if (Promise.all(i).then(function() {
n && n();
}).catch(function() {
n && n();
}), o > 0) for (var r = o; r < this.BannerIDs.length && r < e; r++) Scheduler.schedule("Delay_Preload_Banner", function() {
t.createBannerAd(null, null);
}, !1, 5e3 * (r - 1), 0);
} else n && n();
}
}, {
key: "onShow",
value: function() {
null != this.bannerAd && (this.censusTime(), this.bannerAd.ClickCount++, this.resetBannerAd());
}
}, {
key: "checkReset",
value: function() {
null != this.bannerAd && (this.MaxClickCount > 0 || this.MaxShowTime > 0) && this.bannerAd.ClickCount >= this.MaxClickCount && this.bannerAd.ShowTotalTime >= this.MaxShowTime && this.resetBannerAd();
}
}, {
key: "createBannerAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, i = null;
if (wx) {
var a = n;
if (null == n) {
if (!(this.CreateBannerID.length > 0)) return this.bannerAds.shift();
a = this.CreateBannerID.shift();
}
null == e && (e = {
left: this.SystemInfo.screenWidth / 2 - 150,
top: -this.height,
width: 300
}), e.width = 300, (i = wx.createBannerAd({
adIntervals: 30,
adUnitId: a,
style: e
})).bannerID = a, i.ClickCount = 0, i.ShowTime = i.ShowTotalTime = 0, console.log("banner创建 id=", a), 
i.onLoad(function() {
console.log("banner创建成功 id=", a), i.offLoad(), i.loaded = !0, t.isBannerShow && t.bannerAd == i ? t.showBannerAd(e) : t.bannerAds.push(i), 
adv_interface.reportLoadSuccAdv(FlowAdvType.Banner), o && o();
}), i.onResize(function() {
console.log("Resize", i), i.width = i.style.realWidth || 300, i.height = i.style.realHeight || 105, 
i.aspectratio = i.width / i.height, null != i.lastStyle ? (i.style.left = i.lastStyle.left, 
i.style.top = i.lastStyle.top) : i.style.left = (t.SystemInfo.screenWidth - i.style.realWidth) / 2, 
i.offResize();
}), i.onError(function(n) {
i.offError(), console.log("创建banner失败: ", n), Scheduler.unschedule("delay_retry_create_Banner"), 
t.createTime++;
var a = i.bannerID;
t.createTime <= 3 ? Scheduler.schedule("delay_retry_create_Banner", function() {
t.bannerAd = t.createBannerAd(e, a);
}, !1, 100 * t.createTime, 0) : t.CreateBannerID.push(a), adv_interface.reportLoadFailAdv(FlowAdvType.Banner), 
o && o();
});
}
return i;
}
}, {
key: "left",
get: function() {
return null != this.bannerAd ? this.bannerAd.style.left : this.SystemInfo.screenWidth / 2 - 150;
}
}, {
key: "top",
get: function() {
return null != this.bannerAd ? this.bannerAd.style.top : this.SystemInfo.screenHeight - 105;
}
}, {
key: "width",
get: function() {
return null != this.bannerAd ? this.bannerAd.width : 300;
}
}, {
key: "height",
get: function() {
return null != this.bannerAd ? this.bannerAd.height : 105;
}
}, {
key: "destroyBannerAd",
value: function() {
null != this.bannerAd && (console.log("销毁 banner"), null != this.bannerAd.bannerID && this.CreateBannerID.push(this.bannerAd.bannerID), 
this.bannerAd.destroy(), this.bannerAd = null);
}
}, {
key: "resetBannerAd",
value: function() {
console.log("resetBannerAd,当前是否存在banner?", null != this.bannerAd);
var e = null;
null != this.bannerAd && (e = this.bannerAd.lastStyle, this.hideCurrentBanner()), 
this.isBannerShow && this.showBannerAd(e);
}
}, {
key: "showBannerAd",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
return this.bannerAd && this.bannerAd.visible && this.bannerAd.ShowTime && this.hideBannerAd(), 
this.isBannerShow = !0, this.createTime = 0, null == this.bannerAd && (this.bannerAds.length > 0 ? this.bannerAd = this.bannerAds.shift() : this.bannerAd = this.createBannerAd(e)), 
null != this.bannerAd && (adv_interface.reportShowAdv(FlowAdvType.Banner, PlatAdOnShowFlow.banner), 
!this.bannerAd.visible && this.bannerAd.loaded && (console.log("显示 bannerID" + this.bannerAd.bannerID), 
this.bannerAd.show(), this.bannerAd.visible = !0, this.bannerAd.ShowTime = Date.now()), 
this.bannerAd.lastStyle = e, null == e ? (this.bannerAd.width = 300, this.bannerAd.height = 105, 
this.bannerAd.style.left = (this.SystemInfo.screenWidth - (this.bannerAd.style.realWidth || this.bannerAd.width)) / 2, 
this.bannerAd.style.top = this.SystemInfo.screenHeight - (this.bannerAd.style.realHeight || this.bannerAd.height)) : (this.bannerAd.width = e.width || 300, 
this.bannerAd.height = e.height || 105, this.bannerAd.style.left = null != e.left ? e.left : (this.SystemInfo.screenWidth - (this.bannerAd.style.realWidth || this.bannerAd.width)) / 2, 
this.bannerAd.style.top = null != e.top ? e.top : this.SystemInfo.screenHeight - (this.bannerAd.style.realHeight || this.bannerAd.height))), 
this.bannerAd;
}
}, {
key: "hideBannerAd",
value: function() {
this.isBannerShow = !1, this.hideCurrentBanner();
}
}, {
key: "existsReadyBanner",
get: function() {
return this.bannerAds.length > 0;
}
}, {
key: "hideCurrentBanner",
value: function() {
null != this.bannerAd && (this.bannerAd.visible ? (this.censusTime(), this.bannerAd.hide(), 
this.bannerAd.visible = !1, this.checkClickBanner(), this.CreateBannerID.length > 0 && this.createBannerAd(), 
console.log("隐藏 banner")) : this.bannerAd.loaded && this.bannerAds.push(this.bannerAd), 
this.bannerAd = null);
}
}, {
key: "checkClickBanner",
value: function() {
if (this.bannerAd && (this.bannerAd.ClickCount > 0 ? (console.log("checkClickBanner ", this.bannerAd.bannerID), 
this.clickedBannerAds.push(this.bannerAd)) : this.bannerAds.push(this.bannerAd)), 
this.BannerIDs.length == this.clickedBannerAds.length) {
for (var e = 0; e < this.clickedBannerAds.length; e++) {
var t = this.clickedBannerAds[e];
t.ClickCount = 0, this.bannerAds.push(t);
}
this.clickedBannerAds = [], console.log("配置的所有banner都点击过一遍了,重置", this.clickedBannerAds.length, this.bannerAds.length);
}
}
}, {
key: "brushBanner",
value: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null, n = null;
this.BannerBrushIDs.length > 0 ? (t = this.BannerBrushIDs.pop(), (n = wx.createBannerAd({
adUnitId: t,
adIntervals: 30,
style: {
left: -340,
top: -115,
with: 300
}
})).onLoad(function() {
console.log("加载隐藏刷banner");
}), n.onResize(function() {
var t = (e.SystemInfo.screenWidth - n.style.realWidth) / 2;
n.style.left = 1 - (t + n.style.realWidth), n.style.top = 1 - n.style.realHeight, 
n.offResize();
}), n.onError(function() {
if (n.offError(), console.error("屏幕外banner创建失败：", t), Scheduler.unschedule("delay_brus_Banner"), 
e.refreshTime++, e.refreshTime <= 3) {
var o = n.bannerID;
Scheduler.schedule("delay_brus_Banner", function() {
e.brushBanner(o);
}, !1, 100 * e.refreshTime, 0);
}
})) : n = this.BrushBanners.pop(), null != n && n.show().then(function() {
console.log(" 隐藏刷banner刷新广告显示成功_show", e.brushBannerRefreshCount), e.brushBannerRefreshCount += 1, 
e.refreshTime = 0, e.brushBannerRefreshCount <= e.MaxBrushBannerRefreshCount ? Scheduler.schedule("brush_bannerAd", function() {
n.hide(), e.BrushBanners.push(n), e.brushBanner();
}, !1, 1e3 * e.BrushBannerAdIntervals, 1) : console.log("停止刷新隐藏banner");
}).catch(function() {});
}
}, {
key: "censusTime",
value: function() {
null != this.bannerAd && (this.bannerAd.ShowTotalTime += Date.now() - this.bannerAd.ShowTime, 
this.bannerAd.ShowTime = Date.now());
}
} ]);
return t;
}(), m_newBannerMgr = null, newBannerMgr = function() {
function e() {
_classCallCheck2(this, e);
}
_createClass2(e, null, [ {
key: "Instances",
get: function() {
if (null == m_newBannerMgr) switch (PlatHelper.getPlatType()) {
case "WX":
m_newBannerMgr = new wxBannerMgr();
break;

case "QQ":
m_newBannerMgr = new qqBannerMgr();
break;

default:
m_newBannerMgr = new bannerMgr();
}
return m_newBannerMgr;
}
} ]);
return e;
}(), _adv_interface = function() {
function e() {
_classCallCheck2(this, e);
this._isAutoRefreshBannerScheduled = !1, this._isAutoRefreshBannerPaused = !1, this._passedTimeOfLastRefresh = 0, 
this._gapOfRefreshBanner = 0, this._autoRefreshBannerIndexs = [], this._curAutoRefreshBannerIndex = 0, 
this._autoRefreshBannerAdStyle = null, this._autoRefreshBannerAdFlowID = "", this._autoRefreshBannerAdSuccCb = null, 
this._autoRefreshBannerAdErrCb = null, this._onShowCoupletAdUnitIds = [], this._onShowScrollAdUnitIds = [], 
this._onShowMatrixAdUnitIds = [];
}
_createClass2(e, [ {
key: "reportShowAdv",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "";
PlatHelper.getPlat() && PlatHelper.getPlat().h_ReportFlowAdv ? (h_ReportFlowAdv(e, FlowAdvActionType.Show, t), 
PlatHelper.getPlat().h_ReportFlowAdv(e, FlowAdvActionType.Show, t)) : h_ReportFlowAdv(e, FlowAdvActionType.Show, t);
}
}, {
key: "reportLoadSuccAdv",
value: function(e) {
PlatHelper.getPlat() && PlatHelper.getPlat().h_ReportFlowAdv ? (h_ReportFlowAdv(e, FlowAdvActionType.LoadSucc), 
PlatHelper.getPlat().h_ReportFlowAdv(e, FlowAdvActionType.LoadSucc)) : h_ReportFlowAdv(e, FlowAdvActionType.LoadSucc);
}
}, {
key: "reportLoadFailAdv",
value: function(e) {
PlatHelper.getPlat() && PlatHelper.getPlat().h_ReportFlowAdv ? (h_ReportFlowAdv(e, FlowAdvActionType.LoadFail), 
PlatHelper.getPlat().h_ReportFlowAdv(e, FlowAdvActionType.LoadFail)) : h_ReportFlowAdv(e, FlowAdvActionType.LoadFail);
}
}, {
key: "showAutoRefreshBannerAd",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : [], o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {}, i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : "", a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, r = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
this.stopAutoRefreshBannerAd(), this._isAutoRefreshBannerScheduled = !0, this._isAutoRefreshBannerPaused = !1, 
this._passedTimeOfLastRefresh = 0, this._gapOfRefreshBanner = Math.round(e / 1e3), 
this._autoRefreshBannerIndexs = n, this._curAutoRefreshBannerIndex = -1, this._autoRefreshBannerAdStyle = o, 
this._autoRefreshBannerAdFlowID = i, this._autoRefreshBannerAdSuccCb = a, this._autoRefreshBannerAdErrCb = r, 
this._doShowRefreshBannerAd(), Scheduler.schedule("Schedule_Of_Auto_Refresh_Banner", function() {
t._doRefreshBannerAd();
}, !1, 1e3);
}
}, {
key: "stopAutoRefreshBannerAd",
value: function() {
this._isAutoRefreshBannerScheduled && (Scheduler.unschedule("Schedule_Of_Auto_Refresh_Banner"), 
this._isAutoRefreshBannerScheduled = !1, this._isAutoRefreshBannerPaused = !1, this._passedTimeOfLastRefresh = 0, 
this._gapOfRefreshBanner = 0, this._autoRefreshBannerAdStyle = null);
}
}, {
key: "pauseAutoRefreshBannerAd",
value: function() {
this._isAutoRefreshBannerScheduled && (this._isAutoRefreshBannerPaused = !0);
}
}, {
key: "resumeAutoRefreshBannerAd",
value: function() {
this._isAutoRefreshBannerScheduled && (this._isAutoRefreshBannerPaused = !1);
}
}, {
key: "_doRefreshBannerAd",
value: function() {
this._isAutoRefreshBannerPaused || (this._passedTimeOfLastRefresh += 1, this._passedTimeOfLastRefresh >= this._gapOfRefreshBanner && (this._passedTimeOfLastRefresh = 0, 
this._doShowRefreshBannerAd()));
}
}, {
key: "_doShowRefreshBannerAd",
value: function() {
var e = 0;
this._autoRefreshBannerIndexs.length > 0 && (this._curAutoRefreshBannerIndex += 1, 
this._curAutoRefreshBannerIndex >= this._autoRefreshBannerIndexs.length && (this._curAutoRefreshBannerIndex = 0), 
e = this._autoRefreshBannerIndexs[this._curAutoRefreshBannerIndex]), this.showBannerAd(e, this._autoRefreshBannerAdStyle, this._autoRefreshBannerAdFlowID, this._autoRefreshBannerAdSuccCb, this._autoRefreshBannerAdErrCb);
}
}, {
key: "showBannerAd",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "", o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
HLSDKLocalData$1._isBannerOnShow = !0;
var a = PlatHelper.getSysInfo();
if (PlatAdOnShowFlow.banner = n, PlatHelper.isQGPlatform()) QGAdv.showRandomBannerAd(function(e) {
e && HLSDKLocalData$1._isBannerOnShow ? (e.show(), doCallback$1(o)) : doCallback$1(i);
}); else if (PlatHelper.isWXPlatform() || PlatHelper.isQQPlatform()) {
if (1 == t.out) HLSDKLocalData$1._bannerAdvObj = newBannerMgr.Instances.showBannerAd({
left: -newBannerMgr.Instances.width
}); else if (HLSDKLocalData$1._isNativeland) HLSDKLocalData$1._bannerAdvObj = newBannerMgr.Instances.showBannerAd({
left: a.screenWidth - newBannerMgr.Instances.width
}); else if (newBannerMgr.Instances.height && newBannerMgr.Instances.width && t && t.bannerBottom) {
var r = {
left: (a.screenWidth - newBannerMgr.Instances.width) / 2,
top: a.screenHeight - newBannerMgr.Instances.height - t.bannerBottom,
width: 300
};
HLSDKLocalData$1._bannerAdvObj = newBannerMgr.Instances.showBannerAd(r);
} else HLSDKLocalData$1._bannerAdvObj = newBannerMgr.Instances.showBannerAd();
doCallback$1(o);
} else if (PlatHelper.isWINPlatform()) this.reportShowAdv(FlowAdvType.Banner, n), 
doCallback$1(o); else {
var s = !1, l = 0;
if (PlatHelper.isTTPlatform()) l = 128; else if ((PlatHelper.isQQPlatform() || PlatHelper.isWXPlatform()) && (PlatHelper.isWXPlatform() && t.out && (s = !0), 
t.max ? l = a.screenWidth : t.min ? l = 300 : "number" == typeof t.width && t.width > 0 ? (t.width < 300 && (t.width = 300), 
t.width > a.screenWidth && (t.width = a.screenWidth), l = t.width) : l = a.screenWidth, 
"number" == typeof t.topFromHeight && t.topFromHeight > 0)) {
var c = l / FlowBannerAdvSize.Width * FlowBannerAdvSize.Height;
PlatHelper.isIPhoneX() && (c += Adv.getMiniGapFromBottom());
var d = getSceneSize();
if (c / a.screenHeight * d.height > t.topFromHeight) {
var h = t.topFromHeight / d.height * a.screenHeight;
PlatHelper.isIPhoneX() && (h -= Adv.getMiniGapFromBottom());
var u = h / FlowBannerAdvSize.Height * FlowBannerAdvSize.Width;
u < 300 && (u = 300), l = u;
}
}
var f = "";
if (e > 0 && HLSDKLocalData$1._globalBannerCfg.preloadCount > 1) {
var _ = Adv.getOnShowBannerAdUnitIDs();
f = _[(e - 1) % _.length];
}
if (s) {
var p = l / FlowBannerAdvSize.Width * FlowBannerAdvSize.Height, g = 1;
HLSDKLocalData$1._globalBannerCfg.isTest && (g = 20), HLSDKLocalData$1._bannerAdvObj = Adv.createBannerAd(f, {
left: g - l,
top: g - p,
width: l
}, function(e) {
doCallback$1(i, e);
}, function() {
HLSDKLocalData$1._isBannerOnShow && Adv.showBannerAd(), doCallback$1(o);
});
} else {
var v = 5;
t.min && (v = 10), HLSDKLocalData$1._bannerAdvObj = Adv.createBannerAd(f, {
centerX: 0,
bottom: v,
width: l
}, function(e) {
doCallback$1(i, e);
}, function() {
HLSDKLocalData$1._isBannerOnShow && Adv.showBannerAd(), doCallback$1(o);
});
}
}
}
}, {
key: "hideBannerAd",
value: function() {
HLSDKLocalData$1._isBannerOnShow = !1, HLSDKLocalData$1._bannerAdvObj = null, PlatHelper.isWINPlatform() || (PlatHelper.isQGPlatform() ? QGAdv.hideOnShowBannerAd() : PlatHelper.isWXPlatform() || PlatHelper.isQQPlatform() ? newBannerMgr.Instances.hideBannerAd() : Adv.hideBannerAd());
}
}, {
key: "moveBannerAd",
value: function(e) {
if (HLSDKLocalData$1._isBannerOnShow && HLSDKLocalData$1._bannerAdvObj) {
var t = new Laya.Size(0, 0);
void 0 !== e.left && (t._width = e.left), void 0 !== e.right && (t._width = -e.right), 
void 0 !== e.top && (t._height = e.top), void 0 !== e.bottom && (t._height = -e.bottom);
var n = convertToOpenGLSize(t);
HLSDKLocalData$1._bannerAdvObj._lastLeft = HLSDKLocalData$1._bannerAdvObj.style.left, 
HLSDKLocalData$1._bannerAdvObj._lastTop = HLSDKLocalData$1._bannerAdvObj.style.top, 
0 !== n.width && (HLSDKLocalData$1._bannerAdvObj.style.left -= n.width), 0 !== n.height && (HLSDKLocalData$1._bannerAdvObj.style.top -= n.height), 
(PlatHelper.isWXPlatform() || PlatHelper.isQQPlatform()) && newBannerMgr.Instances.showBannerAd({
left: HLSDKLocalData$1._bannerAdvObj.style.left,
top: HLSDKLocalData$1._bannerAdvObj.style.top
});
}
}
}, {
key: "moveBannerAdTo",
value: function(e) {
if (null != window.wx || null != window.qq) {
var t = convertToOpenGLPt(e), n = PlatHelper.getSysInfo(), o = {
realWidth: 300,
realHeight: 105
};
o.realWidth = newBannerMgr.Instances.width, o.realHeight = newBannerMgr.Instances.height;
var i = t.x - o.realWidth / 2;
i < 0 ? i = 0 : i > n.screenWidth - o.realWidth && (i = n.screenWidth - o.realWidth);
var a = t.y - o.realHeight / 2;
a < 0 ? a = 0 : a > n.screenHeight - o.realHeight && (a = n.screenHeight - o.realHeight), 
newBannerMgr.Instances.showBannerAd({
left: i,
top: a
});
} else if (null == HLSDKLocalData$1._bannerAdvObj && this.showBannerAd(), HLSDKLocalData$1._isBannerOnShow && HLSDKLocalData$1._bannerAdvObj) {
var r = convertToOpenGLPt(e), s = PlatHelper.getSysInfo(), l = {
realWidth: 0,
realHeight: 0
};
void 0 !== HLSDKLocalData$1._bannerAdvObj.style ? (l.realWidth = HLSDKLocalData$1._bannerAdvObj.style.realWidth, 
l.realHeight = HLSDKLocalData$1._bannerAdvObj.style.realHeight) : (l.realWidth = newBannerMgr.Instances.width, 
l.realHeight = newBannerMgr.Instances.height);
var c = r.x - l.realWidth / 2;
c < 0 ? c = 0 : c > s.screenWidth - l.realWidth && (c = s.screenWidth - l.realWidth);
var d = r.y - l.realHeight / 2;
d < 0 ? d = 0 : d > s.screenHeight - l.realHeight && (d = s.screenHeight - l.realHeight), 
HLSDKLocalData$1._bannerAdvObj._lastLeft = HLSDKLocalData$1._bannerAdvObj.style.left, 
HLSDKLocalData$1._bannerAdvObj._lastTop = HLSDKLocalData$1._bannerAdvObj.style.top, 
HLSDKLocalData$1._bannerAdvObj.style.left = c, HLSDKLocalData$1._bannerAdvObj.style.top = d, 
(PlatHelper.isWXPlatform() || PlatHelper.isQQPlatform()) && newBannerMgr.Instances.showBannerAd({
left: HLSDKLocalData$1._bannerAdvObj.style.left,
top: HLSDKLocalData$1._bannerAdvObj.style.top
});
}
}
}, {
key: "moveBannerAdBack",
value: function() {
HLSDKLocalData$1._isBannerOnShow && HLSDKLocalData$1._bannerAdvObj && ("number" == typeof HLSDKLocalData$1._bannerAdvObj._lastLeft && (HLSDKLocalData$1._bannerAdvObj.style.left = HLSDKLocalData$1._bannerAdvObj._lastLeft, 
delete HLSDKLocalData$1._bannerAdvObj._lastLeft), "number" == typeof HLSDKLocalData$1._bannerAdvObj._lastTop && (HLSDKLocalData$1._bannerAdvObj.style.top = HLSDKLocalData$1._bannerAdvObj._lastTop, 
delete HLSDKLocalData$1._bannerAdvObj._lastTop));
}
}, {
key: "isBannerOnShow",
value: function() {
return HLSDKLocalData$1._isBannerOnShow;
}
}, {
key: "tempHideBanner",
value: function() {
HLSDKLocalData$1._isBannerOnShow = !1, HLSDKLocalData$1._bannerAdvObj && HLSDKLocalData$1._bannerAdvObj.hide();
}
}, {
key: "tempShowBanner",
value: function() {
HLSDKLocalData$1._isBannerOnShow = !0, HLSDKLocalData$1._bannerAdvObj && HLSDKLocalData$1._bannerAdvObj.show();
}
}, {
key: "getNextFreeGetWay",
value: function(e) {
if ("function" == typeof e) {
var t = function(t) {
HLSDKLocalData$1._nextFreeGetWay = t, doCallback$1(e, t);
};
PlatHelper.isWINPlatform() ? t(FreeGetWay.FGW_ADV) : PlatHelper.isQGPlatform() ? QGAdv.isSupportVideo() ? t(FreeGetWay.FGW_ADV) : t(FreeGetWay.FGW_NONE) : PlatHelper.isTTPlatform() ? Adv.isSupportVideoAd() ? t(FreeGetWay.FGW_ADV) : t(FreeGetWay.FGW_NONE) : Switch.getRewardTimesOfEachDay(function(e) {
HLSDKLocalData$1._interactInfo._todayAdvTimes >= e ? t(FreeGetWay.FGW_NONE) : Switch.isPublishing(function(e) {
e ? Adv.isSupportVideoAd() ? t(FreeGetWay.FGW_ADV) : t(FreeGetWay.FGW_NONE) : Switch.getAdvTimesBeforeShare(function(e) {
HLSDKLocalData$1._interactInfo._todayAdvTimes < e ? Adv.isSupportVideoAd() ? t(FreeGetWay.FGW_ADV) : t(FreeGetWay.FGW_SHARE) : Adv.isSupportVideoAd() ? Switch.getRateOfShare(function(e) {
random(1, 100) <= e ? t(FreeGetWay.FGW_SHARE) : t(FreeGetWay.FGW_ADV);
}) : t(FreeGetWay.FGW_SHARE);
});
});
});
}
}
}, {
key: "tryFreeToGetAReward",
value: function(e) {
var t = this, n = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], o = !(arguments.length > 2 && void 0 !== arguments[2]) || arguments[2], i = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, a = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, r = function() {
HLSDKLocalData$1._nextFreeGetWay = null, doCallback$1(i);
}, s = function() {
n ? PlatHelper.showModal(null, RewatchVideoDialog.content, !0, function(e) {
e ? (n = !1, t.getNextFreeGetWay(function(e) {
console.log("new free get way: ", e), l();
})) : (HLSDKLocalData$1._nextFreeGetWay = null, doCallback$1(a));
}, {
confirmText: RewatchVideoDialog.confirmText,
cancelText: RewatchVideoDialog.cancelText
}) : (HLSDKLocalData$1._nextFreeGetWay = null, doCallback$1(a));
};
HLSDKLocalData$1._nextFreeGetWay = FreeGetWay.FGW_ADV;
var l = function() {
HLSDKLocalData$1._nextFreeGetWay === FreeGetWay.FGW_ADV ? t.showRewardedVideoAd("", o, r, s) : PlatHelper.isTTPlatform() && HLSDKLocalData$1._nextFreeGetWay === FreeGetWay.FGW_NONE ? (o && PlatHelper.showToast(ShowVideoFailTips.noReady), 
s()) : Share.share(e, null, o, function(e) {
if (e) {
if (addShareTimes(), PlatHelper.setStorage(SK_KEY_OF_INTERACT_INFO, saveInteractInfoToString()), 
HLSDKLocalData$1._nextFreeGetWay === FreeGetWay.FGW_SHARE) return void r();
o && PlatHelper.showToast(ShowVideoFailTips.noMore);
}
s();
});
};
null !== HLSDKLocalData$1._nextFreeGetWay ? l() : this.getNextFreeGetWay(function(e) {
console.log("new free get way: ", e), l();
});
}
}, {
key: "isWatchingVideoAdv",
value: function() {
return PlatHelper.isQGPlatform() ? QGAdv.isWatchingVideoAdv() : Adv.isWatchingVideoAdv();
}
}, {
key: "showRewardedVideoAd",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "", t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = function(e) {
doCallback$1(HLSDKLocalData$1._handles.onShow), e ? (addAdvTimes(), PlatHelper.setStorage(SK_KEY_OF_INTERACT_INFO, saveInteractInfoToString()), 
doCallback$1(n), Reportor$1.postBackToTT(25)) : (t && PlatHelper.showToast(ShowVideoFailTips.noFinish), 
doCallback$1(o, "Not Finish..."));
};
doCallback$1(HLSDKLocalData$1._handles.onHide), PlatHelper.isWINPlatform() ? (this.reportShowAdv(FlowAdvType.RewardedVideo, e), 
i(!0)) : PlatHelper.isQGPlatform() ? (PlatAdOnShowFlow.video = e, QGAdv.showRandomVideoAd(function(e) {
i(e);
}, function(e) {
if (doCallback$1(HLSDKLocalData$1._handles.onShow), t && "number" == typeof e) {
var n = e;
-1 === n ? PlatHelper.showToast(ShowVideoFailTips.noReady) : PlatHelper.showToast(formatString(ShowVideoFailTips.wait, n.toString()));
}
doCallback$1(o, "number" != typeof e ? e : "Unknow...");
})) : (PlatAdOnShowFlow.video = e, 0 !== HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime && (-1 === HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime ? PlatHelper.showLoading(HLSDKLocalData$1._globalVideoCfg.videoLoadingTips) : HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime > 0 && Scheduler.schedule("Delay_Auto_Close_Video_Loading", function() {
PlatHelper.hideLoading();
}, !1, HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime, 1)), Adv.createVideoAdv(function() {
-1 === HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime && PlatHelper.hideLoading();
}, function(e) {
i(e);
}, function(e) {
HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime > 0 && Scheduler.unschedule("Delay_Auto_Close_Video_Loading"), 
PlatHelper.hideLoading(), doCallback$1(HLSDKLocalData$1._handles.onShow), doCallback$1(o, e);
}));
}
}, {
key: "showInterstitialAd",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "", t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
PlatHelper.isWINPlatform() ? (this.reportShowAdv(FlowAdvType.Interstitial, e), doCallback$1(t)) : (PlatAdOnShowFlow.interstitial = e, 
PlatHelper.isQGPlatform() ? QGAdv.showRandomInsertAd(t, n) : Adv.createInterstitialAd(null, t, n));
}
}, {
key: "showPopupCustomAd",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "", o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
PlatHelper.isWXPlatform() && checkString(e) && (PlatAdOnShowFlow.custom = n, Adv.createCustomAd(e, {
layout: "center",
row: t
}, 0, !0, o, i, a)), PlatHelper.isWINPlatform() && (isLoadWXConfig() && this.reportShowAdv(FlowAdvType.Custom, n), 
doCallback$1(o));
}
}, {
key: "showBoxAd",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "", t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
PlatHelper.isQQPlatform() && (PlatAdOnShowFlow.box = e, Adv.createBoxAd(function() {
doCallback$1(t);
}, function() {
doCallback$1(n);
}, function(e) {
doCallback$1(o, e);
})), PlatHelper.isWINPlatform() && (isLoadQQConfig() && this.reportShowAdv(FlowAdvType.Box, e), 
doCallback$1(n));
}
}, {
key: "showPortalAd",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "", n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
PlatHelper.isOPPOPlatform() && (PlatAdOnShowFlow.portal = t, console.error("showPortalAd:  " + PlatAdOnShowFlow.portal), 
Adv.createPortalAd(e, n, o, i)), PlatHelper.isWINPlatform() && (isLoadOPPOConfig() && this.reportShowAdv(FlowAdvType.Portal, t), 
console.error("EEEEE"), doCallback$1(o));
}
}, {
key: "showDrawerAd",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "", o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
PlatHelper.isOPPOPlatform() && (PlatAdOnShowFlow.drawer = n, console.error("showDrawerAd:  " + PlatAdOnShowFlow.drawer), 
Adv.createDrawerAd(e, t, o, i, a)), PlatHelper.isWINPlatform() && (isLoadOPPOConfig() && this.reportShowAdv(FlowAdvType.Drawer, n), 
console.error("EEEEE"), doCallback$1(a));
}
}, {
key: "ShowQgPortalAd",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "", o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null;
PlatHelper.isVIVOPlatform() && (console.log("22222"), PlatAdOnShowFlow.portal = n, 
console.error("QgPortalAd:  " + PlatAdOnShowFlow.portal), Adv.createQgPortalAd(e, t, o, i, a)), 
PlatHelper.isWINPlatform() && (isLoadVIVOConfig() && this.reportShowAdv(FlowAdvType.Portal, n), 
console.error("EEEEE"), doCallback$1(a));
}
}, {
key: "ShowQgStreamerAd",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "", n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
PlatHelper.isVIVOPlatform() && (console.log("22222"), PlatAdOnShowFlow.portal = t, 
console.error("QgStreamerAd:  " + PlatAdOnShowFlow.streamer), Adv.createQgStreamerAd(e, n, i, o)), 
PlatHelper.isWINPlatform() && (isLoadVIVOConfig() && this.reportShowAdv(FlowAdvType.Streamer, t), 
console.error("EEEEE"), doCallback$1(i));
}
}, {
key: "preloadFlowCustomAd",
value: function(e) {
var t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], n = !(arguments.length > 2 && void 0 !== arguments[2]) || arguments[2], o = !(arguments.length > 3 && void 0 !== arguments[3]) || arguments[3], i = HLSDKLocalData$1._flowPreloadPromises[e];
return i || (i = [], HLSDKLocalData$1._flowPreloadPromises[e] = i), t && i.push(adv_interface.preloadCustomAd("matrix", e, HLSDKLocalData$1._globalMatrixAdCfg, "landscape", getMatrixInputLayout)), 
n && i.push(adv_interface.preloadCustomAd("scroll", e, HLSDKLocalData$1._globalScrollAdCfg, "", getScrollInputLayout)), 
o && i.push(adv_interface.preloadCustomAd("couplet", e, HLSDKLocalData$1._globalCoupleAdCfg, "vertical", function(e) {
return parseInt(e.left) > 0 ? {
layout: "left",
left: parseFloat(e.FromLeftPercent),
top: parseFloat(e.leftFromTopPercent)
} : parseInt(e.right) > 0 ? {
layout: "right",
left: parseFloat(e.FromRightPercent),
top: parseFloat(e.rightFromTopPercent)
} : void 0;
})), i;
}
}, {
key: "preloadCustomAd",
value: function(e, t, n, o, i) {
if (PlatHelper.isWXPlatform() && n.length > 0) {
var a = function() {
for (var a = [], r = function(e) {
return void 0 === e.isLoaded && (e.isLoaded = !1), !e.isLoaded && parseInt(e.preloadFlow) === t;
}, s = function(e) {
return checkString(e.matrixAdUnitId) ? e.matrixAdUnitId : checkString(e.adUnitId) ? e.adUnitId : checkString(e.leftAdUnitId) ? e.leftAdUnitId : checkString(e.rightAdUnitId) ? e.rightAdUnitId : "";
}, l = function(e) {
return void 0 !== e.blockSize ? parseInt(e.blockSize) : void 0 !== e.leftSize ? parseInt(e.leftSize) : void 0 !== e.rightSize ? parseInt(e.rightSize) : 0;
}, c = function(c) {
var d = n[c], h = s(d);
r(d) && checkString(h) && a.push(new Promise(function(n) {
var a = function() {
adv_interface.showComponentAd(e, "", h, i(d), 0, l(d), void 0 !== d.orientation ? d.orientation : o, !1, function() {
console.warn(formatString("preload {0} custom ad succ...", e)), d.isLoaded = !0, 
n();
}, function(t) {
console.warn(formatString("preload {0} custom ad fail...", e), {
errCode: t && t.errCode,
errMsg: t && t.errMsg
}), n();
});
};
t === PreloadFlowType.Loading ? a() : Scheduler.schedule("Delay_Try_Preload_WX_Custom_Ad", function() {
a();
}, !1, 1e3 + parseInt(d.delayPreloadTime), 0);
}));
}, d = 0; d < n.length; d++) c(d);
return {
v: a.length > 0 ? Promise.all(a) : Promise.resolve()
};
}();
if ("object" == typeof a) return a.v;
}
return Promise.resolve();
}
}, {
key: "showComponentAd",
value: function(e, t, n, o) {
var i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : "landscape", s = !(arguments.length > 7 && void 0 !== arguments[7]) || arguments[7], l = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : null, c = arguments.length > 9 && void 0 !== arguments[9] ? arguments[9] : null;
checkString(n) && ("couplet" === e.toLowerCase() ? -1 === this._onShowCoupletAdUnitIds.indexOf(n) && this._onShowCoupletAdUnitIds.push(n) : "scroll" === e.toLowerCase() ? -1 === this._onShowScrollAdUnitIds.indexOf(n) && this._onShowScrollAdUnitIds.push(n) : "matrix" === e.toLowerCase() && -1 === this._onShowMatrixAdUnitIds.indexOf(n) && this._onShowMatrixAdUnitIds.push(n), 
"number" == typeof o.top && (o.top = o.top / 100 * getSceneSize().height), "number" == typeof o.bottom && (o.bottom = o.bottom / 100 * getSceneSize().height), 
"number" == typeof o.left && (o.left = o.left / 100 * getSceneSize().width), "number" == typeof o.right && (o.right = o.right / 100 * getSceneSize().width), 
PlatHelper.isWXPlatform() ? (PlatAdOnShowFlow.custom = t, Adv.createCustomAd(n, o, i, s, l, null, c)) : PlatHelper.isQQPlatform() ? (PlatAdOnShowFlow.block = t, 
Adv.createBlockAd(n, o, a, r, l, c)) : PlatHelper.isOPPOPlatform() ? (PlatAdOnShowFlow.streamer = t, 
console.error("in...Adv"), Adv.createStreamerAd(n, o, r, l, null, c)) : (isLoadWXConfig() ? this.reportShowAdv(FlowAdvType.Custom, t) : isLoadQQConfig() ? this.reportShowAdv(FlowAdvType.Block, t) : isLoadOPPOConfig() && this.reportShowAdv(FlowAdvType.Streamer, t), 
doCallback$1(l)));
}
}, {
key: "showgraphicAd",
value: function(e, t, n, o) {
var i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null, r = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : null;
PlatHelper.isOPPOPlatform() || PlatHelper.isVIVOPlatform() ? (PlatAdOnShowFlow.custom = t, 
Adv.createCustomAd(n, o, 0, !0, i, r, a)) : PlatHelper.isWINPlatform() && (this.reportShowAdv(FlowAdvType.Custom, t), 
doCallback$1(r));
}
}, {
key: "_showComponentAd",
value: function(e) {
PlatHelper.isWXPlatform() ? Adv.showCustomAd(e) : PlatHelper.isQQPlatform() ? Adv.showBlockAd(e) : PlatHelper.isOPPOPlatform() ? (Adv.showStreamerAd(e), 
Adv.showDrawerAd(e)) : PlatHelper.isVIVOPlatform() && (Adv.showStreamerQgAd(e), 
Adv.showPortalQgAd(e)), isLoadWXConfig() ? console.log("show target custom ad succ...") : isLoadQQConfig() ? console.log("show target Block ad succ...") : isLoadOPPOConfig() ? console.log("show target Streamer ad succ...") : isLoadVIVOConfig && console.log("show target Streamer ad succ...");
}
}, {
key: "hideComponentAd",
value: function(e) {
var t = this._onShowCoupletAdUnitIds.indexOf(e);
-1 !== t && this._onShowCoupletAdUnitIds.splice(t, 1), -1 !== (t = this._onShowScrollAdUnitIds.indexOf(e)) && this._onShowScrollAdUnitIds.splice(t, 1), 
-1 !== (t = this._onShowMatrixAdUnitIds.indexOf(e)) && this._onShowMatrixAdUnitIds.splice(t, 1), 
this._hideComponentAd(e);
}
}, {
key: "_hideComponentAd",
value: function(e) {
PlatHelper.isWXPlatform() ? Adv.hideCustomAd(e) : PlatHelper.isQQPlatform() ? Adv.hideBlockAd(e) : PlatHelper.isOPPOPlatform() ? (Adv.hideStreamerAd(e), 
Adv.hideDrawerAd(e)) : PlatHelper.isVIVOPlatform() && (Adv.hideStreamerQgAd(e), 
Adv.hidePortalQgAd(e)), isLoadWXConfig() ? console.log("hide target custom ad succ...") : isLoadQQConfig() ? console.log("hide target Block ad succ...") : isLoadOPPOConfig() ? console.log("hide target Streamer ad succ...") : isLoadVIVOConfig() && console.log("hide target Streamer ad succ...");
}
}, {
key: "isComponentAdPreloaded",
value: function(e) {
return PlatHelper.isWXPlatform() ? Adv.isCustomAdPreloaded(e) : PlatHelper.isQQPlatform() ? Adv.isBlockAdPreloaded(e) : PlatHelper.isOPPOPlatform() ? Adv.isStreamerAdPreloaded(e) : !!PlatHelper.isVIVOPlatform() && Adv.isQgStreamerAdPreloaded(e);
}
}, {
key: "hideAllComponentAds",
value: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
this._onShowCoupletAdUnitIds = [], this._onShowScrollAdUnitIds = [], this._onShowMatrixAdUnitIds = [], 
(PlatHelper.isWXPlatform() || PlatHelper.isOPPOPlatform() || PlatHelper.isVIVOPlatform()) && Adv.hideAllCustomAds(), 
PlatHelper.isQQPlatform() ? Adv.destroyAllBlockAds().then(function() {
doCallback$1(e);
}) : PlatHelper.isOPPOPlatform() ? Adv.hideAllStreamerAds() : PlatHelper.isVIVOPlatform() && Adv.hideAllQgStreamerAds(), 
isLoadWXConfig() ? console.log("hide all custom ads succ...") : isLoadQQConfig() ? console.log("destroy all block ads succ...") : isLoadOPPOConfig() ? console.log("hide all streamer ads succ...") : isLoadVIVOConfig() && console.log("hide all streamer ads succ..."), 
PlatHelper.isQQPlatform() || doCallback$1(e);
}
}, {
key: "tempHideAllAdvs",
value: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
!0 === t.couplet && this._onShowCoupletAdUnitIds.length > 0 && this._onShowCoupletAdUnitIds.forEach(function(t) {
HLSDKLocalData$1._tempHides.adv.couplet.push(t), e._hideComponentAd(t);
}), !0 === t.scroll && this._onShowScrollAdUnitIds.length > 0 && this._onShowScrollAdUnitIds.forEach(function(t) {
HLSDKLocalData$1._tempHides.adv.scroll.push(t), e._hideComponentAd(t);
}), !0 === t.matrix && this._onShowMatrixAdUnitIds.length > 0 && this._onShowMatrixAdUnitIds.forEach(function(t) {
HLSDKLocalData$1._tempHides.adv.matrix.push(t), e._hideComponentAd(t);
});
}
}, {
key: "showAllTempHideAdvs",
value: function() {
var e = this;
HLSDKLocalData$1._tempHides.adv.couplet.length > 0 && (HLSDKLocalData$1._tempHides.adv.couplet.forEach(function(t) {
e._showComponentAd(t);
}), HLSDKLocalData$1._tempHides.adv.couplet = []), HLSDKLocalData$1._tempHides.adv.scroll.length > 0 && (HLSDKLocalData$1._tempHides.adv.scroll.forEach(function(t) {
e._showComponentAd(t);
}), HLSDKLocalData$1._tempHides.adv.scroll = []), HLSDKLocalData$1._tempHides.adv.matrix.length > 0 && (HLSDKLocalData$1._tempHides.adv.matrix.forEach(function(t) {
e._showComponentAd(t);
}), HLSDKLocalData$1._tempHides.adv.matrix = []);
}
} ]);
return e;
}(), adv_interface = new _adv_interface();

function getSceneSize() {
return isCocosEngine() ? {
width: cc.winSize.width,
height: cc.winSize.height
} : isLayaEngine() ? {
width: Laya.stage.width,
height: Laya.stage.height
} : {
width: 0,
height: 0
};
}

function convertToScreneOrientationPrefabPath(e) {
return checkString(e) ? isLoadLandscapeConfig$1() ? e + "_Landscape" : e : "";
}

function seekNodeByName(e, t) {
if (e.name === t) return e;
var n = void 0;
return e._children.forEach(function(e) {
n || (n = seekNodeByName(e, t));
}), n;
}

function setGroupName(e, t) {
e.group = t, e._children.forEach(function(e) {
setGroupName(e, t);
});
}

function delayShow(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 3e3;
e && t > 0 ? (isCocosEngine() ? e.active = !1 : e.visible = !1, Scheduler.schedule("Delay_Show_Of_" + generateString(32), function() {
isCocosEngine() ? e.active = !0 : e.visible = !0;
}, !1, t, 0)) : isCocosEngine() ? e.active = !0 : e.visible = !0;
}

function recordOriginalState(e) {
if (e) {
if (!e._originalWidget) {
var t = e.getComponent(cc.Widget);
t ? e._originalWidget = {
left: t.isAlignLeft ? t.left : NaN,
right: t.isAlignRight ? t.right : NaN,
top: t.isAlignTop ? t.top : NaN,
bottom: t.isAlignBottom ? t.bottom : NaN,
horizontalCenter: t.isAlignHorizontalCenter ? t.horizontalCenter : NaN,
verticalCenter: t.isAlignVerticalCenter ? t.verticalCenter : NaN
} : console.error("Can Not Record Pos Without cc.Widget...");
}
e._originalScale || (e._originalScale = {
x: e.scaleX,
y: e.scaleY
}), e.backToOriginalState || (e.backToOriginalState = function() {
if (e._originalWidget) {
var t = e.getComponent(cc.Widget);
if (t) {
var n = function(n, o) {
isNaN(e._originalWidget[o]) ? checkString(n) ? t[n] = !1 : t[o] = NaN : (checkString(n) && (t[n] = !0), 
t[o] = e._originalWidget[o]);
};
n("isAlignLeft", "left"), n("isAlignRight", "right"), n("isAlignTop", "top"), n("isAlignBottom", "bottom"), 
n("isAlignHorizontalCenter", "horizontalCenter"), n("isAlignVerticalCenter", "verticalCenter");
}
}
e._originalScale && (e.scaleX = e._originalScale.x, e.scaleY = e._originalScale.y);
});
}
}

function autoMove(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 0, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = arguments.length > 6 && void 0 !== arguments[6] && arguments[6], s = arguments.length > 7 && void 0 !== arguments[7] ? arguments[7] : {
x: 0,
y: 0
};
e && (recordOriginalState(e), e._moveTween && (e._moveTween.clear(), e._moveTween = null), 
e._scheduleKey && (Scheduler.unschedule(e._scheduleKey), e._scheduleKey = null), 
n > 0 && (e.active = !1), e.backToOriginalState(), e._scheduleKey = generateString(32), 
Scheduler.schedule(e._scheduleKey, function() {
e._scheduleKey = null, doCallback$1(t, "hide_finished"), e.active = !0, e._scheduleKey = generateString(32), 
Scheduler.schedule(e._scheduleKey, function() {
e._scheduleKey = null, doCallback$1(t, "hold_finished_1"), e._scheduleKey = generateString(32), 
Scheduler.schedule(e._scheduleKey, function() {
e._scheduleKey = null, doCallback$1(t, "hold_finished_2");
var n = e.getComponent(cc.Widget);
r && n ? e._moveTween = cc.tween(n).by(a / 1e3, {
bottom: -s.y
}).call(function() {
e._moveTween = null, doCallback$1(t, "move_finished");
}).start() : (e._scheduleKey = generateString(32), Scheduler.schedule(e._scheduleKey, function() {
e._scheduleKey = null, n && (e.backToOriginalState(), n.bottom -= s.y), doCallback$1(t, "move_finished");
}, !1, a, 1));
}, !1, i, 1);
}, !1, o, 1);
}, !1, n, 1));
}

function createMistakeBtn_NoMove(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 0, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = arguments.length > 6 && void 0 !== arguments[6] ? arguments[6] : 0, s = arguments.length > 7 && void 0 !== arguments[7] ? arguments[7] : 0, l = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : 0, c = arguments.length > 9 && void 0 !== arguments[9] ? arguments[9] : null, d = arguments.length > 10 && void 0 !== arguments[10] ? arguments[10] : null, h = arguments.length > 11 && void 0 !== arguments[11] ? arguments[11] : null;
e && createMistakeBtn_Move(e, t, n, o, i, a, r, s, l, !1, {
x: 0,
y: 0
}, c, d, h);
}

function createMistakeBtn_Move(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : 0, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : 0, i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : 0, a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : 0, r = (arguments.length > 6 && void 0 !== arguments[6] && arguments[6], 
arguments.length > 7 && void 0 !== arguments[7] ? arguments[7] : 0), s = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : 0, l = arguments.length > 9 && void 0 !== arguments[9] && arguments[9], c = arguments.length > 10 && void 0 !== arguments[10] ? arguments[10] : {
x: 0,
y: 0
}, d = arguments.length > 11 && void 0 !== arguments[11] ? arguments[11] : null, h = arguments.length > 12 && void 0 !== arguments[12] ? arguments[12] : null, u = arguments.length > 13 && void 0 !== arguments[13] ? arguments[13] : null;
if (e) {
recordOriginalState(e), e._canTouch = !1, e._isTouching = !1, a < 100 && (a = 100), 
e.off("click");
var f = function() {
e.on("click", function() {
e._canTouch && doCallback$1(t);
});
};
e.backToOriginalState(), e.enableMistake = function() {
e._isTouching || (e._canTouch = !1, e._isTouching = !0, checkFunc(d) ? doCallback$1(d, {
out: n === BtnClickMistakeType.Show,
min: !0
}) : adv_interface.showBannerAd(0, {
out: n === BtnClickMistakeType.Show,
min: !0
}, ""), autoMove(e, function(t) {
if ("hold_finished_1" === t) {
if (n === BtnClickMistakeType.Show || n === BtnClickMistakeType.Move) {
var o = e.convertToWorldSpaceAR(new cc.v2(e.width / 2 - e.width * e.anchorX, e.height / 2 - e.height * e.anchorY));
checkFunc(u) ? doCallback$1(u, o) : adv_interface.moveBannerAdTo(o);
}
} else "move_finished" === t && (e._isTouching = !1, e._canTouch = !0, f(), 0 === c.y && (checkFunc(h) ? doCallback$1(h) : adv_interface.hideBannerAd()));
}, i, a, r, s, l, c));
}, e.disableMistake = function() {
f();
var t = e.getComponent(cc.Widget);
t && (e.backToOriginalState(), t.bottom -= c.y), delayShow(e, o || 0);
};
}
}

function createCrazyClickBtn(e, t, n, o, i) {
var a = arguments.length > 5 && void 0 !== arguments[5] ? arguments[5] : null, r = (arguments.length > 6 && void 0 !== arguments[6] && arguments[6], 
arguments.length > 7 && void 0 !== arguments[7] ? arguments[7] : null), s = arguments.length > 8 && void 0 !== arguments[8] ? arguments[8] : null, l = arguments.length > 9 && void 0 !== arguments[9] ? arguments[9] : null, c = arguments.length > 10 && void 0 !== arguments[10] ? arguments[10] : null, d = arguments.length > 11 ? arguments[11] : void 0, h = arguments.length > 12 ? arguments[12] : void 0, u = arguments.length > 13 ? arguments[13] : void 0, f = arguments.length > 14 ? arguments[14] : void 0;
if (e) {
var _ = [ i.target ];
if ("number" != typeof i.target) {
_ = i.target.split("|");
for (var p = 0; p < _.length; p++) _[p] = parseFloat(_[p]);
}
var g = [ i.invokeType ];
if (null != i.invokeType && "number" != typeof i.invokeType) {
g = i.invokeType.split("|");
for (var v = 0; v < g.length; v++) g[v] = parseInt(g[v]);
}
var m = 0, A = 0, y = function() {
return "number" == typeof i.mistakeSuccTimes && m >= i.mistakeSuccTimes || void 0 === i.mistakeSuccTimes && m > 0;
}, S = function() {
return 0 === i.videoTarget || A > 0;
};
"number" != typeof i.maxMistakeTimes && (i.maxMistakeTimes = 0);
var I = function() {
checkString(e._scheduleKey) && (Scheduler.unschedule(e._scheduleKey), e._scheduleKey = "");
};
e._curProgress = h ? 1 : 0, Scheduler.unschedule(e._scheduleKey), e._scheduleKey = "", 
e._isMistakeEnabled = !1, e.enableMistake = function() {
e._isMistakeEnabled = !0;
}, e.disableMistake = function() {
e._isMistakeEnabled = !1;
}, e._invokeMistakeTimes = 0, e._clickedTimes = 0, e._needClickTimes = 0;
var C = function() {
e._clickedTimes = 0, e._needClickTimes = random(i.miniClick, i.maxClick);
};
C(), doCallback$1(t, e._curProgress), I(), e._scheduleKey = generateString(32), 
Scheduler.schedule(e._scheduleKey, function() {
if (void 0 !== h ? e._curProgress < 1 : e._curProgress > 0) {
var n = random(100 * i.miniMinus, 100 * i.maxMinus);
h ? (e._curProgress += n / 100, e._curProgress > 1 && (e._curProgress = 1)) : (e._curProgress -= n / 100, 
e._curProgress < 0 && (e._curProgress = 0));
}
doCallback$1(t, e._curProgress);
}, !1, i.gap);
var b = function() {
m += 1;
}, w = function() {
y() && (i.mistakeStyle == CrazyClickBannerMistakeType.Show && adv_interface.hideBannerAd(), 
S() && P());
};
Event.addEventListerner(EventName.EN_APP_ONHIDE, b), Event.addEventListerner(EventName.EN_APP_ONSHOW, w), 
isLoadQQConfig() || -1 === g.indexOf(CrazyClickInvokeType.Banner) || (checkFunc(a) ? doCallback$1(a, {
out: i.mistakeStyle !== CrazyClickBannerMistakeType.Move,
min: !0
}) : adv_interface.showBannerAd(0, {
out: i.mistakeStyle !== CrazyClickBannerMistakeType.Move,
min: !0
})), e._isRewarded = !1;
var P = function() {
e._isRewarded || (e._isRewarded = !0, Event.removeEventListerner(EventName.EN_APP_ONHIDE, b), 
Event.removeEventListerner(EventName.EN_APP_ONSHOW, w), e._curProgress = h ? 0 : 1, 
I(), Scheduler.unschedule("Delay_Normal_CrazyClick_Mistake_State"), doCallback$1(t, e._curProgress), 
doCallback$1(o));
};
e._isMistakeInvoked = !1;
var k = function() {
if (!e._isMistakeInvoked) {
e._isMistakeInvoked = !0;
var t = g[g.length - 1];
e._invokeMistakeTimes < g.length && (t = g[e._invokeMistakeTimes]), e._invokeMistakeTimes += 1;
var n = g[g.length - 1];
e._invokeMistakeTimes < g.length && (n = g[e._invokeMistakeTimes]), t === CrazyClickInvokeType.Banner ? isLoadQQConfig() || isLoadTTConfig() || i.mistakeStyle == CrazyClickBannerMistakeType.None ? checkFunc(a) ? doCallback$1(a, {
min: !0
}) : adv_interface.showBannerAd(0, {
min: !0
}) : checkFunc(r) ? doCallback$1(r, e.convertToWorldSpaceAR(new cc.v2(e.width / 2 - e.width * e.anchorX, e.height / 2 - e.height * e.anchorY))) : adv_interface.moveBannerAdTo(e.convertToWorldSpaceAR(new cc.v2(e.width / 2 - e.width * e.anchorX, e.height / 2 - e.height * e.anchorY))) : t === CrazyClickInvokeType.CustomScroll ? checkFunc(l) ? doCallback$1(l, i.scrollAdUnitId, {
layout: "center",
centerPt: e.convertToWorldSpaceAR(new cc.v2(e.width / 2 - e.width * e.anchorX, e.height / 2 - e.height * e.anchorY))
}) : adv_interface.showComponentAd("scroll", "", i.scrollAdUnitId, {
layout: "center",
centerPt: e.convertToWorldSpaceAR(new cc.v2(e.width / 2 - e.width * e.anchorX, e.height / 2 - e.height * e.anchorY))
}) : t === CrazyClickInvokeType.Box ? adv_interface.showBoxAd("", null, null, null) : t === CrazyClickInvokeType.VideoBanner && (i.mistakeStyle == CrazyClickBannerMistakeType.None ? d.active = !0 : (d.active = !0, 
d.getComponent(cc.Widget).bottom = e.getComponent(cc.Widget).bottom), E()), Scheduler.unschedule(), 
Scheduler.schedule("Delay_Normal_CrazyClick_Mistake_State", function() {
t === CrazyClickInvokeType.Banner ? i.mistakeStyle !== CrazyClickBannerMistakeType.None ? adv_interface.hideBannerAd() : adv_interface.moveBannerAdBack() : t === CrazyClickInvokeType.CustomScroll && (checkFunc(c) ? doCallback$1(c, i.scrollAdUnitId) : adv_interface.hideComponentAd(i.scrollAdUnitId)), 
n === t === CrazyClickInvokeType.Banner && i.mistakeStyle === CrazyClickBannerMistakeType.Move && (checkFunc(a) ? doCallback$1(a) : adv_interface.showBannerAd(0, {}, "")), 
!y() && (0 === i.maxMistakeTimes || e._invokeMistakeTimes < i.maxMistakeTimes) && (e._isMistakeInvoked = !1, 
C());
}, !1, i.duration, 1);
}
}, T = function() {
if (h ? (e._curProgress -= i.add, e._curProgress <= 0 ? P() : doCallback$1(t, e._curProgress)) : (e._curProgress += i.add, 
e._curProgress >= 1 ? P() : doCallback$1(t, e._curProgress)), e._isMistakeEnabled) {
var n = _[_.length - 1];
e._invokeMistakeTimes < _.length && (n = _[e._invokeMistakeTimes]), 0 === A && i.videoTarget > 0 && (void 0 !== h ? e._curProgress < i.videoTarget : e._curProgress > i.videoTarget) && (A = 1, 
checkFunc(s) ? doCallback$1(s, function() {
O();
}) : (PlatAdOnShowFlow.video = "", adv_interface.showRewardedVideoAd("", !1, function() {
O();
}, function() {
O();
}))), (void 0 !== h ? e._curProgress <= n : e._curProgress >= n) && (e._clickedTimes += 1, 
0 !== e._needClickTimes && e._clickedTimes !== e._needClickTimes || k());
}
}, E = function() {
Scheduler.unschedule("Delay_Hide_Video_Btn"), Scheduler.schedule("Delay_Hide_Video_Btn", function() {
d.active = !1;
}, !1, i.videoBannerTime, 1);
}, O = function() {
b(), y() && S() && P();
};
e.off("click"), e.on("click", function() {
T(), h && !e._isRewarded && (clone_Fx = cc.instantiate(u), clone_Fx.active = !0, 
h.addChild(clone_Fx), cc.tween(clone_Fx).by(.5, {
position: cc.v2(285, 0)
}).call(function() {
null != f && f.play("role02");
}).removeSelf().start()), doCallback$1(n);
}), d && (d.off("click"), d.on("click", function() {
isTouch = !0, A = 1, adv_interface.showRewardedVideoAd("", !1, function() {
d.active = !1, O();
}, function() {
d.active = !1, O();
});
}));
}
}

function doCustomPromise(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = -1, o = function() {
if (Array.isArray(e) && e.length > 0) for (var t = 0; t < e.length; t++) if (e[t].times > 0) return !1;
return !0;
};
o() ? doCallback$1(t) : function t(i) {
++n === e.length && (n = 0);
var a = e[n];
a.times > 0 ? (a.times--, Promise.all([ a.getPromiseFunc() ]).then(function() {
o() ? doCallback$1(i) : t(i);
})) : o() ? doCallback$1(i) : t(i);
}(t);
}

function convertToOpenGLPt(e) {
var t = null;
if (t = isCocosEngine() ? cc.v2(0, 0) : new Laya.Point(0, 0), void 0 === e.x || null === e.x || void 0 === e.y || null === e.y) return t;
var n = PlatHelper.getSysInfo();
return t.x = e.x / getSceneSize().width * n.screenWidth, isCocosEngine() ? t.y = (1 - e.y / getSceneSize().height) * n.screenHeight : t.y = e.y / getSceneSize().height * n.screenHeight, 
t;
}

function convertToOpenGLSize(e) {
var t = null;
if (t = isCocosEngine() ? cc.size(0, 0) : new Laya.Size(0, 0), void 0 === e.width || null === e.width || void 0 === e.height || null === e.height) return t;
var n = PlatHelper.getSysInfo();
return void 0 !== t._width ? (t._width = e.width / getSceneSize().width * n.screenWidth, 
t._height = e.height / getSceneSize().height * n.screenHeight) : (t.width = e.width / getSceneSize().width * n.screenWidth, 
t.height = e.height / getSceneSize().height * n.screenHeight), t;
}

function h_ShowAdvs(e, t) {
Array.isArray(t) ? console.warn("广告曝光 路劲：" + e + "，数量：" + t.length, t) : console.warn("广告曝光 路劲：" + e + "，数量：1", t);
}

function h_ShowView(e) {
console.warn("流程曝光 路劲：" + e);
}

function h_ShowPage(e) {
console.warn("页面曝光 路劲：" + e);
}

function h_ShowComponent(e) {
console.warn("组件曝光 路劲：" + e);
}

function h_ReportFlowAdv(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "";
t === FlowAdvActionType.Show ? console.warn("流量主广告曝光 类型：" + e + ("" !== n ? " 流程：" + n : "")) : t === FlowAdvActionType.LoadSucc ? console.warn("流量主广告加载成功 类型：" + e + ("" !== n ? " 流程：" + n : "")) : t === FlowAdvActionType.LoadFail && console.warn("流量主广告加载失败 类型：" + e + ("" !== n ? " 流程：" + n : ""));
}

var C_SK_FORMAT_OF_NAVAGATED_APPIDS = "navagated_appids_of_player_{0}", _loadNavigatedAppIds = function() {
var e = PlatHelper.getStorage(formatString(C_SK_FORMAT_OF_NAVAGATED_APPIDS, HLSDKLocalData$1._openID));
if (e && "" !== e) {
var t = JSON.parse(e);
if (void 0 !== t.ids && ServerInfo.getCurServerDayOfYear() === t.saveDay && void 0 !== t.ids) return t.ids;
}
return [];
}, _saveNavigatedAppIds = function(e) {
if (Array.isArray(e) && e.length > 0) {
var t = {
ids: e,
saveDay: ServerInfo.getCurServerDayOfYear()
};
PlatHelper.setStorage(formatString(C_SK_FORMAT_OF_NAVAGATED_APPIDS, HLSDKLocalData$1._openID), JSON.stringify(t));
}
}, cls$t = cc.Class({
extends: cc.Component,
properties: {
advKey: {
default: "",
tooltip: "广告的Key值，影响数据来源"
},
delayToLoad: {
default: 0,
tooltip: "延迟加载的毫秒数"
},
advCount: {
default: 0,
tooltip: "广告单元数量"
},
nameCfg: {
default: "",
tooltip: "游戏名称的配置，格式为：字体大小||与图片的间隔||文字颜色代码不要#号"
},
framePath: {
default: "",
tooltip: "外框图片地址"
},
framePathCount: {
default: 1,
tooltip: "外框图片资源数量"
},
isHorizontal: {
default: !1,
tooltip: "是否水平滚动"
},
cellSize: {
default: cc.size(),
tooltip: "滚动单元的大小"
},
imgSize: {
default: cc.size(),
tooltip: "滚动单元中图片的大小"
},
nameNeedPos: {
default: !1,
tooltip: "游戏名称的位置是否需要特殊定位"
},
namePos: {
default: cc.v2(0, 0),
tooltip: "游戏名称位置(相对于单元的左上角)"
},
iconNeedPos: {
default: !1,
tooltip: "游戏Icon的位置是否需要特殊定位"
},
iconPos: {
default: cc.v2(0, 0),
tooltip: "游戏Icon位置(相对于单元的左上角)"
},
isTween: {
default: !1,
tooltip: "是否开启滚动，开启后自动滚动展示所有的广告"
},
tweenSpeed: {
default: 1e3,
tooltip: "滚动速度，滚动一格消耗的时间（毫秒），速度越大越慢"
}
},
ctor: function() {
this._advList = null, this._originalAdvInfos = null, this._advInfos = null, this._onShowAdvImgs = [], 
this._getAdvInfosCb = null, this._getAdvInfosFunc = null, this._advPath = "";
},
onLoad: function() {
var e = this;
this._initUI();
var t = function(t) {
if (t && (e._originalAdvInfos = t, e._refreshAdv(), e.isTween && Scheduler.schedule("Auto_Start_Tween_Show_Of_Ad_" + e.advKey, function() {
e._autoTweenList();
}, !1, 500, 1), e._getAdvInfosCb)) {
var n = e._getAdvInfosCb;
e._getAdvInfosCb = null, n(e._advInfos);
}
};
Scheduler.schedule("Delay_To_Load_Ad", function() {
if (e._getAdvInfosFunc) t(e._getAdvInfosFunc()); else {
var n = "ee2a98b3ba79d62950534db9641ee913";
HttpsHelper.getJson("https://image.game.hnquyou.com/upload/opId10.txt", null, null, function(e, o) {
e && o && o.ret && o[n] && t(o[n]);
});
}
}, !1, 20 + this.delayToLoad, 0);
},
_initUI: function() {
var e = this, t = seekNodeByName(this.node, "list");
if (t) {
this._advList = t;
var n = t.addComponent(cls$u);
n.registerTouchCallback(function(t) {
e.isTween && ("began" === t ? Scheduler.unschedule("Next_Tween_of_Ad_" + e.advKey) : "ended" === t && (Scheduler.unschedule("Next_Tween_of_Ad_" + e.advKey), 
Scheduler.schedule("Next_Tween_of_Ad_" + e.advKey, function() {
e._autoTweenList();
}, !1, 2e3, 1)));
}), n.registerSelectCallback(function(e, t) {
e && this._toMiniProgram(e, function(n) {
var o = this._getNextAdvInfo(e.adv_id);
null !== o && (this._removeOnShowAdvImg(e.logo_url), this._addOnShowAdvImg(o.logo_url), 
PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowAdvs ? PlatHelper.getPlat().h_ShowAdvs(this._advPath, o) : h_ShowAdvs(this._advPath, o)), 
"function" == typeof t && t(o), n || Event.dispatchEvent(EventName.EN_CANCEL_NAVIGATION_FROM_AD, this.advKey);
}.bind(this));
}.bind(this));
}
},
refreshAdv: function() {
var e = this;
this._advList && this._advList.getComponent(cls$v) && (this.isHorizontal ? this._advList.getComponent(cls$v).scrollToLeft() : this._advList.getComponent(cls$v).scrollToTop()), 
console.log("refresh adv: ", this.advKey), this.isTween && Scheduler.schedule("Auto_Start_Tween_Show_Of_Ad_" + this.advKey, function() {
e._autoTweenList();
}, !1, 500, 1), this._refreshAdv();
},
hideAdv: function() {
console.log("hide adv: ", this.advKey), Scheduler.unschedule("Auto_Start_Tween_Show_Of_Ad_" + this.advKey), 
Scheduler.unschedule("Check_Until_All_Advs_Exposed_" + this.advKey), Scheduler.unschedule("Next_Tween_of_Ad_" + this.advKey);
},
onDestroy: function() {
this.hideAdv();
},
randomNavigate: function(e) {
var t = this, n = function() {
console.warn("Auto Random Navigate...");
var n = random(0, t._advInfos.length - 1), o = t._advInfos[n];
t._toMiniProgram(o, function(t) {
"function" == typeof e && e(!0, t);
});
};
this._advInfos ? n() : this.getAdvInfos(n);
},
navagate: function(e, t) {
this._toMiniProgram(e, function(e) {
"function" == typeof t && t(e);
});
},
getAdvInfos: function(e) {
"function" == typeof e && (this._advInfos ? e(this._advInfos) : this._getAdvInfosCb = e);
},
getAllExposedAdvInfos: function() {
var e = this._advList.getComponent(cls$u);
return e ? e.getAllExposedAdvInfos() : [];
},
setAdvPath: function(e) {
this._advPath = e;
},
registerGetAdvInfosFunc: function(e) {
checkFunc(e) && (this._getAdvInfosFunc = e);
},
_refreshAdv: function() {
var e = this;
if (this._originalAdvInfos && (this._onShowAdvImgs = [], this._advInfos = this._convertToLocalAdvInfos(this._originalAdvInfos), 
Array.isArray(this._advInfos))) {
var t = this._advList.getComponent(cls$u);
if (t) {
for (var n = [], o = 0; o < this._advInfos.length && !(this.advCount > 0 && o >= this.advCount); o++) this._addOnShowAdvImg(this._advInfos[o].logo_url), 
n.push(this._advInfos[o]);
if (n.advCount = this.advCount, t.setList(this.isHorizontal, {
width: this.cellSize.width,
height: this.cellSize.height
}, {
imgWidth: this.imgSize.width,
imgHeight: this.imgSize.height,
nameCfg: this.nameCfg,
framePath: this.framePath,
framePathCount: this.framePathCount,
nameNeedPos: this.nameNeedPos,
namePos: this.namePos,
iconNeedPos: this.iconNeedPos,
iconPos: this.iconPos
}, n), this.isTween) {
if (Scheduler.unschedule("Check_Until_All_Advs_Exposed_" + this.advKey), n.length > 0) {
for (var i = [], a = 0; a < n.length; a++) i.push(!1);
var r = function() {
if (null != t.node) {
var o = t.getAllExposedAdvInfos();
if (o.length > 0) {
for (var a = [], r = 0; r < o.length; r++) {
var s = o[r];
i[s.index - 1] || (i[s.index - 1] = !0, a.push(s.info));
}
if (a.length > 0) {
PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowAdvs ? PlatHelper.getPlat().h_ShowAdvs(e._advPath, a) : h_ShowAdvs(e._advPath, a);
var l = 0;
i.forEach(function(e) {
e && l++;
}), l === n.length && Scheduler.unschedule("Check_Until_All_Advs_Exposed_" + e.advKey);
}
}
}
};
Scheduler.schedule("Check_Until_All_Advs_Exposed_" + this.advKey, function() {
r();
}, !1, 200), Scheduler.schedule("First_Check_Exposed_Advs_" + this.advKey, function() {
r();
}, !1, 10, 0);
}
} else PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowAdvs ? PlatHelper.getPlat().h_ShowAdvs(this._advPath, n) : h_ShowAdvs(this._advPath, n);
}
}
},
fixRect: function(e) {
for (var t = 0, n = 0, o = e._cellRects, i = 0; i < o.length; i++) t = Math.max(t, o[i].x + o[i].width), 
n = Math.max(n, o[i].y + o[i].height);
var a = e._view.getContentSize();
this.isHorizontal ? e.content.setContentSize(new cc.size(t, a.height)) : e.content.setContentSize(new cc.size(a.width, n));
},
_autoTweenList: function() {
if (this.isTween && this._advList && this._advList.getComponent(cls$v)) {
var e = this._advList.getComponent(cls$v);
this.fixRect(e);
var t = 0, n = 0;
this.isHorizontal ? (t = Math.abs(e.getScrollOffset().x), n = Math.abs(e.getMaxScrollOffset().x)) : (t = Math.abs(e.getScrollOffset().y), 
n = Math.abs(e.getMaxScrollOffset().y));
var o = 0;
Math.abs(n - t) < (this.isHorizontal ? this.cellSize.width / 2 : this.cellSize.height / 2) ? (o = t / this.cellSize.width * this.tweenSpeed, 
this.isHorizontal ? e.scrollToLeft(o / 1e3, !1) : e.scrollToTop(o / 1e3, !1)) : (o = (n - t) / this.cellSize.width * this.tweenSpeed, 
this.isHorizontal ? e.scrollToRight(o / 1e3, !1) : e.scrollToBottom(o / 1e3, !1));
}
},
_addOnShowAdvImg: function(e) {
-1 === this._onShowAdvImgs.indexOf(e) && this._onShowAdvImgs.push(e);
},
_removeOnShowAdvImg: function(e) {
var t = this._onShowAdvImgs.indexOf(e);
-1 !== t && this._onShowAdvImgs.splice(t, 1);
},
_convertToLocalAdvInfos: function(e) {
var t = [], n = [];
if (Array.isArray(e)) for (var o = 0; o < e.length; o++) {
var i = e[o];
if (Array.isArray(i.logo_attr)) for (var a = random(0, i.logo_attr.length - 1), r = 0; r < i.logo_attr.length; r++) {
var s = cloneDeep(i), l = i.logo_attr[r];
s.logo_url = l && "object" == typeof l ? cloneDeep(l) : l, r === a ? t.push(s) : n.push(s);
} else if ("string" == typeof i.logo_url) t.push(i); else if (Array.isArray(i.logo_url)) for (var c = random(0, i.logo_url.length - 1), d = 0; d < i.logo_url.length; d++) {
var h = cloneDeep(i), u = i.logo_url[d];
h.logo_url = u && "object" == typeof u ? cloneDeep(u) : u, d === c ? t.push(h) : n.push(h);
}
}
return shuffleArray(t), n.length > 0 && (shuffleArray(n), t = t.concat(n)), t;
},
_toMiniProgram: function(e, t) {
if (PlatHelper.getPlat()) {
if (e) {
Reportor$1.report(ReportEventName.REN_NAVIGATION_TO_MINIPROGRAM);
var n = this._getWillNavagatedAdvInfo(e), o = {
adv_id: n.adv_id,
origin_path: n.logo_url.origin_path,
appId: n.appid,
pkgName: n.appid,
path: n.path,
success: function() {
if (PlatHelper.isWXPlatform()) {
var e = _loadNavigatedAppIds();
e.push(o.appId), _saveNavigatedAppIds(e);
}
Reportor$1.report(ReportEventName.REN_NAVIGATION_TO_MINIPROGRAM_SUCCESS), "function" == typeof t && t(!0);
},
fail: function(e) {
e && -1 !== e.errMsg.indexOf("fail cancel") ? Reportor$1.report(ReportEventName.REN_NAVIGATION_TO_MINIPROGRAM_CANCEL) : Reportor$1.report(ReportEventName.REN_NAVIGATION_TO_MINIPROGRAM_ERROR), 
"function" == typeof t && t(!1);
}
};
PlatHelper.isTTPlatform() ? PlatHelper.showMoreGamesModal() : PlatHelper.getPlat() && PlatHelper.getPlat().h_ToMinProgram && PlatHelper.getPlat().h_ToMinProgram(this._advPath, o);
}
} else "function" == typeof t && t(!1);
},
_getWillNavagatedAdvInfo: function(e) {
if (!PlatHelper.isWXPlatform() || !isGlobalMistakeEnabled()) return e;
for (var t = !1, n = _loadNavigatedAppIds(), o = 0; o < n.length; o++) if (n[o] === e.appid) {
t = !0;
break;
}
if (t) {
for (var i = [], a = 0; a < this._advInfos.length; a++) i.push(this._advInfos[a].appid);
i = uniq(i);
var r = xorBy(i, n);
if (r && r.length > 0) for (var s = r[random(0, r.length - 1)], l = 0; l < this._advInfos.length; l++) if (this._advInfos[l].appid === s) return this._advInfos[l];
return e;
}
return e;
},
_getNextAdvInfo: function() {
if (this._advInfos && this._advInfos.length > this.advCount) {
for (var e = [], t = 0; t < this._advInfos.length; t++) {
var n = this._advInfos[t].logo_url;
-1 === this._onShowAdvImgs.indexOf(n) && e.push(this._advInfos[t]);
}
if (e.length > 0) return e[random(0, e.length - 1)];
console.error(this._onShowAdvImgs), console.error(this._advInfos);
}
return null;
}
}), cls$s = cc.Class({
extends: cls$y,
ctor: function() {
this._uiParams = null, this._advLoadMgrs = [];
},
onHide: function() {
for (var e = 0; e < this._advLoadMgrs.length; e++) this._advLoadMgrs[e].hideAdv();
},
_onInit: function(e) {
this._uiParams = null, e ? (this._uiParams = convertWebParams(e), this._super(this._uiParams)) : this._super();
},
bindName: function(e, t) {
var n = this, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : [];
checkString(t.name) && -1 !== o.indexOf(t.name) && (e[t.name] = t), (t.children ? t.children : t._children).forEach(function(t) {
n.bindName(e, t, o);
});
},
refreshAdv: function() {
for (var e = arguments.length > 0 && void 0 !== arguments[0] && arguments[0], t = e ? this._advLoadMgrs.length : 1, n = 0; n < t; n++) this._advLoadMgrs[n].refreshAdv();
},
setAdvPath: function(e) {
for (var t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], n = !(arguments.length > 2 && void 0 !== arguments[2]) || arguments[2], o = t ? this._advLoadMgrs.length : 1, i = 0; i < o; i++) this._advLoadMgrs[i].setAdvPath(e), 
n && this._advLoadMgrs[i].refreshAdv();
},
randomNavigate: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
this._advLoadMgrs.length > 0 && this._advLoadMgrs[0].randomNavigate(e);
},
addAdvLoadMgr: function() {
for (var e = this, t = null, n = null, o = 0; o < arguments.length; o++) null != (t = arguments[o]) && null !== (n = t.getComponent(cls$t)) && (this._advLoadMgrs.push(n), 
n.registerGetAdvInfosFunc(function() {
return e._getAdvInfos();
}));
},
_getAdvInfos: function() {
return HLSDKLocalData$1._advInfos;
},
_showBannerAd: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, t = 0;
"number" == typeof this._uiParams.bannerIndex && this._uiParams.bannerIndex > 0 && (t = this._uiParams.bannerIndex), 
adv_interface.showBannerAd(t, e, this._getAdvPagePath());
},
_hideBannerAd: function() {
adv_interface.hideBannerAd();
},
_moveBannerAdTo: function(e) {
adv_interface.moveBannerAdTo(e);
},
_showRewardedVideoAd: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
adv_interface.showRewardedVideoAd(this._getAdvPagePath(), !1, function() {
doCallback$1(e, !0);
}, function() {
doCallback$1(e, !1);
});
},
_showInterstitialAd: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
adv_interface.showInterstitialAd(this._getAdvPagePath(), function() {
doCallback$1(e);
}, function() {
doCallback$1(e);
});
},
_preloadScrollAd: function(e, t) {
adv_interface.isComponentAdPreloaded(e) ? this._hideScrollAd(e) : (this._showScrollAd(e, t), 
this._hideScrollAd(e));
},
_showScrollAd: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
adv_interface.showComponentAd("scroll", this._getAdvPagePath(), e, t, 0, 5, "landscape", !0, null, n);
},
_hideScrollAd: function(e) {
adv_interface.hideComponentAd(e);
},
_showMoreGameAd: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
isLoadWXConfig() ? adv_interface.showPopupCustomAd(e.matrixAdUnitId, parseInt(e.matrixAdRow), this._getAdvPagePath(), null, function() {
console.log("hideUI.MaskBB"), doCallback$1(n);
}, function() {
doCallback$1(t);
}) : isLoadQQConfig() && adv_interface.showBoxAd(this._getAdvPagePath(), null, null, function() {
doCallback$1(t);
});
},
_showPortalAd: function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
isLoadOPPOConfig() && adv_interface.showPortalAd(e.portalAdUnitId, this._getAdvPagePath(), function() {
console.error("Portal....succ....");
}, null, function() {
doCallback$1(t);
});
},
_getAdvPagePath: function() {
return checkString(this._uiParams.advPath) ? this._uiParams.advPath.indexOf("/") === this._uiParams.advPath.lastIndexOf("/") ? this._uiParams.advPath : this._uiParams.advPath.substring(0, this._uiParams.advPath.lastIndexOf("/")) : "";
}
}), cls$r = cc.Class({
extends: cc.Component,
properties: {
miniScale: {
default: 1,
tooltip: "最小缩放比",
type: cc.Float
},
maxScale: {
default: 1.1,
tooltip: "最大缩放比",
type: cc.Float
},
duration: {
default: .8,
tooltip: "缩放耗时（秒)",
type: cc.Float
},
_action: null
},
onEnable: function() {
this._doScale();
},
onDisable: function() {
this._clearTween();
},
setTweenEnable: function(e) {
this._clearTween(), this.node.scaleX = this.miniScale, this.node.scaleY = this.miniScale, 
e && this._doScale();
},
_doScale: function() {
var e = this, t = null;
(t = function() {
e.node.scaleX < e.maxScale ? e._scaleToMax(t) : e._scaleToMini(t);
})();
},
_scaleToMini: function(e) {
var t = this;
if (this._clearTween(), this.node && this.node.scaleX > this.miniScale) {
var n = (this.node.scaleX - this.miniScale) / (this.maxScale - this.miniScale) * this.duration;
this._action = this.node.runAction(cc.sequence(cc.scaleTo(n, this.miniScale), cc.callFunc(function() {
t._action = null, "function" == typeof e && e();
})));
} else "function" == typeof e && e();
},
_scaleToMax: function(e) {
var t = this;
if (this._clearTween(), this.node && this.node.scaleX < this.maxScale) {
var n = (this.maxScale - this.node.scaleX) / (this.maxScale - this.miniScale) * this.duration;
this._action = this.node.runAction(cc.sequence(cc.scaleTo(n, this.maxScale), cc.callFunc(function() {
t._action = null, "function" == typeof e && e();
})));
} else "function" == typeof e && e();
},
_clearTween: function() {
this.node && null !== this._action && (this.node.stopAction(this._action), this._action = null);
}
}), MoreGameInvokeType = {
None: 0,
MoreGame: 1,
MoreGameAd: 2
}, cls$q = cc.Class({
extends: cls$s,
ctor: function() {},
onInitUI: function() {
this.bindName(this, this.node, [ "leftEntranceBtn", "rightEntranceBtn", "middleEntranceBtn" ]), 
this.leftEntranceBtn && this.leftEntranceBtn.on("click", this.onEntranceTouched, this), 
this.rightEntranceBtn && this.rightEntranceBtn.on("click", this.onEntranceTouched, this), 
this.middleEntranceBtn && this.middleEntranceBtn.on("click", this.onEntranceTouched, this);
},
onInit: function(e) {
var t = this, n = function(n, o) {
if (n) {
n.active = o;
var i = seekNodeByName(n, "dot");
i && (i.active = 1 === e.hot), n.getComponent(cls$r).setTweenEnable(1 === e.autoScale), 
"middleEntranceBtn" != n.name && e.fromTopPercent >= 0 && (n.getComponent(cc.Widget).top = e.fromTopPercent / 100 * (t.node && t.node.parent ? t.node.parent.height : cc.winSize.height)), 
"leftEntranceBtn" == n.name && e.fromLeftPercent >= 0 && (n.getComponent(cc.Widget).left = e.fromLeftPercent / 100 * (t.node && t.node.parent ? t.node.parent.width : cc.winSize.width)), 
"rightEntranceBtn" == n.name && e.fromRightPercent >= 0 && (n.getComponent(cc.Widget).right = e.fromRightPercent / 100 * (t.node && t.node.parent ? t.node.parent.width : cc.winSize.width)), 
"middleEntranceBtn" == n.name && ((e.centerX >= 0 || e.centerX < 0) && (n.x = e.centerX), 
(e.centerY >= 0 || e.centerY < 0) && (n.y = e.centerY));
}
};
this.leftEntranceBtn && n(this.leftEntranceBtn, 1 === e.left), this.rightEntranceBtn && n(this.rightEntranceBtn, 1 === e.right), 
this.middleEntranceBtn && n(this.middleEntranceBtn, 1 === e.middle);
},
onEntranceTouched: function() {
isLoadWXConfig() ? this._uiParams.type === MoreGameInvokeType.MoreGameAd && checkString(this._uiParams.matrixAdUnitId) ? (UIManager.showUI(UIKeys.Mask), 
this._showMoreGameAd({
matrixAdUnitId: this._uiParams.matrixAdUnitId,
matrixAdRow: this._uiParams.matrixAdRow
}, function() {
UIManager.hideUI(UIKeys.Mask);
}, function() {
UIManager.hideUI(UIKeys.Mask);
})) : UIManager.showUI(UIKeys.MoreGame, DEFAULT_BUNDLE_TEMPLATE, null, this._uiParams).catch(function() {}) : isLoadQQConfig() ? this._showMoreGameAd() : isLoadOPPOConfig() ? this._showPortalAd({
portalAdUnitId: this._uiParams.portalAdUnitId
}, function() {
console.error("moreGameEntrance....showPortalAd....fail");
}) : console.error("not support platfrom...");
}
}), C_MistakeType = {
None: 0,
Banner: 1,
Video: 2,
Custom: 3,
videoBanner: 4
}, C_InvokeType = {
None: 0,
AutoRandom: 1,
Video: 2,
Custom: 3
}, cls$p = cc.Class({
extends: cls$s,
ctor: function() {
this._pageKey = "", this._isAutoOpen = !1;
},
onInit: function(e) {
var t = this;
if ("number" == typeof e.autoClose && e.autoClose > 0 && this.autoClosePage(e.autoClose), 
"number" == typeof e.autoOpen && e.autoOpen > 0 && (this._isAutoOpen = !0), e.isMistakeEnabled && e.autoNav && (e.autoNav > 1 ? doCustomPromise([ {
getPromiseFunc: function() {
return Promise.resolve();
},
times: 0
}, {
getPromiseFunc: function() {
return new Promise(function(e) {
t.randomNavigate(function() {
e();
});
});
},
times: e.autoNav
} ]) : this.randomNavigate()), e.isMistakeEnabled && (e.autoVideo && e.autoInsert ? (this._showInterstitialAd(), 
Scheduler.schedule("Delay_Open_RewardedVideoAd_While_Show_InsertAd_In_Page", function() {
t._showRewardedVideoAd();
}, !1, 1500, 0)) : e.autoVideo ? this._showRewardedVideoAd() : e.autoInsert && this._showInterstitialAd()), 
e.isMistakeEnabled && isLoadWXConfig() && e.isBannerAutoRefresh) {
this._uiParams.isBannerAutoRefresh && isLoadLandscapeConfig$1() && (HLSDKLocalData$1._isNativeland = !0);
var n = 0;
this.showBanner(), Scheduler.schedule("Auto_Refresh_Banner_In_Page", function() {
e.eachBannerShowTimes > 1 ? adv_interface.isBannerOnShow() ? (console.log("hide old banner"), 
adv_interface.tempHideBanner()) : (n += 1) > 1 && n <= e.eachBannerShowTimes ? (console.log("show old banner"), 
adv_interface.tempShowBanner()) : (n = 1, console.log("show new banner"), t._hideBannerAd(), 
Scheduler.schedule("Show_New_Banner", function() {
t.showBanner();
}, !1, e.bannerAutoRefreshGap, 1)) : (t._hideBannerAd(), Scheduler.schedule("Show_New_Banner", function() {
t.showBanner();
}, !1, e.bannerAutoRefreshGap, 1));
}, !1, 2 * e.bannerAutoRefreshGap);
}
this._isAutoOpen && (this._uiParams.isAutoOpen || this.hidePage());
},
showBanner: function() {
this._showBannerAd({
min: !0
});
},
hidePage: function() {
var e = this;
if (this.cancelAutoClosePage(), this._uiParams.isBannerAutoRefresh && (Scheduler.unschedule("Auto_Refresh_Banner_In_Page"), 
Scheduler.unschedule("Show_New_Banner")), this._isAutoOpen) {
var t = this._uiParams.autoOpen;
this._uiParams.isAutoOpen && (this._uiParams.isAutoOpen = null, t = Math.random() * Math.max(0, t - 2e4) + 2e4), 
Scheduler.unschedule(this._getAutoOpenScheduleKey()), Scheduler.schedule(this._getAutoOpenScheduleKey(), function() {
e._uiParams.isAutoOpen = !0, UIManager.showUI(e._pageKey, null, e._uiParams);
}, !1, t, 1);
}
checkString(this._pageKey) ? UIManager.hideUI(this._pageKey) : console.error("Page Key Not Set...");
},
autoClosePage: function(e) {
var t = this;
Scheduler.isScheduled(this._getAutoCloseScheduleKey()) || Scheduler.schedule(this._getAutoCloseScheduleKey(), function() {
t.hidePage();
}, !1, e, 1);
},
cancelAutoClosePage: function() {
Scheduler.unschedule(this._getAutoCloseScheduleKey());
},
_getAutoCloseScheduleKey: function() {
return "Auto_Close_Page_Of_" + this._pageKey;
},
_getAutoOpenScheduleKey: function() {
return "Auto_Open_Page_Of_" + this._pageKey;
},
addPlayBtntouchAction: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] && arguments[1];
e.off("click"), e.on("click", function() {
var o = t._uiParams.invokeType;
n || (o = t._uiParams.mistakeType), n && o === C_InvokeType.AutoRandom ? t.randomNavigate(function() {
t.hidePage();
}) : o === C_MistakeType.Video ? t._showRewardedVideoAd(function() {
t.hidePage();
}) : o === C_MistakeType.Custom ? (e.mouseEnabled = !1, doCustomPromise([ {
getPromiseFunc: function() {
return new Promise(function(e) {
t._showRewardedVideoAd(function() {
e();
});
});
},
times: "number" == typeof t._uiParams.customVideoCount ? t._uiParams.customVideoCount : 0
}, {
getPromiseFunc: function() {
return new Promise(function(e) {
t.randomNavigate(function() {
e();
});
});
},
times: "number" == typeof t._uiParams.customNavCount ? t._uiParams.customNavCount : 0
} ], function() {
e.mouseEnabled = !0, t.hidePage();
})) : t.hidePage();
});
}
}), cls$o = cc.Class({
extends: cc.Component,
properties: {
disableIfUninteractable: !0,
downScale: new cc.v2(.9, .9),
upScale: new cc.v2(1, 1)
},
editor: !1,
onLoad: function() {
var e = this.node.scaleX, t = this.node.scaleY;
this.downScale = new cc.v2(e - .1, t - .1), this.upScale = new cc.v2(e, t);
},
onEnable: function() {
this.node.on(cc.Node.EventType.TOUCH_START, function() {
this._checkEnable() ? this.node.setScale(this.downScale) : this.node.setScale(this.upScale);
}, this), this.node.on(cc.Node.EventType.TOUCH_END, function() {
this._checkEnable(), this.node.setScale(this.upScale);
}, this), this.node.on(cc.Node.EventType.TOUCH_CANCEL, function() {
this._checkEnable(), this.node.setScale(this.upScale);
}, this);
},
onDisable: function() {
this.node.targetOff(this);
},
_checkEnable: function() {
return !(this.disableIfUninteractable && !this.node.getComponent(cc.Button).interactable);
}
}), cls$n = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.MoreGame;
},
onInitUI: function() {
if (this.bindName(this, this.node, [ "adLoader", "closeBtn", "fakeCloseBtn" ]), 
this.closeBtn) {
var e = this.closeBtn;
e.setOriginalScale = function(t) {
var n = e.getComponent(cls$o);
n && (n.upScale = cc.v2(t, t), n.downScale = cc.v2(.9 * t, .9 * t)), e._originalScale = t, 
e.scaleX = t, e.scaleY = t;
}, e.setOriginalScale(1), e.on("click", this.onCloseTouched, this);
}
if (this.fakeCloseBtn) {
var t = this.fakeCloseBtn;
t.setOriginalScale = function(e) {
var n = t.getComponent(cls$o);
n && (n.upScale = cc.v2(e, e), n.downScale = cc.v2(.9 * e, .9 * e)), t._originalScale = e, 
t.scaleX = e, t.scaleY = e;
}, t.setOriginalScale(1), t.on("click", this.onFakeCloseTouched, this);
}
this.addAdvLoadMgr(this.adLoader);
},
onInit: function(e) {
this._super(e), e.isMistakeEnabled && e.enableMistake ? (this.closeBtn.setOriginalScale(.5), 
this.fakeCloseBtn.setOriginalScale(.5), this.fakeCloseBtn.active = !0) : (this.closeBtn.setOriginalScale(1), 
this.fakeCloseBtn.setOriginalScale(1), this.fakeCloseBtn.active = !1, e.delayShow ? delayShow(this.closeBtn, e.delayShow) : delayShow(this.closeBtn, 0)), 
this.setAdvPath(e.advPath);
},
onCloseTouched: function() {
var e = this;
this._uiParams.isMistakeEnabled && this._uiParams.enableMistake ? this._showRewardedVideoAd(function() {
e.hidePage();
}) : this.hidePage();
},
onFakeCloseTouched: function() {
this.hidePage();
}
}), cls$m = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.FakeLoading;
},
onInitUI: function() {
var e = this;
this.bindName(this, this.node, [ "startBtn", "btnAdvLoader", "listAdvLoader", "progress", "progressTips" ]), 
this.addAdvLoadMgr(this.btnAdvLoader, this.listAdvLoader), this.startBtn && this.addPlayBtntouchAction(this.startBtn, !0), 
this.listAdvLoader && (this.addAdvLoadMgr(this.listAdvLoader), this.getBundle().load(convertToScreneOrientationPrefabPath("FakeListItem"), cc.Prefab, function(t, n) {
t ? (console.error(t), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR)) : seekNodeByName(e.listAdvLoader, "list").getComponent(cls$v).extCellAtIndex(function(t, o) {
if (t) {
var i = 3 + o * t.getCellCount();
t.children.forEach(function(t) {
if (t instanceof cls$w) {
if (i += 1, !t._advFrameExt) {
var o = cc.instantiate(n);
o._rank = seekNodeByName(o, "rank"), o._tips = seekNodeByName(o, "tips"), o.anchorX = 0, 
o.anchorY = 0, o.x = 0, o.y = 0, t._advFrameExt = o, o.zIndex = 99, t.addChild(o);
}
t._advFrameExt._rank.getComponent(cc.Label).string = i.toString(), e.setRankTips(t._advFrameExt._tips, i);
}
});
}
});
}));
},
onInit: function(e) {
var t = this;
this._super(e), this.startBtn.active = !1, this.setFakeProgress(0);
var n = ServerInfo.getServerTime();
Scheduler.schedule("Fake_Loading_Progress", function() {
var o = (ServerInfo.getServerTime() - n) / e.time;
t.setFakeProgress(o), o >= 1 && (t.startBtn.active = !0, Scheduler.unschedule("Fake_Loading_Progress"));
}, 0);
for (var o = 1; o <= 3; o++) {
var i = "static_tips_" + o.toString(), a = seekNodeByName(this.node, i);
this.setRankTips(a, o);
}
this.setAdvPath(e.advPath);
},
setFakeProgress: function(e) {
e = e > 1 ? 1 : e, this.progress.getComponent(cc.ProgressBar).progress = e, this.progressTips.getComponent(cc.Label).string = "游戏资源加载中..." + Math.floor(100 * e).toString() + "%";
},
setRankTips: function(e, t) {
var n = e.getComponent(cc.Label);
if (n && e) if (t <= 20) {
var o = 8 * (20 - t), i = 8 * (20 - t + 1);
n.string = Math.round(Math.random() * (i - o) + o).toString() + "万人在玩";
} else n.string = "新游立即玩";
}
}), cls$l = cc.Class({
extends: cls$s,
ctor: function() {},
onInitUI: function() {
this.bindName(this, this.node, [ "bg", "adLoader" ]), this.addAdvLoadMgr(this.adLoader);
},
onInit: function(e) {
if (this.setAdvPath(e.advPath), this.bg && (e.withBg ? this.bg.active = !!e.withBg : this.bg.active = !1), 
this.adLoader) {
var t = this.adLoader.getComponent(cc.Widget), n = this.adLoader.height;
e.top ? (t.isAlignTop = !0, e.fromTopPercent > 0 ? t.top = e.fromTopPercent / 100 * (this.node && this.node.parent ? this.node.parent.height : cc.winSize.height) : t.top = 0, 
t.isAlignBottom = !1, t.bottom = 0) : e.bottom && (t.isAlignTop = !1, t.top = 0, 
t.isAlignBottom = !0, e.fromBottomPercent > 0 ? t.bottom = e.fromBottomPercent / 100 * (this.node && this.node.parent ? this.node.parent.height : cc.winSize.height) : t.bottom = 0), 
this.adLoader.height = n;
}
}
}), cls$k = cc.Class({
extends: cc.Component,
properties: {
gap: {
default: 3,
tooltip: "缩放耗时（秒）",
type: cc.Float
},
_action: null,
_shakeTimes: 0,
_scheduleKey: ""
},
onEnable: function() {
this._doShake();
},
onDisable: function() {
this._clearTween();
},
setTweenEnable: function(e) {
"" !== this._scheduleKey && (Scheduler.unschedule(this._scheduleKey), this._scheduleKey = ""), 
this._clearTween(), this.node.angle = 0, e && this._doShake();
},
_doShake: function() {
var e = this, t = null;
(t = function() {
if (e.node) if (e._shakeTimes > 0 && e._shakeTimes % 3 == 0) e._shakeTimes = 0, 
e._shakeToMiddle(function() {
Scheduler.schedule("auto_shake_" + generateString(32), t, !1, 1e3 * e.gap, 0);
}); else {
var n = -e.node.angle;
cc.RotateTo._reverse && (n = e.node.angle), n < 15 ? (e._shakeTimes += 1, e._shakeToRight(t)) : (e._shakeTimes += 1, 
e._shakeToLeft(t));
}
})();
},
_shakeToRight: function(e) {
var t = this;
this._clearTween();
var n = -this.node.angle;
if (cc.RotateTo._reverse && (n = this.node.angle), this.node && n < 15) {
var o = (15 - n) / 30 * .05;
this._action = this.node.runAction(cc.sequence(cc.rotateTo(o, 15), cc.callFunc(function() {
t._action = null, "function" == typeof e && e();
})));
} else "function" == typeof e && e();
},
_shakeToLeft: function(e) {
var t = this;
this._clearTween();
var n = -this.node.angle;
if (cc.RotateTo._reverse && (n = this.node.angle), this.node && n > -15) {
var o = (n + 15) / 30 * .05;
this._action = this.node.runAction(cc.sequence(cc.rotateTo(o, -15), cc.callFunc(function() {
t._action = null, "function" == typeof e && e();
})));
} else "function" == typeof e && e();
},
_shakeToMiddle: function(e) {
var t = this;
this._clearTween();
var n = -this.node.angle;
if (cc.RotateTo._reverse && (n = this.node.angle), this.node && 0 !== n) {
var o = Math.abs(n) / 30 * .05;
this._action = this.node.runAction(cc.sequence(cc.rotateTo(o, 0), cc.callFunc(function() {
t._action = null, "function" == typeof e && e();
})));
} else "function" == typeof e && e();
},
_clearTween: function() {
this.node && null !== this._action && (this.node.stopAction(this._action), this._action = null);
}
}), cls$j = cc.Class({
extends: cls$s,
ctor: function() {
this._isFirstOpen = !0, this._leftNodes = [], this._rightNodes = [];
},
onInitUI: function() {},
onInit: function(e) {
var t = this;
Scheduler.unschedule("Auto_Refresh_Of_Couplet_Ad");
var n = function(e, n, o, i) {
if (e.length > 0) {
var a = e[0], r = !1;
if (o || -1 === a.name.indexOf("_WithName") || (r = !0), o && -1 === a.name.indexOf("_WithName") && (r = !0), 
r || e.length > n) {
var s = n;
r && (s = 0);
for (var l = e.length - 1; l >= s; l--) {
var c = e[l];
c.removeSelf(), c.destroy(), e.splice(l, 1);
}
}
}
if (e.length > 0 && e.forEach(function(e) {
e.getComponent(cls$t).refreshAdv();
}), e.length < n) {
var d = "FlowItem";
o && (d = "FlowItem_WithName"), t.getBundle().load(convertToScreneOrientationPrefabPath(d), cc.Prefab, function(o, a) {
if (o) console.error(o), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR); else for (var r = e.length; r < n; r++) {
var s = cc.instantiate(a);
t.node.addChild(s), e.push(s);
}
doCallback$1(i);
});
} else doCallback$1(i);
}, o = [];
o.push(new Promise(function(o) {
n(t._leftNodes, e.leftCount, e.withName, function() {
o();
});
})), o.push(new Promise(function(o) {
n(t._rightNodes, e.rightCount, e.withName, function() {
o();
});
})), Promise.all(o).then(function() {
if (t._leftNodes.length > 0) for (var n, o = e.fromTopPercent / 100 * (t.node && t.node.parent ? t.node.parent.height : cc.winSize.height), i = 0; i < t._leftNodes.length; i++) {
var a = t._leftNodes[i];
a && (n = a.getComponent(cc.Widget), t.addAdvLoadMgr(a), a.getComponent(cls$r).setTweenEnable(1 === e.autoScale), 
a.getComponent(cls$k).setTweenEnable(1 === e.autoShake), n && (n.isAlignLeft = !0, 
n.left = 10, n.top = o + i * (a.height + 30)));
}
if (t._rightNodes.length > 0) for (var r, s = e.fromTopPercent / 100 * (t.node && t.node.parent ? t.node.parent.height : cc.winSize.height), l = 0; l < t._rightNodes.length; l++) {
var c = t._rightNodes[l];
c && (r = c.getComponent(cc.Widget), t.addAdvLoadMgr(c), c.getComponent(cls$r).setTweenEnable(1 === e.autoScale), 
c.getComponent(cls$k).setTweenEnable(1 === e.autoShake), r && (r.isAlignRight = !0, 
r.right = 10, r.top = s + l * (c.height + 30)));
}
t.setAdvPath(e.advPath, !0, !1), e.refreshGap > 0 && Scheduler.schedule("Auto_Refresh_Of_Couplet_Ad", function() {
t.refreshAdv(!0);
}, !1, e.refreshGap);
});
},
onHide: function() {
this._super(), Scheduler.unschedule("Auto_Refresh_Of_Couplet_Ad");
}
}), cls$i = cc.Class({
extends: cls$s,
ctor: function() {
this._advNode = null;
},
onInitUI: function() {},
onInit: function(e) {
var t = this;
Scheduler.unschedule("Auto_Refresh_Of_Matrix_Ad");
var n = "3x2";
e.style2x2 && (n = "2x2"), !this._advNode || this._advNode._style === n && this._advNode._advRowCount === e.advRowCount || (this._advNode.destroy(), 
this._advNode = null);
var o = function() {
if (t._advNode) {
var n = t._advNode.getComponent(cc.Widget);
n && (e.fromTopPercent > 0 ? n.top = e.fromTopPercent / 100 * (t.node && t.node.parent ? t.node.parent.height : cc.winSize.height) : n.top = 0), 
e.refreshGap > 0 && Scheduler.schedule("Auto_Refresh_Of_Matrix_Ad", function() {
t.refreshAdv();
}, !1, e.refreshGap);
}
t.setAdvPath(e.advPath);
};
this._advNode ? (this.refreshAdv(), o()) : this.getBundle().load(convertToScreneOrientationPrefabPath("MatrixItem_" + n), cc.Prefab, function(n, i) {
if (n) console.error(n), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR); else {
var a = cc.instantiate(i);
if (t.addAdvLoadMgr(a), e.advRowCount > 2) {
var r = a.getComponent(cls$t);
r && (r.advCount = r.advCount / 2 * e.advRowCount, r.inertia = !0, r.elastic = !0, 
r.isTween = !0);
var s = seekNodeByName(a, "list").getComponent(cls$v);
s && (s.inertia = !0, s.elastic = !0);
}
t._advNode = a, t.node.addChild(a), o();
}
});
},
onHide: function() {
this._super(), Scheduler.unschedule("Auto_Refresh_Of_Matrix_Ad");
}
}), _reseekAndCb = function(e, t) {
e && (PlatHelper.isWXPlatform() ? (e.currentTime > 0 && e.seek(0), doCallback$1(t, e)) : e.currentTime > 0 ? (e.onSeeked(function n() {
e.offSeeked(n), doCallback$1(t, e);
}), e.seek(0)) : doCallback$1(t, e));
}, AudioBaseHelper = function() {
function e() {
_classCallCheck2(this, e);
this._isInited = !1, this._soundPlayLoopTimes = {}, this._playingSoundContexts = [], 
this._backupSoundContexts = [], this._bgmUrl = "", this._bgmContext = null, this._bgmLoopState = !0, 
this._isBgmStoped = !1, this._lastBgmPos = -1;
}
_createClass2(e, [ {
key: "_init",
value: function() {
this._isInited || (this._isInited = !0, this._isSupportAudioContext() && (this._bgmContext = this._getAudioContext(), 
this._bgmContext && (this._bgmContext._bgSrc = "")));
}
}, {
key: "_isSupportAudioContext",
value: function() {
return !0;
}
}, {
key: "_isSupportLocalUrl",
value: function() {
return !0;
}
}, {
key: "_canPlayByPlatContext",
value: function() {
return !0;
}
}, {
key: "_getAudioContext",
value: function() {
var e = null;
return this._isSupportAudioContext() && (this._backupSoundContexts.length > 0 ? (e = this._backupSoundContexts[0], 
this._backupSoundContexts.splice(0, 1)) : (e = PlatHelper.getPlat().createInnerAudioContext()).onError(function(e) {
console.log("play error:", e);
})), this._playingSoundContexts.push(e), e;
}
}, {
key: "_recycleAudioContext",
value: function(e) {
var t = this._playingSoundContexts.indexOf(e);
-1 !== t && this._playingSoundContexts.splice(t, 1), this._backupSoundContexts.push(e);
}
}, {
key: "loadSound",
value: function(e, t) {
if (this._init(), checkString(e)) if (this._canPlayByPlatContext(e)) if (this._isSupportAudioContext()) {
var n = this._getAudioContext();
if (n.src == e) return void _reseekAndCb(n, t);
n.src = e, n.loop = !1, n.autoplay = !1;
n.onCanplay(function e() {
n.offCanplay(e), _reseekAndCb(n, t);
});
} else doCallback$1(t, null); else doCallback$1(t, null); else doCallback$1(t, null);
}
}, {
key: "loadMusic",
value: function(e, t) {
var n = this;
if (this._init(), checkString(e)) if (this._canPlayByPlatContext(e)) if (this._isSupportAudioContext()) {
if (this._bgmContext.src == e) return this._bgmContext._bgSrc = e, void _reseekAndCb(this._bgmContext, t);
this._bgmContext.src = e, this._bgmContext._bgSrc = e, this._bgmContext.autoplay = !1;
this._bgmContext.onCanplay(function e() {
n._bgmContext.offCanplay(e), _reseekAndCb(n._bgmContext, t);
});
} else doCallback$1(t, null); else doCallback$1(t, null); else doCallback$1(t, null);
}
}, {
key: "playSound",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 1;
if (this._init(), this.stopSound(e), n = n <= 0 ? 99999 : n, this._canPlayByPlatContext(e)) {
if (checkString(e)) if (this._isSupportAudioContext()) {
var o = generateString(32);
this.loadSound(e, function(i) {
if (i) {
var a = function n() {
void 0 !== t._soundPlayLoopTimes[e] && t._soundPlayLoopTimes[e].identify === o && t._soundPlayLoopTimes[e].loops > 1 ? (t._soundPlayLoopTimes[e].loops -= 1, 
i.seek(0), i.play()) : (void 0 !== t._soundPlayLoopTimes[e] && delete t._soundPlayLoopTimes[e], 
i._endCb = null, i.offEnded(n), t._recycleAudioContext(i));
};
n > 1 && (t._soundPlayLoopTimes[e] = {
loops: n,
identify: o
}), i.loop = !1, i.seek(0), i.play(), i._endCb = a, i.onEnded(a);
}
});
} else this._playSoundByNative(e, n);
} else this._playSoundByNative(e, n);
}
}, {
key: "_playSoundByNative",
value: function(e, t) {
var n = generateString(32);
t > 1 && (this._soundPlayLoopTimes[e] = {
loops: t,
identify: n
}), "function" == typeof this.playSoundByNative && this.playSoundByNative(e, t);
}
}, {
key: "stopSound",
value: function(e) {
if (this._canPlayByPlatContext(e)) {
if (checkString(e)) if (this._isSupportAudioContext()) {
void 0 !== this._soundPlayLoopTimes[e] && delete this._soundPlayLoopTimes[e];
for (var t = 0; t < this._playingSoundContexts.length; t++) {
var n = this._playingSoundContexts[t];
n.src === e && (n._endCb && (n.offEnded(n._endCb), n._endCb = null), n.stop(), this._recycleAudioContext(n));
}
} else this._stopSoundByNative(e);
} else this._stopSoundByNative(e);
}
}, {
key: "_stopSoundByNative",
value: function(e) {
"function" == typeof this.stopSoundByNative && this.stopSoundByNative(e), void 0 !== this._soundPlayLoopTimes[e] && delete this._soundPlayLoopTimes[e];
}
}, {
key: "stopAllSounds",
value: function() {
for (var e in this._soundPlayLoopTimes) this.stopSound(e);
}
}, {
key: "playMusic",
value: function(e) {
var t = this, n = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
this._init(), checkString(e) && this.stopMusic(function() {
if (t._isBgmStoped = !1, !t._canPlayByPlatContext(e)) return t._playMusicByNative(e, n), 
void doCallback$1(o);
t._isSupportAudioContext() ? t.loadMusic(e, function(e) {
t._isBgmStoped || e && (e.seek(0), e.play(), e.loop = n, doCallback$1(o));
}) : (t._playMusicByNative(e, n), doCallback$1(o));
});
}
}, {
key: "_playMusicByNative",
value: function(e, t) {
this._bgmUrl = e, this._bgmLoopState = t, "function" == typeof this.playMusicByNative && this.playMusicByNative(e, t);
}
}, {
key: "stopMusic",
value: function(e) {
var t = this;
if (this._isBgmStoped = !0, this._lastBgmPos = -1, "" !== this._bgmUrl) this._stopMusicByNative(), 
doCallback$1(e); else if (this._bgmContext && "" !== this._bgmContext._bgSrc) {
var n = function() {
t._bgmContext._bgSrc = "", doCallback$1(e);
};
0 !== this._bgmContext.volume ? (this._bgmContext.onStop(function e() {
t._bgmContext.offStop(e), n();
}), this._bgmContext.stop()) : (this._bgmContext.stop(), n());
} else doCallback$1(e);
}
}, {
key: "_stopMusicByNative",
value: function() {
this._bgmUrl = "", this._bgmLoopState = !0, "function" == typeof this.stopMusicByNative && this.stopMusicByNative();
}
}, {
key: "resumeMusic",
value: function() {
this._bgmContext && "" !== this._bgmContext._bgSrc ? (this._bgmContext.volume = 1, 
-1 != this._lastBgmPos && (this._bgmContext.seek(this._lastBgmPos), this._lastBgmPos = -1), 
this._bgmContext.play()) : "" !== this._bgmUrl && ("function" == typeof this.resumeMusicByNative && this.resumeMusicByNative() || this.playMusic(this._bgmUrl, null, this._bgmLoopState));
}
}, {
key: "pauseMusic",
value: function() {
this._bgmContext ? (this._bgmContext.pause(), this._lastBgmPos = this.getCurMusicTime(), 
this._bgmContext.volume = 0) : "" !== this._bgmUrl && "function" == typeof this.pauseMusicByNative && this.pauseMusicByNative();
}
}, {
key: "getCurMusicTime",
value: function() {
return this._bgmContext ? this._bgmContext.currentTime : 0;
}
}, {
key: "isMusicUrlValid",
value: function() {
return !!("" !== this._bgmUrl || this._bgmContext && "" !== this._bgmContext._bgSrc);
}
}, {
key: "setMusicInfo",
value: function(e) {
var t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1];
this._bgmContext ? (this._bgmContext._bgSrc = e, this._bgmContext.loop = t) : (this._bgmUrl = e, 
this._bgmLoopState = t);
}
} ]);
return e;
}(), CocosAudioHelper = function() {
_inherits2(t, AudioBaseHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._playingEffectAudioIDs = {}, n._bgmAudioID = -1;
return n;
}
_createClass2(t, [ {
key: "_canPlayByPlatContext",
value: function(e) {
return !(e instanceof cc.AudioClip || !this._isSupportLocalUrl() && -1 === e.indexOf("http"));
}
}, {
key: "playSoundByNative",
value: function(e) {
var t = this, n = "";
void 0 !== this._soundPlayLoopTimes[e] && (n = this._soundPlayLoopTimes[e].identify);
(function o() {
t._getClip(e, function(i) {
var a = cc.audioEngine.playEffect(i, !1);
t._playingEffectAudioIDs[e] = a, cc.audioEngine.setFinishCallback(a, function() {
delete t._playingEffectAudioIDs[e], void 0 !== t._soundPlayLoopTimes[e] && t._soundPlayLoopTimes[e].identify === n && (t._soundPlayLoopTimes[e].loops -= 1, 
t._soundPlayLoopTimes[e].loops > 0 ? o() : delete t._soundPlayLoopTimes[e]);
});
});
})();
}
}, {
key: "stopSoundByNative",
value: function(e) {
void 0 !== this._playingEffectAudioIDs[e] && (cc.audioEngine.stopEffect(this._playingEffectAudioIDs[e]), 
delete this._playingEffectAudioIDs[e]);
}
}, {
key: "playMusicByNative",
value: function(e, t) {
var n = this;
this._getClip(e, function(e) {
n._bgmAudioID = cc.audioEngine.playMusic(e, t), cc.audioEngine.setMusicVolume(1);
});
}
}, {
key: "stopMusicByNative",
value: function() {
-1 !== this._bgmAudioID && (cc.audioEngine.stop(this._bgmAudioID), cc.audioEngine.setMusicVolume(0), 
this._bgmAudioID = 0);
}
}, {
key: "resumeMusicByNative",
value: function() {
return -1 !== this._bgmAudioID && (cc.audioEngine.resumeMusic(), cc.audioEngine.setMusicVolume(1), 
!0);
}
}, {
key: "pauseMusicByNative",
value: function() {
-1 !== this._bgmAudioID && (cc.audioEngine.pauseMusic(), cc.audioEngine.setMusicVolume(0));
}
}, {
key: "getCurMusicTime",
value: function() {
return "" !== this._bgmUrl ? -1 !== this._bgmAudioID ? cc.audioEngine.getCurrentTime(this._bgmAudioID) : 0 : _get2(_getPrototypeOf2(t.prototype), "getCurMusicTime", this).call(this);
}
}, {
key: "_getClip",
value: function(e, t) {
checkFunc(t) && (checkString(e) ? -1 !== e.indexOf("http") || -1 !== e.indexOf("assets/resources/native/") ? cc.assetManager.loadRemote(e, function(e, n) {
if (e) return console.error(e), void t(null);
t(n);
}) : cc.assetManager.getBundle("hl_core").load(e, function(e, n) {
e ? (console.error(e), t(null)) : t(n);
}) : e instanceof cc.AudioClip ? t(e) : (console.error("Error: unsupport clip type, ", clip), 
t(null)));
}
} ]);
return t;
}(), LayaAudioHelper = function() {
_inherits2(t, AudioBaseHelper);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._bgmAudio = null;
return n;
}
_createClass2(t, [ {
key: "_canPlayByPlatContext",
value: function(e) {
if (!this._isSupportLocalUrl()) {
if (-1 === e.indexOf("http")) return !1;
if (Laya.MiniFileMgr && void 0 !== Laya.MiniFileMgr.fakeObj[e]) return !1;
}
return !0;
}
}, {
key: "playSoundByNative",
value: function(e) {
var t = this, n = "";
void 0 !== this._soundPlayLoopTimes[e] && (n = this._soundPlayLoopTimes[e].identify);
(function o() {
Laya.SoundManager.playSound(e, 1, Laya.Handler.create(null, function() {
void 0 !== t._soundPlayLoopTimes[e] && t._soundPlayLoopTimes[e].identify === n && (t._soundPlayLoopTimes[e].loops -= 1, 
t._soundPlayLoopTimes[e].loops > 0 ? o() : delete t._soundPlayLoopTimes[e]);
}), 0);
})();
}
}, {
key: "stopSoundByNative",
value: function(e) {
Laya.SoundManager.stopSound(e);
}
}, {
key: "playMusicByNative",
value: function(e, t) {
var n = this, o = t ? 99999 : 1;
(function t() {
n._bgmAudio = Laya.SoundManager.playMusic(e, 1, Laya.Handler.create(null, function() {
o -= 1, "" !== n._bgmUrl && o > 0 && t();
}), 0), n._bgmAudio.volume = 1;
})();
}
}, {
key: "stopMusicByNative",
value: function() {
this._bgmAudio && (this._bgmAudio.stop(), this._bgmAudio.volume = 0, this._bgmAudio = null);
}
}, {
key: "resumeMusicByNative",
value: function() {
return !!this._bgmAudio && (this._bgmAudio.resume(), this._bgmAudio.volume = 1, 
!0);
}
}, {
key: "pauseMusicByNative",
value: function() {
this._bgmAudio && (this._bgmAudio.pause(), this._bgmAudio.volume = 0);
}
}, {
key: "getCurMusicTime",
value: function() {
return "" !== this._bgmUrl ? this._bgmAudio ? this._bgmAudio.position : 0 : _get2(_getPrototypeOf2(t.prototype), "getCurMusicTime", this).call(this);
}
} ]);
return t;
}(), EngineAudioHelper = AudioBaseHelper;

"undefined" != typeof window && void 0 !== window.cc && void 0 !== window.cc.ENGINE_VERSION ? EngineAudioHelper = CocosAudioHelper : "undefined" != typeof window && void 0 !== window.Laya && void 0 !== window.Laya.version && (EngineAudioHelper = LayaAudioHelper);

var CommonAudioHelper = function() {
_inherits2(t, EngineAudioHelper);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "_isSupportAudioContext",
value: function() {
return PlatHelper.getPlat();
}
}, {
key: "_isSupportLocalUrl",
value: function() {
return !0;
}
}, {
key: "playMusic",
value: function(e) {
var n = this, o = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], i = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
_get2(_getPrototypeOf2(t.prototype), "playMusic", this).call(this, e, o, function() {
PlatHelper.getPlat() && adv_interface.isWatchingVideoAdv() && n.pauseMusic(), doCallback$1(i);
});
}
} ]);
return t;
}(), OPPOAudioHelper = function() {
_inherits2(t, AudioBaseHelper);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "_isSupportAudioContext",
value: function() {
return !0;
}
}, {
key: "_isSupportLocalUrl",
value: function() {
return !1;
}
}, {
key: "playMusic",
value: function(e) {
var n = this, o = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], i = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
_get2(_getPrototypeOf2(t.prototype), "playMusic", this).call(this, e, o, function() {
adv_interface.isWatchingVideoAdv() && n.pauseMusic(), doCallback$1(i);
});
}
} ]);
return t;
}(), VIVOAudioHelper = function() {
_inherits2(t, AudioBaseHelper);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "_isSupportAudioContext",
value: function() {
return !0;
}
}, {
key: "_isSupportLocalUrl",
value: function() {
return !1;
}
}, {
key: "_recycleAudioContext",
value: function(e) {
var t = this._playingContexts.indexOf(e);
-1 !== t && this._playingContexts.splice(t, 1), e && e.destroy();
}
}, {
key: "playMusic",
value: function(e) {
var n = this, o = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], i = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
_get2(_getPrototypeOf2(t.prototype), "playMusic", this).call(this, e, o, function() {
adv_interface.isWatchingVideoAdv() && n.pauseMusic(), doCallback$1(i);
});
}
} ]);
return t;
}(), _AudioHelper_Cls = CommonAudioHelper, AudioHelper = new (_AudioHelper_Cls = "undefined" != typeof qg && qg.getProvider().toLowerCase().indexOf("oppo") > -1 ? OPPOAudioHelper : "undefined" != typeof qg && qg.getProvider().toLowerCase().indexOf("vivo") > -1 ? VIVOAudioHelper : CommonAudioHelper)(), _AudioMgr = function() {
function e() {
_classCallCheck2(this, e);
}
_createClass2(e, [ {
key: "loadSound",
value: function(e, t) {
AudioHelper.loadSound(e, t);
}
}, {
key: "playSound",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 1;
HLSDKLocalData$1._settings._isSoundEnabled && AudioHelper.playSound(this._fixUrl(e), t);
}
}, {
key: "stopSound",
value: function(e) {
AudioHelper.stopSound(this._fixUrl(e));
}
}, {
key: "stopAllSounds",
value: function() {
AudioHelper.stopAllSounds();
}
}, {
key: "loadMusic",
value: function(e, t) {
AudioHelper.loadMusic(this._fixUrl(e), t);
}
}, {
key: "playMusic",
value: function(e) {
var t = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
HLSDKLocalData$1._settings._isMusicEnabled ? AudioHelper.playMusic(this._fixUrl(e), t, n) : AudioHelper.setMusicInfo(this._fixUrl(e), t);
}
}, {
key: "stopMusic",
value: function(e) {
AudioHelper.stopMusic(e);
}
}, {
key: "pauseMusic",
value: function() {
AudioHelper.pauseMusic();
}
}, {
key: "resumeMusic",
value: function() {
HLSDKLocalData$1._settings._isMusicEnabled && AudioHelper.resumeMusic();
}
}, {
key: "getCurMusicTime",
value: function() {
return AudioHelper.getCurMusicTime();
}
}, {
key: "setMusicEnable",
value: function(e) {
e && AudioHelper.isMusicUrlValid() ? AudioHelper.resumeMusic() : !e && AudioHelper.isMusicUrlValid() && AudioHelper.pauseMusic();
}
}, {
key: "_fixUrl",
value: function(e) {
if (checkString(SubConfig.path)) return SubConfig.path + e;
if (!isLayaEngine()) return e;
if (PlatHelper.getPlat() && "" !== Laya.URL.basePath) {
var t = !1, n = getLayaMiniAdapter();
if (n.nativefiles.length > 0) for (var o = 0; o < n.nativefiles.length; o++) {
var i = n.nativefiles[o];
if (-1 !== e.indexOf(i)) {
t = !0;
break;
}
}
t || (e = Laya.URL.basePath + e);
}
return e;
}
} ]);
return e;
}(), AudioMgr = new _AudioMgr(), cls$h = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.FullExport;
},
onInitUI: function() {
this.bindName(this, this.node, [ "closeBtn", "scrollAdvLoader", "bannerAdvLoader" ]), 
this.addAdvLoadMgr(this.scrollAdvLoader, this.bannerAdvLoader);
},
onInit: function(e) {
var t = this;
this._super(e), this.setAdvPath(e.advPath, !0), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
this._hideBannerAd()), this.closeBtn && (this._uiParams.mistakeType === C_MistakeType.Banner || this._uiParams.mistakeType === C_MistakeType.None ? (e.stopAutoMoveBtn ? createMistakeBtn_NoMove(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.bannerShow, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}) : createMistakeBtn_Move(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.btnMoveAfterShowBanner, e.moveDuration, !0, {
x: 0,
y: -200
}, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}), this._uiParams.mistakeType === C_MistakeType.None ? this.closeBtn.disableMistake() : e.isMistakeEnabled && e.enableMistake ? e.mistakeDelay > 0 ? Scheduler.schedule("Delay_Auto_Start_Page_Banner_Mistake", function() {
t.closeBtn.enableMistake();
}, !1, e.mistakeDelay, 0) : -1 === e.mistakeDelay ? this.closeBtn.enableMistake() : this.closeBtn.once("click", function() {
t.closeBtn.enableMistake();
}) : this.closeBtn.disableMistake()) : this.addPlayBtntouchAction(this.closeBtn));
},
onHide: function() {
this._super(), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.resumeAutoRefreshBannerAd(), 
this._hideBannerAd());
},
onCloseTouched: function() {
this.hidePage();
}
}), cls$g = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.FullExit;
},
onInitUI: function() {
this.bindName(this, this.node, [ "closeBtn", "advLoader" ]), this.addAdvLoadMgr(this.advLoader);
},
onInit: function(e) {
var t = this;
this._super(e), this.setAdvPath(e.advPath, !1), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
this._hideBannerAd()), this.closeBtn && (this.closeBtn.off("click"), this._uiParams.mistakeType === C_MistakeType.Banner || this._uiParams.mistakeType === C_MistakeType.None ? (e.stopAutoMoveBtn ? createMistakeBtn_NoMove(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.bannerShow, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}) : createMistakeBtn_Move(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.btnMoveAfterShowBanner, e.moveDuration, !0, {
x: 0,
y: -200
}, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}), this._uiParams.mistakeType === C_MistakeType.None ? this.closeBtn.disableMistake() : e.isMistakeEnabled && e.enableMistake ? e.mistakeDelay > 0 ? Scheduler.schedule("Delay_Auto_Start_Page_Banner_Mistake", function() {
t.closeBtn.enableMistake();
}, !1, e.mistakeDelay, 0) : -1 === e.mistakeDelay ? this.closeBtn.enableMistake() : this.closeBtn.once("click", function() {
t.closeBtn.enableMistake();
}) : this.closeBtn.disableMistake()) : this.addPlayBtntouchAction(this.closeBtn));
},
onHide: function() {
this._super(), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.resumeAutoRefreshBannerAd(), 
this._hideBannerAd());
},
onCloseTouched: function() {
this.hidePage();
}
}), cls$f = cc.Class({
extends: cc.ScrollView,
ctor: function() {
this._innerScrollViews = [], this._planDir = null, this._scrollingInnerSv = null;
},
onLoad: function() {
var e = this;
this._planDir = null, this._innerScrollViews.forEach(function(t) {
t.setOuterScrollView(e);
});
},
addInnerScrollView: function(e) {
e instanceof cls$v && (e.setOuterScrollView(this), this._innerScrollViews.push(e));
},
_isHisChild: function(e, t) {
return e == t || null != e.parent && (e.parent == t || this._isHisChild(e.parent, t));
},
_findScrollingInnerSv: function(e) {
for (var t = 0; t < this._innerScrollViews.length; t++) if (this._isHisChild(e, this._innerScrollViews[t].node)) return this._innerScrollViews[t];
return null;
},
isDifferentBetweenSettingAndPlan: function(e) {
return !(0 == this._planDir || 1 == this._planDir && e.horizontal || -1 == this._planDir && e.vertical);
},
_hasNestedViewGroup: function(e) {
if (e.eventPhase === cc.Event.CAPTURING_PHASE) return !1;
},
hasNestedViewGroup: function(e, t) {
return this._hasNestedViewGroup(e, t);
},
_onTouchBegan: function(e, t) {
if (this.enabledInHierarchy && !this.hasNestedViewGroup(e, t)) {
this._planDir = null, this._scrollingInnerSv = null;
var n = e.touch;
this.content && this._handlePressLogic(n), this._touchMoved = !1, this._stopPropagationIfTargetIsMe(e);
}
},
_onTouchMoved: function(e, t) {
if (this.enabledInHierarchy && !this.hasNestedViewGroup(e, t)) {
var n = e.touch, o = n.getLocation().sub(n.getStartLocation());
if (null == this._planDir && o.mag() > 7) if (this._scrollingInnerSv = this._findScrollingInnerSv(e.target), 
null != this._scrollingInnerSv) {
var i = this._scrollingInnerSv.content.getContentSize(), a = this._scrollingInnerSv.node.getContentSize();
this._scrollingInnerSv.vertical && i.height > a.height || this._scrollingInnerSv.horizontal && i.width > a.width ? this._planDir = Math.abs(o.x) > Math.abs(o.y) ? 1 : -1 : this._planDir = 0;
} else this._planDir = 0;
if (this.content && (this.isDifferentBetweenSettingAndPlan(this) || this._handleMoveLogic(n)), 
this.cancelInnerEvents && null == this._scrollingInnerSv) {
if (o.mag() > 7 && !this._touchMoved && e.target !== this.node) {
var r = new cc.Event.EventTouch(e.getTouches(), e.bubbles);
r.type = cc.Node.EventType.TOUCH_CANCEL, r.touch = e.touch, r.simulate = !0, e.target.dispatchEvent(r), 
this._touchMoved = !0;
}
this._stopPropagationIfTargetIsMe(e);
}
}
}
}), cls$e = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.FullExport_V2, this._isTouching = !1, this._fromTopToBottom = !0, 
this._isFirstOpen = !0, this._outerView = null;
},
onInitUI: function() {
var e = this;
this.bindName(this, this.node, [ "closeBtn", "list" ]), this.list && (this._outerView = seekNodeByName(this.node, "list").getComponent(cls$f), 
this._outerView && (this._outerView.node.on("scroll-began", function() {
Scheduler.unschedule("Next_Tween_of_Ad_Full_Export_V2");
}), this._outerView.node.on("scroll-ended", function() {
Scheduler.unschedule("Next_Tween_of_Ad_Full_Export_V2"), Scheduler.schedule("Next_Tween_of_Ad_Full_Export_V2", function() {
e._doTweenList();
}, !1, 2e3, 1);
}), this.getBundle().load(convertToScreneOrientationPrefabPath("fullExportContent_v2"), cc.Prefab, function(t, n) {
if (t) console.error(t), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR); else {
var o = cc.instantiate(n), i = seekNodeByName(o, "staticAdvLoader"), a = seekNodeByName(o, "scrollAdvLoader"), r = seekNodeByName(o, "listAdvLoader");
e.addAdvLoadMgr(i, a, r), o.anchorX = 0, o.anchorY = 1, o.x = 0, o.y = 0, e._outerView.content.height = o.height, 
o.parent = e._outerView.content, e._outerView.addInnerScrollView(o.getComponent(cls$v)), 
Scheduler.schedule("Start_Tween_Full_Export_V2", function() {
e._doTweenList();
}, !1, 500, 1);
}
})));
},
_doTweenList: function() {
if (this.list) {
var e = Math.abs(this._outerView.getScrollOffset().y), t = Math.abs(this._outerView.getMaxScrollOffset().y), n = 0;
Math.abs(t - e) < 50 ? (n = e / t * 5e3, this._outerView.scrollToTop(n / 1e3, !1)) : (n = (t - e) / t * 5e3, 
this._outerView.scrollToBottom(n / 1e3, !1));
}
},
onInit: function(e) {
var t = this;
this._super(e), this.setAdvPath(e.advPath, !0), this._isFirstOpen ? this._isFirstOpen = !1 : this.refreshAdv(!0), 
this._outerView && Math.abs(this._outerView.getMaxScrollOffset().y) > 0 && Scheduler.schedule("Start_Tween_Full_Export_V2", function() {
t._doTweenList();
}, !1, 500, 1), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
this._hideBannerAd()), this.closeBtn && (null == this._uiParams.mistakeType || this._uiParams.mistakeType === C_MistakeType.Banner || this._uiParams.mistakeType === C_MistakeType.None ? (e.stopAutoMoveBtn ? createMistakeBtn_NoMove(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.bannerShow, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}) : createMistakeBtn_Move(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.btnMoveAfterShowBanner, e.moveDuration, !0, {
x: 0,
y: -250
}, function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
t._showBannerAd(e);
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}), this._uiParams.mistakeType === C_MistakeType.None ? this.closeBtn.disableMistake() : e.isMistakeEnabled && e.enableMistake ? e.mistakeDelay > 0 ? Scheduler.schedule("Delay_Auto_Start_Page_Banner_Mistake", function() {
t.closeBtn.enableMistake();
}, !1, e.mistakeDelay, 0) : -1 === e.mistakeDelay ? this.closeBtn.enableMistake() : this.closeBtn.once("click", function() {
t.closeBtn.enableMistake();
}) : this.closeBtn.disableMistake()) : this.addPlayBtntouchAction(this.closeBtn));
var n = function() {
var e = null;
if (t._advLoadMgrs && t._advLoadMgrs.length > 2) {
var n = t._advLoadMgrs[2].getAllExposedAdvInfos();
if (n.length > 6) {
var o = random(0, 5);
e = n[o];
} else if (n.length > 0) {
var i = random(0, n.length - 1);
e = n[i];
}
}
if (Scheduler.unschedule("Finger_Auto_Follow_Target_Of_FullExportPopup_V2"), UIManager.hideUI(UIKeys.Finger).catch(function() {}), 
e) {
var a = e.getCenterPt();
UIManager.showUI(UIKeys.Finger, DEFAULT_BUNDLE_TEMPLATE, null, new cc.v2(a.x, a.y)).then(function(t) {
var n = t[1];
Scheduler.schedule("Finger_Auto_Follow_Target_Of_FullExportPopup_V2", function() {
var t = e.getCenterPt();
n.fixPos(new cc.v2(t.x, t.y));
}, !0);
});
}
};
Scheduler.schedule("Auto_Show_Finger_Of_FullExportPopup_V2", function() {
n();
}, !1, 2e3), Scheduler.schedule("First_Show_Finger_Of_FullExportPopup_V2", function() {
n();
}, !1, 500, 0);
},
onHide: function() {
this._super(), UIManager.hideUI(UIKeys.Finger).catch(function() {}), Scheduler.unschedule("Next_Tween_of_Ad_Full_Export_V2"), 
Scheduler.unschedule("Auto_Show_Finger_Of_FullExportPopup_V2"), Scheduler.unschedule("Finger_Auto_Follow_Target_Of_FullExportPopup_V2"), 
Scheduler.unschedule("Start_Tween_Full_Export_V2"), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.resumeAutoRefreshBannerAd(), 
this._hideBannerAd());
},
onCloseTouched: function() {
this.hidePage();
}
}), InvokeType = cc.Enum({
None: 0,
Banner: 1,
CustomScroll: 2
}), cls$d = cc.Class({
extends: cls$p,
properties: {
invokeType: {
type: cc.Enum(InvokeType),
default: InvokeType.Banner,
tooltip: "触发表现方式"
}
},
ctor: function() {
this._pageKey = UIKeys.CrazyClick, this._scheduleKey = "", this.ClickImgs = [], 
this.beatAni = null;
},
onInitUI: function() {
if (this.bindName(this, this.node, [ "clickProgress", "clickBtn", "finger", "tips", "icon", "clickBg", "ownSkillRoot", "SkillRoot", "skillFx", "skillEx", "role02" ]), 
this.clickProgress) {
var e = this.clickProgress.getComponent(cc.ProgressBar);
e.progress = 0, e.barSprite.node.active = !1;
}
this.clickBtn && (this.clickBtn._originalBottom = this.clickBtn.getComponent(cc.Widget).bottom), 
this.finger && (this.finger._originalBottom = this.finger.getComponent(cc.Widget).bottom), 
this.tips && (this.tips._originalBottom = this.tips.getComponent(cc.Widget).bottom), 
this.clickBg && (this.clickBg._originalBottom = this.clickBg.getComponent(cc.Widget).bottom, 
this.clickBg.active = !1), this.skillFx && (this.skillFx.active = !1), this.skillEx && (this.skillEx.active = !1), 
this.role02 && (this.beatAni = this.role02.getComponent(cc.Animation));
},
getClickImg: function() {
var e = this;
if (this.ClickImgs = [], null != this.MouldName) for (var t = this.getBundle(), n = 1; n < 10; n++) t.load("res/" + n.toString(), cc.SpriteFrame, function(t, n) {
t || e.ClickImgs.push(n);
});
},
onInit: function(e) {
var t = this;
if (this._super(e), console.error("creazy_click.js", e), this.MouldName = e.tpl, 
this.getClickImg(), this.skillEx && Scheduler.schedule("Play_Ani", function() {
clone_Ex = cc.instantiate(t.skillEx), clone_Ex && (clone_Ex.active = !0, t.SkillRoot.addChild(clone_Ex), 
cc.tween(clone_Ex).by(.5, {
position: cc.v2(285, 0)
}).removeSelf().start());
}, !1, 500), e.invokeType === CrazyClickInvokeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
this._hideBannerAd()), (checkString(e.invokeType) || e.invokeType === CrazyClickInvokeType.CustomScroll) && checkString(e.scrollAdUnitId) && this._preloadScrollAd(e.scrollAdUnitId, {
layout: "bottom",
bottom: 0
}), e.invokeType === CrazyClickInvokeType.Banner && e.mistakeStyle === CrazyClickBannerMistakeType.Move) this.clickBtn.getComponent(cc.Widget).bottom = this.clickBtn._originalBottom + 200, 
this.finger && (this.finger.getComponent(cc.Widget).bottom = this.finger._originalBottom + 200), 
this.tips && (this.tips.getComponent(cc.Widget).bottom = this.tips._originalBottom + 200); else if (e.invokeType === CrazyClickInvokeType.VideoBanner) this.clickBtn.bottom = this.clickBtn._originalBottom + 200, 
this.finger && (this.finger.bottom = this.finger._originalBottom + 200), this.tips && (this.tips.bottom = this.tips._originalBottom + 200); else if (e.invokeType <= 0 || e.invokeType === CrazyClickInvokeType.CustomScroll) this.clickBtn.getComponent(cc.Widget).bottom = this.clickBtn._originalBottom - 60, 
this.finger && (this.finger.getComponent(cc.Widget).bottom = this.finger._originalBottom - 60), 
this.tips && (this.tips.getComponent(cc.Widget).bottom = this.tips._originalBottom - 60); else if (e.invokeType <= 0 && 0 !== e.videoTarget) {
var n = .168 * Laya.stage.height;
isLoadLandscapeConfig$1() && (n = .248 * Laya.stage.height);
var o = n - this.clickBtn.height / 2 - this.clickBtn._originalBottom;
this.clickBtn.bottom = this.clickBtn._originalBottom + o, this.finger && (this.finger.bottom = this.finger._originalBottom + o), 
this.tips && (this.tips.bottom = this.tips._originalBottom + o);
} else this.clickBtn.getComponent(cc.Widget).bottom = this.clickBtn._originalBottom, 
this.finger && (this.finger.getComponent(cc.Widget).bottom = this.finger._originalBottom), 
this.tips && (this.tips.getComponent(cc.Widget).bottom = this.tips._originalBottom);
(checkString(e.invokeType) || e.invokeType === CrazyClickInvokeType.CustomScroll) && checkString(e.scrollAdUnitId) && Scheduler.schedule("Delay_Preload_Custom_Ad", function() {
t._preloadScrollAd(e.scrollAdUnitId, {
layout: "center",
centerPt: t.clickBtn.convertToWorldSpaceAR(new cc.v2(t.clickBtn.width / 2 - t.clickBtn.width * t.clickBtn.anchorX, t.clickBtn.height / 2 - t.clickBtn.height * t.clickBtn.anchorY))
});
}, !1, 100, 0), createCrazyClickBtn(this.clickBtn, function(e) {
if (t.clickProgress) {
var n = t.clickProgress.getComponent(cc.ProgressBar);
if (n.progress = e, n.progress > 0) {
if (n.barSprite.node.active = !0, t.icon && t.ClickImgs.length > 0) {
var o = Math.min(Math.floor(e * t.ClickImgs.length), t.ClickImgs.length - 1);
t.icon.getComponent(cc.Sprite).spriteFrame = t.ClickImgs[o];
}
t.cancelAutoClosePage();
} else n.barSprite.node.active = !1;
}
}, function() {}, function() {
t._delayToHide();
}, e, function() {
var n = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
n.out || e.mistakeStyle !== CrazyClickBannerMistakeType.Show || t._moveBannerAdTo(t.clickBtn.convertToWorldSpaceAR(new cc.v2(t.clickBtn.width / 2 - t.clickBtn.width * t.clickBtn.anchorX, t.clickBtn.height / 2 - t.clickBtn.height * t.clickBtn.anchorY)));
}, function() {
t._hideBannerAd();
}, function(e) {
t._moveBannerAdTo(e);
}, function(e) {
t._showRewardedVideoAd(e);
}, function(e, n) {
t._showScrollAd(e, n);
}, function(e) {
t._hideScrollAd(e);
}, this.clickBg, this.ownSkillRoot, this.skillFx, this.beatAni), e.isMistakeEnabled && e.enableMistake ? this.clickBtn.enableMistake() : this.clickBtn.disableMistake();
},
onHide: function() {
this._super(), this._uiParams.invokeType === CrazyClickInvokeType.Banner && adv_interface.resumeAutoRefreshBannerAd();
},
_delayToHide: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : 500;
Scheduler.isScheduled("Delay_Hide_Click_Mistake_Popup") || (Scheduler.unschedule("Play_Ani"), 
Scheduler.schedule("Delay_Hide_Click_Mistake_Popup", function() {
e._uiParams.invokeType === CrazyClickInvokeType.Banner ? e._hideBannerAd() : e._uiParams.invokeType === CrazyClickInvokeType.CustomScroll && checkString(e._uiParams.scrollAdUnitId) && e._hideScrollAd(e._uiParams.scrollAdUnitId), 
e.hidePage();
}, !1, t, 1));
}
}), cls$c = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.NativeTemplateAd, this._isCloseBtnCanInvoke = null;
},
onInitUI: function() {
this.bindName(this, this.node, [ "closeBtn", "clickBg" ]);
},
onInit: function(e) {
var t = this;
this._super(e), this.setAdvPath(e.advPath), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
this._hideBannerAd()), this._uiParams.isBannerAutoRefresh && isLoadLandscapeConfig$1() && (HLSDKLocalData$1._isNativeland = !0), 
this.clickBg && (this.clickBg.on("click", this.onShowVideo, this), this.clickBg.active = !1), 
this.closeBtn && (this.closeBtn.off("click"), this._uiParams.mistakeType === C_MistakeType.Banner ? (e.stopAutoMoveBtn || !this._uiParams.enableMistake ? createMistakeBtn_NoMove(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.btnInvalid, e.btnMoveAfterShowBanner, 0, e.bannerShow, function() {
var n = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
isLoadWXConfig() && e.isBannerAutoRefresh || t._showBannerAd(n);
}, function() {
isLoadWXConfig() && e.isBannerAutoRefresh || t._hideBannerAd();
}) : createMistakeBtn_Move(this.closeBtn, function() {
t.onCloseTouched(t.closeBtn);
}, BtnClickMistakeType.Show, e.btnDelay, e.btnHide, e.btnUnhandle, e.btnInvalid, e.btnMoveAfterShowBanner, e.moveDuration, !0, {
x: 0,
y: -200
}, function() {
var n = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
isLoadWXConfig() && e.isBannerAutoRefresh || t._showBannerAd(n);
}, function() {
isLoadWXConfig() && e.isBannerAutoRefresh || t._hideBannerAd();
}, function(n) {
isLoadWXConfig() && e.isBannerAutoRefresh || t._moveBannerAdTo(n);
}), this._uiParams.mistakeType === C_MistakeType.None ? this.closeBtn.disableMistake() : e.isMistakeEnabled && e.enableMistake ? e.mistakeDelay > 0 ? Scheduler.schedule("Delay_Auto_Start_Page_Banner_Mistake", function() {
t.closeBtn.enableMistake();
}, !1, e.mistakeDelay, 0) : -1 === e.mistakeDelay ? this.closeBtn.enableMistake() : this.closeBtn.once("click", function() {
t.closeBtn.enableMistake();
}) : this.closeBtn.disableMistake()) : this._uiParams.mistakeType === C_MistakeType.videoBanner ? (e.videoBannerAutoRefresh && this._uiParams.enableMistake && (this.clickBg.active = !0, 
Scheduler.schedule("Auto_Refresh_Video_Banner_Img", function() {
t.clickBg.active ? t.clickBg.active = !1 : t.clickBg.active = !0;
}, !1, e.videoBannerAutoRefreshGap)), this.closeBtn.on("click", this.onCloseTouched, this)) : e.isMistakeEnabled && !this._uiParams.enableMistake && this._uiParams.btnInvalid > 0 && !this._isCloseBtnCanInvoke ? null === this._isCloseBtnCanInvoke && (this._isCloseBtnCanInvoke = !1, 
this.closeBtn.once("click", null, function() {
Scheduler.schedule("Delay_Enable_Close_Btn", function() {
t._isCloseBtnCanInvoke = !0, t.addPlayBtntouchAction(t.closeBtn);
}, !1, t._uiParams.btnInvalid, 0);
})) : this.addPlayBtntouchAction(this.closeBtn));
},
onShowVideo: function() {
var e = this;
adv_interface.showRewardedVideoAd("", !1, function() {
Scheduler.unschedule("Auto_Refresh_Video_Banner_Img"), e.clickBg.active = !1;
}, function() {
Scheduler.unschedule("Auto_Refresh_Video_Banner_Img"), e.clickBg.active = !1;
});
},
onHide: function() {
this._super(), Scheduler.unschedule("Auto_Refresh_Video_Banner_Img"), this._uiParams.mistakeType === C_MistakeType.Banner && (adv_interface.resumeAutoRefreshBannerAd(), 
this._hideBannerAd());
},
onCloseTouched: function() {
this.hidePage(), HLSDKLocalData$1._isNativeland = !1;
}
}), cls$b = cc.Class({
extends: cls$s,
ctor: function() {
this._pageKey = UIKeys.VideoBanner;
},
onInitUI: function() {
this.bindName(this, this.node, [ "Bg", "boxImgs", "lightRing", "finger" ]);
},
onInit: function(e) {
this.setAdvPath(e.advPath), this.Bg && this.Bg.on("click", this.onShowVideo, this), 
this.initBoxImgs(), this.playAni();
},
onShowVideo: function() {
adv_interface.showRewardedVideoAd();
},
initBoxImgs: function() {
this.boxImgs && (this.boxImgs.children ? this.boxImgs.children : this.boxImgs._children).forEach(function(e) {
e.setScale(1);
});
},
playAni: function() {
this.boxImgs && this.boxTween(0, 0), this.finger && this.lightRing && this.lightTween(0);
},
boxTween: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : 0, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0, o = this.boxImgs.getChildByName("box" + (n + 1));
t < 3 ? (t += 1, Scheduler.schedule("show_next_box_tween", function() {
e.boxTween(t, n);
}, !1, 600, 1), o.runAction(cc.sequence(cc.scaleTo(.3, 1.1, 1.1), cc.callFunc(function() {
o.runAction(cc.sequence(cc.scaleTo(.3, 1, 1), cc.callFunc(null)));
})))) : ((n += 1) == this.boxImgs.childrenCount && (n = 0), this.boxTween(0, n), 
this.lightTween(n));
},
lightTween: function() {
this.lightRing.setScale(.5), this.lightRing.Opacity = 1, this.lightRing.runAction(cc.sequence(cc.scaleTo(1.8, 1, 1), cc.callFunc(null)));
},
onHide: function() {
this._super(), Scheduler.unschedule("show_next_box_tween");
},
getOnlineImg: function(e, t) {
var n = "http://r.game.hnquyou.com/upload/HLSDK/cocosVideoBannerImgs/V1/" + t;
cc.assetManager.loadRemote(n, function(t, n) {
!t && imageAsset && (e.getComponent(cc.Sprite).spriteFrame = new cc.SpriteFrame(n));
});
}
}), WX_UIRegisterInfos = [], moreGameEntranceInfo$4 = {
key: WX_UIKeys.MoreGameEntrance,
zIndex: 11,
isAutoDestory: !1,
cls: cls$q,
clsPath: "0b0e75LOmVKxZG6oUUZW6Ma",
prefab: "Entrance",
bundle: "hl_entrance"
};

WX_UIRegisterInfos.push(moreGameEntranceInfo$4);

var matrixAdInfo = {
key: WX_UIKeys.Matrix,
zIndex: 21,
isAutoDestory: !1,
cls: cls$i,
clsPath: "00485EsLCVH54/qtyI7qsYV",
prefab: "MatrixAd",
bundle: "hl_matrix"
};

WX_UIRegisterInfos.push(matrixAdInfo);

var coupletAdInfo = {
key: WX_UIKeys.Couplet,
zIndex: 22,
isAutoDestory: !1,
cls: cls$j,
clsPath: "69bff+qsENHloUvAqnJTEcW",
prefab: "CoupletAd",
bundle: "hl_couplet"
};

WX_UIRegisterInfos.push(coupletAdInfo);

var scrollAdInfo = {
key: WX_UIKeys.Scroll,
zIndex: 23,
isAutoDestory: !1,
cls: cls$l,
clsPath: "24673m+pO9JmZq6GdQQrIsB",
prefab: "ScrollAd",
bundle: "hl_scroll"
};

WX_UIRegisterInfos.push(scrollAdInfo);

var scrollWithNameAdInfo = {
key: WX_UIKeys.ScrollWithName,
zIndex: 23,
isAutoDestory: !1,
cls: cls$l,
clsPath: "24673m+pO9JmZq6GdQQrIsB",
prefab: "ScrollAd_WithName",
bundle: "hl_scroll"
};

WX_UIRegisterInfos.push(scrollWithNameAdInfo);

var crazyClickInfo$2 = {
key: WX_UIKeys.CrazyClick,
zIndex: 102,
isAutoDestory: !1,
cls: cls$d,
clsPath: "3809fDls7ZNgqNcvRwMA8Bo",
prefab: "CrazyClick",
bundle: "hl_crazy_click"
};

WX_UIRegisterInfos.push(crazyClickInfo$2);

var fakeLoadingAdInfo = {
key: WX_UIKeys.FakeLoading,
zIndex: 211,
isAutoDestory: !1,
cls: cls$m,
clsPath: "133cdM9mYlGDbJpTwfsWe9L",
prefab: "FakeLoadingAd",
bundle: "hl_fakeLoading"
};

WX_UIRegisterInfos.push(fakeLoadingAdInfo);

var nativeTemplateAd = {
key: WX_UIKeys.NativeTemplateAd,
zIndex: 211,
isAutoDestory: !1,
cls: cls$c,
clsPath: "46ec6gbkbxNra+i8VzpI12W",
prefab: "NativeTemplateAd",
bundle: "hl_nativeTemplate"
};

WX_UIRegisterInfos.push(nativeTemplateAd);

var moreGameAdInfo = {
key: WX_UIKeys.MoreGame,
zIndex: 212,
isAutoDestory: !1,
cls: cls$n,
clsPath: "a590536sNBOD5qDmWYmbnVQ",
prefab: "MoreGameAd",
bundle: "hl_moreGame"
};

WX_UIRegisterInfos.push(moreGameAdInfo);

var fullExportAdInfo = {
key: WX_UIKeys.FullExport,
zIndex: 213,
isAutoDestory: !1,
cls: cls$h,
clsPath: "c3dbcGz8I5J6JshiJ7QyR+S",
prefab: "FullExportAd",
bundle: "hl_fullExport"
};

WX_UIRegisterInfos.push(fullExportAdInfo);

var fullExport_V2_AdInfo = {
key: WX_UIKeys.FullExport_V2,
zIndex: 214,
isAutoDestory: !1,
cls: cls$e,
clsPath: "ff5c4i00EtFi6aEoQIqkMXh",
prefab: "FullExportAd_v2",
bundle: "hl_fullExport_v2"
};

WX_UIRegisterInfos.push(fullExport_V2_AdInfo);

var fullExitAdInfo = {
key: WX_UIKeys.FullExit,
zIndex: 215,
isAutoDestory: !1,
cls: cls$g,
clsPath: "a3aa4DHNbVFkKXqkO/qYphZ",
prefab: "FullExitAd",
bundle: "hl_fullExit"
};

WX_UIRegisterInfos.push(fullExitAdInfo);

var videoBannerAdInfo = {
key: WX_UIKeys.VideoBanner,
zIndex: 23,
isAutoDestory: !1,
cls: cls$b,
clsPath: "524f0oaKmtNbq1XbTiGtboi",
prefab: "VideoBannerAd",
bundle: "hl_videoBanner"
};

WX_UIRegisterInfos.push(videoBannerAdInfo);

var QQ_UIRegisterInfos = [], moreGameEntranceInfo$3 = {
key: QQ_UIKeys.MoreGameEntrance,
zIndex: 11,
isAutoDestory: !1,
cls: cls$q,
clsPath: "0b0e75LOmVKxZG6oUUZW6Ma",
prefab: "Entrance",
bundle: "hl_entrance"
};

QQ_UIRegisterInfos.push(moreGameEntranceInfo$3);

var crazyClickInfo$1 = {
key: QQ_UIKeys.CrazyClick,
zIndex: 102,
isAutoDestory: !1,
cls: cls$d,
clsPath: "3809fDls7ZNgqNcvRwMA8Bo",
prefab: "CrazyClick",
bundle: "hl_crazy_click"
};

QQ_UIRegisterInfos.push(crazyClickInfo$1);

var TT_UIRegisterInfos = [], moreGameEntranceInfo$2 = {
key: TT_UIKeys.MoreGameEntrance,
zIndex: 11,
isAutoDestory: !1,
cls: cls$q,
clsPath: "script/game/ui/popup/MoreGameEntrance.js",
prefab: "hlsdk/res/prefab/moreGameEntrance.json",
customResPathes: [ "hlsdk/res/more_game_btn.png", "hlsdk/res/red_dot.png", "hlsdk/res/more_game_btn_fliped.png" ]
};

TT_UIRegisterInfos.push(moreGameEntranceInfo$2);

var crazyClickInfo = {
key: TT_UIKeys.CrazyClick,
zIndex: 102,
isAutoDestory: !1,
cls: cls$d,
clsPath: "script/game/ui/popup/CrazyClickPopup.js",
prefab: "hlsdk/res/prefab/crazyClick.json",
customResPathes: [ "hlsdk/res/crazyClick/bg.png", "hlsdk/res/crazyClick/box.png", "hlsdk/res/crazyClick/button.png", "hlsdk/res/crazyClick/finger.png", "hlsdk/res/crazyClick/progress_bg.png", "hlsdk/res/crazyClick/progress_fill$bar.png", "hlsdk/res/crazyClick/progress_fill.png", "hlsdk/res/crazyClick/tips.png", "hlsdk/res/crazyClick/title.png" ]
};

TT_UIRegisterInfos.push(crazyClickInfo);

var cls$a = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.NativeBanner, this._nativeAdObj = null, this._nativeAdInfo = null;
},
onInitUI: function() {
this.bindName(this, this.node, [ "bg", "closeBtn", "advBtn", "checkBtn", "title", "desc" ]), 
this.bg && this.bg.on("click", this.onAdvTouched, this), this.advBtn && this.advBtn.on("click", this.onAdvTouched, this), 
this.checkBtn && this.checkBtn.on("click", this.onAdvTouched, this), this.closeBtn && this.closeBtn.on("click", this.onCloseTouched, this);
},
onInit: function(e) {
var t = this;
this._super(e);
var n = QGAdv.getNextNativeAdInfo();
if (n) {
var o = n[0], i = n[1];
o && i ? (this._nativeAdInfo = o, this._nativeAdInfo = i, this.title && (this.title.getComponent(cc.Label).string = i.title), 
this.desc && (this.desc.getComponent(cc.Label).string = i.desc), this.advBtn && i.imgUrlList.length > 0 && (this.advBtn.active = !1, 
cc.assetManager.loadRemote(i.imgUrlList[0], function(e, n) {
t.advBtn.active = !0, t.advBtn.getComponent(cc.Sprite).spriteFrame = new cc.SpriteFrame(n);
}))) : this.hidePage();
} else this.hidePage();
},
onHide: function() {
this._super(), this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdHide(), 
this._nativeAdObj = null, this._nativeAdInfo = null);
},
onAdvTouched: function() {
this._clickAdv(), this.hidePage();
},
onCloseTouched: function() {
this.hidePage();
},
_clickAdv: function() {
this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdClick(this._nativeAdObj, this._nativeAdInfo.adId, this._nativeAdInfo.localAdID), 
this._nativeAdObj = null, this._nativeAdInfo = null);
}
}), cls$9 = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.NativeBottomBanner, this._nativeAdObj = null, this._nativeAdInfo = null;
},
onInitUI: function() {
this.bindName(this, this.node, [ "checkBtn", "closeBtn", "advBtn" ]), this.advBtn && this.advBtn.on("click", this.onAdvTouched, this), 
this.checkBtn && this.checkBtn.on("click", this.onAdvTouched, this), this.closeBtn && this.closeBtn.on("click", this.onCloseTouched, this);
},
onInit: function(e) {
var t = this;
this._super(e);
var n = QGAdv.getNextNativeAdInfo();
if (n) {
var o = n[0], i = n[1];
o && i ? (this._nativeAdInfo = o, this._nativeAdInfo = i, this.advBtn && i.imgUrlList.length > 0 && (this.advBtn.active = !1, 
cc.assetManager.loadRemote(i.imgUrlList[0], function(e, n) {
t.advBtn.active = !0, t.advBtn.getComponent(cc.Sprite).spriteFrame = new cc.SpriteFrame(n);
}))) : this.hidePage();
} else this.hidePage();
},
onHide: function() {
this._super(), this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdHide(), 
this._nativeAdObj = null, this._nativeAdInfo = null);
},
onAdvTouched: function() {
this._clickAdv(), this.hidePage();
},
onCloseTouched: function() {
this.hidePage();
},
_clickAdv: function() {
this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdClick(this._nativeAdObj, this._nativeAdInfo.adId, this._nativeAdInfo.localAdID), 
this._nativeAdObj = null, this._nativeAdInfo = null);
}
}), cls$8 = cc.Class({
extends: cls$p,
ctor: function() {
this._pageKey = UIKeys.NativeMiddleBanner, this._nativeAdObj = null, this._nativeAdInfo = null;
},
onInitUI: function() {
this.bindName(this, this.node, [ "bg", "closeBtn", "advBtn", "checkBtn", "desc" ]), 
this.bg && this.bg.on("click", this.onAdvTouched, this), this.advBtn && this.advBtn.on("click", this.onAdvTouched, this), 
this.checkBtn && this.checkBtn.on("click", this.onAdvTouched, this), this.closeBtn && this.closeBtn.on("click", this.onCloseTouched, this);
},
onInit: function(e) {
var t = this;
this._super(e), this.bg && (e.fromTopPercent > 0 ? (this.bg.getComponent(cc.Widget).top = e.fromTopPercent / 100 * (this.node && this.node.parent ? this.node.parent.height : cc.winSize.height), 
console.error("TOP:  " + this.bg.getComponent(cc.Widget).top)) : this.bg.getComponent(cc.Widget).top = 0);
var n = QGAdv.getNextNativeAdInfo();
if (n) {
var o = n[0], i = n[1];
o && i ? (this._nativeAdInfo = o, this._nativeAdInfo = i, this.desc && (this.desc.getComponent(cc.Label).string = i.desc), 
this.advBtn && i.imgUrlList.length > 0 && (this.advBtn.active = !1, cc.assetManager.loadRemote(i.imgUrlList[0], function(e, n) {
t.advBtn.active = !0, t.advBtn.getComponent(cc.Sprite).spriteFrame = new cc.SpriteFrame(n);
}))) : this.hidePage();
} else this.hidePage();
},
onHide: function() {
this._super(), this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdHide(), 
this._nativeAdObj = null, this._nativeAdInfo = null);
},
onAdvTouched: function() {
this._clickAdv(), this.hidePage();
},
onCloseTouched: function() {
this.hidePage();
},
_clickAdv: function() {
this._nativeAdObj && this._nativeAdInfo && (QGAdv.reportNativeAdClick(this._nativeAdObj, this._nativeAdInfo.adId, this._nativeAdInfo.localAdID), 
this._nativeAdObj = null, this._nativeAdInfo = null);
}
}), OPPO_UIRegisterInfos = [], moreGameEntranceInfo$1 = {
key: OPPO_UIKeys.MoreGameEntrance,
zIndex: 11,
isAutoDestory: !1,
cls: cls$q,
clsPath: "0b0e75LOmVKxZG6oUUZW6Ma",
prefab: "Entrance",
bundle: "hl_entrance"
};

OPPO_UIRegisterInfos.push(moreGameEntranceInfo$1);

var nativeBannerInfo$1 = {
key: OPPO_UIKeys.NativeBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$a,
clsPath: "2d8a7XGdnNLrIPDrTC7sg+8",
prefab: "NativeBannerAd",
bundle: "hl_nativeBanner"
};

OPPO_UIRegisterInfos.push(nativeBannerInfo$1);

var nativeBottomInfo$1 = {
key: OPPO_UIKeys.NativeBottomBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$9,
clsPath: "11ab0TnZYZAw4TMzQNaE3vt",
prefab: "NativeBottomAd",
bundle: "hl_nativeBottomAd"
};

OPPO_UIRegisterInfos.push(nativeBottomInfo$1);

var nativeMiddleInfo$1 = {
key: OPPO_UIKeys.NativeMiddleBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$8,
clsPath: "dad36WTEIFHk5RpbbWZzg0P",
prefab: "NativeMiddleAd",
bundle: "hl_nativeMiddleAd"
};

OPPO_UIRegisterInfos.push(nativeMiddleInfo$1);

var VIVO_UIRegisterInfos = [], moreGameEntranceInfo = {
key: VIVO_UIKeys.MoreGameEntrance,
zIndex: 11,
isAutoDestory: !1,
cls: cls$q,
clsPath: "0b0e75LOmVKxZG6oUUZW6Ma",
prefab: "Entrance",
bundle: "hl_entrance"
};

VIVO_UIRegisterInfos.push(moreGameEntranceInfo);

var nativeBannerInfo = {
key: VIVO_UIKeys.NativeBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$a,
clsPath: "2d8a7XGdnNLrIPDrTC7sg+8",
prefab: "NativeBannerAd",
bundle: "hl_nativeBanner"
};

VIVO_UIRegisterInfos.push(nativeBannerInfo);

var nativeBottomInfo = {
key: VIVO_UIKeys.NativeBottomBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$9,
clsPath: "11ab0TnZYZAw4TMzQNaE3vt",
prefab: "NativeBottomAd",
bundle: "hl_nativeBottomAd"
};

VIVO_UIRegisterInfos.push(nativeBottomInfo);

var nativeMiddleInfo = {
key: VIVO_UIKeys.NativeMiddleBanner,
zIndex: 12,
isAutoDestory: !1,
cls: cls$8,
clsPath: "dad36WTEIFHk5RpbbWZzg0P",
prefab: "NativeMiddleAd",
bundle: "hl_nativeMiddleAd"
};

VIVO_UIRegisterInfos.push(nativeMiddleInfo);

var cls$7 = cc.Class({
extends: cls$y,
ctor: function() {
this._bg = null, this._content = null, this._maxContendWidth = .8 * cc.winSize.width;
},
onLoad: function() {
this._initUI(), this._doClean();
},
_initUI: function() {
var e = seekNodeByName(this.node, "bg").getComponent(cc.Sprite);
e && (this._bg = e);
var t = seekNodeByName(this.node, "content").getComponent(cc.Label);
t && (this._content = t);
},
onInit: function(e) {
this._doClean(), this._content.node.x = 0, this._content.node.y = 0, this._content.overflow = cc.Label.Overflow.NONE, 
this._content.string = e, cc.ENGINE_VERSION >= "2.2" ? this._content._forceUpdateRenderData() : this._content._updateRenderData(!0), 
this._content.node.width > this._maxContendWidth && (this._content.overflow = cc.Label.Overflow.RESIZE_HEIGHT, 
this._content.node.width = this._maxContendWidth, cc.ENGINE_VERSION >= "2.2" ? this._content._forceUpdateRenderData() : this._content._updateRenderData(!0)), 
this._bg.node.width = this._content.node.width + 30, this._bg.node.height = this._content.node.height + 30, 
this._bg.node.runAction(cc.sequence(cc.delayTime(2), cc.callFunc(function() {
UIManager.hideUI(UIKeys.Tips);
})));
},
onHide: function() {
this._doClean();
},
_doClean: function() {
this._bg.node.stopAllActions();
}
}), cls$6 = cc.Class({
extends: cls$y,
ctor: function() {
this._bg = null, this._title = null, this._content = null, this._cancelBtn = null, 
this._confirmBtn = null, this._singleConfirmBtn = null, this._cb = null;
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = seekNodeByName(this.node, "bg").getComponent(cc.Sprite);
e && (this._bg = e);
var t = seekNodeByName(this.node, "title").getComponent(cc.Label);
t && (this._title = t);
var n = seekNodeByName(this.node, "content").getComponent(cc.Label);
n && (this._content = n);
var o = seekNodeByName(this.node, "cancelBtn").getComponent(cc.Button);
o && (o.node.on("click", this.onCancelTouched, this), this._cancelBtn = o);
var i = seekNodeByName(this.node, "confirmBtn").getComponent(cc.Button);
i && (i.node.on("click", this.onConfirmTouched, this), this._confirmBtn = i);
var a = seekNodeByName(this.node, "singleConfirmBtn").getComponent(cc.Button);
a && (a.node.on("click", this.onConfirmTouched, this), this._singleConfirmBtn = a);
},
onInit: function(e) {
var t = this;
this._cb = e.cb, this._title && (e.title ? (this._title.node.active = !0, this._title.string = e.title, 
this._bg && (this._bg.node.height = 266)) : (this._title.node.active = !1, this._bg && (this._bg.node.height = 226))), 
this._content && e.content && (this._content.string = e.content), this._cancelBtn && (e.cancelText ? this._setBtnText(this._cancelBtn, e.cancelText) : this._setBtnText(this._cancelBtn, "取消"), 
e.cancelColor ? this._setBtnTextColor(this._cancelBtn, e.cancelColor) : this._setBtnTextColor(this._cancelBtn, cc.color(0, 0, 0))), 
[ this._confirmBtn, this._singleConfirmBtn ].forEach(function(n) {
e.confirmText ? t._setBtnText(n, e.confirmText) : t._setBtnText(n, "确定"), e.confirmColor ? t._setBtnTextColor(n, e.confirmColor) : t._setBtnTextColor(n, cc.color(87, 107, 149));
}), e.showCancel ? (this._cancelBtn.node.active = this._confirmBtn.node.active = !0, 
this._singleConfirmBtn.node.active = !1) : (this._cancelBtn.node.active = this._confirmBtn.node.active = !1, 
this._singleConfirmBtn.node.active = !0);
},
onCancelTouched: function() {
UIManager.hideUI(UIKeys.Modal), doCallback$1(this._cb, !1);
},
onConfirmTouched: function() {
UIManager.hideUI(UIKeys.Modal), doCallback$1(this._cb, !0);
},
_setBtnText: function(e, t) {
e && (e._text || (e._text = e.node.getChildByName("text").getComponent(cc.Label)), 
e._text.string = t);
},
_setBtnTextColor: function(e, t) {
e && (e._text && e._textOutline || (e._text = e.node.getChildByName("text").getComponent(cc.Label), 
e._textOutline = e._text.node.getComponent(cc.LabelOutline)), "string" == typeof t ? (e._text.node.color = cc.color(t), 
e._textOutline.color = cc.color(t)) : (e._text.node.color = t, e._textOutline.color = t));
}
}), C_Max_Str_Length_Of_Loading_Content = 14, cls$5 = cc.Class({
extends: cls$y,
ctor: function() {
this._bg = null, this._icon = null, this._content = null;
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = seekNodeByName(this.node, "bg").getComponent(cc.Sprite);
e && (this._bg = e);
var t = seekNodeByName(this.node, "icon").getComponent(cc.Sprite);
t && (t.rotateForever = function() {
t._isRotating || (t._isRotating = !0, Scheduler.schedule("Rotate_Of_Loading_Icon", function() {
t.node.angle = (t.node.angle - 45) % 360;
}, !1, 100));
}, t.stopRotate = function() {
t._isRotating && (t._isRotating = !1, t.node.angle = 0, Scheduler.unschedule("Rotate_Of_Loading_Icon"));
}, t._isRotating = !1, this._icon = t);
var n = seekNodeByName(this.node, "content").getComponent(cc.Label);
n && (this._content = n);
},
onShow: function() {
this._icon && this._icon.rotateForever();
},
onInit: function(e) {
this._content && (this._content.string = cutString(e, 14));
},
onHide: function() {
this._icon && this._icon.stopRotate();
}
}), cls$4 = cc.Class({
extends: cls$y,
ctor: function() {
this._finger = null, this._release = null, this._press = null;
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = seekNodeByName(this.node, "finger");
e && (this._finger = e);
var t = seekNodeByName(this.node, "release");
t && (this._release = t);
var n = seekNodeByName(this.node, "press");
n && (this._press = n);
},
onInit: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 2e3;
this._release.active = !0, this._press.active = !1, this.fixPos(e), Scheduler.schedule("Auto_Change_Fingers", function() {
t._release.active = !t._release.active, t._press.active = !t._press.active;
}, !1, 200), n > 0 && Scheduler.schedule("Auto_Close_Finger", function() {
UIManager.hideUI(UIKeys.Finger).catch(function() {});
}, !1, n, 1);
},
fixPos: function(e) {
var t = this._finger.parent.convertToNodeSpaceAR(e);
this._finger.x = t.x, this._finger.y = t.y;
},
onHide: function() {
Scheduler.unschedule("Auto_Change_Fingers"), Scheduler.unschedule("Auto_Close_Finger");
}
}), cls$3 = cc.Class({
extends: cls$y,
ctor: function() {},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = seekNodeByName(this.node, "blockBtn").getComponent(cc.Button);
e && e.node.on("click", this.onBlockTouched, this);
},
onInit: function() {},
onHide: function() {},
onBlockTouched: function() {
console.log("view flow is progressing...");
}
}), cls$2 = cc.Class({
extends: cls$y,
ctor: function() {
this.Frames = {}, this.Privates = {};
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = this;
this.ConfirmUI = seekNodeByName(this.node, "ConfirmUI"), this.BaseUI = seekNodeByName(this.node, "BaseUI"), 
this.InfoUI = seekNodeByName(this.node, "InfoUI"), this.Content = seekNodeByName(this.node, "content"), 
this.LabPanel = seekNodeByName(this.node, "LabPanel"), this.LabPanel1 = seekNodeByName(this.node, "LabPanel1"), 
this.LabText = seekNodeByName(this.node, "LabText").getComponent(cc.Label), this.LabText.string = "";
var t = seekNodeByName(this.node, "UnagreenBtn").getComponent(cc.Button);
t && (this._UnagreenBtn = t, t.node.on("click", function() {
e.onConfirmExit();
}, null));
var n = seekNodeByName(this.node, "ConfirmExit").getComponent(cc.Button);
n && n.node.on("click", function() {
e.onConfirmExit();
}, null);
var o = seekNodeByName(this.node, "BackAgreenBtn").getComponent(cc.Button);
o && o.node.on("click", function() {
e.onBackAgreenBon();
}, null);
var i = seekNodeByName(this.node, "ConfirmCloseBtn").getComponent(cc.Button);
i && i.node.on("click", function() {
e.onConfirmCloseBtn();
}, null);
var a = seekNodeByName(this.node, "AgreenBtn").getComponent(cc.Button);
a && (this._AgreenBtn = a, a.node.on("click", function() {
e.onAgreenBtn();
}, null));
var r = seekNodeByName(this.node, "ServiceBtn").getComponent(cc.Button);
r && r.node.on("click", function() {
e.onServiceBtn();
}, null);
var s = seekNodeByName(this.node, "PrivacyBtn").getComponent(cc.Button);
s && s.node.on("click", function() {
e.onPrivacyBtn();
}, null);
var l = seekNodeByName(this.node, "closeBtn").getComponent(cc.Button);
l && (this._closeBtn = l, l.node.on("click", function() {
e.oncloseBtn();
}, this));
var c = seekNodeByName(this.node, "OkBtn").getComponent(cc.Button);
c && c.node.on("click", function() {
e.onOkBtn();
}, null), this.LabValue = seekNodeByName(this.node, "LabValue").getComponent(cc.WebView);
},
onInit: function() {
var e = "1" == cc.sys.localStorage.getItem("Private");
if (0 != HLSDKLocalData$1._witchPrivacy) return 1 == HLSDKLocalData$1._witchPrivacy ? (this.BaseUI.active = !1, 
this.ConfirmUI.active = !1, void this.onPrivacyBtn()) : (this.BaseUI.active = !1, 
this.ConfirmUI.active = !1, void this.onServiceBtn());
this.ConfirmUI.active = !1, this.InfoUI.active = !1, this._UnagreenBtn.node.active = !e, 
this._AgreenBtn.node.active = !e, this._closeBtn.node.active = e, this.Tips = 1;
},
onUnagreenBtn: function() {
this.Tips ? (this.ConfirmUI.active = !0, this.Tips = 0) : PlatHelper.exitApp();
},
onConfirmExit: function() {
PlatHelper.exitApp();
},
onBackAgreenBon: function() {
this.ConfirmUI.active = !1;
},
onConfirmCloseBtn: function() {
this.ConfirmUI.active = !1;
},
onAgreenBtn: function() {
cc.sys.localStorage.setItem("Private", "1"), UIManager.hideUI(UIKeys.Private);
},
onServiceBtn: function() {
this.initHTMLFrame("https://r.game.hnquyou.com/upload/games/privacy/agreement.txt?timespace=" + Date.now(), 2);
},
onPrivacyBtn: function() {
this.initHTMLFrame("https://r.game.hnquyou.com/upload/games/privacy/privacy2.html?company" + HLSDK_CFG.CompanyName, 1);
},
initHTMLFrame: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 1;
null != window.qq || null != window.qg || null != window.wx ? (this.request(e, t), 
this.LabPanel.active = !1, this.LabPanel1.active = !0) : (this.LabValue.url = e, 
this.LabPanel.active = !0, this.LabPanel1.active = !1), this.InfoUI.active = !0;
},
request: function(e, t) {
var n = this;
if (this.Content.height = 0, null == this.Privates[t]) {
this.Privates[t] = "";
var o = cc.loader.getXMLHttpRequest();
o.open("GET", e, !0), o.onload = function() {
4 == o.readyState && o.status >= 200 && o.status < 300 && (n.Privates[t] = n.processLab(o.responseText), 
n.LabText.string = n.Privates[t], n.LabText._onBlendChanged(), cc.ENGINE_VERSION >= "2.2" ? n.LabText._forceUpdateRenderData() : n.LabText._updateRenderData(!0), 
n.Content.height = n.LabText.node.height);
}, o.ontimeout = function(e) {
console.error(e);
}, o.onerror = function(e) {
console.error(e);
}, o.setRequestHeader("content-type", "application/x-www-form-urlencoded"), o.send(null);
} else this.LabText.string = this.Privates[t], this.LabText._onBlendChanged(), cc.ENGINE_VERSION >= "2.2" ? this.LabText._forceUpdateRenderData() : this.LabText._updateRenderData(!0), 
this.Content.height = this.LabText.node.height;
},
processLab: function(e) {
var t = 0, n = 0, o = "";
if (-1 != (t = (e = (e = (e = (e = (e = (e = (e = (e = (e = (e = e.replace(/\[\u672c\u6e38\u620f\]/g, HLSDK_CFG.GameName)).substring(e.indexOf("<body>"))).replace(/\[\u672c\u516c\u53f8\]/g, HLSDK_CFG.CompanyName)).substring(e.indexOf("<body>"))).replace(/ /g, "")).replace(/&emsp;/g, "")).replace(/&ldquo;/g, "")).replace(/&rdquo;/g, "")).replace(/&nbsp;/g, "")).replace(/\;/g, "")).indexOf(">", n))) {
for (n = e.indexOf("<", t); t >= 0 && n >= 0; ) o += e.substring(t + 1, n), t = e.indexOf(">", n), 
n = e.indexOf("<", t);
for (o = (o += e.substring(t + 1, e.length - 1)).substring(0, o.indexOf("function")); 0 == o.indexOf("\n"); ) o = o.replace("\n", "");
return o;
}
return e;
},
oncloseBtn: function() {
UIManager.hideUI(UIKeys.Private);
},
onOkBtn: function() {
0 != HLSDKLocalData$1._witchPrivacy ? UIManager.hideUI(UIKeys.Private) : this.InfoUI.active = !1;
}
}), cls$10 = cc.Class({
extends: cls$y,
ctor: function() {
this.announcementStr = [ "亲爱的玩家：\n", "  自游戏上线以来，在你们的陪伴下，我们一起度过了无数个欢乐的时光，您的不离不弃一直是我们最大的鼓励！您的宽容理解也将成为我们最珍贵的回忆！在此想所有玩家致以最真诚的感谢！\n", "  由于游戏运营策略调整，我们怀着万分遗憾的心情宣布：本游戏将在[下线时间]停止运营，届时将关闭服务器入口。\n\n", "  在此期间，我们将会继续努力做好最后的运营工作，再次感谢玩家的理解和支持，同时也对此次小游戏停止运营给您造成的不便深感歉意！\n\n", "后续关服安排：\n", "  关闭服务器时间：[下线时间]12:00\n\n", "[游戏名称]运营团队\n\n", "[发布公告时间]" ];
},
onLoad: function() {
this._initUI();
},
_initUI: function() {
var e = this;
this.okBtn = seekNodeByName(this.node, "okBtn").getComponent(cc.Button), this.okBtn.node.on("click", function() {
e.onOkBtn();
}, null), this.changeAnnounce();
},
onOkBtn: function() {
UIManager.hideUI(UIKeys.Announcement);
},
changeAnnounce: function() {
for (var e = this.announcementStr, t = "", n = 0; n < e.length; n++) {
var o = e[n];
-1 != o.indexOf("[游戏名称]") && (o = o.replace("[游戏名称]", HLSDK_CFG.GameName)), -1 != o.indexOf("[发布公告时间]") && (o = o.replace("[发布公告时间]", HLSDKLocalData$1._qqAnnouncementData[0])), 
-1 != o.indexOf("[下线时间]") && (o = o.replace("[下线时间]", HLSDKLocalData$1._qqAnnouncementData[1])), 
t += o;
}
this.LabValue = seekNodeByName(this.node, "LabValue").getComponent(cc.Label), this.LabValue.fontSize = 27, 
this.LabValue.string = t;
}
}), modalInfo = {
key: UIKeys.Modal,
zIndex: 996,
isAutoDestory: !1,
cls: cls$6,
clsPath: "a404fPlWwxBxaekL9ouvwXf",
prefab: "Modal",
bundle: "hl_interact"
}, loadingInfo = {
key: UIKeys.Loading,
zIndex: 998,
isAutoDestory: !1,
cls: cls$5,
clsPath: "b79bdWmlZdLnYRjwkBoYT6P",
prefab: "Loading",
bundle: "hl_interact"
}, tipsInfo = {
key: UIKeys.Tips,
zIndex: 999,
isAutoDestory: !1,
cls: cls$7,
clsPath: "c1c82g/DWBMZYYFEqhDOtwL",
prefab: "Tips",
bundle: "hl_interact"
}, fingerInfo = {
key: UIKeys.Finger,
zIndex: 990,
isAutoDestory: !1,
cls: cls$4,
clsPath: "e1f8dR1hBpC/Y4v1hdK0w+Q",
prefab: "Finger",
bundle: "hl_interact"
}, maskInfo = {
key: UIKeys.Mask,
zIndex: 100,
isAutoDestory: !1,
cls: cls$3,
clsPath: "80a7cmufqBOU4WGEcqyqSX2",
prefab: "Mask",
bundle: "hl_interact"
}, privateInfo = {
key: UIKeys.Private,
zIndex: 100,
isAutoDestory: !1,
cls: cls$2,
clsPath: "818248VDUFE5IJP+blA+mWt",
prefab: "AgreementUI",
bundle: "hl_agreement"
}, announcementInfo = {
key: UIKeys.Announcement,
zIndex: 100,
isAutoDestory: !1,
cls: cls$10,
clsPath: "f1771MyTMxA1pboYtzWrdG1",
prefab: "AnnoucementUI",
bundle: "hl_announcement"
}, UIRegisterInfos = null;

isLoadQQConfig() ? UIRegisterInfos = [ fingerInfo, maskInfo, privateInfo, announcementInfo ].concat(QQ_UIRegisterInfos) : isLoadTTConfig() ? UIRegisterInfos = [ fingerInfo, maskInfo, tipsInfo, privateInfo, announcementInfo ].concat(TT_UIRegisterInfos) : isLoadOPPOConfig() ? UIRegisterInfos = [ fingerInfo, maskInfo, tipsInfo, privateInfo, announcementInfo ].concat(OPPO_UIRegisterInfos) : isLoadVIVOConfig() ? UIRegisterInfos = [ fingerInfo, maskInfo, tipsInfo, privateInfo, announcementInfo ].concat(VIVO_UIRegisterInfos) : isLoadWXConfig() ? UIRegisterInfos = [ maskInfo ] : console.error("Not Support This Platform, check hlsdk_config.js first..."), 
_isWINPlatform() && (-1 === UIRegisterInfos.indexOf(modalInfo) && UIRegisterInfos.push(modalInfo), 
-1 === UIRegisterInfos.indexOf(loadingInfo) && UIRegisterInfos.push(loadingInfo), 
-1 === UIRegisterInfos.indexOf(tipsInfo) && UIRegisterInfos.push(tipsInfo), -1 === UIRegisterInfos.indexOf(privateInfo) && UIRegisterInfos.push(privateInfo), 
-1 === UIRegisterInfos.indexOf(announcementInfo) && UIRegisterInfos.push(announcementInfo)), 
UIRegisterInfos.forEach(function(e) {
e.prefab = convertToScreneOrientationPrefabPath(e.prefab);
});

var UIRegisterInfos$1 = UIRegisterInfos, WX_UIBundles = [], QQ_UIBundles = [], TT_UIBundles = [], OPPO_UIBundles = [], VIVO_UIBundles = [], UIBaseBundles = [ "hl_core", "hl_interact" ], UIBundles = [];

isLoadQQConfig() ? UIBundles = UIBaseBundles.concat(QQ_UIBundles) : isLoadTTConfig() ? UIBundles = UIBaseBundles.concat(TT_UIBundles) : isLoadOPPOConfig() ? UIBundles = UIBaseBundles.concat(OPPO_UIBundles) : isLoadVIVOConfig() ? UIBundles = UIBaseBundles.concat(VIVO_UIBundles) : isLoadWXConfig() ? UIBundles = UIBaseBundles.concat(WX_UIBundles) : console.error("Not Support This Platform, check hlsdk_config.js first...");

var UIBundles$1 = UIBundles, cls$1 = cc.Class({
extends: cc.Component,
properties: {
gap: {
default: 1,
tooltip: "点击间隔（秒）",
type: cc.Float
},
_scheduleKeyOfEnableButtonDelay: ""
},
editor: !1,
onEnable: function() {
this.node.on("click", this.onClick, this);
},
onDisable: function() {
this.node.off("click", this.onClick, this);
},
onDestroy: function() {
"" !== this._scheduleKeyOfEnableButtonDelay && (G_Scheduler.unschedule(this._scheduleKeyOfEnableButtonDelay), 
this._scheduleKeyOfEnableButtonDelay = "");
},
onClick: function() {
var e = this;
"" === this._scheduleKeyOfEnableButtonDelay && (this._disableTouchOnNextFrame(), 
this._scheduleKeyOfEnableButtonDelay = "enable_touch_delay_" + G_Utils.generateString(32), 
G_Scheduler.schedule(this._scheduleKeyOfEnableButtonDelay, function() {
e._scheduleKeyOfEnableButtonDelay = "", e.node.isValid && e._enableTouchOnNextFrame();
}, this.gap, 1));
},
_enableTouchOnNextFrame: function() {
this.node.isValid && (this.node.getComponent(cc.Button).interactable = !0);
},
_disableTouchOnNextFrame: function() {
var e = this;
G_Scheduler.schedule("disable_touch_on_next_frame", function() {
e.node.isValid && (e.node.getComponent(cc.Button).interactable = !1);
}, 0, 0);
}
}), cls = cc.Class({
extends: cc.Component,
properties: {
disableIfUninteractable: !0,
clickAudio: {
default: null,
type: cc.AudioClip
}
},
editor: !1,
onEnable: function() {
this.node.on("click", this.onClick, this);
},
onDisable: function() {
this.node.off("click", this.onClick, this);
},
onClick: function() {
this._checkEnable() && (this.clickAudio ? AudioMgr.playSound(this.clickAudio) : console.log("the clip of button is null..."));
},
_checkEnable: function() {
return !(this.disableIfUninteractable && !this.node.getComponent(cc.Button).interactable);
}
});

function getRunningScene() {
return isCocosEngine() ? cc.director.getScene() : null;
}

function formatWebBundleUrl(e, t) {
return isLoadLandscapeConfig$1() ? formatString("https://image.game.hnquyou.com/upload/HLSDK/Cocos_Bundles/{0}/{1}_landscape/{2}", e, t, e) : formatString("https://image.game.hnquyou.com/upload/HLSDK/Cocos_Bundles/{0}/{1}/{2}", e, t, e);
}

var _UIManager = function() {
function e() {
_classCallCheck2(this, e);
this._UIInfos = {}, this._UIRoot = null;
}
_createClass2(e, [ {
key: "registerAllUIs",
value: function(e) {
var t = this, n = cc.js._setClassId;
n("86702gdpN9C8LL0nG4nE6dX", cls$r), n("9ac68kKSuxHWLBbqk48ofvG", cls$k), n("c5628tnHqRHVpMttWxmwe21", cls$t), 
n("e4e94zhynlAbL8+RahKxQjO", cls$1), n("472f67kIvVBR5pJdi0Zt7h/", cls$o), n("70ec0BoW05GNY2RbIFTyEpx", cls), 
n("8f6e0VFlK1Eq7dFPdJZ9Fue", cls$v), n("a30c80yrSlIMaJT8wsULf4w", cls$f);
var o = [].concat(UIBundles$1);
UIRegisterInfos$1.forEach(function(e) {
n(e.clsPath, e.cls), -1 === o.indexOf(e.bundle) && o.push(e.bundle), Array.isArray(e.dependentBundles) && e.dependentBundles.forEach(function(e) {
-1 === o.indexOf(e) && o.push(e);
}), t._registerUI(e.key, e.zIndex, e.isAutoDestory, e.cls, e.prefab, e.bundle);
}), cc.assetManager.loadBundle(formatWebBundleUrl("hl_core", DEFAULT_BUNDLE_TEMPLATE), function(t) {
if (t) console.error(t), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR); else if (o.length > 0 && PreloadConfig.isPreloadResInInit) {
var n = [];
o.forEach(function(e) {
"hl_core" !== e && n.push(new Promise(function(t) {
cc.assetManager.loadBundle(formatWebBundleUrl(e, DEFAULT_BUNDLE_TEMPLATE), function(e) {
e ? (console.error(e), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR)) : t();
});
}));
}), n.length > 0 ? Promise.all(n).then(function() {
doCallback$1(e);
}) : doCallback$1(e);
} else doCallback$1(e);
});
}
}, {
key: "unregisterAllUIs",
value: function() {
for (var e in this._UIInfos) {
var t = this._UIInfos[e];
this._destroyUI(t);
}
this._UIInfos = {};
}
}, {
key: "tempHideAllUIs",
value: function() {
var e = this, t = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, n = function(t) {
var n = e.getUI(t);
if (Array.isArray(n)) {
var o = n[0], i = n[1];
if (o && i && i.isOnShow()) return i.hideUI(), i;
}
return null;
};
!0 === t.couplet && (HLSDKLocalData$1._tempHides.ui.couplet = n(UIKeys.Couplet)), 
!0 === t.scroll && (HLSDKLocalData$1._tempHides.ui.scroll = n(UIKeys.Scroll), HLSDKLocalData$1._tempHides.ui.scrollWithName = n(UIKeys.ScrollWithName)), 
!0 === t.matrix && (HLSDKLocalData$1._tempHides.ui.matrix = n(UIKeys.Matrix)), !0 === t.MoreGameEntrance && (HLSDKLocalData$1._tempHides.ui.MoreGameEntrance = n(UIKeys.MoreGameEntrance)), 
!0 === t.VideoBanner && (HLSDKLocalData$1._tempHides.ui.VideoBanner = n(UIKeys.VideoBanner));
}
}, {
key: "showAllTempHideUIs",
value: function() {
for (var e in HLSDKLocalData$1._tempHides.ui) {
var t = HLSDKLocalData$1._tempHides.ui[e];
t && (t.tempShowUI(), HLSDKLocalData$1._tempHides.ui[e] = null);
}
}
}, {
key: "showUI",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : DEFAULT_BUNDLE_TEMPLATE, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, i = this._doCheck(e, "showUI");
if (i) {
var a = function(e) {
return i.closeCb = o, i.node.zIndex = i.zIndex, i.clsObj.showUI.apply(i.clsObj, e), 
new Promise(function(e) {
e([ i.node, i.clsObj ]);
});
}, r = [];
arguments.length > 3 && ((r = Array.prototype.slice.call(arguments)).shift(), r.shift(), 
r.shift()), checkString(n) || (n = DEFAULT_BUNDLE_TEMPLATE);
var s = function() {
if (i.tpl = n, i.node) return a(r);
var e = function(e) {
return new Promise(function(n, o) {
var s = function(s) {
if (i.node) a(r).then(function(e) {
n(e);
}); else {
i.node = cc.instantiate(s), setGroupName(i.node, UIGroupConfig.name), i.clsObj = i.node.getComponent(i.cls), 
i.clsObj.registerBundle(e);
var l = t._getUIRoot();
l ? (l.addChild(i.node), a(r).then(function(e) {
n(e);
})) : o();
}
};
i.prefab ? s(i.prefab) : e.load(i.prefabPath, cc.Prefab, function(e, t) {
e ? (o(e), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR)) : (t.addRef(), i.prefab = t, 
s(t));
});
});
};
if (i.bundle) return e(i.bundle);
var o = cc.assetManager.getBundle(i.bundleName);
return o ? (i.bundle = o, e(i.bundle)) : new Promise(function(t, o) {
cc.assetManager.loadBundle(formatWebBundleUrl(i.bundleName, n), function(n, a) {
n ? (o(n), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR)) : (i.bundle = a, e(a).then(function(e) {
t(e);
}).catch(function(e) {
o(e);
}));
});
});
};
return i.tpl !== n ? new Promise(function(e, n) {
t._destroyUI(i, function() {
s().then(function(t) {
e(t);
}).catch(function(e) {
n(e);
});
});
}) : s();
}
return new Promise(function(e, t) {
t();
});
}
}, {
key: "hideUI",
value: function(e) {
var t = this, n = this._doCheck(e, "hideUI");
return n && n.node && n.clsObj && n.clsObj.isOnShow() ? new Promise(function(e) {
var o = null;
o = function() {
n.clsObj.unregisterCallback("close", o);
var i = n.closeCb;
n.closeCb = null, n.isAutoDestory && t._destroyUI(n), "function" == typeof i && i(), 
e();
}, n.clsObj.registerCallback("close", o), n.clsObj.hideUI();
}) : new Promise(function(e) {
e();
});
}
}, {
key: "hideAllUIs",
value: function() {
var e = this;
return new Promise(function(t) {
var n = [];
for (var o in e._UIInfos) {
var i = e._UIInfos[o];
i && i.node && n.push(e.hideUI(o));
}
n.length > 0 ? Promise.all(n).then(function() {
t();
}) : t();
});
}
}, {
key: "getUI",
value: function(e) {
var t = this._doCheck(e, "getUI");
return t ? [ t.node, t.clsObj ] : null;
}
}, {
key: "zOrderUI",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0, n = this._doCheck(e, "zIndexUI");
n && n.node && (n.node.zIndex = t + n.zIndex);
}
}, {
key: "_getUIRoot",
value: function() {
var e = getRunningScene();
if (!e) return console.error("Not Support Engine..."), null;
if (this._UIRoot) return this._UIRoot.parent || e.addChild(this._UIRoot), this._UIRoot;
if (!this._UIRoot) {
this._UIRoot = new cc.Node(), this._UIRoot.name = "hl_uiRoot", this._UIRoot.pivotX = .5, 
this._UIRoot.pivotY = .5, this._UIRoot.zIndex = 999, this._UIRoot.group = UIGroupConfig.name;
var t = getSceneSize();
DesignSize.width < DesignSize.height ? (this._UIRoot.width = DesignSize.width, this._UIRoot.height = t.height / t.width * DesignSize.width, 
this._UIRoot.scaleX = t.width / DesignSize.width, this._UIRoot.scaleY = this._UIRoot.scaleX) : (this._UIRoot.height = DesignSize.height, 
this._UIRoot.width = t.width / t.height * DesignSize.height, this._UIRoot.scaleY = t.height / DesignSize.height, 
this._UIRoot.scaleX = this._UIRoot.scaleY), this._UIRoot.x = t.width / 2, this._UIRoot.y = t.height / 2, 
e.addChild(this._UIRoot), cc.game.addPersistRootNode(this._UIRoot);
}
return this._UIRoot;
}
}, {
key: "_registerUI",
value: function(e, t, n, o, i, a) {
if (checkString(e)) if (void 0 === this._UIInfos[e]) if (checkString(i)) if (checkString(a)) {
this._UIInfos[e] = {
key: e,
zIndex: t,
isAutoDestory: n,
cls: o,
prefabPath: i,
bundleName: a,
tpl: DEFAULT_BUNDLE_TEMPLATE,
prefab: null,
bundle: null,
node: null,
clsObj: null,
closeCb: null
};
var r = cc.assetManager.getBundle(a);
r && (this._UIInfos[e].bundle = r), console.log(formatString("UIManager.registerUI: {0} UI has registered successful...", e));
} else console.error("UIManager.registerUI: bundleName must be a type of string and not empty..."); else console.error("UIManager.registerUI: prefabPath must be a type of string and not empty..."); else console.error(formatString("UIManager.registerUI: {0} has registered before...", e)); else console.error("UIManager.registerUI: key must be a type of string and not empty...");
}
}, {
key: "_doCheck",
value: function(e, t) {
if (!checkString(e)) return console.error(formatString("UIManager.{0}: key must be a type of string and not empty...", t)), 
null;
var n = this._UIInfos[e];
return void 0 === n ? (console.error(formatString("UIManager.{0}: {1} has not registered before...", t, e)), 
null) : n;
}
}, {
key: "_destroyUI",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
if (e) {
e.bundle && (e.bundle = null);
var n = cc.assetManager.getBundle(e.bundleName);
n && cc.assetManager.removeBundle(n), e.node && (e.node.destroy(), e.node = null), 
e.prefab && (e.prefab.decRef(), e.prefab = null), e.clsObj = null, checkFunc(t) && Scheduler.schedule("delay_show_tpl", function() {
doCallback$1(t);
}, !1, 100, 0);
}
}
} ]);
return e;
}(), UIManager = new _UIManager(), BaseFlow = function() {
function e() {
_classCallCheck2(this, e);
this._flowCfg = null;
}
_createClass2(e, [ {
key: "startFlow",
value: function(e) {
return this._flowCfg = e, this._onStartFlow(e);
}
}, {
key: "endFlow",
value: function() {
return this._flowCfg ? this._onEndFlow(this._flowCfg) : Promise.resolve();
}
}, {
key: "_onStartFlow",
value: function(e) {
return "function" == typeof this.onStartFlow ? this.onStartFlow(e) : Promise.reject("Not Implement...");
}
}, {
key: "_onEndFlow",
value: function(e) {
return "function" == typeof this.onEndFlow ? this.onEndFlow(e) : Promise.reject("Not Implement...");
}
}, {
key: "_checkBlackState",
value: function(e, t) {
return !!isGlobalMistakeEnabled() && checkBlackState(e, t);
}
}, {
key: "_getAdvPagePath",
value: function() {
var e = this._flowCfg.config.advPath;
return checkString(e) ? e.indexOf("/") === e.lastIndexOf("/") ? e : e.substring(0, e.lastIndexOf("/")) : "";
}
} ]);
return e;
}(), BaseComponentFlow = function() {
_inherits2(t, BaseFlow);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._baseZOrder = 0;
return n;
}
_createClass2(t, [ {
key: "startFlow",
value: function(e) {
var n = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
return this._baseZOrder = n, _get2(_getPrototypeOf2(t.prototype), "startFlow", this).call(this, e);
}
}, {
key: "onStartFlow",
value: function(e) {
try {
var t = e.type;
if (-1 === Object.keys(SupportComponentTypes).indexOf(t)) return Promise.reject("Not Support...");
var n = this._checkBlackState(e.blackArea, e.blackScene);
isObject$1(e.config) && !Array.isArray(e.config) ? e.config.isMistakeEnabled = n ? "1" : "0" : e.config = {
isMistakeEnabled: n ? "1" : "0"
}, e.config.advPath = e.workflow_id + "/" + e.node_id + "/" + e.element_id, PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowComponent ? PlatHelper.getPlat().h_ShowComponent(e.config.advPath) : h_ShowComponent(e.config.advPath);
} catch (e) {
return Promise.reject(e);
}
return this.onStartFlow_Extend(e);
}
}, {
key: "onStartFlow_Extend",
value: function() {
return Promise.resolve();
}
}, {
key: "onEndFlow",
value: function() {
return Promise.resolve("Not Need...");
}
} ]);
return t;
}(), _ComponentBannerMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this)).DelayID = 0, n.HideBannerID = 0, n.ShowBannerID = 0, n.ShowBannerIndex = 0, 
n.ShowBannerCount = 0, n.ShowBannerTime = 0;
return n;
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
try {
var i = e.config;
if (isLoadWXConfig()) {
t.ShowBannerCount = t.ShowBannerIndex = Number(i.bannerShowCount || 0), t.ShowBannerTime = Number(i.bannerShowTime || 3e4), 
adv_interface.stopAutoRefreshBannerAd();
var a = function() {
t.ShowBannerIndex--, adv_interface.showBannerAd(0, {
min: "1" === i.isMin,
out: "1" === i.isOutScreen,
bannerBottom: i.bannerBottom ? parseFloat(i.bannerBottom) : 0
}, t._getAdvPagePath(), function() {}, function() {}), t.ShowBannerTime > 0 && (t.HideBannerID = setTimeout(r, Math.max(1e3, t.ShowBannerTime)));
}, r = function() {
adv_interface.hideBannerAd(), (t.ShowBannerIndex > 0 || 0 == t.ShowBannerCount) && (t.ShowBannerID = setTimeout(a, Number(i.bannerShowSpace || 0)));
}, s = Number(i.bannerDelay || 0);
s > 0 ? t.DelayID = setTimeout(a, s) : a(), n();
} else {
var l = [];
checkString(i.bannerIndex) && i.bannerIndex.split("||").forEach(function(e) {
NaN !== parseInt(e) && 0 !== parseInt(e) && l.push(parseInt(e));
}), parseInt(i.refreshGap) > 0 && !Switch.isPublishingSync() && !HLSDKLocalData$1._globalBannerCfg.isLongstay ? adv_interface.showAutoRefreshBannerAd(parseInt(i.refreshGap), l, {
min: "1" === i.isMin,
out: "1" === i.isOutScreen
}, t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
}) : (adv_interface.stopAutoRefreshBannerAd(), adv_interface.showBannerAd(l.length > 0 ? l[0] : 0, {
min: "1" === i.isMin,
out: "1" === i.isOutScreen
}, t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
}));
}
} catch (s) {
o(s);
}
});
}
}, {
key: "onEndFlow",
value: function() {
var e = this;
return new Promise(function(t) {
clearTimeout(e.DelayID), clearTimeout(e.HideBannerID), clearTimeout(e.ShowBannerID), 
adv_interface.hideBannerAd(), t();
});
}
} ]);
return t;
}(), ComponentBannerMgr = new _ComponentBannerMgr(), _ComponentCoupletMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
parseInt(i.left) && adv_interface.showComponentAd("couplet", t._getAdvPagePath(), i.leftAdUnitId, {
layout: "left",
left: parseFloat(i.FromLeftPercent),
top: parseFloat(i.leftFromTopPercent)
}, 0, void 0 !== i.leftSize ? parseInt(i.leftSize) : 0, "vertical", !0, function() {
n();
}, function(e) {
o(e);
}), parseInt(i.right) && adv_interface.showComponentAd("couplet", t._getAdvPagePath(), i.rightAdUnitId, {
layout: "right",
left: parseFloat(i.FromRightPercent),
top: parseFloat(i.rightFromTopPercent)
}, 0, void 0 !== i.rightSize ? parseInt(i.rightSize) : 0, "vertical", !0, function() {
n();
}, function(e) {
o(e);
});
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
parseInt(n.left) && adv_interface.hideComponentAd(n.leftAdUnitId), parseInt(n.right) && adv_interface.hideComponentAd(n.rightAdUnitId), 
t();
});
}
} ]);
return t;
}(), ComponentCoupletMgr = new _ComponentCoupletMgr(), _ComponentMatrixMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
if (checkString(i.matrixAdUnitId)) if (isLoadWXConfig()) adv_interface.showComponentAd("matrix", t._getAdvPagePath(), i.matrixAdUnitId, getMatrixInputLayout(i), 0, 0, "landscape", !0, function() {
n();
}, function(e) {
o(e);
}), parseInt(i.preload) && adv_interface.hideComponentAd(i.matrixAdUnitId); else if (isLoadQQConfig()) {
var a = parseInt(i.row), r = i.matrixAdUnitId.split("|");
if (r.length < a) for (var s = r.length + 1; s <= a; s++) r.push(r[r.length - 1]);
for (var l = 0; l < r.length; l++) adv_interface.showComponentAd("matrix", t._getAdvPagePath(), r[l], {
layout: "center",
top: parseFloat(i.fromTopPercent) + 6 * l,
row: parseInt(i.row)
}, 0, parseInt(i.matrixSize), "landscape", !0, function() {
n();
}, function(e) {
o(e);
});
}
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.matrixAdUnitId), t();
});
}
} ]);
return t;
}(), ComponentMatrixMgr = new _ComponentMatrixMgr(), _ComponentScrollMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
if (isLoadWXConfig()) {
var a = getScrollInputLayout(i);
adv_interface.showComponentAd("scroll", t._getAdvPagePath(), i.adUnitId, a, 0, void 0 !== i.blockSize ? parseInt(i.blockSize) : 0, a.orientation, !0, function() {
n();
}, function(e) {
o(e);
});
} else parseInt(i.top) && adv_interface.showComponentAd("scroll", t._getAdvPagePath(), i.topAdUnitId, {
layout: "top",
top: parseFloat(i.fromTopPercent)
}, 0, void 0 !== i.blockSize ? parseInt(i.blockSize) : 0, "landscape", !0, function() {
n();
}, function(e) {
o(e);
}), parseInt(i.bottom) && adv_interface.showComponentAd("scroll", t._getAdvPagePath(), i.bottomAdUnitId, {
layout: "bottom",
bottom: parseFloat(i.fromBottomPercent)
}, 0, void 0 !== i.blockSize ? parseInt(i.blockSize) : 0, "landscape", !0, function() {
n();
}, function(e) {
o(e);
}), parseInt(i.left) && adv_interface.showComponentAd("scroll", t._getAdvPagePath(), i.leftAdUnitId, {
layout: "left",
top: parseFloat(i.fromTopPercent)
}, 0, void 0 !== i.blockSize ? parseInt(i.blockSize) : 0, "vertical", !0, function() {
n();
}, function(e) {
o(e);
}), parseInt(i.right) && adv_interface.showComponentAd("scroll", t._getAdvPagePath(), i.rightAdUnitId, {
layout: "right",
top: parseFloat(i.fromTopPercent)
}, 0, void 0 !== i.blockSize ? parseInt(i.blockSize) : 0, "vertical", !0, function() {
n();
}, function(e) {
o(e);
});
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.adUnitId), t();
});
}
} ]);
return t;
}(), ComponentScrollMgr = new _ComponentScrollMgr(), _ComponentUIMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.type, a = e.config.tpl;
a = "" != a && null != a ? a : DEFAULT_BUNDLE_TEMPLATE, UIManager.showUI(i, a, null, e.config).then(function() {
t._baseZOrder > 0 && UIManager.zOrderUI(i, t._baseZOrder), n();
}).catch(function(e) {
o(e);
});
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t, n) {
var o = e.type;
UIManager.hideUI(o).then(function() {
t();
}).catch(function(e) {
n(e);
});
});
}
} ]);
return t;
}(), ComponentUIMgr = new _ComponentUIMgr(), BasePageFlow = function() {
_inherits2(t, BaseFlow);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this))._isFlowFirstOpen = !1, n._isBackToFlow = !1;
return n;
}
_createClass2(t, [ {
key: "startFlow",
value: function(e) {
var n = !(arguments.length > 1 && void 0 !== arguments[1]) || arguments[1], o = arguments.length > 2 && void 0 !== arguments[2] && arguments[2];
return this._isFlowFirstOpen = n, this._isBackToFlow = o, _get2(_getPrototypeOf2(t.prototype), "startFlow", this).call(this, e);
}
}, {
key: "onStartFlow",
value: function(e) {
try {
var t = e.type;
if (-1 === Object.keys(SupportPageTypes).indexOf(t)) return Promise.reject("Not Support...");
var n = this._checkBlackState(e.blackArea, e.blackScene);
if (void 0 !== e.blacktype && !this._checkBlackTag(e.blacktype, n)) return Promise.reject("Black State...");
if (void 0 !== e.newUser && !this._checkUserTag(e.newUser)) return Promise.reject("User Blocked...");
if (!this._isFlowFirstOpen && e.config && void 0 !== e.config.onlyFirstOpen && "1" === e.config.onlyFirstOpen.toString()) return Promise.reject("Not First...");
if (this._isFlowFirstOpen && e.config && void 0 !== e.config.notFirstOpen && "1" === e.config.notFirstOpen.toString()) return Promise.reject("First...");
if (!this.isCanShowPage()) return Promise.reject("Back From Other Flow...");
isObject$1(e.config) && !Array.isArray(e.config) ? e.config.isMistakeEnabled = n ? "1" : "0" : e.config = {
isMistakeEnabled: n ? "1" : "0"
}, e.config.tpl = e.tpl, e.config.advPath = e.workflow_id + "/" + e.node_id, HLSDKLocalData$1._lastOnShowPagePath = HLSDKLocalData$1._curOnShowPagePath, 
HLSDKLocalData$1._curOnShowPagePath = e.config.advPath, PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowPage ? PlatHelper.getPlat().h_ShowPage(e.config.advPath) : h_ShowPage(e.config.advPath);
} catch (e) {
return Promise.reject(e);
}
return this.onStartFlow_Extend(e);
}
}, {
key: "onStartFlow_Extend",
value: function() {
return Promise.resolve();
}
}, {
key: "onEndFlow",
value: function() {
return Promise.reject("Not Right...");
}
}, {
key: "isCanShowPage",
value: function() {
return !this._isBackToFlow;
}
}, {
key: "_checkBlackTag",
value: function(e, t) {
return e === BlackTypeTag.All || !t && e === BlackTypeTag.Black || !(!t || e !== BlackTypeTag.Normal);
}
}, {
key: "_checkUserTag",
value: function(e) {
return e === UserTypeTag.All || !(!HLSDKLocalData$1._isNewPlayer || e !== UserTypeTag.New) || !HLSDKLocalData$1._isNewPlayer && e === UserTypeTag.Old;
}
}, {
key: "_showCompomentsOfPage",
value: function(e, t) {
e.forEach(function(e) {
var n = e.type, o = SupportComponentTypes[n];
o ? o.startFlow(e, t).then(function() {
console.warn("show compoment " + n + " succ...");
}).catch(function(e) {
checkString(e) ? console.warn("show compoment " + n + " fail：", e) : (console.error(e), 
console.warn("show compoment " + n + " fail..."));
}) : console.warn("show compoment " + n + " fail：", "Not Support On Current SDK Version...");
});
}
}, {
key: "_hideCompomentsOfPage",
value: function(e) {
e.forEach(function(e) {
var t = e.type, n = SupportComponentTypes[t];
n ? (n._flowCfg = e, n.endFlow().then(function() {
console.warn("hide compoment " + t + " succ...");
}).catch(function(e) {
checkString(e) ? console.warn("hide compoment " + t + " fail...", e) : (console.error(e), 
console.warn("hide compoment " + t + " fail..."));
})) : console.warn("hide compoment " + t + " fail...", "Not Support On Current SDK Version...");
});
}
} ]);
return t;
}(), _PageInsertMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
var n;
_classCallCheck2(this, t);
(n = e.call(this)).Time = Date.now(), n.ShowIndex = 0, n.ShowCount = 0, n.ShowSpaceTime = 0;
return n;
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
if (isLoadWXConfig()) {
var a = Date.now() - t.Time;
t.ShowIndex = t.ShowCount = Number(i.showCount || 0), t.ShowSpaceTime = Math.max(31e3, Number(i.showSpaceTime || 31e3));
var r = Number(i.firstDelayShow || 0), s = function e() {
t.ShowIndex--, adv_interface.showInterstitialAd(t._getAdvPagePath(), function() {
(t.ShowIndex > 0 || 0 == t.ShowCount) && (t.DelayID = setTimeout(e, t.ShowSpaceTime));
}, function() {});
};
a > 3e4 && 0 == r ? (t.ShowIndex--, adv_interface.showInterstitialAd(t._getAdvPagePath(), function() {
n(), (t.ShowIndex > 0 || 0 == t.ShowCount) && (t.DelayID = setTimeout(s, t.ShowSpaceTime));
}, function(e) {
o(e);
})) : (t.DelayID = setTimeout(s, r), n());
} else adv_interface.showInterstitialAd(t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
});
});
}
}, {
key: "onEndFlow",
value: function() {
var e = this;
return new Promise(function(t) {
clearTimeout(e.DelayID), t();
});
}
} ]);
return t;
}(), PageInsertMgr = new _PageInsertMgr(), _PageMoreGameMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
if (isLoadWXConfig()) {
var i = e.config;
adv_interface.showPopupCustomAd(i.matrixAdUnitId, parseInt(i.matrixAdRow), t._getAdvPagePath(), null, function() {
n();
}, function(e) {
o(e);
});
} else isLoadQQConfig() && adv_interface.showBoxAd(t._getAdvPagePath(), null, function() {
n();
}, function(e) {
o(e);
});
});
}
} ]);
return t;
}(), PageMoreGameMgr = new _PageMoreGameMgr(), _PageUIMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.type;
UIManager.showUI(i, e.tpl, function() {
-1 !== SupportComponentPageTypes.indexOf(i) && t._hideCompomentsOfPage(e.elements), 
n();
}, e.config).then(function(n) {
n && n.length > 0 && -1 !== SupportComponentPageTypes.indexOf(i) && t._showCompomentsOfPage(e.elements, n[0].zIndex);
}).catch(function(e) {
o(e);
});
});
}
} ]);
return t;
}(), PageUIMgr = new _PageUIMgr(), _PageVideoInsertMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function() {
var e = this;
return new Promise(function(t) {
var n = [];
n.push(new Promise(function(t) {
adv_interface.showInterstitialAd(e._getAdvPagePath(), function() {
t();
}, function(e) {
console.error(e), t();
});
})), n.push(new Promise(function(t) {
Scheduler.schedule("Delay_Open_RewardedVideoAd_While_Show_InsertAd", function() {
adv_interface.showRewardedVideoAd(e._getAdvPagePath(), !1, function() {
t();
}, function(e) {
console.error(e), t();
});
}, !1, 1500, 0);
})), Promise.all(n).then(function() {
t();
});
});
}
} ]);
return t;
}(), PageVideoInsertMgr = new _PageVideoInsertMgr(), _PageVideoMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
0 == HLSDKLocalData$1._gameTimes || HLSDKLocalData$1._gameTimes >= i.openTime ? adv_interface.showRewardedVideoAd(t._getAdvPagePath(), !1, function() {
n();
}, function(e) {
o(e);
}) : n();
});
}
} ]);
return t;
}(), PageVideoMgr = new _PageVideoMgr(), _SupportPageTypes$5 = {};

_SupportPageTypes$5[WX_AdvKeys.RewardedVideo] = PageVideoMgr, _SupportPageTypes$5[WX_AdvKeys.Interstitial] = PageInsertMgr, 
_SupportPageTypes$5[WX_AdvKeys.VideoInterstitial] = PageVideoInsertMgr, _SupportPageTypes$5[WX_AdvKeys.MoreGame] = PageMoreGameMgr, 
_SupportPageTypes$5[WX_UIKeys.FakeLoading] = PageUIMgr, _SupportPageTypes$5[WX_UIKeys.NativeTemplateAd] = PageUIMgr, 
_SupportPageTypes$5[WX_UIKeys.MoreGame] = PageUIMgr, _SupportPageTypes$5[WX_UIKeys.FullExport] = PageUIMgr, 
_SupportPageTypes$5[WX_UIKeys.FullExport_V2] = PageUIMgr, _SupportPageTypes$5[WX_UIKeys.FullExit] = PageUIMgr, 
_SupportPageTypes$5[WX_UIKeys.CrazyClick] = PageUIMgr;

var WX_SupportPageTypes = _SupportPageTypes$5, WX_SupportComponentPageTypes = [ WX_UIKeys.CrazyClick, WX_UIKeys.MoreGame, WX_UIKeys.NativeTemplateAd ], _SupportComponentTypes$5 = {};

_SupportComponentTypes$5[WX_AdvKeys.Banner] = ComponentBannerMgr, _SupportComponentTypes$5[WX_AdvKeys.Couplet] = ComponentCoupletMgr, 
_SupportComponentTypes$5[WX_AdvKeys.Scroll] = ComponentScrollMgr, _SupportComponentTypes$5[WX_AdvKeys.Matrix] = ComponentMatrixMgr, 
_SupportComponentTypes$5[WX_UIKeys.Scroll] = ComponentUIMgr, _SupportComponentTypes$5[WX_UIKeys.ScrollWithName] = ComponentUIMgr, 
_SupportComponentTypes$5[WX_UIKeys.Couplet] = ComponentUIMgr, _SupportComponentTypes$5[WX_UIKeys.Matrix] = ComponentUIMgr, 
_SupportComponentTypes$5[WX_UIKeys.MoreGameEntrance] = ComponentUIMgr, _SupportComponentTypes$5[WX_UIKeys.VideoBanner] = ComponentUIMgr;

var WX_SupportComponentTypes = _SupportComponentTypes$5, _SupportPageTypes$4 = {};

_SupportPageTypes$4[QQ_AdvKeys.RewardedVideo] = PageVideoMgr, _SupportPageTypes$4[QQ_AdvKeys.Interstitial] = PageInsertMgr, 
_SupportPageTypes$4[QQ_AdvKeys.MoreGame] = PageMoreGameMgr, _SupportPageTypes$4[QQ_UIKeys.CrazyClick] = PageUIMgr;

var QQ_SupportPageTypes = _SupportPageTypes$4, QQ_SupportComponentPageTypes = [ QQ_UIKeys.CrazyClick ], _SupportComponentTypes$4 = {};

_SupportComponentTypes$4[QQ_AdvKeys.Banner] = ComponentBannerMgr, _SupportComponentTypes$4[QQ_AdvKeys.Couplet] = ComponentCoupletMgr, 
_SupportComponentTypes$4[QQ_AdvKeys.Scroll] = ComponentScrollMgr, _SupportComponentTypes$4[QQ_AdvKeys.Matrix] = ComponentMatrixMgr, 
_SupportComponentTypes$4[QQ_UIKeys.MoreGameEntrance] = ComponentUIMgr;

var QQ_SupportComponentTypes = _SupportComponentTypes$4, _SupportPageTypes$3 = {};

_SupportPageTypes$3[TT_AdvKeys.RewardedVideo] = PageVideoMgr, _SupportPageTypes$3[TT_AdvKeys.Interstitial] = PageInsertMgr, 
_SupportPageTypes$3[TT_AdvKeys.MoreGame] = PageMoreGameMgr, _SupportPageTypes$3[TT_UIKeys.CrazyClick] = PageUIMgr;

var TT_SupportPageTypes = _SupportPageTypes$3, TT_SupportComponentPageTypes = [ TT_UIKeys.CrazyClick ], _SupportComponentTypes$3 = {};

_SupportComponentTypes$3[TT_AdvKeys.Banner] = ComponentBannerMgr, _SupportComponentTypes$3[TT_UIKeys.MoreGameEntrance] = ComponentUIMgr;

var TT_SupportComponentTypes = _SupportComponentTypes$3, _PagePortalMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
if (isLoadOPPOConfig()) {
var i = e.config;
adv_interface.showPortalAd(i.portalAdUnitId, t._getAdvPagePath(), function() {
console.error("Portal....succ...."), n();
}, null, function(e) {
o(e);
});
}
});
}
} ]);
return t;
}(), PagePortalMgr = new _PagePortalMgr(), _ComponentDrawerMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
checkString(i.drawerAdUnitId) && isLoadOPPOConfig() && adv_interface.showDrawerAd(i.drawerAdUnitId, parseFloat(i.fromTopPercent), t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
}, null);
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.drawerAdUnitId), t();
});
}
} ]);
return t;
}(), ComponentDrawerMgr = new _ComponentDrawerMgr(), _ComponentGraphicMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
if (checkString(i.graphicAdUnitId)) if (isLoadOPPOConfig() || isLoadVIVOConfig()) {
var a = parseInt(i.maxShowCount), r = t.getGraphicShowedCount(), s = function e() {
Scheduler.unschedule("delay_show_graphicAd"), Scheduler.unschedule("show_interval_graphicAd");
var r = t.getGraphicShowedCount();
if (a > 0 && r < a) {
var s = parseInt(i.showIntervalTime);
Scheduler.schedule("show_interval_graphicAd", function() {
console.log("show_interval_graphicAd_count:", r), t.showGraphicFunc(i, n, o, e);
}, !1, 1e3 * s, 1);
} else Scheduler.unschedule("show_interval_graphicAd");
}, l = parseInt(i.delayShowTime);
if (l > 0 && 0 == r) {
var c = UIManager.getUI(UIKeys.Mask), d = 1 == parseInt(i.canDelayTimeClick);
c && d && (console.log("图文AD延迟显示,先隐藏maskUI,使游戏正常进行"), UIManager.hideUI(UIKeys.Mask)), 
Scheduler.schedule("delay_show_graphicAd", function() {
t.showGraphicFunc(i, n, o, s);
}, !1, 1e3 * l, 1);
} else t.showGraphicFunc(i, n, o, s);
} else UIManager.getUI(UIKeys.Mask) && UIManager.hideUI(UIKeys.Mask); else UIManager.getUI(UIKeys.Mask) && UIManager.hideUI(UIKeys.Mask);
});
}
}, {
key: "showGraphicFunc",
value: function(e, t, n, o) {
var i = this.getGraphicShowedCount();
this.setGraphicShowedCount(i + 1), adv_interface.showgraphicAd("couplet", this._getAdvPagePath(), e.graphicAdUnitId, {
layout: "top",
top: parseFloat(e.fromTopPercent),
left: parseFloat(e.fromLeftPercent),
type: parseInt(e.graphicAdType)
}, function() {
t();
}, function(e) {
n(e);
}, function() {
o && "function" == typeof o && o();
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.graphicAdUnitId), Scheduler.unschedule("delay_show_graphicAd"), 
Scheduler.unschedule("show_interval_graphicAd"), t();
});
}
}, {
key: "getGraphicShowedCount",
value: function() {
var e = FlowManager._currentViewName + "hasShownGraphicCount", t = 0;
return isLayaEngine() ? Laya.LocalStorage.getItem(e) && (t = parseInt(Laya.LocalStorage.getItem(e))) : isCocosEngine() && cc.sys.localStorage.getItem(e) && (t = parseInt(cc.sys.localStorage.getItem(e))), 
t;
}
}, {
key: "setGraphicShowedCount",
value: function(e) {
var t = FlowManager._currentViewName + "hasShownGraphicCount";
isLayaEngine() ? Laya.LocalStorage.setItem(t, e.toString()) : isCocosEngine() && cc.sys.localStorage.setItem(t, e.toString());
}
} ]);
return t;
}(), ComponentGraphicMgr = new _ComponentGraphicMgr(), _PageGraphicMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
if (console.log("_PageGraphicMgr  onStartFlow_Extend", i), checkString(i.graphicAdUnitId)) if (isLoadOPPOConfig() || isLoadVIVOConfig()) {
var a = parseInt(i.maxShowCount), r = t.getGraphicShowedCount(), s = function e() {
Scheduler.unschedule("delay_show_graphicAd"), Scheduler.unschedule("show_interval_graphicAd");
var r = t.getGraphicShowedCount();
if (a > 0 && r < a) {
var s = parseInt(i.showIntervalTime);
Scheduler.schedule("show_interval_graphicAd", function() {
console.log("show_interval_graphicAd_count:", r), t.showGraphicFunc(i, n, o, e);
}, !1, 1e3 * s, 1);
} else Scheduler.unschedule("show_interval_graphicAd");
}, l = parseInt(i.delayShowTime);
if (l > 0 && (!r || 0 == r)) {
var c = UIManager.getUI(UIKeys.Mask), d = 1 == parseInt(i.canDelayTimeClick);
c && d && (console.log("图文AD延迟显示,先隐藏maskUI,使游戏正常进行"), UIManager.hideUI(UIKeys.Mask)), 
Scheduler.schedule("delay_show_graphicAd", function() {
t.showGraphicFunc(i, n, o, s);
}, !1, 1e3 * l, 1);
} else t.showGraphicFunc(i, n, o, s);
} else console.warn("非OV平台不展示原生广告"), UIManager.getUI(UIKeys.Mask) && UIManager.hideUI(UIKeys.Mask); else console.warn("未获取OV平台原生广告信息"), 
UIManager.getUI(UIKeys.Mask) && UIManager.hideUI(UIKeys.Mask);
});
}
}, {
key: "showGraphicFunc",
value: function(e, t, n, o) {
var i = this.getGraphicShowedCount();
this.setGraphicShowedCount(i + 1), adv_interface.showgraphicAd("couplet", this._getAdvPagePath(), e.graphicAdUnitId, {
layout: "top",
top: parseFloat(e.fromTopPercent),
left: parseFloat(e.fromLeftPercent),
type: parseInt(e.graphicAdType)
}, function() {
t();
}, function(e) {
n(e);
}, function() {
o && "function" == typeof o && o();
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.graphicAdUnitId), Scheduler.unschedule("delay_show_graphicAd"), 
Scheduler.unschedule("show_interval_graphicAd"), t();
});
}
}, {
key: "getGraphicShowedCount",
value: function() {
var e = FlowManager._currentViewName + "hasShownGraphicCount", t = 0;
return isLayaEngine() ? Laya.LocalStorage.getItem(e) && (t = parseInt(Laya.LocalStorage.getItem(e))) : isCocosEngine() && cc.sys.localStorage.getItem(e) && (t = parseInt(cc.sys.localStorage.getItem(e))), 
t;
}
}, {
key: "setGraphicShowedCount",
value: function(e) {
var t = FlowManager._currentViewName + "hasShownGraphicCount";
isLayaEngine() ? Laya.LocalStorage.setItem(t, e.toString()) : isCocosEngine() && cc.sys.localStorage.setItem(t, e.toString());
}
} ]);
return t;
}(), PageGraphicMgr = new _PageGraphicMgr(), _SupportPageTypes$2 = {};

_SupportPageTypes$2[OPPO_AdvKeys.RewardedVideo] = PageVideoMgr, _SupportPageTypes$2[OPPO_AdvKeys.Portal] = PagePortalMgr, 
_SupportPageTypes$2[OPPO_AdvKeys.Graphic] = PageGraphicMgr;

var OPPO_SupportPageTypes = _SupportPageTypes$2, OPPO_SupportComponentPageTypes = [], _SupportComponentTypes$2 = {};

_SupportComponentTypes$2[OPPO_AdvKeys.Banner] = ComponentBannerMgr, _SupportComponentTypes$2[OPPO_UIKeys.MoreGameEntrance] = ComponentUIMgr, 
_SupportComponentTypes$2[OPPO_UIKeys.NativeBanner] = ComponentUIMgr, _SupportComponentTypes$2[OPPO_UIKeys.NativeBottomBanner] = ComponentUIMgr, 
_SupportComponentTypes$2[OPPO_UIKeys.NativeMiddleBanner] = ComponentUIMgr, _SupportComponentTypes$2[OPPO_AdvKeys.Scroll] = ComponentScrollMgr, 
_SupportComponentTypes$2[OPPO_AdvKeys.Drawer] = ComponentDrawerMgr, _SupportComponentTypes$2[OPPO_AdvKeys.Graphic] = ComponentGraphicMgr;

var OPPO_SupportComponentTypes = _SupportComponentTypes$2, _PageTransplateMgr = function() {
_inherits2(t, BasePageFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n) {
t._showCompomentsOfPage(e.elements, 0), n();
});
}
}, {
key: "isCanShowPage",
value: function() {
return !0;
}
} ]);
return t;
}(), PageTransplateMgr = new _PageTransplateMgr(), _ComponentPortalMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
checkString(i.portalAdUnitId) && isLoadVIVOConfig() && adv_interface.ShowQgPortalAd(i.portalAdUnitId, 200, t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
}, null);
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
e.config, t();
});
}
} ]);
return t;
}(), ComponentPortalMgr = new _ComponentPortalMgr(), _ComponentStreamerMgr = function() {
_inherits2(t, BaseComponentFlow);
var e = _createSuper2(t);
function t() {
_classCallCheck2(this, t);
return e.call(this);
}
_createClass2(t, [ {
key: "onStartFlow_Extend",
value: function(e) {
var t = this;
return new Promise(function(n, o) {
var i = e.config;
checkString(i.streamerAdUnitId) && isLoadVIVOConfig() && adv_interface.ShowQgStreamerAd(i.streamerAdUnitId, t._getAdvPagePath(), function() {
n();
}, function(e) {
o(e);
}, null);
});
}
}, {
key: "onEndFlow",
value: function(e) {
return new Promise(function(t) {
var n = e.config;
adv_interface.hideComponentAd(n.streamerAdUnitId), t();
});
}
} ]);
return t;
}(), ComponentStreamerMgr = new _ComponentStreamerMgr(), _SupportPageTypes$1 = {};

_SupportPageTypes$1[VIVO_AdvKeys.RewardedVideo] = PageVideoMgr, _SupportPageTypes$1[VIVO_AdvKeys.Interstitial] = PageInsertMgr;

var VIVO_SupportPageTypes = _SupportPageTypes$1, VIVO_SupportComponentPageTypes = [], _SupportComponentTypes$1 = {};

_SupportComponentTypes$1[VIVO_AdvKeys.Banner] = ComponentBannerMgr, _SupportComponentTypes$1[VIVO_AdvKeys.Portal] = ComponentPortalMgr, 
_SupportComponentTypes$1[VIVO_AdvKeys.Streamer] = ComponentStreamerMgr, _SupportComponentTypes$1[VIVO_UIKeys.NativeBanner] = ComponentUIMgr, 
_SupportComponentTypes$1[VIVO_UIKeys.NativeBottomBanner] = ComponentUIMgr, _SupportComponentTypes$1[VIVO_UIKeys.NativeMiddleBanner] = ComponentUIMgr, 
_SupportComponentTypes$1[VIVO_AdvKeys.Graphic] = ComponentGraphicMgr;

var VIVO_SupportComponentTypes = _SupportComponentTypes$1, _SupportPageTypes = {};

_SupportPageTypes[UIKeys.Transplate] = PageTransplateMgr;

var _SupportComponentPageTypes = [], _SupportComponentTypes = {};

isLoadQQConfig() ? (Object.assign(_SupportPageTypes, QQ_SupportPageTypes), _SupportComponentPageTypes = _SupportComponentPageTypes.concat(QQ_SupportComponentPageTypes), 
Object.assign(_SupportComponentTypes, QQ_SupportComponentTypes)) : isLoadTTConfig() ? (Object.assign(_SupportPageTypes, TT_SupportPageTypes), 
_SupportComponentPageTypes = _SupportComponentPageTypes.concat(TT_SupportComponentPageTypes), 
Object.assign(_SupportComponentTypes, TT_SupportComponentTypes)) : isLoadOPPOConfig() ? (Object.assign(_SupportPageTypes, OPPO_SupportPageTypes), 
_SupportComponentPageTypes = _SupportComponentPageTypes.concat(OPPO_SupportComponentPageTypes), 
Object.assign(_SupportComponentTypes, OPPO_SupportComponentTypes)) : isLoadVIVOConfig() ? (Object.assign(_SupportPageTypes, VIVO_SupportPageTypes), 
_SupportComponentPageTypes = _SupportComponentPageTypes.concat(VIVO_SupportComponentPageTypes), 
Object.assign(_SupportComponentTypes, VIVO_SupportComponentTypes)) : isLoadWXConfig() ? (Object.assign(_SupportPageTypes, WX_SupportPageTypes), 
_SupportComponentPageTypes = _SupportComponentPageTypes.concat(WX_SupportComponentPageTypes), 
Object.assign(_SupportComponentTypes, WX_SupportComponentTypes)) : console.error("Not Support This Platform, check hlsdk_config.js first...");

var SupportPageTypes = _SupportPageTypes, SupportComponentPageTypes = _SupportComponentPageTypes, SupportComponentTypes = _SupportComponentTypes, VIEW_NAME = {
MAIN: "mainView",
GAMING: "gamingView",
GAMEEND: "gameEndView",
REVIVE: "reviveView",
Finish: "finishView",
FinishFail: "finishFailView",
Custom: "customView",
Custom_02: "customView_02",
Custom_03: "customView_03",
Custom_04: "customView_04",
Custom_05: "customView_05",
EmptyView: "EmptyView"
}, _FlowManager = function() {
function e() {
_classCallCheck2(this, e);
this._currentViewName = "";
}
_createClass2(e, [ {
key: "exeMainView",
value: function() {
var e = this;
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.MAIN, [ "", VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ], function() {}).then(function(o) {
console.warn("开始新一轮游戏..."), HLSDKLocalData$1._gameTimes += 1, e._exe(VIEW_NAME.MAIN, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeGamingView",
value: function() {
var e = this, t = this._currentViewName;
return new Promise(function(n, o) {
e._isViewCanExe(VIEW_NAME.GAMING, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.EmptyView ]).then(function(i) {
e._exe(VIEW_NAME.GAMING, i, t === VIEW_NAME.REVIVE).then(function() {
n();
}).catch(function(e) {
o(e);
});
}).catch(function(e) {
o(e);
});
});
}
}, {
key: "exeGameEndView",
value: function() {
var e = this;
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.GAMEEND, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.GAMEEND, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeReviveView",
value: function() {
var e = this;
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.REVIVE, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.REVIVE, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeFinishView",
value: function() {
var e = this;
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Finish, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Finish, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeFinishFailView",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.FinishFail, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.FinishFail, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeCustomView",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Custom, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Custom, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeCustomView_02",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Custom_02, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Custom_02, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeCustomView_03",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Custom_03, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Custom_03, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeCustomView_04",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Custom_04, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Custom_04, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeCustomView_05",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.Custom_05, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING, VIEW_NAME.EmptyView ]).then(function(o) {
e._exe(VIEW_NAME.Custom_05, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "exeEmptyView",
value: function() {
var e = this;
arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
return new Promise(function(t, n) {
e._isViewCanExe(VIEW_NAME.EmptyView, [ "", VIEW_NAME.MAIN, VIEW_NAME.Custom, VIEW_NAME.Custom_02, VIEW_NAME.Custom_03, VIEW_NAME.Custom_04, VIEW_NAME.Custom_05, VIEW_NAME.REVIVE, VIEW_NAME.GAMEEND, VIEW_NAME.Finish, VIEW_NAME.FinishFail, VIEW_NAME.GAMING ]).then(function(o) {
e._exe(VIEW_NAME.EmptyView, o).then(function() {
t();
}).catch(function(e) {
n(e);
});
}).catch(function(e) {
n(e);
});
});
}
}, {
key: "_isViewCanExe",
value: function(e, t) {
var n = this, o = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
return new Promise(function(i, a) {
var r = n._currentViewName;
if (HLSDKLocalData$1._isSkipFlow) HLSDKLocalData$1._isSkipFlow = !1; else {
if (n._currentViewName === e) return void a("不要连续多次执行同一流程...");
if (-1 === t.indexOf(r)) return void a("上一流程非法，请按流程图所示顺序调用...");
}
n._currentViewName = e;
var s = !1, l = "_is" + e.charAt(0).toUpperCase() + e.substr(1) + "Showed";
HLSDKLocalData$1._viewStatus[l] || (HLSDKLocalData$1._viewStatus[l] = !0, s = !0, 
doCallback$1(o)), i(s);
});
}
}, {
key: "_exe",
value: function(e) {
var t = this, n = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], o = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], i = HLSDKLocalData$1._gameFlows[e];
return new Promise(function(a) {
t._doCleanBeforeExe(e).then(function() {
t._doExe(i, n, o).then(function() {
t._doCleanAfterExe().then(function() {
a();
});
}).catch(function() {
t._doCleanAfterExe().then(function() {
a();
});
});
});
});
}
}, {
key: "_doCleanBeforeExe",
value: function(e) {
return new Promise(function(t) {
adv_interface.stopAutoRefreshBannerAd(), adv_interface.hideBannerAd(), Scheduler.unschedule("Schedule_Of_Create_CustomAd_Agin"), 
-1 == e.indexOf("customView") && (PlatHelper.isOPPOPlatform() || PlatHelper.isVIVOPlatform()) && (console.log("OV执行流程之前的清理"), 
Scheduler.unschedule("delay_show_graphicAd"), Scheduler.unschedule("show_interval_graphicAd"));
var n = [];
n.push(new Promise(function(e) {
adv_interface.hideAllComponentAds(function() {
e();
});
})), UIManager.showAllTempHideUIs(), n.push(new Promise(function(e) {
UIManager.hideAllUIs().then(function() {
e();
});
})), Promise.all(n).then(function() {
UIManager.showUI(UIKeys.Mask).then(function() {
t();
});
});
});
}
}, {
key: "_doExe",
value: function(e, t, n) {
return new Promise(function(o) {
if (void 0 !== e && void 0 !== e.flows) {
PlatHelper.getPlat() && PlatHelper.getPlat().h_ShowView ? PlatHelper.getPlat().h_ShowView(e.workflow_id) : h_ShowView(e.workflow_id);
var i = -1, a = e.flows;
Array.isArray(a) && a.length > 0 ? function e() {
if (i < a.length - 1) {
var r = a[i += 1], s = SupportPageTypes[r.type];
s ? s.startFlow(r, t, n).then(function() {
console.warn("show page " + r.type + " succ..."), e();
}).catch(function(t) {
checkString(t) ? console.warn("show page " + r.type + " fail：", t) : (console.error(t), 
console.warn("show page " + r.type + " fail...")), e();
}) : (console.warn("show page " + r.type + " fail：", "Not Support On Current SDK Version..."), 
e());
} else o();
}() : o();
} else o();
});
}
}, {
key: "_doCleanAfterExe",
value: function() {
return new Promise(function(e) {
UIManager.hideUI(UIKeys.Mask), e();
});
}
}, {
key: "_checkBlackState",
value: function(e, t) {
return !!isGlobalMistakeEnabled() && checkBlackState(e, t);
}
}, {
key: "_checkBlackTag",
value: function(e, t) {
return e === BlackTypeTag.All || !t && e === BlackTypeTag.Black || !(!t || e !== BlackTypeTag.Normal);
}
}, {
key: "_checkUserTag",
value: function(e) {
return e === UserTypeTag.All || !(!HLSDKLocalData$1._isNewPlayer || e !== UserTypeTag.New) || !HLSDKLocalData$1._isNewPlayer && e === UserTypeTag.Old;
}
} ]);
return e;
}(), FlowManager = new _FlowManager(), _ui_interface = function() {
function e() {
_classCallCheck2(this, e);
this._currentViewName = "", this._uiRoot = null;
}
_createClass2(e, [ {
key: "registerRunningScene",
value: function(e) {
isLayaEngine() ? e && e instanceof Laya.Scene ? HLSDKLocalData$1._runningScene = e : console.error("scene must instanceof Laya.Scene...") : console.error("no need call this function...");
}
}, {
key: "doBtnMistake",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {
x: 0,
y: 0
};
if (e) if (adv_interface.pauseAutoRefreshBannerAd(), adv_interface.hideBannerAd(), 
0 !== n.x || 0 !== n.y) {
var o = HLSDKLocalData$1._globalMoveMistakeBtnCfg;
isGlobalMistakeEnabled() && o.isEnabled && o.btnInvokeType === BtnClickInvokeType.RewardedVideo ? adv_interface.showRewardedVideoAd("", !1, function() {
doCallback$1(t);
}, function() {
doCallback$1(t);
}) : (createMistakeBtn_Move(e, function() {
adv_interface.resumeAutoRefreshBannerAd(), doCallback$1(t);
}, BtnClickMistakeType.Show, o.btnDelay, o.btnHide, o.btnUnhandle, o.btnMoveAfterShowBanner, o.moveDuration, !0, n), 
isGlobalMistakeEnabled() && o.isEnabled ? e.enableMistake() : e.disableMistake());
} else {
var i = HLSDKLocalData$1._globalNoMoveMistakeBtnCfg;
isGlobalMistakeEnabled() && i.isEnabled && i.btnInvokeType === BtnClickInvokeType.RewardedVideo ? adv_interface.showRewardedVideoAd("", !1, function() {
doCallback$1(t);
}, function() {
doCallback$1(t);
}) : (createMistakeBtn_NoMove(e, function() {
adv_interface.resumeAutoRefreshBannerAd(), doCallback$1(t);
}, i.btnMistakeType, i.btnDelay, i.btnHide, i.btnUnhandle, i.bannerShow), isGlobalMistakeEnabled() && i.isEnabled ? e.enableMistake() : e.disableMistake());
}
}
}, {
key: "doBtnCrazyClick",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
if (e) {
var i = HLSDKLocalData$1._globalCrazyClickBtnCfg;
if (e && null == e._originalBottom && (e._originalBottom = e.bottom), i.invokeType === CrazyClickInvokeType.Banner && i.mistakeStyle === CrazyClickBannerMistakeType.Move) e.bottom = e._originalBottom + 200; else if (i.invokeType > 0 || i.invokeType === CrazyClickInvokeType.CustomScroll) e.bottom = e._originalBottom - 140; else if (i.invokeType <= 0 && 0 !== i.videoTarget) {
var a = .168 * getSceneSize().height;
isLoadLandscapeConfig$1() && (a = .248 * getSceneSize().height);
var r = a - e.height / 2 - e._originalBottom;
e.bottom = e._originalBottom + r;
} else e.bottom = e._originalBottom;
i.invokeType === CrazyClickInvokeType.Banner && (adv_interface.pauseAutoRefreshBannerAd(), 
adv_interface.hideBannerAd()), (checkString(i.invokeType) || i.invokeType === CrazyClickInvokeType.CustomScroll) && checkString(i.scrollAdUnitId) && (adv_interface.isComponentAdPreloaded(i.scrollAdUnitId) ? adv_interface.hideComponentAd(i.scrollAdUnitId) : (adv_interface.showComponentAd("scroll", "", i.scrollAdUnitId, {
layout: "bottom",
bottom: 0
}), adv_interface.hideComponentAd(i.scrollAdUnitId))), createCrazyClickBtn(e, t, n, function() {
i.isEnabled && (i.invokeType === CrazyClickInvokeType.Banner ? adv_interface.resumeAutoRefreshBannerAd() : (checkString(i.invokeType) || i.invokeType === CrazyClickInvokeType.Box) && adv_interface.showBoxAd("", null, null, null)), 
doCallback$1(o);
}, i), isGlobalMistakeEnabled() && i.isEnabled ? e.enableMistake() : e.disableMistake();
}
}
} ]);
return e;
}(), ui_interface = new _ui_interface(), _share_interface = function() {
function e() {
_classCallCheck2(this, e);
}
_createClass2(e, [ {
key: "isSupport",
value: function() {
return Share.isSupport();
}
}, {
key: "share",
value: function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, n = !(arguments.length > 2 && void 0 !== arguments[2]) || arguments[2], o = arguments.length > 3 && void 0 !== arguments[3] ? arguments[3] : null;
Share.share(e, t, n, function(t) {
t && e !== ShareScene.SS_SYSTEM_MENU && (addShareTimes(), PlatHelper.setStorage(SK_KEY_OF_INTERACT_INFO, saveInteractInfoToString())), 
doCallback$1(o, t);
});
}
}, {
key: "shareVideo",
value: function(e, t) {
var n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null, o = !(arguments.length > 3 && void 0 !== arguments[3]) || arguments[3], i = arguments.length > 4 && void 0 !== arguments[4] ? arguments[4] : null;
Share.shareVideo(e, t, n, o, function(t) {
t && e !== ShareScene.SS_SYSTEM_MENU && (addShareTimes(), PlatHelper.setStorage(SK_KEY_OF_INTERACT_INFO, saveInteractInfoToString())), 
doCallback$1(i, t);
});
}
} ]);
return e;
}(), share_interface = new _share_interface(), _event_interface = function() {
function e() {
_classCallCheck2(this, e);
this._GlobalEventIDs = {};
}
_createClass2(e, [ {
key: "handleGlobalEvents",
value: function() {
var e = this, t = function(t, n) {
e._GlobalEventIDs[t] = n, Event.addEventListerner(t, n);
};
t(EventName.EN_APP_ONSHOW, function(e) {
AudioMgr.resumeMusic(), doCallback$1(HLSDKLocalData$1._handles.onShow, e);
}), t(EventName.EN_APP_ONHIDE, function() {
AudioMgr.pauseMusic(), PlatHelper.getPlat() && checkFunc(PlatHelper.getPlat().h_ReportAllSavedAdvInfos) && PlatHelper.getPlat().h_ReportAllSavedAdvInfos(), 
doCallback$1(HLSDKLocalData$1._handles.onHide);
}), t(EventName.EN_SYSTEM_ERROR, function() {
checkFunc(HLSDKLocalData$1._handles.onErr) ? doCallback$1(HLSDKLocalData$1._handles.onErr) && e.handleError() : e.handleError();
}), t(EventName.EN_SHOW_CUSTOM_TIPS, function(e) {
UIManager.showUI(UIKeys.Tips, DEFAULT_BUNDLE_TEMPLATE, null, e);
}), t(EventName.EN_HIDE_CUSTOM_TIPS, function() {
UIManager.hideUI(UIKeys.Tips, DEFAULT_BUNDLE_TEMPLATE);
}), t(EventName.EN_SHOW_CUSTOM_MODAL, function(e) {
UIManager.showUI(UIKeys.Modal, DEFAULT_BUNDLE_TEMPLATE, null, e);
}), t(EventName.EN_SHOW_CUSTOM_LOADING, function(e) {
UIManager.showUI(UIKeys.Loading, DEFAULT_BUNDLE_TEMPLATE, null, e);
}), t(EventName.EN_HIDE_CUSTOM_LOADING, function() {
UIManager.hideUI(UIKeys.Loading, DEFAULT_BUNDLE_TEMPLATE);
});
}
}, {
key: "unHandleGlobalEvents",
value: function() {
for (var e in this._GlobalEventIDs) Event.removeEventListerner(e, this._GlobalEventIDs[e]);
this._GlobalEventIDs = {};
}
}, {
key: "handleError",
value: function() {
PlatHelper.showModal(HandleErrorDialog.title, HandleErrorDialog.content, isCocosEngine(), function(e) {
isCocosEngine() && e ? (PlatHelper.restartApp(), console.error("restart app...")) : (PlatHelper.exitApp(), 
console.error("exit app..."));
}, {
confirmText: HandleErrorDialog.confirmText,
cancelText: HandleErrorDialog.cancelText
});
}
} ]);
return e;
}(), event_interface = new _event_interface(), C_TIMEOUT_OF_LOGIN = 1e4, HLSDK = {
VERSION: "1.0.0"
};

HLSDK.EventName = EventName, HLSDK.PropagationEventNames = PropagationEventNames, 
HLSDK.SwitchName = SwitchName, HLSDK.ShareScene = ShareScene, HLSDK.platHelper = PlatHelper, 
PlatHelper.init(), NetHelper.init(), HLSDK.isEnterRealGame = function(e) {
NetHelper.reqIsEnterRealGame(HLSDK.VERSION, function(t) {
t && "200" === t.status ? doCallback$1(e.cb, "0" === t.result.isShield) : doCallback$1(e.cb, !0);
});
}, HLSDK.init = function(e) {
if (HLSDKLocalData$1._isInited) doCallback$1(e.onInit); else if (console.log("start to init HLSDK..."), 
HLSDK_CFG.VERSION === HLSDK.VERSION) if (HLSDK_CFG.Orientation === ScreenOrientation.portrait || HLSDK_CFG.Orientation === ScreenOrientation.landscape) if (HLSDK_CFG.Orientation, 
HLSDK_CFG.Orientation === ScreenOrientation.portrait ? (DesignSize.width = 750, 
DesignSize.height = 1334) : (DesignSize.width = 1334, DesignSize.height = 750), 
checkString(HLSDK_CFG.Base.appVersion) && 6 === HLSDK_CFG.Base.appVersion.length) {
AppConfig.version = HLSDK_CFG.Base.appVersion, checkString(HLSDK_CFG.Base.company) && (CompanyConfig.name = HLSDK_CFG.Base.company), 
checkString(HLSDK_CFG.UIGroupName) && (UIGroupConfig.name = HLSDK_CFG.UIGroupName), 
void 0 !== HLSDK_CFG.Base.isPreloadAllResInInit ? PreloadConfig.isPreloadResInInit = HLSDK_CFG.Base.isPreloadAllResInInit : PreloadConfig.isPreloadResInInit = !0, 
checkString(HLSDK_CFG.SubPath) ? SubConfig.path = HLSDK_CFG.SubPath : SubConfig.path = "";
for (var t in HLSDK_CFG.SwitchName) void 0 === HLSDK.SwitchName[t] ? HLSDK.SwitchName[t] = HLSDK_CFG.SwitchName[t] : console.error(formatString("Switch Name: {0} Conflicted, It's Used By SDK...", t));
for (var n in HLSDK_CFG.ShareScene) void 0 === HLSDK.ShareScene[n] ? HLSDK.ShareScene[n] = HLSDK_CFG.ShareScene[n] : console.error(formatString("Share Scene Name: {0} Conflicted, It's Used By SDK...", n));
Object.assign(PlatIDs, HLSDK_CFG.PlatIDs), Object.assign(AldConfig, HLSDK_CFG.ReportorConfig), 
Object.assign(UmaConfig, HLSDK_CFG.UmaConfig), Object.assign(LoginConfig, HLSDK_CFG.LoginConfig);
for (var o in e) void 0 !== HLSDKLocalData$1._handles[o] && checkFunc(e[o]) && (HLSDKLocalData$1._handles[o] = e[o]);
PlatHelper.isWXPlatform() || PlatHelper.isQQPlatform() ? PlatHelper.isWXPlatform() ? Reportor$1.init(!0, checkString(AldConfig.appKey), checkString(UmaConfig.wxAppKey)) : Reportor$1.init(!0, checkString(AldConfig.qqAppKey), checkString(UmaConfig.qqAppKey)) : Reportor$1.init(!0, !1, !1), 
event_interface.handleGlobalEvents();
var i = function(e) {
return new Promise(function(t) {
NetHelper.reqGetWebConfig(HLSDK.VERSION, e, function(e) {
if (console.log(e), e && "200" === e.status) {
if (void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.base) {
var n = e.result.baseInfo.config.base;
Object.assign(SwitchCfgs, n), AppConfig.version === SwitchCfgs[SwitchName.SN_COMMIT_VERSION] ? SwitchCfgs[SwitchName.SN_IS_PUBLISHING] = n[SwitchName.SN_IS_PUBLISHING] : SwitchCfgs[SwitchName.SN_IS_PUBLISHING] = "0", 
"1" === SwitchCfgs[SwitchName.SN_IS_PUBLISHING] ? console.log("app ver: ", AppConfig.version, " ispublishing: ", !0) : console.log("app ver: ", AppConfig.version, " ispublishing: ", !1);
}
if (void 0 !== e.result.baseInfo.config) {
var o = function(e) {
for (var t in e) void 0 !== PlatAdUnitIDs[t] && (checkString(e[t]) ? PlatAdUnitIDs[t] = e[t].split("||") : PlatAdUnitIDs[t] = []);
for (var n in PlatAdUnitIDs) shuffleArray(PlatAdUnitIDs[n]);
};
void 0 !== e.result.baseInfo.config.adv && o(e.result.baseInfo.config.adv), void 0 !== e.result.baseInfo.config.wxAdv && o(e.result.baseInfo.config.wxAdv), 
isLoadWXConfig() && void 0 !== e.result.baseInfo.config.wxAdv && o(e.result.baseInfo.config.wxAdv), 
isLoadQQConfig() && void 0 !== e.result.baseInfo.config.qqAdv && o(e.result.baseInfo.config.qqAdv), 
isLoadTTConfig() && void 0 !== e.result.baseInfo.config.ttAdv && o(e.result.baseInfo.config.ttAdv), 
(isLoadOPPOConfig() || isLoadVIVOConfig()) && void 0 !== e.result.baseInfo.config.qgAdv && o(e.result.baseInfo.config.qgAdv);
}
if (void 0 !== e.result.share && e.result.share.forEach(function(e) {
void 0 === ShareSceneCfgs[e.scene_name] && (ShareSceneCfgs[e.scene_name] = {
cfgs: []
}), ShareSceneCfgs[e.scene_name].cfgs.push({
title: e.title,
weight: e.weight,
img_url: e.image_url,
template_id: "",
tag: e.flag
});
}), Share.init(), void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.banner ? (HLSDKLocalData$1._globalBannerCfg.preloadCount = parseInt(e.result.baseInfo.config.banner.preloadBannerCount), 
HLSDKLocalData$1._globalBannerCfg.isTest = 1 === parseInt(e.result.baseInfo.config.banner.isTestBanner), 
HLSDKLocalData$1._globalBannerCfg.maxShowTime = parseInt(e.result.baseInfo.config.banner.maxShowTime), 
HLSDKLocalData$1._globalBannerCfg.maxClickedTimes = parseInt(e.result.baseInfo.config.banner.maxClickedTimes), 
HLSDKLocalData$1._globalBannerCfg.isLongstay = 1 === parseInt(e.result.baseInfo.config.banner.bannerLongstay)) : (HLSDKLocalData$1._globalBannerCfg.preloadCount = 1, 
HLSDKLocalData$1._globalBannerCfg.isTest = !1, HLSDKLocalData$1._globalBannerCfg.maxShowTime = 999999, 
HLSDKLocalData$1._globalBannerCfg.maxClickedTimes = 99, HLSDKLocalData$1._globalBannerCfg.isLongstay = !1), 
void 0 !== e.result.globalAd && void 0 !== e.result.globalAd["pre-MatrixAd"] && (HLSDKLocalData$1._globalMatrixAdCfg = e.result.globalAd["pre-MatrixAd"]), 
void 0 !== e.result.globalAd && void 0 !== e.result.globalAd["pre-ScrollAd"] && (HLSDKLocalData$1._globalScrollAdCfg = e.result.globalAd["pre-ScrollAd"]), 
void 0 !== e.result.globalAd && void 0 !== e.result.globalAd["pre-CoupleAd"] && (HLSDKLocalData$1._globalCoupleAdCfg = e.result.globalAd["pre-CoupleAd"]), 
void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.video ? (HLSDKLocalData$1._globalVideoCfg.videoLoadingTips = e.result.baseInfo.config.video.videoLoadingTips, 
HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime = parseInt(e.result.baseInfo.config.video.videoLoadingShowTime)) : (HLSDKLocalData$1._globalVideoCfg.videoLoadingTips = "", 
HLSDKLocalData$1._globalVideoCfg.videoLoadingShowTime = 0), void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.noMoreMistakeBtn) {
var i = convertWebParams(e.result.baseInfo.config.noMoreMistakeBtn);
for (var a in i) "enableMistake" === a ? HLSDKLocalData$1._globalNoMoveMistakeBtnCfg.isEnabled = 1 === i.enableMistake : void 0 !== HLSDKLocalData$1._globalNoMoveMistakeBtnCfg[a] && (HLSDKLocalData$1._globalNoMoveMistakeBtnCfg[a] = i[a]);
} else HLSDKLocalData$1._globalNoMoveMistakeBtnCfg.isEnabled = !1;
if (void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.moreMistakeBtn) {
var r = convertWebParams(e.result.baseInfo.config.moreMistakeBtn);
for (var s in r) if ("enableMistake_More" === s) HLSDKLocalData$1._globalMoveMistakeBtnCfg.isEnabled = 1 === r.enableMistake_More; else {
var l = s;
-1 !== s.indexOf("_More") && (l = s.substring(0, s.indexOf("_More"))), void 0 !== HLSDKLocalData$1._globalMoveMistakeBtnCfg[l] && (HLSDKLocalData$1._globalMoveMistakeBtnCfg[l] = r[s]);
}
} else HLSDKLocalData$1._globalMoveMistakeBtnCfg.isEnabled = !1;
if (void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.crazyClickBtn) {
var c = convertWebParams(e.result.baseInfo.config.crazyClickBtn);
for (var d in c) if ("enableMistake_Click" === d) HLSDKLocalData$1._globalCrazyClickBtnCfg.isEnabled = 1 === c.enableMistake_Click; else {
var h = d;
-1 !== d.indexOf("_Click") && (h = d.substring(0, d.indexOf("_Click"))), void 0 !== HLSDKLocalData$1._globalCrazyClickBtnCfg[h] && (HLSDKLocalData$1._globalCrazyClickBtnCfg[h] = c[d]);
}
} else HLSDKLocalData$1._globalCrazyClickBtnCfg.isEnabled = !1;
if (void 0 !== e.result.baseInfo.config && void 0 !== e.result.baseInfo.config.qqAnnouncement) {
var u = convertWebParams(e.result.baseInfo.config.qqAnnouncement);
for (var f in u) "qq_AnnouceSwitch" === f ? HLSDKLocalData$1._isEnableQQShowAnnounceUI = 1 === u.qq_AnnouceSwitch : "qq_AnnounceData" === f && (HLSDKLocalData$1._qqAnnouncementData = u.qq_AnnounceData.split("||"));
} else HLSDKLocalData$1._isEnableQQShowAnnounceUI = !1, HLSDKLocalData$1._qqAnnouncementData = [ "", "" ];
HLSDKLocalData$1._gameFlows = e.result.gameFlows;
var _ = function(e) {
var t = HLSDKLocalData$1._gameFlows[e], n = HLSDKLocalData$1._gameFlows[e].flows;
void 0 !== n && n.forEach(function(e) {
e.workflow_id = t.workflow_id;
var n = e.elements;
void 0 !== n && n.forEach(function(n) {
n.workflow_id = t.workflow_id, n.node_id = e.node_id;
});
});
};
for (var p in HLSDKLocalData$1._gameFlows) _(p);
void 0 !== e.result.allBackList ? (HLSDKLocalData$1._blackInfo.backArea = e.result.allBackList.backArea, 
HLSDKLocalData$1._blackInfo.blackScene = e.result.allBackList.blackScene) : (HLSDKLocalData$1._blackInfo.backArea = "", 
HLSDKLocalData$1._blackInfo.blackScene = ""), newBannerMgr.Instances.init(e.result.baseInfo.config.wxAdv.bannerAdUnitIDs, Number(e.result.baseInfo.config.banner.brushAdIntervals || 3e3), Number(e.result.baseInfo.config.banner.brushRefreshTime || 600), Number(e.result.baseInfo.config.banner.maxShowTime || 1), Number(e.result.baseInfo.config.banner.maxClickedTimes || 6e4), Number(e.result.baseInfo.config.banner.preloadBannerCount || 0), Number(e.result.baseInfo.config.banner.isOutsideBanner || 0), Number(e.result.baseInfo.config.banner.brushRefreshCount || 5), function() {
t();
});
} else Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
});
});
}, a = [];
a.push(new Promise(function(e) {
UIManager.registerAllUIs(function() {
e();
});
})), a.push(new Promise(function(e) {
NetHelper.reqGetAdvList(function(t) {
t && "200" === t.status ? (HLSDKLocalData$1._advInfos = t.result, e()) : Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
});
})), a.push(new Promise(function(e) {
if (PlatHelper.canLoginOnline()) PlatHelper.getPlat().login({
timeout: 1e4,
success: function(t) {
var n = t.code ? t.code : t.data.code;
NetHelper.reqLogin(n, function(t) {
t && "200" === t.status ? (ServerInfo.registerServerTime(Math.floor(parseInt(t.time_stamp, 10) / 1e3)), 
HttpsHelper.registerGetServerTimeFunc(function() {
return ServerInfo.getServerTime();
}), HLSDKLocalData$1._isNewPlayer = "1" === t.result.is_new, HLSDKLocalData$1._openID = t.result.openid, 
HLSDKLocalData$1._token = t.result.token, HLSDKLocalData$1._address = t.result.address, 
PlatHelper.getStorage(SK_KEY_OF_INTERACT_INFO) && loadInteractInfoFromString(PlatHelper.getStorage(SK_KEY_OF_INTERACT_INFO)), 
HLSDKLocalData$1._interactInfo._saveDay !== ServerInfo.getCurServerDayOfYear() && (HLSDKLocalData$1._interactInfo._saveDay = ServerInfo.getCurServerDayOfYear(), 
HLSDKLocalData$1._interactInfo._todayShareTimes = 0, HLSDKLocalData$1._interactInfo._todayAdvTimes = 0, 
PlatHelper.setStorage(SK_KEY_OF_INTERACT_INFO, saveInteractInfoToString())), PlatHelper.setStorage(SK_KEY_OF_LOGINED_OPENID_AND_TOKEN, HLSDKLocalData$1._openID + "&&" + HLSDKLocalData$1._token), 
Reportor$1.setOpenID(HLSDKLocalData$1._openID), i(HLSDKLocalData$1._openID).then(function() {
e();
})) : (console.error("login fail:", t ? t.description : "unknow error"), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR));
});
},
fail: function(e) {
console.error(e), Event.dispatchEvent(EventName.EN_SYSTEM_ERROR);
}
}); else {
if (ServerInfo.registerServerTime(Math.round(new Date() / 1e3)), LoginConfig.isAlwaysNewPlayer && (HLSDKLocalData$1._isNewPlayer = !0, 
PlatHelper.clearStorage(SK_KEY_OF_LOGINED_OPENID_AND_TOKEN)), checkString(LoginConfig.fixedOpenID) && (HLSDKLocalData$1._openID = LoginConfig.fixedOpenID, 
HLSDKLocalData$1._token = generateString(32), PlatHelper.setStorage(SK_KEY_OF_LOGINED_OPENID_AND_TOKEN, HLSDKLocalData$1._openID + "&&" + HLSDKLocalData$1._token)), 
!checkString(HLSDKLocalData$1._openID)) {
var t = PlatHelper.getStorage(SK_KEY_OF_LOGINED_OPENID_AND_TOKEN);
if (null !== t) {
var n = t.split("&&");
2 === n.length && (HLSDKLocalData$1._isNewPlayer = !1, HLSDKLocalData$1._openID = n[0], 
HLSDKLocalData$1._token = n[1]);
}
checkString(HLSDKLocalData$1._openID) || (HLSDKLocalData$1._openID = generateString(28), 
HLSDKLocalData$1._token = generateString(32), PlatHelper.setStorage(SK_KEY_OF_LOGINED_OPENID_AND_TOKEN, HLSDKLocalData$1._openID + "&&" + HLSDKLocalData$1._token));
}
Reportor$1.setOpenID(HLSDKLocalData$1._openID), i(HLSDKLocalData$1._openID).then(function() {
e();
});
}
})), Promise.all(a).then(function() {
if (HLSDKLocalData$1._isInited = !0, console.error("Current OpenID: ", HLSDKLocalData$1._openID), 
HLSDKLocalData$1._isMistakeEnabled = checkBlackState(HLSDKLocalData$1._blackInfo.backArea, HLSDKLocalData$1._blackInfo.blackScene), 
Reportor$1.postBackToTT(0), console.log("init HLSDK succ..."), isLoadOPPOConfig() || isLoadQQConfig() || isLoadVIVOConfig()) "1" != cc.sys.localStorage.getItem("Private") ? HLSDK.showPrivacy(0, function() {
isLoadQQConfig() && HLSDKLocalData$1._isEnableQQShowAnnounceUI ? HLSDK.showAnnouncement(function() {
doCallback$1(e.onInit);
}) : doCallback$1(e.onInit);
}) : isLoadQQConfig() && HLSDKLocalData$1._isEnableQQShowAnnounceUI ? HLSDK.showAnnouncement(function() {
doCallback$1(e.onInit);
}) : doCallback$1(e.onInit); else {
var t = adv_interface.preloadFlowCustomAd(PreloadFlowType.Loading, !1, !0, !0);
Promise.all(t).then(function() {
console.warn("All Loading Custom Adv Preloaded..."), doCallback$1(e.onInit);
});
}
});
} else console.error("请在SDK配置文件中填写有效的app版本：appVersion"); else console.error("请在SDK配置文件中填写有效的屏幕方向：Orientation"); else console.error("当前SDK版本与SDK配置文件版本不匹配，请检查");
}, HLSDK.preLoadAd = function() {
PlatHelper.isQGPlatform() ? QGAdv.init(function() {
QGAdv.preload();
}) : PlatHelper.isWINPlatform() || Adv.preload(), adv_interface.preloadFlowCustomAd(PreloadFlowType.Loading, !0, !1, !1);
}, HLSDK.showPrivacy = function(e, t) {
HLSDKLocalData$1._witchPrivacy = e, UIManager.showUI(UIKeys.Private, DEFAULT_BUNDLE_TEMPLATE, function() {
doCallback$1(t);
});
}, HLSDK.showAnnouncement = function(e) {
UIManager.showUI(UIKeys.Announcement, DEFAULT_BUNDLE_TEMPLATE, function() {
doCallback$1(e);
});
}, cc.sys.localStorage.clear = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] && arguments[0];
if (e) cc.sys.localStorage._baseClass.clear(); else {
var t = cc.sys.localStorage.getItem("Private");
cc.sys.localStorage._baseClass.clear(), null != t && cc.sys.localStorage.setItem("Private", t);
}
}, HLSDK.isNewPlayer = function() {
return HLSDKLocalData$1._isNewPlayer;
}, HLSDK.isMistakeEnabled = function() {
return isGlobalMistakeEnabled();
}, HLSDK.isPublishing = function() {
return Switch.isPublishingSync();
}, HLSDK.isMistakeClickEnabled = function() {
return HLSDKLocalData$1._globalCrazyClickBtnCfg.isEnabled;
}, HLSDK.isMistakeMoveEnabled = function() {
return HLSDKLocalData$1._globalMoveMistakeBtnCfg.isEnabled;
}, HLSDK.getOpenID = function() {
return HLSDKLocalData$1._openID;
}, HLSDK.setSoundEnable = function(e) {
HLSDKLocalData$1._settings._isSoundEnabled = e;
}, HLSDK.isSoundEnable = function() {
return HLSDKLocalData$1._settings._isSoundEnabled;
}, HLSDK.setMusicEnable = function(e) {
HLSDKLocalData$1._settings._isMusicEnabled = e;
}, HLSDK.isMusicEnable = function() {
return HLSDKLocalData$1._settings._isMusicEnabled;
}, HLSDK.setMuteEnable = function(e) {
HLSDKLocalData$1._settings._isMuteEnabled = e;
}, HLSDK.isMuteEnable = function() {
return HLSDKLocalData$1._settings._isMuteEnabled;
}, HLSDK.vibratePhone = function(e) {
return PlatHelper.vibratePhone(e);
}, HLSDK.doBtnMistake = function(e) {
ui_interface.doBtnMistake(e.btn, e.touchCb, e.offsetPos);
}, HLSDK.doBtnCrazyClick = function(e) {
ui_interface.doBtnCrazyClick(e.btn, e.progressCb, e.clickCb, e.rewardCb);
}, HLSDK.hideAllComponentAds = function(e) {
adv_interface.hideAllComponentAds(e);
}, HLSDK.getCustomParams = function() {
return HLSDKLocalData$1._globalCrazyClickBtnCfg.customParams;
}, HLSDK.showMainView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null, t = arguments.length > 1 && void 0 !== arguments[1] && arguments[1];
if (console.warn("showMainView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.MAIN), 
t) return HLSDKLocalData$1._isSkipFlow = t, doCallback$1(e), void console.log("允许跳过showMainView...");
if (!HLSDKLocalData$1._flowPreloadStates[PreloadFlowType.Main]) {
HLSDKLocalData$1._flowPreloadStates[PreloadFlowType.Main] = !0;
var n = adv_interface.preloadFlowCustomAd(PreloadFlowType.Main);
Promise.all(n).then(function() {
HLSDKLocalData$1._flowPreloadPromises[PreloadFlowType.Main] = null, console.warn("All Main Custom Adv Preloaded...");
});
}
FlowManager.exeMainView().then(function() {
console.warn("showMainView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showMainView fail..."), doCallback$1(e);
});
};

var checkFlowPreloadCustomAd = function(e, t) {
var n = HLSDKLocalData$1._flowPreloadPromises[e];
n && 0 !== n.length ? (PlatHelper.showLoading("疯狂加载中"), Promise.all(n).then(function() {
PlatHelper.hideLoading(), doCallback$1(t);
})) : doCallback$1(t);
};

HLSDK.showGamingView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showGamingView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.GAMING), 
checkFlowPreloadCustomAd(PreloadFlowType.Main, function() {
if (!HLSDKLocalData$1._flowPreloadStates[PreloadFlowType.Gaming]) {
HLSDKLocalData$1._flowPreloadStates[PreloadFlowType.Gaming] = !0;
var t = adv_interface.preloadFlowCustomAd(PreloadFlowType.Gaming);
Promise.all(t).then(function() {
HLSDKLocalData$1._flowPreloadPromises[PreloadFlowType.Gaming] = null, console.warn("All Gaming Custom Adv Preloaded...");
});
}
FlowManager.exeGamingView().then(function() {
console.warn("showGamingView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showGamingView fail..."), doCallback$1(e);
});
});
}, HLSDK.showGameEndView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showGameEndView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.GAMEEND), 
checkFlowPreloadCustomAd(PreloadFlowType.Gaming, function() {
FlowManager.exeGameEndView().then(function() {
console.warn("showGameEndView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showGameEndView fail..."), doCallback$1(e);
});
});
}, HLSDK.showReviveView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showReviveView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.REVIVE), 
checkFlowPreloadCustomAd(PreloadFlowType.Gaming, function() {
FlowManager.exeReviveView().then(function() {
console.warn("showReviveView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showReviveView fail..."), doCallback$1(e);
});
});
}, HLSDK.showFinishView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showFinishView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Finish), 
checkFlowPreloadCustomAd(PreloadFlowType.Gaming, function() {
FlowManager.exeFinishView().then(function() {
console.warn("showFinishView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showFinishView fail..."), doCallback$1(e);
});
});
}, HLSDK.showFinishFailView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showFinishFailView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.FinishFail), 
checkFlowPreloadCustomAd(PreloadFlowType.Gaming, function() {
FlowManager.exeFinishFailView().then(function() {
console.warn("showFinishFailView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showFinishFailView fail..."), doCallback$1(e);
});
});
}, HLSDK.showCustomView = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showCustomView..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Custom), 
FlowManager.exeCustomView().then(function() {
console.warn("showCustomView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showCustomView fail..."), doCallback$1(e);
});
}, HLSDK.showCustomView_02 = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showCustomView_02..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Custom_02), 
FlowManager.exeCustomView_02().then(function() {
console.warn("showCustomView_02 succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showCustomView_02 fail..."), doCallback$1(e);
});
}, HLSDK.showCustomView_03 = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showCustomView_03..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Custom_03), 
FlowManager.exeCustomView_03().then(function() {
console.warn("showCustomView_03 succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showCustomView_03 fail..."), doCallback$1(e);
});
}, HLSDK.showCustomView_04 = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showCustomView_04..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Custom_04), 
FlowManager.exeCustomView_04().then(function() {
console.warn("showCustomView_04 succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showCustomView_04 fail..."), doCallback$1(e);
});
}, HLSDK.showCustomView_05 = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showCustomView_05..."), (isLoadOPPOConfig() || isLoadVIVOConfig()) && HLSDK.resetOVStateConfig(VIEW_NAME.Custom_05), 
FlowManager.exeCustomView_05().then(function() {
console.warn("showCustomView_05 succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showCustomView_05 fail..."), doCallback$1(e);
});
}, HLSDK.hideAllSDKPage = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : null;
console.warn("showEmptyView"), FlowManager.exeEmptyView().then(function() {
console.warn("showEmptyView succ..."), doCallback$1(e);
}).catch(function(t) {
console.error(t), console.warn("showEmptyView fail..."), doCallback$1(e);
});
}, HLSDK.getLastPageViewName = function() {
return FlowManager && FlowManager._currentViewName ? FlowManager._currentViewName : null;
}, HLSDK.showLastSDKPage = function(e) {
var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null;
if (null == e || "" == e) return console.warn("请传入正确的界面流程名"), void (t && "function" == typeof t && t());
switch (e) {
case VIEW_NAME.MAIN:
HLSDK.showMainView(t);
break;

case VIEW_NAME.GAMING:
HLSDK.showGamingView(t);
break;

case VIEW_NAME.GAMEEND:
HLSDK.showGameEndView(t);
break;

case VIEW_NAME.Finish:
HLSDK.showFinishView(t);
break;

case VIEW_NAME.FinishFail:
HLSDK.showFinishFailView(t);
break;

case VIEW_NAME.REVIVE:
HLSDK.showReviveView(t);
break;

case VIEW_NAME.Custom:
HLSDK.showCustomView(t);
break;

case VIEW_NAME.Custom_02:
HLSDK.showCustomView_02(t);
break;

case VIEW_NAME.Custom_03:
HLSDK.showCustomView_03(t);
break;

case VIEW_NAME.Custom_04:
HLSDK.showCustomView_04(t);
break;

case VIEW_NAME.Custom_05:
HLSDK.showCustomView_05(t);
break;

default:
console.warn("未找到{0}页面", e);
}
}, HLSDK.tempHide = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {
couplet: !0,
scroll: !0,
matrix: !0,
MoreGameEntrance: !0,
VideoBanner: !0
};
UIManager.tempHideAllUIs(e), adv_interface.tempHideAllAdvs(e);
}, HLSDK.showTempHide = function() {
UIManager.showAllTempHideUIs(), adv_interface.showAllTempHideAdvs();
}, HLSDK.showBannerAd = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
adv_interface.showBannerAd(0, e, "");
}, HLSDK.hideBannerAd = function() {
adv_interface.hideBannerAd();
}, HLSDK.moveBannerAd = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
adv_interface.moveBannerAd(e);
}, HLSDK.moveBannerAdTo = function(e) {
adv_interface.moveBannerAdTo(e);
}, HLSDK.isBannerOnShow = function() {
return adv_interface.isBannerOnShow();
}, HLSDK.pauseAutoRefreshBannerAd = function() {
adv_interface.pauseAutoRefreshBannerAd();
}, HLSDK.resumeAutoRefreshBannerAd = function() {
adv_interface.resumeAutoRefreshBannerAd();
}, HLSDK.getNextFreeGetWay = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
adv_interface.getNextFreeGetWay(e.cb);
}, HLSDK.tryFreeToGetAReward = function(e) {
adv_interface.tryFreeToGetAReward(e.shareScene, e.isFailTryAgain, e.showFailTips, e.succCb, e.failCb);
}, HLSDK.isWatchingVideoAdv = function() {
return adv_interface.isWatchingVideoAdv();
}, HLSDK.showInterstitialAd = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
adv_interface.showInterstitialAd("", e.closeCb, e.errCb);
}, HLSDK.showCustomAd = function(e) {
adv_interface._showComponentAd(e);
}, HLSDK.share = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
share_interface.share(e.sceneName, e.customQueryObj, e.showFailTips, e.cb);
}, HLSDK.shareVideo = function() {
var e = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
share_interface.shareVideo(e.sceneName, e.videoPath, e.customQueryObj, e.showFailTips, e.cb);
}, HLSDK.sendEvent = function(e) {
Reportor$1.report(e.eventName, e.data);
}, HLSDK.postBackToTT = function(e) {
Reportor$1.postBackToTT(e, !1);
}, HLSDK.resetOVStateConfig = function(e) {
var t = e + "hasShownGraphicCount";
isLayaEngine() ? Laya.LocalStorage.setItem(t, "0") : isCocosEngine() && cc.sys.localStorage.setItem(t, "0");
}, HLSDK.getOVNativeMistakeParam = function() {
return HLSDKLocalData$1._globalCrazyClickBtnCfg.ov_nativeMistake;
}, HLSDK.isCocosPlat = function() {
return isCocosEngine();
}, HLSDK.getAppIdKey = function() {
return PlatIDs[hl_cfg.app_id_key];
}, window.HLSDK = HLSDK;